package cn.superdesk.uniorder.common.enums.common;

import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 对账(结算)单 关联的
 * 订单 商品 流水 共用
 * 对账状态 是否对账的问题
 * @Author: linjinyu
 * @CreateDate: 6/18/20 8:59 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 6/18/20 8:59 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public enum CommonAccountingStateEnum {

	不对账(-1, "不对账"),
	已对账(1, "已对账"),
	未对账(2, "未对账"),
	已作废(3, "已作废"),// 20200713 添加 by linjinyu 原因 老是说要作废什么订单
	;

	private Integer key;
	private String  desc;

	CommonAccountingStateEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}

	public static String getDesc(Integer key) {
		for (CommonAccountingStateEnum c : CommonAccountingStateEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return null;
	}

	private static final Map<Integer, CommonAccountingStateEnum> LOOKUP = new HashMap<>();

	static {
		for (CommonAccountingStateEnum s : EnumSet.allOf(CommonAccountingStateEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static CommonAccountingStateEnum get(Integer key) {
		return LOOKUP.get(key);
	}

}
