package cn.superdesk.uniorder.common.enums.common;

import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: key 的作用是 商城过来的 订单有 order_type
 * @Author: linjinyu
 * @CreateDate: 8/6/20 6:40 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 8/6/20 6:40 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public enum CommonServiceEnum {

	UNKNOW(-1, "UNKNOW", "未知类型"),
	SUPER(0, "SUPER", "服务之窗"),
	QYNG(1, "QYNG", "企业采购"),
	DKXD(2, "DKXD", "代客下单"),//TODO TMD 20200601 要求 "DKXD" 变成 "QYNG"  TODO TMD 20200601 要求 "代客下单" 变成 "企业采购"

	//
//	代客下单 新的订单类型 add at 20210512 mark by linjinyu
//	企业采购(代客)
//	企业福利(代客)
//	企业差旅
//	企业饭卡
//	信息技术服务
//	平台服务

//  SUBMIT
//  SUBCW
//  SUBCT
//  SUBMC
//  SUBIT
//  SUBPS

	SUBMIT(21, "SUBMIT", "企业采购(代客)"),
	SUBCW(22, "SUBCW", "企业福利(代客)"),
	SUBCT(23, "SUBCT", "企业差旅"),
	SUBMC(24, "SUBMC", "企业饭卡"),
	SUBIT(25, "SUBIT", "信息技术服务"),
	SUBPS(26, "SUBPS", "平台服务"),

	FLSC(3, "FLSC", "企业福利"),
	FLSC_QCH(31, "FLSC_QCH", "企业福利_侨城汇"),
	LNSS(4, "LNSS", "楼闪送"),
	;

	// 也是对映的 order_type
	private Integer serviceId;
	private String  serviceNo;
	private String  serviceName;

	CommonServiceEnum(Integer key, String serviceNo, String serviceName) {
		this.serviceId = key;
		this.serviceNo = serviceNo;
		this.serviceName = serviceName;
	}

	public Integer getServiceId() {
		return serviceId;
	}

	public String getServiceNo() {
		return serviceNo;
	}

	public String getServiceName() {
		return serviceName;
	}

	public static String getServiceNoByServiceId(Integer key) {
		for (CommonServiceEnum c : CommonServiceEnum.values()) {
			if (c.serviceId.equals(key)) {
				return c.getServiceNo();
			}
		}
		return UNKNOW.getServiceNo();
	}

	public static String getServiceNameByServiceId(Integer key) {
		for (CommonServiceEnum c : CommonServiceEnum.values()) {
			if (c.serviceId.equals(key)) {
				return c.getServiceName();
			}
		}
		return UNKNOW.getServiceName();
	}

	public static CommonServiceEnum getByServiceNo(String serviceNo) {
		for (CommonServiceEnum commonServiceEnum : CommonServiceEnum.values()) {
			if (commonServiceEnum.serviceNo.equals(serviceNo)) {
				return commonServiceEnum;
			}
		}
		return CommonServiceEnum.UNKNOW;
	}

	public static CommonServiceEnum getByServiceId(Integer serviceId) {
		return LOOKUP.get(serviceId);
	}

	private static final Map<Integer, CommonServiceEnum> LOOKUP = new HashMap<>();


	private static final Map<Integer, CommonServiceEnum> LOOK_UP_DKXD = new HashMap<>();

	static {
		for (CommonServiceEnum s : EnumSet.allOf(CommonServiceEnum.class)) {
			LOOKUP.put(s.getServiceId(), s);
		}
	}

}
