package cn.superdesk.uniorder.common.enums.common;

import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 通用来源
 * @Author: linjinyu
 * @CreateDate: 8/31/20 4:42 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 8/31/20 4:42 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public enum CommonSourceFromEnum {

	/****************************************** 大类? start ******************************************/
	统一订单(1, "system", "统一订单"),
	服务之窗(100, "superdesk-app", "服务之窗"),
	统一商城(101, "superdesk-mall", "统一商城"),
	/****************************************** 大类? start ******************************************/

	// 上边的没细分

	/****************************************** 大类-小类 start ******************************************/
	楼内闪送(100004, "LNSS", "楼内闪送"),

	企业采购(200, "QYNG", "企业采购"),
	代客下单(200002, "DKXD", "企业采购"),//TODO TMD 20200601 要求 "DKXD" 变成 "QYNG"  TODO TMD 20200601 要求 "代客下单" 变成 "企业采购"

	企业福利(300, "FLSC", "企业福利"),
	// 31 推 3*100 . 001
	企业福利_侨城汇(300001, "FLSC_QCH", "企业福利_侨城汇"),
	/****************************************** 大类-小类 start ******************************************/

	;

	// 这个值的定义还要考量一下
	private Integer key;
	// 这个值就这样定了
	private String  sourceFromCode;
	private String  sourceFromName;

	CommonSourceFromEnum(Integer key, String sourceFromCode, String sourceFromName) {
		this.key = key;
		this.sourceFromCode = sourceFromCode;
		this.sourceFromName = sourceFromName;
	}

	public Integer getKey() {
		return key;
	}

	public String getSourceFromCode() {
		return sourceFromCode;
	}

	public String getSourceFromName() {
		return sourceFromName;
	}

//	public static String getSourceFromCode(Integer key) {
//		for (SysRoleExtDataSampleSourceFromEnum c : SysRoleExtDataSampleSourceFromEnum.values()) {
//			if (c.key.equals(key)) {
//				return c.getSourceFromCode();
//			}
//		}
//		return "UNKNOW";
//	}

//	public static String getSourceFromName(Integer key) {
//		for (SysRoleExtDataSampleSourceFromEnum c : SysRoleExtDataSampleSourceFromEnum.values()) {
//			if (c.key.equals(key)) {
//				return c.getSourceFromName();
//			}
//		}
//		return "未知类型";
//	}


	public static CommonSourceFromEnum getBySourceFromCode(String sourceFromCode) {
		for (CommonSourceFromEnum c : CommonSourceFromEnum.values()) {
			if (c.sourceFromCode.equals(sourceFromCode)) {
				return c;
			}
		}
		return CommonSourceFromEnum.统一订单;
	}

	public static CommonSourceFromEnum get(Integer key) {
		return LOOKUP.get(key);
	}

	private static final Map<Integer, CommonSourceFromEnum> LOOKUP = new HashMap<>();

	static {
		for (CommonSourceFromEnum s : EnumSet.allOf(CommonSourceFromEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}
}
