package cn.superdesk.uniorder.common.enums.invoice;


import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 是否回款_回款状态:0-未回款;1-部分回款;2-全部回款;69-红冲发票;
 * @Author: linjinyu
 * @CreateDate: 7/30/20 4:52 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 7/30/20 4:52 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public enum InvoiceApplyBackAccountStatusEnum {


	未回款(0, "未回款"),
	部分回款(1, "部分回款"),
	已回款(2, "已回款"),
	红冲发票(69, "红冲发票"),
	;

	private Integer key;
	private String  desc;

	InvoiceApplyBackAccountStatusEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}

	public static String getDesc(Integer key) {
		for (InvoiceApplyBackAccountStatusEnum c : InvoiceApplyBackAccountStatusEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return "未知状态";
	}

	private static final Map<Integer, InvoiceApplyBackAccountStatusEnum> LOOKUP = new HashMap<>();

	static {
		for (InvoiceApplyBackAccountStatusEnum s : EnumSet.allOf(InvoiceApplyBackAccountStatusEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static InvoiceApplyBackAccountStatusEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
