package cn.superdesk.uniorder.common.enums.invoice;

import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 同质 AccountingInvoiceStatus 要弃一个
 * <p>
 * 此类目前 只在`订单管理 上用到? 与 发票申请中的发票状态 又不是一个东西
 * <p>
 * <p>
 * 已经与彩娇 20200730 确认过 就是这个信息 发票状态 0-未邮寄;1-已邮寄;2-已作废;
 * <p>
 * TODO 如查非 开票申请 用到这个发票状态 可能 就是错的 flag 202007301711
 * @Author: linjinyu
 * @CreateDate: 7/8/20 4:07 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 7/8/20 4:07 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public enum InvoiceApplyInvoiceProgressingStatusEnum {

	// 这个是错过
//	已开票(1, "已开票"),
//	未开票(2, "未开票"),
//	部分开票(3, "部分开票");

	// 已经与彩娇 20200730 确认过 就是这个信息 发票状态 0-未邮寄;1-已邮寄;2-已作废;
	待开票(0, "待开票"),// 未邮寄 -> 待开票
	已邮寄(1, "已邮寄"),// 弃用
	已作废(2, "已作废"),//

	// at 20210714 张雪 【积分结算2.0优化需求（保留现有的银行流水和收款核销模块）】 https://www.tapd.cn/33003868/prong/stories/view/1133003868001002470
//	State_0_待开票
//	State_10_开票中
//	State_11_已开票
	开票中(10, "开票中"),//
	已开票(11, "已开票"),//
	;

	// 发票开票进度状态:0-待开票(原:未邮寄);1-已邮寄(弃用);2-已作废;10-开票中;11-已开票;

	private Integer key;
	private String  desc;

	InvoiceApplyInvoiceProgressingStatusEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}

	public static String getDesc(Integer key) {
		for (InvoiceApplyInvoiceProgressingStatusEnum c : InvoiceApplyInvoiceProgressingStatusEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return "未知状态";
	}

	private static final Map<Integer, InvoiceApplyInvoiceProgressingStatusEnum> LOOKUP = new HashMap<>();

	static {
		for (InvoiceApplyInvoiceProgressingStatusEnum s : EnumSet.allOf(InvoiceApplyInvoiceProgressingStatusEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static InvoiceApplyInvoiceProgressingStatusEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
