package cn.superdesk.uniorder.common.enums.statement;

import java.util.EnumSet;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: 同质?不是
 * UnifiedOrderInvoiceState 是订单
 * AccountingOrderInvoiceStatus 是 发票申请 对账单
 * @Author: linjinyu
 * @CreateDate: 6/23/20 5:38 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 6/23/20 5:38 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public enum AccountingOrderInvoiceStatusEnum {


	未申请(0, "未申请"),
	全部申请(1, "全部申请"),
	部分申请(2, "部分申请"),
	;

	private Integer key;
	private String  desc;

	AccountingOrderInvoiceStatusEnum(Integer key, String desc) {
		this.key = key;
		this.desc = desc;
	}

	public Integer getKey() {
		return key;
	}

	public String getDesc() {
		return desc;
	}


	public static String getDesc(Integer key) {
		for (AccountingOrderInvoiceStatusEnum c : AccountingOrderInvoiceStatusEnum.values()) {
			if (c.key.equals(key)) {
				return c.getDesc();
			}
		}
		return null;
	}

	private static final Map<Integer, AccountingOrderInvoiceStatusEnum> LOOKUP = new HashMap<>();

	static {
		for (AccountingOrderInvoiceStatusEnum s : EnumSet.allOf(AccountingOrderInvoiceStatusEnum.class)) {
			LOOKUP.put(s.getKey(), s);
		}
	}

	public static AccountingOrderInvoiceStatusEnum get(Integer key) {
		return LOOKUP.get(key);
	}
}
