package cn.superdesk.uniorder.common.rest.response;

import cn.hutool.core.io.FileUtil;
import cn.hutool.core.io.IoUtil;
import cn.hutool.json.JSONUtil;
import lombok.NoArgsConstructor;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URLEncoder;

@NoArgsConstructor
public class AnResponseStreamUtils {

	/**
	 * @param fileFullPath
	 * @param fileName
	 * @param response
	 * @throws IOException
	 */
	public static void download(/*文件绝对地址 全路径*/String fileFullPath, /*下载文件名*/String fileName, HttpServletResponse response) throws IOException {


		if (!FileUtil.exist(fileFullPath)) {
			outputJson(response, JSONUtil.toJsonStr(ResponseResultOuterUtils.createErrorResult("500", "文件不存在或过期被清理")));

			return;
		}

		ServletOutputStream outputStream = response.getOutputStream();

		// 准备将Excel的输出流通过response输出到页面下载
		response.reset();
		// 二进制输出流
//        response.setContentType("application/octet-stream");
		response.setContentType("application/force-download");
		response.setCharacterEncoding("UTF-8");

		// 设置编码，避免文件名中文乱码
		response.setHeader("Content-Disposition", "attachment;filename=" + URLEncoder.encode(fileName, "UTF-8"));

		outputStream.write(FileUtil.readBytes(fileFullPath));

		IoUtil.close(outputStream);
	}

	public static void outputJson(HttpServletResponse response, String json) {

		response.setContentType("application/json;charset=utf-8");

		PrintWriter out;

		try {
			out = response.getWriter();

			out.print(json);
			out.flush();
			out.close();

		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
