package cn.superdesk.uniorder.dao.entity.accounting.jd;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import lombok.Data;
import lombok.ToString;

@Data
@ToString
public class AccountingUnifiedSupplierOrderJd implements Serializable {
    /**
     * Id
     */
    private Long id;

    /**
     * 批次Id
     */
    private String batchId;

    /**
     * 订单编号 215961349611
     */
    private String jdOrderSn;

    /**
     * 原始订单号 215276644920
     */
    private String jdOriginalOrderSn;

    /**
     * 支付号 72927521073111000607247
     */
    private String paymentNo;

    /**
     * 用户名  侨城汇vsp
     */
    private String jdAccoumtUserName;

    /**
     * 产品编号 KA
     */
    private String productNumber;

    /**
     * 业务类型
     */
    private String bizType;

    /**
     * 订单时间 eg 2021-02-28 10:25:41
     */
    private Date jdCreateTime;

    /**
     * 支付时间 eg 2021-02-28 10:50:09
     */
    private Date jdPayTime;

    /**
     * 完成时间 eg 2021-02-28 17:32:42
     */
    private Date jdFinishTime;

    /**
     * 订单金额 159.18
     */
    private BigDecimal jdOrderAmount;

    /**
     * 还款金额 0.00
     */
    private BigDecimal jdRepaymentAmount;

    /**
     * 退款金额 106.12
     */
    private BigDecimal jdRefundAmount;

    /**
     * 未结清 53.06
     */
    private BigDecimal jdOutStandingAmount;

    /**
     * 京东 订单状态 ++
     */
    private Integer jdOrderState;

    /**
     * 京东 订单状态 已完成 部分退货
     */
    private String jdOrderStateName;

    /**
     * 京东 入账状态 ++
     */
    private Integer wereAccountedState;

    /**
     * 京东 入账状态 已入账
     */
    private String wereAccountedStateName;

    /**
     * 出账时间 2021-08-01 00:00:00
     */
    private Date outAccountTime;

    /**
     * 账单编号 202103010000900180 直接
     */
    private String jdAccountingOrderSn;

    /**
     * 京东 结清状态 ++
     */
    private Integer settledState;

    /**
     * 京东 结清状态 未结清 
     */
    private String settledStateName;

    /**
     * 结清时间 未结清为 空串
     */
    private Date settledTime;

    /**
     * 合同编号 ACTBO201811130029
     */
    private String purchaserContractSn;

    /**
     * 企业编号 C1004592650
     */
    private String purchaserVirtCode;

    /**
     * 企业名称 深圳市侨城汇网络科技有限公司
     */
    private String purchaserVirtName;

    /**
     * 发票状态
     */
    private Integer invoicedState;

    /**
     * 发票状态 未开
     */
    private String invoicedStateName;

    /**
     * 售后状态
     */
    private Integer afterSaleState;

    /**
     * 售后状态 未进售后 售后完成 已进售后
     */
    private String afterSaleStateName;

    /**
     * 还款编号 目前为空
     */
    private String repaymentOrderSn;

    /**
     * 发票时间 目前为空 大概也会是 2021-04-01 00:00:00
     */
    private Date invoicedDate;

    /**
     * 应还日期 2021-04-01 00:00:00
     */
    private Date repaymentTime;

    /**
     * 逾期天数 0
     */
    private Integer overdueDays;

    /**
     * 京东 订单类型
     */
    private Integer jdOrderType;

    /**
     * 京东 订单类型 原始订单 子订单
     */
    private String jdOrderTypeName;

    /**
     * 京东 支付类型 ++
     */
    private Integer jdPayType;

    /**
     * 京东 支付类型 金采支付
     */
    private String jdPayTypeName;

    /**
     * 京东 发票号(如果开票了会有)
     */
    private String invoiceNumber;

    /**
     * 发票代码(大概是发票类型代码吧)
     */
    private String invoiceCategoryCode;

    /**
     * 发票金额(含税)
     */
    private BigDecimal totalAmountIncludingTax;

    /**
     * 发票抬头
     */
    private String purchaserCompanyName;

    /**
     * 发票类型Id 看一下能不能对上统一上的表记录
     */
    private Integer invoiceTypeId;

    /**
     * 发票类型
     */
    private String invoiceType;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 操作人 sysUserId
     */
    private Long createUserId;

    /**
     * 操作人 sysUserName
     */
    private String createUserName;

    /**
     * 最近更新时间
     */
    private Date updateTime;

    /**
     * 操作人 sysUserId
     */
    private Long updateUserId;

    /**
     * 操作人 sysUserName
     */
    private String updateUserName;

    /**
     * 处理结果:-1-正常;2-异常;
     */
    private Integer processResult;

    /**
     * 处理过程报告
     */
    private String processReport;

    private static final long serialVersionUID = 1L;
}