package cn.superdesk.uniorder.dao.entity.accounting.jd;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import lombok.Data;
import lombok.ToString;

@Data
@ToString
public class AccountingUnifiedSupplierOrderJdCheckUpReport implements Serializable {
    /**
     * Id
     */
    private Long id;

    /**
     * 批次Id
     */
    private String batchId;

    /**
     * 京东 账单编号 202103010000900180 直接
     */
    private String jdAccountingOrderSn;

    /**
     * 订单编号 215961349611
     */
    private String jdOrderSn;

    /**
     * 原始订单号 215276644920
     */
    private String jdOriginalOrderSn;

    /**
     * 订单金额 159.18
     */
    private BigDecimal jdOrderAmount;

    /**
     * 还款金额 0.00
     */
    private BigDecimal jdRepaymentAmount;

    /**
     * 退款金额 106.12
     */
    private BigDecimal jdRefundAmount;

    /**
     * 未结清 53.06
     */
    private BigDecimal jdOutStandingAmount;

    /**
     * 京东 订单状态 ++
     */
    private Integer jdOrderState;

    /**
     * 京东 订单状态 已完成 部分退货
     */
    private String jdOrderStateName;

    /**
     * 京东 入账状态 ++
     */
    private Integer wereAccountedState;

    /**
     * 京东 入账状态 已入账
     */
    private String wereAccountedStateName;

    /**
     * 售后状态
     */
    private Integer afterSaleState;

    /**
     * 售后状态 未进售后 售后完成 已进售后
     */
    private String afterSaleStateName;

    /**
     * 统一订单-第三方订单编号
     */
    private String orderSn;

    /**
     * 统一订单-订单-销售金额
     */
    private BigDecimal orderAmount;

    /**
     * 统一订单-订单-成本金额
     */
    private BigDecimal orderCostAmount;

    /**
     * 统一订单-订单-销售金额
     */
    private BigDecimal refundOrderAmount;

    /**
     * 统一订单-订单-成本金额
     */
    private BigDecimal refundOrderCostAmount;

    /**
     * 统一订单-订单-商户承担运费
     */
    private BigDecimal transportAmount;

    /**
     * 统一订单-订单-商户承担运费
     */
    private BigDecimal transportMerchantAssumeAmount;

    /**
     * 统一订单-订单-商品销售金额(包含运费)
     */
    private BigDecimal goodsAmount;

    /**
     * 统一订单-订单-商品成本金额(包含运费)
     */
    private BigDecimal goodsCostAmount;

    /**
     * 统一订单-订单-退品销售金额(包含运费)
     */
    private BigDecimal refundGoodsAmount;

    /**
     * 统一订单-订单-退品成本金额(包含运费)
     */
    private BigDecimal refundGoodsCostAmount;

    /**
     * 统一订单-订单-订单状态
     */
    private Integer orderState;

    /**
     * 统一订单-订单-完成状态
     */
    private Integer completState;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 处理结果:-1-正常;2-异常;
     */
    private Integer processResult;

    /**
     * 处理过程报告
     */
    private String processReport;

    private static final long serialVersionUID = 1L;
}