package cn.superdesk.uniorder.dao.entity.accounting.score.customer;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import lombok.Data;
import lombok.ToString;

@Data
@ToString
public class AccountingScoreCustomer implements Serializable {
    /**
     * 系统信息-自增Id
     */
    private Long id;

    /**
     * 对账(结算)单-编号
     */
    private String accountingOrderSn;

    /**
     * 对账(结算)单-渠道来源
     */
    private String serviceNo;

    /**
     * 对账(结算)单-数据来源-积分类型id（如果是微信支付，显示0）
     */
    private Integer creditType;

    /**
     * 对账(结算)单-数据来源-积分类型
     */
    private String creditName;

    /**
     * 对账(结算)单-数据来源-积分批次
     */
    private String batchs;

    /**
     * 统计-对账(结算)单-订单数
     */
    private Integer quantityOrder;

    /**
     * 统计-对账(结算)单-订单商品数
     */
    private Integer quantityOrderGoods;

    /**
     * 统计-对账(结算)单-积分流水数
     */
    private Integer quantityOrderCredit;

    /**
     * 对账(结算)单 总额
     */
    private BigDecimal accountingAmount;

    /**
     * 对账(结算)单 状态:0-未确认;1-已确认;-1-已取消;
     */
    private Integer accountingStatus;

    /**
     * 发票申请-发票信息-发票类型(关联表:unified_inv_type):1-增值税普票;2-增值税专票;
     */
    private Integer invoiceType;

    /**
     * 发票申请-发票信息-开票状态:0-未开票;1-已开票;2-部分开票;
     */
    private Integer invoiceStatus;

    /**
     * 发票申请-发票信息-开票抬头
     */
    private String invoiceCompanyName;

    /**
     * 发票申请-发票信息-纳税人代码
     */
    private String invoiceTaxpayersIDCode;

    /**
     * 对账单-购方信息-所属企业
     */
    private Long enterpriseId;

    /**
     * 对账单-购方信息-用户Id
     */
    private Long purchaseUserId;

    /**
     * 对账单-购方信息-实名或昵称-用于显示-非登陆用
     */
    private String purchaseUserName;

    /**
     * 对账单-购方信息-电话
     */
    private String purchasePhone;

    /**
     * 对账单-购方信息-地址
     */
    private String purchaseAddress;

    /**
     * 对账(结算)单-是否发邮件:0-不发;1-发;
     */
    private Integer isSendEmail;

    /**
     * 对账(结算)单-发邮件时间
     */
    private Date sendEmailTime;

    /**
     * 账单周期 基于:1-发货时间;2-下单时间;3-完成时间;
     */
    private Integer dateType;

    /**
     * 账单周期-开始时间
     */
    private Date startTime;

    /**
     * 账单周期-结束时间
     */
    private Date endTime;

    /**
     * 对账(结算)单-回款标记:0-未回款;1-部分回款;2-全部回款;
     */
    private Integer backAccountStatus;

    /**
     * 对账(结算)单-供方信息-银行信息Id(关联表)-收款主体
     */
    private Long bankInfoId;

    /**
     * 系统信息-创建时间
     */
    private Date createTime;

    /**
     * 系统信息-创建人Id
     */
    private Long createUserId;

    /**
     * 系统信息-更新时间
     */
    private Date updateTime;

    /**
     * 系统信息-更新人Id
     */
    private Long updateUserId;

    /**
     * 对账(结算)单-支付方式
     */
    private Integer payType;

    /**
     * 对账(结算)单-支付状态:1-已支付;2-未支付;
     */
    private Integer payStatus;

    /**
     * 对账(结算)单-查看二维码
     */
    private String wxQrcodeImgUrl;

    /**
     * 系统信息-软删除
     */
    private Integer deleted;

    /**
     * 后台操作人员备注
     */
    private String remark;

    private static final long serialVersionUID = 1L;
}