package cn.superdesk.uniorder.dao.entity.accounting.unified.customer;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import lombok.Data;
import lombok.ToString;

/**
 *
 *
 * table accounting_unified_customer
 */
@Data
@ToString
public class AccountingUnifiedCustomer implements Serializable {
    /**
     *
     *
     * column accounting_unified_customer.id
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Long id;

    /**
     * Database Column Remarks:
     *   供应商 对账单 创建维度:0-订单;1-商品;2-流水;
     *
     *
     * column accounting_unified_customer.dim_create_by
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Integer dimCreateBy;

    /**
     * Database Column Remarks:
     *   用于标记生成逻辑:10-早期;20-改版202012
     *
     *
     * column accounting_unified_customer.logic_mode
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Integer logicMode;

    /**
     * Database Column Remarks:
     *   这个数据类型是什么鬼:1-发货时间;2-下单时间;3-完成时间;
     *
     *
     * column accounting_unified_customer.date_type
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Integer dateType;

    /**
     *
     *
     * column accounting_unified_customer.accounting_order_sn
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private String accountingOrderSn;

    /**
     *
     *
     * column accounting_unified_customer.service_no
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private String serviceNo;

    /**
     *
     *
     * column accounting_unified_customer.cycle_begin_time
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Date cycleBeginTime;

    /**
     *
     *
     * column accounting_unified_customer.cycle_end_time
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Date cycleEndTime;

    /**
     * Database Column Remarks:
     *   对账单(结算单) 总额
     *
     *
     * column accounting_unified_customer.accounting_amount
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private BigDecimal accountingAmount;

    /**
     * Database Column Remarks:
     *   统计结算单-订单数
     *
     *
     * column accounting_unified_customer.quantity_order
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Integer quantityOrder;

    /**
     *
     *
     * column accounting_unified_customer.purchase_user_name
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private String purchaseUserName;

    /**
     *
     *
     * column accounting_unified_customer.purchase_phone
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private String purchasePhone;

    /**
     * Database Column Remarks:
     *   对账单(结算单)状态:0-未确认;1-已确认;-1-已取消;
     *
     *
     * column accounting_unified_customer.accounting_status
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Integer accountingStatus;

    /**
     * Database Column Remarks:
     *   开票状态，0-未开票，1-已开票，2-部分开票
     *
     *
     * column accounting_unified_customer.invoice_status
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Integer invoiceStatus;

    /**
     *
     *
     * column accounting_unified_customer.enterprise_id
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Long enterpriseId;

    /**
     * Database Column Remarks:
     *   readname_Id
     *
     *
     * column accounting_unified_customer.purchase_user_id
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Long purchaseUserId;

    /**
     * Database Column Remarks:
     *   开票抬头
     *
     *
     * column accounting_unified_customer.invoice_company_name
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private String invoiceCompanyName;

    /**
     * Database Column Remarks:
     *   纳税人代码
     *
     *
     * column accounting_unified_customer.invoice_taxpayers_i_d_code
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private String invoiceTaxpayersIDCode;

    /**
     * Database Column Remarks:
     *   发票类型(关联表:unified_inv_type):1-增值税普票;2-增值税专票;
     *
     *
     * column accounting_unified_customer.invoice_type
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Integer invoiceType;

    /**
     *
     *
     * column accounting_unified_customer.purchase_address
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private String purchaseAddress;

    /**
     * Database Column Remarks:
     *   是否发邮件0-不发，1-发
     *
     *
     * column accounting_unified_customer.is_send_email
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Integer isSendEmail;

    /**
     *
     *
     * column accounting_unified_customer.send_email_time
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Date sendEmailTime;

    /**
     * Database Column Remarks:
     *   账单周期
     *
     *
     * column accounting_unified_customer.start_time
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Date startTime;

    /**
     *
     *
     * column accounting_unified_customer.end_time
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Date endTime;

    /**
     * Database Column Remarks:
     *   0-未回款;1-部分回款;2-全部回款
     *
     *
     * column accounting_unified_customer.back_account_status
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Integer backAccountStatus;

    /**
     *
     *
     * column accounting_unified_customer.create_time
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Date createTime;

    /**
     *
     *
     * column accounting_unified_customer.create_user_id
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Long createUserId;

    /**
     *
     *
     * column accounting_unified_customer.update_time
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Date updateTime;

    /**
     *
     *
     * column accounting_unified_customer.update_user_id
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Long updateUserId;

    /**
     * Database Column Remarks:
     *   支付方式
     *
     *
     * column accounting_unified_customer.pay_type
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Integer payType;

    /**
     * Database Column Remarks:
     *   支付状态 1 已支付2-未支付
     *
     *
     * column accounting_unified_customer.pay_status
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Integer payStatus;

    /**
     *
     *
     * column accounting_unified_customer.wx_qrcode_imgurl
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private String wxQrcodeImgurl;

    /**
     * Database Column Remarks:
     *   银行信息ID?收款主体
     *
     *
     * column accounting_unified_customer.bank_info_id
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private Long bankInfoId;

    /**
     *
     * table accounting_unified_customer
     *
     * Fri Jan 08 16:15:18 CST 2021
     */
    private static final long serialVersionUID = 1L;
}