package cn.superdesk.uniorder.dao.entity.fund;

import lombok.Data;
import lombok.ToString;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description: 基金
 * @tableName sys_fund_activated
 * @Author: linjinyu
 * @CreateDate: 4/21/20 6:32 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 4/21/20 6:32 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
@ToString
public class SysFundActivated implements Serializable {

	private static final long serialVersionUID = 1L;

	/**
	 * id
	 */
	private Long id;

	/**
	 * 基金用户id
	 */
	private Long fundUserId;

	/**
	 * 发票号
	 */
	private String invoiceNo;

	/**
	 * 核销金额
	 */
	private BigDecimal checkCount;

	/**
	 * 基金金额
	 */
	private BigDecimal fundCount;

	/**
	 * 激活状态 1-已激活 0-未激活
	 */
	private Integer activatedStatus;

	/**
	 * 创建人
	 */
	private Long createUserId;

	/**
	 * 创建时间
	 */
	private Date createTime;

	/**
	 * 更新人
	 */
	private Long checkUserId;

	/**
	 * 更新时间
	 */
	private Date checkTime;


}