package cn.superdesk.uniorder.dao.entity.invoice.customer;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import lombok.Data;
import lombok.ToString;

@Data
@ToString
public class InvoiceApply implements Serializable {

    private Long id;

    /**
     * 对账单类型 1-一般;2-积分;
     */
    private Integer accountingOrderType;

    /**
     * 对账单 创建维度:0-订单;1-商品;2-流水;
     */
    private Integer dimCreateBy;

    /**
     * 发票登记部分-填写税局发票号
     */
    private String invoiceNumber;

    /**
     * 寄票登记部分-寄票登记人-后台帐号
     */
    private Long mailTickUserId;

    /**
     * 寄票登记部分-寄票状态:0-未寄票;1-已寄票;
     */
    private Integer mailTickStatus;

    /**
     * 寄票登记部分-寄票时间
     */
    private Date mailTickTime;

    /**
     * 寄票登记部分-快递公司ID
     */
    private Long expressCompanyId;

    /**
     * 寄票登记部分-快递单号
     */
    private String expressNo;

    /**
     * 回款登记部分-回款状态:0-未回款;1-部分回款;2全部回款;
     */
    private Integer backAccountStatus;

    /**
     * 回款登记部分-回款登记方式记录:0-初始;10-手动;11-流水;
     */
    private Integer backAccountModeRecord;

    /**
     * 回款登记部分-最后更新人-sysUserId
     */
    private Long backAccountUserId;

    /**
     * 回款登记部分-最后更新时间
     */
    private Date backAccountTime;

    /**
     * 备注
     */
    private String remark;

    /**
     * 后台操作人员备注
     */
    private String remark2;

    private Integer serviceId;

    private String serviceNo;

    /**
     * 订单类型-订单来源渠道
     */
    private String serviceName;

    /**
     * 统一订单 项目ID
     */
    private Long sysOrgId;

    /**
     * 统一订单 企业ID
     */
    private Long sysVirtId;

    /**
     * 外部系统 项目ID 一般是指 服务之窗 或 福利商城
     */
    private Long outOrgId;

    /**
     * 外部系统 企业ID 一般是指 服务之窗 或 福利商城
     */
    private Long outVirtId;

    private Integer relationMode;

    /**
     * 发票申请部分-发票申请号 invoice_apply_sn 内部生成的Sn
     */
    private String invoiceNo;

    /**
     * 发票申请部分-发票申请人Id-后台帐号
     */
    private Long applyUserId;

    /**
     * 发票申请部分-发票申请时间
     */
    private Date applyTime;

    /**
     * 发票申请部分-开票申请金额:商品或流水累加
     */
    private BigDecimal invoiceApplyAmount;

    /**
     * 发票申请部分-减免金额
     */
    private BigDecimal freeAmount;

    /**
     * 发票申请部分-实际金额
     */
    private BigDecimal realAmount;

    /**
     * 发票申请部分-初始为真实金额(开票申请金额-减免金额),如果有回款，这个数值是会相映的减的
     */
    private BigDecimal noCheckCount;

    /**
     * 发票申请部分-税率-unified_tax_rate.id
     */
    private String taxRate;

    /**
     * 发票申请部分-开票抬头
     */
    private String invoiceTitle;

    /**
     * 发票申请部分-发票类型
     */
    private Integer invoiceType;

    /**
     * 发票申请审核部分-审核人Id-后台帐号
     */
    private Long auditUserId;

    /**
     * 发票申请审核部分-审核状态 1-未审核;2-已同意;3-已拒绝
     */
    private Integer auditStatus;

    /**
     * 发票申请审核部分-审核时间
     */
    private Date auditTime;

    /**
     * 开票进展部分-开票进展状态:0-待开票(原:未邮寄);1-已邮寄(弃用);2-已作废;10-开票中;11-已开票;
     */
    private Integer invoiceStatus;

    /**
     * 开票进展部分-最后更新人-sysUserId
     */
    private Long invoiceProgressingUserId;

    /**
     * 开票进展部分-最后更新时间
     */
    private Date invoiceProgressingTime;

    /**
     * 发票登记部分-开票登记人-后台帐号
     */
    private Long makeInvoiceUserId;

    /**
     * 发票登记部分-开票状态 0-未开票;1-已开票;2-重新开票;
     */
    private Integer makeInvoiceStatus;

    /**
     * 发票登记部分-开票时间
     */
    private Date makeInvoiceTime;

    /**
     * 领票部分-领票状态:0-未领票;1-已领票;
     */
    private Integer receiveInvoiceStatus;

    /**
     * 领票部分-最后更新人-sysUserId
     */
    private Long receiveInvoiceUserId;

    /**
     * 领票部分-最后更新时间
     */
    private Date receiveInvoiceTime;

    private Long errorCheckRelation01;

    private Long errorCheckRelation02;

    private static final long serialVersionUID = 1L;
}