package cn.superdesk.uniorder.dao.entity.invoice.supplier;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import lombok.Data;
import lombok.ToString;

@Data
@ToString
public class UnifiedSupplierInv implements Serializable {
    private Long id;

    /**
     * 发票号
     */
    private String invoiceNumber;

    /**
     * 发票申请号
     */
    private String invoiceSn;

    private Long saleId;

    private String saleName;

    /**
     * 发票申请部分-发票申请人名字-后台帐号
     */
    private String applyUserName;

    /**
     * 发票申请部分-发票申请人Id-后台帐号
     */
    private Long applyUserId;

    /**
     * 发票申请部分-发票申请时间
     */
    private Date applyTime;

    /**
     * 发票申请审核部分-审核人名字-后台帐号
     */
    private String auditUserName;

    /**
     * 发票申请审核部分-审核人Id-后台帐号
     */
    private Long auditUserId;

    /**
     * 发票申请审核部分-审核状态:1-未审核;2-已同意;3-已拒绝;
     */
    private Integer auditStatus;

    /**
     * 发票申请审核部分-审核时间
     */
    private Date auditTime;

    /**
     * 发票登记部分-开票登记人-后台帐号
     */
    private String makeInvoiceUserName;

    /**
     * 发票登记部分-开票登记人-后台帐号
     */
    private Long makeInvoiceUserId;

    /**
     * 发票登记部分-开票登记时间
     */
    private Date makeInvoiceTime;

    /**
     * 发票登记部分-发票登记状态:0-未登记;1-已登记;2-重新开票;
     */
    private Integer makeInvoiceStatus;

    /**
     * 寄票登记部分-快递公司ID
     */
    private Long expressCompanyId;

    /**
     * 寄票登记部分-快递单号
     */
    private String expressNo;

    /**
     * 开票抬头
     */
    private String invoiceTitle;

    /**
     * 备注
     */
    private String remark;

    private Integer invoiceType;

    /**
     * 寄票登记部分-寄票时间
     */
    private Date mailTickTime;

    /**
     * 寄票登记部分-寄票登记人-后台帐号
     */
    private Long mailTickUserId;

    /**
     * 寄票登记部分-寄票状态:0-未寄票;1-已寄票;
     */
    private Integer mailTickStatus;

    /**
     * 发票状态 0未邮寄 1已邮寄 2已作废
     */
    private Integer invoiceStatus;

    /**
     * 回款状态 0未回款 1部分回款 2全部回款
     */
    private Integer backAccountStatus;

    /**
     * 对账单数量
     */
    private Integer accountingOrderQuantity;

    private Integer orderQuantity;

    private BigDecimal orderAmount;

    /**
     * 订单商品item数量累加
     */
    private Integer goodsQuantity;

    /**
     * 订单商品item的数量累加
     */
    private Integer goodsItemQuantity;

    /**
     * 商品销售金额(统一订单)
     */
    private BigDecimal goodsAmount;

    /**
     * 商品成本金额(统一订单)
     */
    private BigDecimal goodsCostAmount;

    private static final long serialVersionUID = 1L;
}