package cn.superdesk.uniorder.dao.entity.scheduler;

import java.io.Serializable;
import java.util.Date;

import lombok.Data;
import lombok.ToString;

@Data
@ToString
public class SysQuartzScheduleTaskStatementOfAccountJd implements Serializable {
	/**
	 * ID
	 */
	private Long id;

	/**
	 * 对账单 创建维度:0-订单;1-商品;2-流水;
	 */
	private Integer dimCreateBy;

	/**
	 * 对账单名 eg:某某企业 12月对账单
	 */
	private String statementOfAccountName;

	/**
	 * 对账单类型 1-客户结算;2-供应商结算;21-供应商结算-京东;
	 */
	private Integer statementOfAccountType;

	private Integer serviceId;
	private String  serviceNo;

	/**
	 * 订单类型-订单来源渠道
	 */
	private String serviceName;

	/**
	 * 统一订单 项目ID
	 */
	private Long sysOrgId;
	/**
	 * 统一订单 企业ID
	 */
	private Long sysVirtId;
	/**
	 * 服务之窗 项目ID
	 */
	private Long outOrgId;
	/**
	 * 服务之窗 企业ID
	 */
	private Long outVirtId;
	/**
	 * 商户ID 内部
	 */
	private Long sysMerchantId;

	/**
	 * 商户ID 外部
	 */
	private Long outMerchantId;

	private Date cycleBeginTime;
	private Date cycleEndTime;

	/**
	 * 状态：1暂停、0启用 | 单纯标记能不能去执行而已
	 */
	private Integer isPause;

	/**
	 * sys_quartz_job.id
	 */
	private Long jobId;

	/**
	 * 产品(⑧支持核对编号查询) 批次Id
	 */
	private String batchId;

	/**
	 * 产品(③支持任务状态下拉查询：任务状态：待执行、执行中、执行成功、执行失败) 说明 前端上传完Excel与提交完表单后 后端创建任务 任务状态为 待执行 |
	 */
	private Integer runState;

	/**
	 * 产品(②支持导入状态下拉查询：导入状态：成功、失败) 说明 Excel的数据全部入库视之为 导入状态 成功 | 任务运行状态：-1-失败;0-待命;1-成功
	 */
	private Integer processState;

	/**
	 * 产品(⑤支持核对状态下拉查询：核对状态：正常、异常)
	 */
	private Integer checkState;

	/**
	 * 产品(④支持账单状态下拉查询：账单状态：待确认、已确认、已取消) | 对账单(结算单)状态:-1-已取消;0-未确认(待确认);1-已确认;2-已拒绝;3-待提交;
	 */
	private Integer accountingStatus;

	/**
	 * 备注
	 */
	private String remark;

	private Date createTime;

	private Long createUserId;

	private Date updateTime;

	private Long updateUserId;

	private Date runTime;

	private Date processTime;

	private Date checkTime;

	private Date finishTime;

	/**
	 * 对账单编号
	 */
	private String accountingOrderSn;

	/**
	 * 对账单json
	 */
	private String result;

	/**
	 * 参数json ,记录 什么条件生成
	 */
	private String params;

	/**
	 * 中间参数 快照
	 */
	private String paramsSnapshot;

	private static final long serialVersionUID = 1L;
}