package cn.superdesk.uniorder.dto.param.accounting.unified.supplier;

import cn.superdesk.uniorder.common.pagination.AnBaseQueryCriteria;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.ToString;

import java.util.List;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 2021/7/7 下午3:26
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/7/7 下午3:26
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
@ToString
public class AccountingSupplierNotYetDimGoodsCriteria extends AnBaseQueryCriteria {

//// hasOutVirtId 0 条件忽略 1 要有企业 2 没有企业
//params.put("hasOutVirtId",getInteger("hasOutVirtId"));
//
//// 订单编号
//params.put("orderSn", getString("orderSn"));
//
//// 业务系统的订单状态 不是统一订单的统一订单状态 mark by linjinyu at 20210305
//params.put("orderState", getInteger("orderState"));
//params.put("orderStateName", getString("orderStateName"));


//<result column="order_locking_customer" property="orderLockingCustomer" jdbcType="INTEGER"/>
//<result column="order_locking_supplier" property="orderLockingSupplier" jdbcType="INTEGER"/>
//<result column="goods_locking_customer" property="goodsLockingCustomer" jdbcType="INTEGER"/>
//<result column="goods_locking_supplier" property="goodsLockingSupplier" jdbcType="INTEGER"/>

//<result column="create_time"  property="createTime" jdbcType="TIMESTAMP"/>
//<result column="update_time"  property="updateTime" jdbcType="TIMESTAMP"/>
//<result column="pay_time"     property="payTime"    jdbcType="TIMESTAMP"/>
//<result column="send_time"    property="sendTime"   jdbcType="TIMESTAMP"/>
//<result column="finish_time"  property="finishTime" jdbcType="TIMESTAMP"/>

//params.put("serviceNo", getString("serviceNo"));
//
//// 下单人 企业
//params.put("purchaseVirtId", getLong("purchaseVirtId"));
//params.put("purchaseVirtName", getString("purchaseVirtName"));
//
//// 供应商名称
//params.put("supplierId", getLong("supplierId"));
//params.put("supplierName", getString("supplierName"));
//
//// 订单金额 =
//params.put("amount", getString("amount"));
//
//// 下单时间
//params.put("startTime", getString("startTime"));
//params.put("endTime", getString("endTime"));
//
//// 供应商对账状态  未对账 2
//params.put("accountingStateSupplier", CommonAccountingStateEnum.未对账.getKey());

	@ApiModelProperty("hasOutVirtId:0-条件忽略;1-要有企业;2-没有企业;")
	private Integer hasOutVirtId;

	@ApiModelProperty("订单编号")
	private String orderSn;

	@ApiModelProperty("订单类型:1-订单;2-售退(退单);")
	private Integer orderType;

	@ApiModelProperty("订单状态")
	private Integer orderState;
	@ApiModelProperty("订单状态")
	private String  orderStateName;

	@ApiModelProperty("客户结算-订单锁定:0-正常;1-销定;")
	private Integer orderLockingCustomer;
	@ApiModelProperty("供应商结算-订单锁定:0-正常;1-销定;")
	private Integer orderLockingSupplier;
	@ApiModelProperty("客户结算-商品锁定:0-正常;1-销定;")
	private Integer goodsLockingCustomer;
	@ApiModelProperty("供应商结算-商品锁定:0-正常;1-销定; 对映界面 只显示售后中(挂载订单)")
	private Integer goodsLockingSupplier;

	@ApiModelProperty("")
	private String serviceNo;

	@ApiModelProperty("下单人 企业Id outVirtId eq")
	private Integer purchaseVirtId;
	@ApiModelProperty("下单人 企业名称 outVirtName like")
	private String  purchaseVirtName;

	@ApiModelProperty("下单人 Id eq")
	private Integer purchaseUserId;
	@ApiModelProperty("下单人 名称 like %xxx%")
	private String  purchaseUserName;
	@ApiModelProperty("下单人 电话 eq")
	private String  purchasePhone;

	@ApiModelProperty("供应商Id")
	private Integer supplierId;
	@ApiModelProperty("供应商名称")
	private String  supplierName;

	@ApiModelProperty("订单金额")
	private String amount;

	@ApiModelProperty("时间类型:1-createTime(下单时间);2-updateTime(最后更新时间);3-payTime(支付时间);4-sendTime(发货时间);5-finishTime(完成时间);6-accountingTime(结算时间);")
	private Integer dateType;
	@ApiModelProperty("startTime: 2021-07-02")
	private String  startTime;
	@ApiModelProperty("endTime: 2021-07-03")
	private String  endTime;

	// CommonAccountingStateEnum.未对账.getKey() 不能设置默认值
	@ApiModelProperty("供应商对账状态:2-未对账;")
	private Integer accountingStateSupplier;

	/****************************************** 勾选导出 start ******************************************/

	private List<Long> unifiedOrderGoodsIds;

}
