package cn.superdesk.uniorder.dto.param.operationCenter.order;

import cn.superdesk.uniorder.common.pagination.PageQueryParam;
import lombok.Data;

import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @Author : zx
 * @Create : 2023/3/24 11:31
 * Description : 运营中心PC 订单管理列表入参
 */

@Data
public class OperationCenterOrderParam implements Serializable {
    @NotNull
    private Integer pageNumber;//页码
    @NotNull
    private Integer pageSize;//每页数量

    //运营商id
    private String operatorId;
    //业务平台 业务平台编码 ①FLSC：福利商城②FWZC：服务之窗
    private String bizPlatformCode;
    //订单类型 订单类型编码1）FLSC：福利商城（2）FZS：蜂助手
    private String orderTypeCode;
    //业务类型 1-订单 2-售后单
    private Integer orderBizTypeId;
    //支付状态 1-未支付，2-已支付，3-未退款，4-已退款
    private Integer orderPayStatus;
    //支付方式：1：余额支付，11：后台支付，21：微信支付，24：组合支付，25：云闪付，26：饭卡支付，31：华侨城酒店积分支付，40：餐卡支付，41：餐卡组合支付
    private Integer bizOrderPayTypeId;

    //交易状态  1-未完成，2-已完成，3-已取消
    private Integer transactionStatusId;
    //订单编号
    private String orderSn;

    //订单时间 开始时间
    private String orderBeginTime;
    //订单截止 时间
    private String orderEndTime;
    //1-支付时间 2-发货时间 3-完成时间
    private Integer timeType;



}
