package cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.proxyclient;

import com.fasterxml.jackson.annotation.JsonProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;


/**
 * @Description: 代客下单
 * @Author: linjinyu
 * @CreateDate: 2021/4/26 上午11:06
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/4/26 上午11:06
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class ProxyClientOrderGoodsReceiveParam implements Serializable {

	private Long goodsId;//	商品Id		必须	业务方商品Id (商品表Id)
	private Long outSnapshotOrderGoodsId;//	订单商品快照Id		必须	业务方订单商品快照Id (订单商品表Id)，业务系统自增编号，多次推单做数据合并使用

	private String goodsName;//	商品名称		必须	业务方商品各称
	private String goodsAlias;// 商品名称 别名

	private Integer    quantity;//	商品数量		必须
	private BigDecimal sellingPrice;//    商品销售单价 必须
	private BigDecimal costPrice;//	商品销售单个成本价		必须
	private String     unit;//	商品单位		非必须	个，件


	private BigDecimal merchTaxRate; //	商户税率	浮点数（新增）
	private String     merchTaxCode; //	商户税率编码	字符串	（新增）
	private Long       merchTaxId;//	商户税率ID	整型	（新增）


	private BigDecimal operationTaxRate;//	平台税率	    浮点数	（新增）
	private String     operationTaxCode;//	平台税率编码	字符串	（新增）
	private Long       operationTaxId;//	平台税率ID	整型	（新增）

	private Long   cateIdLv1;//	一级分类Id		非必须
	private String cateNameLv1;//	一级分类名称		非必须
	private Long   cateIdLv2;//	二级分类Id		非必须
	private String cateNameLv2;//	二级分类名称		非必须
	private Long   cateIdLv3;//	三级分类Id		非必须
	private String cateNameLv3;//	三级分类名称		非必须


	private String selfOption;// 规格

	private String goodsParams;// 商品属性		非必须	传json字串
}
