package cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.unified;

import cn.superdesk.uniorder.common.json.deserializer.DateTimeConvertDeserializer;
import cn.superdesk.uniorder.common.json.serializer.DateTimeConvertSerializer;
import cn.superdesk.uniorder.dto.receive.consumer.BaseReceiveParam;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import lombok.Data;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @Description: 用于一般订单 接收 已对过 20200714 1446
 * @Author: linjinyu
 * @CreateDate: 7/14/20 2:46 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 7/14/20 2:46 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class UnifiedOrderReceiveParam extends BaseReceiveParam {

	/**
	 * "orderid": 53322,
	 */
	@JsonProperty("orderid")
	private Long orderId;
	/**
	 * "parent_order_id": 0,
	 */
	@JsonProperty("parent_order_id")
	private Long parentOrderId;

	/**
	 * "ordersn": "ME20200511190608727927",
	 */
	@JsonProperty("ordersn")
	private String orderSn;
	/**
	 * "parent_ordersn": "",
	 */
	@JsonProperty("parent_ordersn")
	private String parentOrderSn;


	/**
	 * "enterpriseId": "4138",
	 */
	@JsonProperty("enterpriseId")
	private Long   enterpriseId;
	/**
	 * "organizationId": "313",
	 */
	@JsonProperty("organizationId")
	private Long   organizationId;
	/**
	 * "organization_name": "超级前台湘江",
	 */
	@JsonProperty("organization_name")
	private String organizationName;
	/**
	 * "enterprise_name": "超级前台湘江内购",
	 */
	@JsonProperty("enterprise_name")
	private String enterpriseName;


	/**
	 * "order_type": "3",
	 */
	@JsonProperty("order_type")
	private Integer    orderType;
	/**
	 * "paytype": "0",
	 */
	@JsonProperty("paytype")
	private Integer    payType;
	/**
	 * "status": "1",
	 */
	@JsonProperty("status")
	private Integer    status;
	/**
	 * "price": "130.85",
	 */
	@JsonProperty("price")
	private BigDecimal price;


	/**
	 * "expresssn": "",
	 */
	@JsonProperty("expresssn")
	private String     expressSn;
	/**
	 * "dispatchname": "快递",
	 */
	@JsonProperty("dispatchname")
	private String     dispatchName;
	/**
	 * "dispatchtype": "0",
	 */
	@JsonProperty("dispatchtype")
	private Integer    dispatchType;
	/**
	 * 用户产生的运费
	 * "dispatchprice": "0.00",
	 */
	@JsonProperty("dispatchprice")
	private BigDecimal dispatchPrice;
	/**
	 * 京东产生的运费 TODO 詹家豪 20201214 1555 就说要了加个字段
	 */
	@JsonProperty("dispatchprice_jd")
	private BigDecimal dispatchPriceJd;


	/**
	 * "createtime": "2020-05-11 19:06:08",
	 */
	@JsonProperty("createtime")
	@JsonSerialize(using = DateTimeConvertSerializer.class)
	@JsonDeserialize(using = DateTimeConvertDeserializer.class)
	private Date createTime;
	/**
	 * "paytime": "2020-05-11 19:06:16",
	 */
	@JsonProperty("paytime")
	@JsonSerialize(using = DateTimeConvertSerializer.class)
	@JsonDeserialize(using = DateTimeConvertDeserializer.class)
	private Date payTime;
	/**
	 * "sendtime": "1970-01-01 08:00:00",
	 */
	@JsonProperty("sendtime")
	@JsonSerialize(using = DateTimeConvertSerializer.class)
	@JsonDeserialize(using = DateTimeConvertDeserializer.class)
	private Date sendTime;
	/**
	 * "finishtime": "1970-01-01 08:00:00",
	 */
	@JsonProperty("finishtime")
	@JsonSerialize(using = DateTimeConvertSerializer.class)
	@JsonDeserialize(using = DateTimeConvertDeserializer.class)
	private Date finishTime;


	/**
	 * "companyName": "不开发票",
	 */
	@JsonProperty("companyName")
	private String companyName;
	/**
	 * "taxpayersIDcode": "",
	 */
	@JsonProperty("taxpayersIDcode")
	private String taxpayersIDcode;


	/**
	 * "invoice": "",
	 */
	@JsonProperty("invoice")
	private String  invoice;
	/**
	 * "invoiceid": "0",
	 */
	@JsonProperty("invoiceid")
	private Long    invoiceId;
	/**
	 * "invoiceType": "0",
	 */
	@JsonProperty("invoiceType")
	private Integer invoiceType;
	/**
	 * "invoiceBank": "",
	 */
	@JsonProperty("invoiceBank")
	private String  invoiceBank;
	/**
	 * "invoiceAccount": "",
	 */
	@JsonProperty("invoiceAccount")
	private String  invoiceAccount;


	/**
	 * "isverify": "0",
	 */
	@JsonProperty("isverify")
	private Integer isVerify;
	/**
	 * "isvirtual": "0",
	 */
	@JsonProperty("isvirtual")
	private Integer isVirtual;
	/**
	 * "virtual": "0",
	 */
	@JsonProperty("virtual")
	private Long    virtual;
	/**
	 * "deleted": "0",
	 */
	@JsonProperty("deleted")
	private Integer deleted;

	/**
	 * "carrier": "a:0:{}",
	 */
	@JsonProperty("carrier")
	private String carrier;


	/**
	 * "address": "a:18:{s:2:\"id\";s:4:\"3391\";s:7:\"uniacid\";s:2:\"17\";s:6:\"openid\";s:23:\"wap_user_17_17773191107\";s:8:\"realname\";s:6:\"岳琳\";s:6:\"mobile\";s:11:\"17773191107\";s:8:\"province\";s:6:\"湖南\";s:4:\"city\";s:9:\"长沙市\";s:4:\"area\";s:9:\"雨花区\";s:4:\"town\";s:15:\"候家塘街道\";s:7:\"address\";s:34:\"韶山北路298号紫金苑6栋907\";s:9:\"isdefault\";s:1:\"0\";s:7:\"zipcode\";s:0:\"\";s:7:\"deleted\";s:1:\"0\";s:20:\"jd_vop_province_code\";s:2:\"18\";s:16:\"jd_vop_city_code\";s:4:\"1482\";s:18:\"jd_vop_county_code\";s:5:\"48937\";s:16:\"jd_vop_town_code\";s:5:\"53600\";s:11:\"jd_vop_area\";s:19:\"18_1482_48937_53600\";}",
	 */
	@JsonProperty("address")
	private String address;
	/**
	 * "addressid": "3391",
	 */
	@JsonProperty("addressid")
	private Long   addressId;


	/**
	 * "realnameId": "5917",
	 */
	@JsonProperty("realnameId")
	private Long   realNameId;
	/**
	 * "realname": "邱丽萍",
	 */
	@JsonProperty("realname")
	private String realName;

	/**
	 * "mobile": "17773191107",
	 */
	@JsonProperty("mobile")
	private String mobile;
	/**
	 * "arealname": "岳琳",
	 */
	@JsonProperty("arealname")
	private String aRealName;
	/**
	 * "amobile": "17773191107",
	 */
	@JsonProperty("amobile")
	private String aMobile;
	/**
	 * "aprovince": "湖南",
	 */
	@JsonProperty("aprovince")
	private String aProvince;
	/**
	 * "acity": "长沙市",
	 */
	@JsonProperty("acity")
	private String aCity;
	/**
	 * "aarea": "雨花区",
	 */
	@JsonProperty("aarea")
	private String aArea;
	/**
	 * "atown": "候家塘街道",
	 */
	@JsonProperty("atown")
	private String aTown;
	/**
	 * "aaddress": "韶山北路298号紫金苑6栋907",
	 */
	@JsonProperty("aaddress")
	private String aAddress;


	/**
	 * "examineId": "",
	 */
	@JsonProperty("examineId")
	private String examineId;
	/**
	 * "examine_name": "",
	 */
	@JsonProperty("examine_name")
	private String examineName;


	/****************************************** 代客专用 Excel 导入后台账号 start mark by linjinyu at 20201221 ******************************************/
	@JsonProperty("create_account")
	private String operAccount;
	@JsonProperty("create_name")
	private String operName;
	/****************************************** 代客专用 Excel 导入后台账号   end mark by linjinyu at 20201221 ******************************************/


	/**
	 * "merchid": "8",
	 */
	@JsonProperty("merchid")
	private Long   merchId;
	/**
	 * "merch_name": "超级前台自营京东旗舰店",
	 */
	@JsonProperty("merch_name")
	private String merchName;


	/**
	 * "address_realname": "岳琳",
	 */
	@JsonProperty("address_realname")
	private String addressRealName;
	/**
	 * "address_mobile": "17773191107",
	 */
	@JsonProperty("address_mobile")
	private String addressMobile;
	/**
	 * "address_province": "湖南",
	 */
	@JsonProperty("address_province")
	private String addressProvince;
	/**
	 * "address_city": "长沙市",
	 */
	@JsonProperty("address_city")
	private String addressCity;
	/**
	 * "address_area": "雨花区",
	 */
	@JsonProperty("address_area")
	private String addressArea;
	/**
	 * "address_town": "候家塘街道",
	 */
	@JsonProperty("address_town")
	private String addressTown;
	/**
	 * "address_address": "湖南 长沙市 雨花区 候家塘街道 韶山北路298号紫金苑6栋907",
	 */
	@JsonProperty("address_address")
	private String addressAddress;

	/**
	 * "detail_url": "https://wxn.avic-s.com/web/index.php?c=site&a=entry&m=superdesk_shopv2&do=web&r=order.detail&id=53322",
	 */
	@JsonProperty("detail_url")
	private String detailUrl;
	/**
	 * "remark": "",
	 */
	@JsonProperty("remark")
	private String remark;

	/**
	 * 目前只有超级前台-福利
	 * "message_id":"20210907173938-57a306a58362b1bd17d024521c3ce752"
	 */
	@JsonProperty("message_id")
	private String messageId;


	private List<UnifiedOrderGoodsReceiveParam> goods;
}
