package cn.superdesk.uniorder.dto.vo.accounting.score.customer;


import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 6/28/20 10:33 AM
 * @UpdateUser: linjinyu
 * @UpdateDate: 6/28/20 10:33 AM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class AccountingScoreCustomerVo implements Serializable {

	private Long id;

	//	积分批次
	private String batchs;


	//	积分类型
	/**
	 * 积分类型id（如果是微信支付，显示0）
	 */
	private Integer creditType;
	/**
	 * 积分类型
	 */
	private String  creditName;

	//	结算单编号
	private String accountingOrderSn;


	//	企业名称
	private Long   enterpriseId;
	private String enterpriseName;


	//	账单联系人
	private Integer purchaseUserId;
	private String  purchaseUserName;
	private String  purchasePhone;
	private String  purchaseAddress;


	//	订单数量
	/**
	 * 统计结算单-订单数量
	 */
	private Integer quantityOrder;
	/**
	 * 统计结算单-订单商品数
	 */
	private Integer quantityOrderGoods;
	/**
	 * 统计结算单-积分流水数
	 */
	private Integer quantityOrderCredit;


	//	积分总数
	private BigDecimal accountingAmount;


	//	结算单状态
	/**
	 * 对账单(结算单)状态:0-未确认;1-已确认;-1-已取消;
	 */
	private Integer accountingStatus;
	/**
	 * 程序处理
	 */
	private String  accountingStatusName;


	//	邮件状态
	/**
	 * 是否发邮件:0-不发;1-发;
	 */
	private Integer isSendEmail;
	private Date    sendEmailTime;
	/**
	 * 程序处理
	 */
	private String  sendEmailStatusName;


	//	发票状态
	/**
	 * 开票状态:0-未开票;1-已开票;2-部分开票;
	 */
	private Integer invoiceStatus;
	/**
	 * 程序处理
	 */
	private String  invoiceStatusName;
	/**
	 * 发票类型(关联表:unified_inv_type):1-增值税普票;2-增值税专票;
	 */
	private Integer invoiceType;
	/**
	 * 开票抬头
	 */
	private String  invoiceCompanyName;
	/**
	 * 纳税人代码
	 */
	private String  invoiceTaxpayersIDCode;

	// 对账时间
	private Date   createTime;
	private Long   createUserId;
	private String createUserName;

	private Date   updateTime;
	private Long   updateUserId;
	private String updateUserName;

	private Date startTime;
	private Date endTime;

	private String remark;

}
