package cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 2021/4/1 下午12:16
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/4/1 下午12:16
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class CustomerUnAccountingDimGoodsVo implements Serializable {

	// 非mapper产生 start
	private Long   accountingOrderId;
	private String accountingOrderSn;
	// 非mapper产生 end


	// uog.id as unified_order_goods_id,
	private Long   unifiedOrderGoodsId;
	// uo.id as unified_order_id,
	private Long   unifiedOrderId;
	private String orderSn;

	/****************************************** 订单表 start ******************************************/
	private BigDecimal orderAmount;
	private BigDecimal orderCostAmount;
	private BigDecimal orderTransportAmount;

	private Long   outOrgId;
	private String outOrgName;

	private Long   purchaseVirtId;
	private String purchaseVirtName;

	private Long   purchaseUserId;
	private String purchaseUserName;
	private String purchasePhone;

	// uo.express_sn
	private String expressSn;
	// uo.express
	private String express;
	// uo.express_company
	private String expressCompany;

	private Integer orderState;
	private String  orderStateName;

	private Long   saleId;
	private String saleName;

	private Integer payType;
	private String  payTypeName;
	private Integer payState;
	private String  payStateName;


	private String serviceName;
	private String serviceNo;


	private String recUserName;
	private Long   recUserId;
	private String recUserPhone;
	private String recAddress;


	private Date createTime;
	private Date updateTime;
	/**
	 * 订单 支付时间
	 */
	private Date payTime;
	/**
	 * 订单 发货时间
	 */
	private Date sendTime;
	/**
	 * 订单 完成时间
	 */
	private Date finishTime;

	// uo.remarks
	private String remarks;

	/****************************************** 订单表   end ******************************************/

	/****************************************** 订单商品表 start ******************************************/

	private Long   goodsId;
	private Long   outSnapshotOrderGoodsId;
	private String goodsName;
	private String goodsAlias;


	private Long   cateIdLv1;
	private String cateNameLv1;
	private Long   cateIdLv2;
	private String cateNameLv2;
	private Long   cateIdLv3;
	private String cateNameLv3;
	private String selfOption;
	private String unit;


	//	<!-- 发票申请状态 是否已申请 0-未申请;1-已申请; -->
//	<!--		uoc.invoice_apply_status,-->
//	<result column="invoice_apply_status" property="invoiceApplyStatus" jdbcType="INTEGER"/>
//    private Integer invoiceApplyStatus;
//    private String  invoiceApplyStatusName;
	//	<!-- 开票状态 是否已登记开票 0-未登记;1-已登记; -->
//	<!--		uoc.invoice_make_status,-->
//	<result column="invoice_make_status" property="invoiceMakeStatus" jdbcType="INTEGER"/>
//    private Integer invoiceMakeStatus;
//    private String  invoiceMakeStatusName;
	//	<!-- 回款状态 是否回款 0-未回款;1-已回款; -->
//	<!--		uoc.back_status,-->
//	<result column="back_status" property="backStatus" jdbcType="INTEGER"/>
//    private Integer backStatus;
//    private String  backStatusName;


	// uog.price,
	private BigDecimal price;
	// uog.cost_price,
	private BigDecimal costPrice;
	// uog.quantity,
	private Integer    quantity;
	private BigDecimal goodsAmount;
	private BigDecimal goodsCostAmount;


	/**
	 * 财务编码
	 */
	private String     fiscalCode;
	/**
	 * 税务编码
	 */
	private String     taxCode;
	/**
	 * 税率 %
	 */
	private BigDecimal taxRate;
	/**
	 * 商户税率ID-20210413-添加
	 */
	private Long       merchTaxId;
	/**
	 * 商户税率编码-20210413-添加
	 */
	private String     merchTaxCode;
	/**
	 * 商户税率-20210413-添加
	 */
	private BigDecimal merchTaxRate;
	/**
	 * 平台税率ID-20210413-添加
	 */
	private Long       operationTaxId;
	/**
	 * 平台税率编码-20210413-添加
	 */
	private String     operationTaxCode;
	/**
	 * 平台税率-20210413-添加
	 */
	private BigDecimal operationTaxRate;


	// uoc.accounting_state_customer 客户对账:1-已对账;2-未对账
	private Integer accountingStateCustomer;
	private String  accountingStateCustomerName;
	// uoc.accounting_state_supplier 供应商对账:1-已对账;2-未对账
	private Integer accountingStateSupplier;
	private String  accountingStateSupplierName;
}
