package cn.superdesk.uniorder.dto.vo.accounting.unified.supplier;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

@Data
public class UnifiedSupplierStatementOfAccountVo implements Serializable {

	private static final long serialVersionUID = -1766638008250239289L;

	/****************************************** 走继承 extends AccountingUnifiedSupplier 走不了 start ******************************************/
	private Long    id;
	// 供应商 对账单 创建维度:0-订单;1-商品;
	//    <!--		aus.dim_create_by,-->
//		<result column="dim_create_by" property="dimCreateBy" jdbcType="INTEGER"/>
	private Integer dimCreateBy;
	/**
	 * 对账单编号
	 */
	private String  accountingOrderSn;
	/**
	 * 对账单状态0-未确认，1-已确认，-1-已取消,2-已拒绝
	 */
	private Integer accountingStatus;
	private String  accountingStatusName;
	/**
	 * 开票状态，0-未开票，1-已开票，2-部分开票
	 */
	private Integer invoiceStatus;
	private String  invoiceStatusName;

	private Long   saleId;
	/**
	 * 供应商名称
	 */
	private String saleName;

	private String  invoiceTitle;
	private String  taxCode;
	private Integer invoiceType;
	private String  address;

	private Integer isSendEmail;
	private Date    sendEmailTime;


	private Date startTime;
	private Date endTime;


	private Integer backAccountStatus;

	/**
	 * 出账时间
	 */
	private Date   createTime;
	private Long   createUserId;
	private String createUserName;

	private Date   updateTime;
	private Long   updateUserId;
	private String updateUserName;

	/****************************************** 走继承 start ******************************************/

	/**
	 * 对账单金额（元）
	 */
	private BigDecimal amount;
	private BigDecimal amountWithFreight;


//<!--		auso.amount_with_freight,-->
//<!--		auso.cost_amount_with_freight,-->
//<result column="amount_with_freight" property="amountWithFreight" jdbcType="DECIMAL"/>
//<result column="cost_amount_with_freight" property="costAmountWithFreight" jdbcType="DECIMAL"/>


	/****************************************** 补丁程序修正 start ******************************************/

	/******************************** 前端显示 start ********************************/
	// 商品成本-商品退成本
	private BigDecimal costAmount;
	// 商品成本-商品退成本 + 运费
	private BigDecimal costAmountWithFreight;
	/******************************** 前端显示   end ********************************/

	// 订单记录成本 累加
	private BigDecimal orderCostAmount;
	// 订单记录运费 累加
	private BigDecimal orderTransportAmount;

	// 商品记录成本 累加
	private BigDecimal goodsCostAmount;
	// 商品记录运费 累加
	private BigDecimal goodsRefundCostAmount;
	// 商品记录运费 累加
	private BigDecimal goodsTransportAmount;
	/****************************************** 补丁程序修正   end ******************************************/


	/**
	 * 退单的 商品 销售金额累加
	 */
	private BigDecimal refundAmount;
	/**
	 * 退单的 商品 成本金额累加
	 */
	private BigDecimal refundCostAmount;

	/**
	 * 订单数量
	 */
	private Integer orderQuantity;


	private String remark;


}
