package cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.notyet;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description: 目前修改为
 * 1. 供应商 对账单 详情 导出
 * @Author: linjinyu
 * @CreateDate: 5/14/20 3:35 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 5/14/20 3:35 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class UnifiedOrderJoinGoodsOfSupplierStatementOfAccount implements Serializable {

	private static final long serialVersionUID = 1964454586516073535L;

	private Long   unifiedOrderGoodsId;
	private Long   unifiedOrderId;
	private String orderSn;

	private BigDecimal orderAmount;
	private BigDecimal orderCostAmount;
	private BigDecimal orderTransportAmount;

	private Long   outOrgId;
	private String outOrgName;

	private Long   purchaseVirtId;
	private String purchaseVirtName;

	//	uo.purchase_user_id, 没有 用户账号 只能用 这个Id 替代
	private Long   purchaseUserId;
	//	uo.purchase_user_name,
	private String purchaseUserName;
	//	uo.purchase_phone,
	private String purchasePhone;

	//"!物流名称", "!物流单号", "!运费",// add 20200819
	//	uo.express_sn,
	private String expressSn;
	//	uo.express,
	private String express;
	//	uo.express_company,
	private String expressCompany;

	private Integer orderState;
	private String  orderStateName;

	private Long   saleId;
	//	uo.sale_name,
	private String saleName;

	/**
	 * 支付方式
	 */
	private Integer payType;
	/**
	 * 支付方式名称
	 */
	private String  payTypeName;
	/**
	 * 付款状态
	 */
	private Integer payState;

	/**
	 * 支付状态名称
	 */
	private String payStateName;

	private String serviceName;
	private String serviceNo;


	private String recUserName;
	private Long   recUserId;
	private String recUserPhone;
	private String recAddress;


	/****************************************** recAddress 拆分字段 start ******************************************/
	private String addressProvince;
	private String addressCity;
	private String addressArea;
	private String addressTown;
	private String addressAddress;


	@ApiModelProperty("订单 下单时间")
	private Date createTime;
	@ApiModelProperty("订单 最后更新时间")
	private Date updateTime;
	@ApiModelProperty("订单 支付时间")
	private Date payTime;
	@ApiModelProperty("订单 发货时间")
	private Date sendTime;
	@ApiModelProperty("订单 完成时间")
	private Date finishTime;
	@ApiModelProperty("结算时间")
	private Date accountingTime;


	private Long   goodsId;
	private Long   outSnapshotOrderGoodsId;
	private String goodsName;
	private String goodsAlias;

	private Integer    quantity;
	// 必填 | 商品 单个 销售价
	private BigDecimal price;
	// 必填 | 商品 单个 成本价
	private BigDecimal costPrice;
	private BigDecimal goodsAmount;
	private BigDecimal goodsCostAmount;

	private Integer direction;

	private Long   cateIdLv1;
	private String cateNameLv1;
	private Long   cateIdLv2;
	private String cateNameLv2;
	private Long   cateIdLv3;
	private String cateNameLv3;
	private String selfOption;
	private String unit;

	/**
	 * 财务编码
	 */
	private String     fiscalCode;
	/**
	 * 税务编码
	 */
	private String     taxCode;
	/**
	 * 税率 %
	 */
	private BigDecimal taxRate;
	/**
	 * 商户税率ID-20210413-添加
	 */
	private Long       merchTaxId;
	/**
	 * 商户税率编码-20210413-添加
	 */
	private String     merchTaxCode;
	/**
	 * 商户税率-20210413-添加
	 */
	private BigDecimal merchTaxRate;
	/**
	 * 平台税率ID-20210413-添加
	 */
	private Long       operationTaxId;
	/**
	 * 平台税率编码-20210413-添加
	 */
	private String     operationTaxCode;
	/**
	 * 平台税率-20210413-添加
	 */
	private BigDecimal operationTaxRate;

	private String goodsParams;

	// uoc.accounting_state_customer 客户对账:1-已对账;2-未对账
	private Integer accountingStateCustomer;
	private String  accountingStateCustomerName;
	// uoc.accounting_state_supplier 供应商对账:1-已对账;2-未对账
	private Integer accountingStateSupplier;
	private String  accountingStateSupplierName;


	@ApiModelProperty("客户对账锁定:0-正常;1-销定")
	private Integer orderLockingCustomer;
	@ApiModelProperty("供应商对账锁定:0-正常;1-销定")
	private Integer orderLockingSupplier;
	@ApiModelProperty("客户对账锁定:0-正常;1-销定")
	private Integer goodsLockingCustomer;
	@ApiModelProperty("供应商对账锁定:0-正常;1-销定")
	private Integer goodsLockingSupplier;

}
