package cn.superdesk.uniorder.dto.vo.invoice.customer;

import cn.superdesk.uniorder.dto.vo.score.ScoreOrderReconciliationNotYetVo;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @Description: 发票申请管理(积分结算)(流水维度)-查看详情
 * @Author: linjinyu
 * @CreateDate: 7/28/20 4:59 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 7/28/20 4:59 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class InvoiceApplyDetailDimCreditVo implements Serializable {

	private static final long serialVersionUID = 1L;

	@ApiModelProperty("")
	private Long id;

	@ApiModelProperty("accounting_order_type 对账单类型 1-一般;2-积分;")
	private Integer accountingOrderType = 2;
	@ApiModelProperty("dim_create_by 对账单 创建维度:0-订单;1-商品;2-流水;")
	private Integer dimCreateBy         = 2;

	@ApiModelProperty("开票申请编号")
	private String invoiceNo;
	@ApiModelProperty("发票号")
	private String invoiceNumber;

	@ApiModelProperty("申请人Id")
	private Long   applyUserId;
	@ApiModelProperty("申请人")
	private String applyUserName;
	@ApiModelProperty("申请时间")
	private Date   applyTime;

	@ApiModelProperty("审核人Id")
	private Long    auditUserId;
	@ApiModelProperty("审核人")
	private String  auditUserName;
	@ApiModelProperty("审核状态:1-未审核;2-已同意;3-已拒绝;")
	private Integer auditStatus;
	@ApiModelProperty("审核时间")
	private Date    auditTime;

	@ApiModelProperty("开票人Id")
	private Long    makeInvoiceUserId;
	@ApiModelProperty("开票人")
	private String  makeUserName;
	@ApiModelProperty("开票状态:0-未开票;1-已开票;")
	private Integer makeInvoiceStatus;
	@ApiModelProperty("开票时间")
	private Date    makeInvoiceTime;

	@ApiModelProperty("发票抬头")
	private String invoiceTitle;
	@ApiModelProperty("备注")
	private String remark;

	@ApiModelProperty("")
	private Long   expressCompanyId;
	@ApiModelProperty("")
	private String expressCompanyName;
	@ApiModelProperty("")
	private String expressNo;

	@ApiModelProperty("")
	private BigDecimal backMoney;
	@ApiModelProperty("")
	private BigDecimal noBackMoney;
	@ApiModelProperty("")
	private Date       maxBackTime;

	@ApiModelProperty("流水")
	private List<ScoreOrderReconciliationNotYetVo> dzOrders;

}
