package cn.superdesk.uniorder.dto.vo.invoice.customer;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 7/30/20 5:52 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 7/30/20 5:52 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class InvoiceApplyPage implements Serializable {

	private static final long serialVersionUID = 1L;

	private Long id;

	private Integer accountingOrderType;
	private Integer dimCreateBy;


	private String  invoiceNo;// 开票申请编号
	private String  invoiceNumber;// 发票号
	private Integer invoiceStatus;// 发票状态 0未邮寄 1已邮寄 2已作废
	private String  invoiceTitle;// 发票抬头
	private Integer invoiceType;

	private String taxRate; // 外键 unified_tax_rate.id

	/****************************************** 申请部分 start ******************************************/
	private Long   applyUserId;// 申请人Id
	private String applyUserName;// 申请人
	private Date   applyTime;// 申请时间

	/****************************************** 审核部分 start ******************************************/
	private Long    auditUserId;// 审核人Id
	private String  auditUserName;// 审核人
	private Date    auditTime;// 审核时间
	private Integer auditStatus;// 审核状态 未审核1 已同意2 已拒绝3
	private String  auditStatusName; // 数据库没记录

	/****************************************** 开票登记部分 start ******************************************/
	private Long    makeInvoiceUserId;// 开票人Id
	private String  makeInvoiceUserName;//开票人
	private Date    makeInvoiceTime;//开票时间
	private Integer makeInvoiceStatus;//开票状态 0未开票 1 已开票
	private String  makeInvoiceStatusName; // 数据库没记录

	/****************************************** 寄票登记部分 start ******************************************/
	private Long    mailTickUserId;// 寄票人Id
	private String  mailTickUserName;//寄票人
	private Date    mailTickTime;// 寄票时间
	private Integer mailTickStatus;
	private String  mailTickStatusName;

	private Long   expressCompanyId;
	private String expressCompanyName;
	private String expressNo;

	private String remark;//备注
	private String remark2;//备注


	/****************************************** 差异点 start ******************************************/
	private Integer serviceId;
	private String  serviceNo;
	/**
	 * 订单类型-订单来源渠道
	 */
	private String  serviceName;

	/**
	 * 统一订单 项目ID
	 */
	private Long sysOrgId;
	/**
	 * 统一订单 企业ID
	 */
	private Long sysVirtId;
	/**
	 * 外部系统 项目ID 一般是指 服务之窗 或 企业福利
	 */
	private Long outOrgId;
	/**
	 * 外部系统 企业ID 一般是指 服务之窗 或 企业福利
	 */
	private Long outVirtId;
	/****************************************** 差异点   end ******************************************/


	/****************************************** 差异点 start ******************************************/
	// 订单数量
	private Integer    unifiedOrderCountQuantity;
	// 订单总金额
//	private BigDecimal dzMoney;
	/****************************************** 差异点   end ******************************************/

	//	@NonNull("开票申请金额")
	@ApiModelProperty("开票申请金额: #公式= ∑(销售单价*商品数量)#-新添加 20210712-产品要求名为: 账单金额")
	private BigDecimal invoiceApplyAmount;
	//	@NonNull("减免金额")
	@ApiModelProperty("减免金额")
	private BigDecimal freeAmount;
	//	@NonNull("实际金额")
	@ApiModelProperty("实际金额(开票申请金额-减免金额)-产品要求名为: 开票申请金额")
	private BigDecimal realAmount;
	//	// inva.real_amount as back_money,
//	private BigDecimal backMoney;
	// inva.no_check_count as no_back_money,
	private BigDecimal noBackMoney;

	private Date    maxBackTime;
	private Integer backAccountStatus;// 回款状态 0未回款 1部分回款 2全部回款
	private String  backAccountStatusName;

	private String outVirtNamesStr;//企业名称

	// TODO 对账单Sn 标记 可能不能共用字段
	private String accountingOrderSn;
	/****************************************** mark by linjinyu at 20210105 start ******************************************/
	// https://docs.qq.com/sheet/DUlpFQmVQWUJ0ZWtv?tab=BB08J2
	//	1、列表添加：对账单编号字段
	//<!-- group_concat(DISTINCT t6.accounting_order_sn) AS accounting_order_sns_str -->
	//<result column="accounting_order_sns_str" jdbcType="VARCHAR" property="accountingOrderSnsStr"/>
	private String accountingOrderSnsStr;

	/****************************************** mark by linjinyu at 20210105   end ******************************************/


}
