package cn.superdesk.uniorder.dto.vo.invoice.customer;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;


/**
 * @Description: 用于 发票申请 时返回的
 * @Author: linjinyu
 * @CreateDate: 7/15/20 2:13 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 7/15/20 2:13 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class InvoiceApplySelectScoreVo implements Serializable {

	private static final long serialVersionUID = 1L;

	private Long unifiedOrderCreditId;

	private Long unifiedOrderGoodsId;

	private Long unifiedOrderId;

	/**
	 * 对账单 Id
	 */
	private Long   accountingOrderId;
	/**
	 * 对账单 编号
	 */
	private String accountingOrderSn;


	/**
	 * 订单编号
	 */
	private String orderSn;


	private Integer creditType;

	/**
	 * 积分名称
	 */
	private String creditName;

	/**
	 * 积分变动类型（1充值 2消费 3退款）
	 */
	private Integer dailyAccountType;

	/**
	 * 积分批次 （如果是微信支付，显示 wechat）
	 */
	private String batchs;

	/**
	 * 消耗 积分额度 积分支付金额
	 */
	private BigDecimal balance;


	/**
	 * 发票申请状态 是否已申请 0-未申请;1-已申请;
	 */
	private Integer invoiceApplyStatus;

	/**
	 * 开票状态 是否已登记开票 0-未登记;1-已登记;
	 */
	private Integer invoiceMakeStatus;

	/**
	 * 回款状态 是否回款 0-未回款;1-已回款;
	 */
	private Integer backStatus;


	/**
	 * 发票抬头
	 */
	private String invoiceCompanyName;

	/**
	 * 下单人 名字
	 */
	private String realName;
	private Long   purchaseVirtId;
	/**
	 * 企业名称
	 */
	private String purchaseVirtName;


	/**
	 * 单价 * 数量 = 价格
	 */
	private BigDecimal price;
	/**
	 * 数量
	 */
	private Integer    quantity;
	/**
	 * 单位
	 */
	private String     unit;
	/**
	 * 单价
	 */
	private BigDecimal unitPrice;
	/**
	 * 商品名
	 */
	private String     goodsName;


	// ************************************ update by linjinjy 20200727 20200723_林志鹏_税率，退款格式.docx ************************************
	/**
	 * 财务编码
	 */
	private String     fiscalCode;
	/**
	 * 税务编码
	 */
	private String     taxCode;
	/**
	 * 税率 %
	 */
	private BigDecimal taxRate;
	// ************************************ update by linjinjy 20200727 20200723_林志鹏_税率，退款格式.docx ************************************


}
