package cn.superdesk.uniorder.dto.vo.invoice.supplier;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

@Data
public class UnifiedSupplierInvDetail implements Serializable {

    private static final long serialVersionUID = -1956139928027439782L;

    private Long id;

    private String  invoiceNumber;
    private String  invoiceSn;
    private String  invoiceTitle;
    private Integer invoiceStatus;

    private Long   saleId;
    private String saleName;

    private String applyUserName;
    private Long   applyUserId;
    private Date   applyTime;

    private String  auditUserName;
    private Long    auditUserId;
    private Integer auditStatus;
    private Date    auditTime;

    private String  makeUserName;
    private Long    makeInvoiceUserId;
    private Date    makeInvoiceTime;
    private Integer makeInvoiceStatus;

    private Long   expressCompanyId;
    private String expressNo;

    private String remark;

    private Date mailTickTime;


    private Integer backAccountStatus;


    /**
     * Database Column Remarks:
     * 对账单数量
     */
    private Integer accountingOrderQuantity;

    private Integer    orderQuantity;
    private BigDecimal orderAmount;
    /**
     * Database Column Remarks:
     * 订单商品item数量累加
     */
    private Integer    goodsQuantity;

    /**
     * Database Column Remarks:
     * 订单商品item的数量累加
     */
    private Integer goodsItemQuantity;

    /**
     * Database Column Remarks:
     * 商品销售金额(统一订单)
     */
    private BigDecimal goodsAmount;

    /**
     * Database Column Remarks:
     * 商品成本金额(统一订单)
     */
    private BigDecimal goodsCostAmount;

    private List<UnifiedSupplierInvGoodsDetail> goods;

}
