package cn.superdesk.uniorder.dto.vo.operationCenter.order;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Author : zx
 * @Create : 2023/3/27 14:49
 * Description : 运营中心-订单管理-详情 返回封装类
 */
@Data
public class OperationCenterOrderDetailsVo implements Serializable {
    //运营中心订单id
    private Long id;
    //运营商
    private String operatorName;
    //订单类型
    private String orderTypeName;
    //业务类型 1-订单 2-售后单
    private Byte orderBizTypeId;
    //订单编号
    private String orderSn;
    //订单时间
    private Date orderCreateTime;
    //支付状态
    private Byte orderPayStatus;
    //交易状态
    private Byte transactionStatusId;
    //商品金额
    private BigDecimal orderGoodsAmount;
    //运费金额
    private BigDecimal transportAmount;
    //优惠金额
    private BigDecimal discountAmount;
    //订单金额
    private BigDecimal orderPrice;
    //结算金额
    private BigDecimal orderSettlementAmount;
    //支付方式 平台
    private String platformPayType;
    //支付时间
    private Date tradingTime;
    //发货时间
    private Date sendTime;
    //完成时间
    private Date finishTime;
    //下单人
    private String buyerName;
    //第三方单号
    private String thirdPartyOrderSn;
    //退单原单号
    private String refundOriginOrderSn;
    //售后状态
    private Byte platformAftersaleStatusId;
    private String platformAftersaleType;
    //订单备注
    private String orderRemark;

    //父单编号
    private String parentOrderSn;
    //项目名称
    private String orgName;
    //企业名称
    private String enterpriseName;
    //收货人
    private String consignee;
    //收货人号码
    private String consigneeMobile;
    //收货人地址
    private String consigneeAddress;
    //快递名称
    private String expressName;
    //物流单号
    private String expressTrackingNo;
}
