package cn.superdesk.uniorder.dto.vo.organisation;

import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 2021/5/14 下午4:05
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/5/14 下午4:05
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class SysEnterpriseExtInvoiceExtPathVo implements Serializable {

	private Long id;

	private Integer serviceNo;

	/**
	 * 编号
	 */
	private String serialNumber;

	/**
	 * 统一订单 项目ID
	 */
	private Long sysOrgId;

	/**
	 * 统一订单 企业ID
	 */
	private Long sysVirtId;

	/**
	 * 服务之窗 项目ID
	 */
	private Long outOrgId;

	/**
	 * 服务之窗 企业ID
	 */
	private Long outVirtId;

	/**
	 * 开票方式(1为随货开票，0为订单预借，2为集中开票 )
	 */
	private Integer invoiceState;

	/**
	 * 1普通发票 2增值税发票
	 */
	private Integer invoiceType;

	/**
	 * 发票类型：4个人，5单位
	 */
	private Integer selectedInvoiceTitle;

	/**
	 * 个人发票抬头
	 */
	private String realname;

	/**
	 * 发票抬头  (如果selectedInvoiceTitle=5则此字段必须)
	 */
	private String companyName;

	/**
	 * 纳税人识别码 备注 开企业抬头发票，请填写 纳税人识别号 ,以免影响您报销
	 */
	private String taxpayersIDCode;

	/**
	 * 1:明细，3：电脑配件，19:耗材，22：办公用品 备注:若增值发票则只能选1 明细
	 */
	private Integer invoiceContent;

	/**
	 * 增值票收票人姓名 备注：当invoiceType=2 且invoiceState=1时则此字段必填
	 */
	private String invoiceName;

	/**
	 * 增值票收票人电话 备注：当invoiceType=2 且invoiceState=1时则此字段必填
	 */
	private String invoicePhone;

	private String invoiceEmail;

	/**
	 * 增值票收票人所在省(京东地址编码) 备注：当invoiceType=2 且invoiceState=1时则此字段必填
	 */
	private Integer invoiceProvice;

	/**
	 * 增值票收票人所在市(京东地址编码) 备注：当invoiceType=2 且invoiceState=1时则此字段必填
	 */
	private Integer invoiceCity;

	/**
	 * 增值票收票人所在区/县(京东地址编码) 备注：当invoiceType=2 且invoiceState=1时则此字段必填
	 */
	private Integer invoiceCounty;

	/**
	 * 增值票收票人所在地址 备注：当invoiceType=2 且invoiceState=1时则此字段必填
	 */
	private String invoiceAddress;

	/**
	 * 地址电话
	 */
	private String invoiceAddressPhone;

	/**
	 * 银行名称与账号
	 */
	private String invoiceBankAccountNumber;

	/**
	 * 增值票开户银行
	 */
	private String invoiceBank;

	/**
	 * 增值票开户帐号
	 */
	private String invoiceAccount;



	/**
	 * 联系人-名称
	 */
	private String contactsName;

	/**
	 * 联系人-邮箱
	 */
	private String contactsEmail;

	/**
	 * 联系人-电话
	 */
	private String contactsPhone;

	private Integer isDefault;

	private Integer enabled;
	private String  enabledName;

	private Integer deleted;
	private String  deletedName;

	private Date   createTime;
	private Long   createUserId;
	private String createUserName;

	private Date   updateTime;
	private Long   updateUserId;
	private String updateUserName;


	private String remark;

	private String path;
	private String effect;
}
