package cn.superdesk.uniorder.dto.vo.unified;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;

/**
 * @Description: resultMap -> DzGoodsResultMap
 * <p>
 * select -> getStatementOfAccountDimOrder2GoodsList
 * 用于 供应商发票申请 基于 对账单Sn 来返回 对账单 商品数据 弃用 mark by 20201103 linjinyu
 * @Author: linjinyu
 * @CreateDate: 7/13/20 3:04 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 7/13/20 3:04 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class InvoiceApplySupplierSelectGoodsVo implements Serializable {

	private static final long serialVersionUID = -5332656371471369119L;

	private String accountingOrderSn;
	private String orderSn;

	// 订单商品表 UnifiedOrderGoods.id 非商品ID goodsId
	private Long       goodsId;
	private String     goodsName;
	private String     goodsAlias;

    private Integer    quantity;
	private BigDecimal price;
	private BigDecimal costPrice;


	// 弃用 与彩娇对过 这个是不需要 mark by 20201103 linjinyu
	//	private String goodsParams;
	//	private String     unit;


}
