package cn.superdesk.uniorder.dto.vo.unified;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

/**
 * @Description: 订单.商品信息
 * @Author: linjinyu
 * @CreateDate: 2021/1/20 上午11:22
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/1/20 上午11:22
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class UnifiedOrderJoinGoodsDetailVo implements Serializable {

	private static final long serialVersionUID = 7022662380639604726L;

	private Long unifiedOrderId;

	private String orderSn;
	private String orderSnOutTrade;

	private String serviceName;
	private String serviceNo;

	private Long   projectId;
	private String projectName;

	private Long   purchaseVirtId;
	private String purchaseVirtName;

	private Long   purchaseUserId;
	private String purchaseUserName;
	private String purchasePhone;

	private Long   saleId;
	private String saleName;

	private BigDecimal amount;
	private BigDecimal costAmount;
	private BigDecimal transportAmount;

	private Integer completState;

	private Integer accountingStateSupplier;
	private Integer accountingStateCustomer;

	private Integer payType;
	private String  payTypeName;
	private Integer payState;
	/**
	 * 支付状态名称
	 */
	private String  payStateName;
	private Integer orderState;
	private String  orderStateName;

	private Integer settlementType;
	private Integer appraiseState;
	private Integer sourceChannel;
	private String  otherParams;
	private String  userType;
	private String  userName;

	private Long createUserId;
	private Long updateUserId;

	private Date createTime;
	private Date updateTime;
	/**
	 * 订单 支付时间
	 */
	private Date payTime;
	/**
	 * 订单 发货时间
	 */
	private Date sendTime;
	/**
	 * 订单 完成时间
	 */
	private Date finishTime;


	private String recUsername;
	private Long   recUserid;
	private String recUserphone;
	private String recAddress;

	/**
	 * 物流单号
	 */
	private String expressSn;
	/**
	 * 快递拼音简写
	 */
	private String express;
	/**
	 * 快递名称 eg:京东快递;韵达快运
	 */
	private String expressCompany;

	private String remarks;

	private Integer invState;
	private String  invStateName;
	private String  invNumber;
	private String  invSn;


	private Long   unifiedOrderGoodsId;
	private Long   goodsId;
	private Long   outSnapshotOrderGoodsId;
	private String goodsName;
	private String goodsAlias;

	private Integer    quantity;
	// 必填 | 商品 单个 销售价
	private BigDecimal price;
	// 必填 | 商品 单个 成本价
	private BigDecimal costPrice;
	private BigDecimal goodsAmount;
	private BigDecimal goodsCostAmount;

	private Integer direction;

	private Long   cateIdLv1;
	private String cateNameLv1;
	private Long   cateIdLv2;
	private String cateNameLv2;
	private Long   cateIdLv3;
	private String cateNameLv3;
	private String selfOption;
	private String unit;

	/**
	 * 财务编码
	 */
	private String     fiscalCode;
	/**
	 * 税务编码
	 */
	private String     taxCode;
	/**
	 * 税率 %
	 */
	private BigDecimal taxRate;
	/**
	 * 商户税率ID-20210413-添加
	 */
	private Long       merchTaxId;
	/**
	 * 商户税率编码-20210413-添加
	 */
	private String     merchTaxCode;
	/**
	 * 商户税率-20210413-添加
	 */
	private BigDecimal merchTaxRate;
	/**
	 * 平台税率ID-20210413-添加
	 */
	private Long       operationTaxId;
	/**
	 * 平台税率编码-20210413-添加
	 */
	private String     operationTaxCode;
	/**
	 * 平台税率-20210413-添加
	 */
	private BigDecimal operationTaxRate;

	private String goodsParams;

}
