package cn.superdesk.uniorder.dto.vo.unified;

import lombok.Data;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;


/**
 * @Description: 订单管理 > 订单管理-table list-VO
 * @Author: linjinyu
 * @CreateDate: 5/14/20 2:39 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 5/14/20 2:39 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class ViewUnifiedOrderGoods implements Serializable {

	/**
	 * 这个是什么id
	 */
	private Long id;

	/****************************************** 订单维度 ******************************************/
	private String     orderSn;
	// 订单总价 商品*数量 N 累加 + 运费
//	private BigDecimal amount;

//	<result column="order_amount" property="orderAmount" jdbcType="DECIMAL"/>
//	<result column="order_cost_amount" property="orderCostAmount" jdbcType="DECIMAL"/>

	private BigDecimal orderAmount;
	private BigDecimal orderCostAmount;
	/****************************************** 订单维度 ******************************************/


	// <result column="project_id" property="projectId" jdbcType="BIGINT"/>
	private Long       projectId;
	private String     projectName;

	// <result column="sale_id" property="saleId" jdbcType="BIGINT"/>
	private Long   saleId;
	private String saleName;

	private String serviceNo;
	private String serviceName;

	private Integer payType;
	private String  payTypeName;

	private Integer payState;
	private String  payStateName;

	private Integer orderState;
	private String  orderStateName;

	// <result column="purchase_virt_id" property="purchaseVirtId" jdbcType="BIGINT"/>
	private Long   purchaseVirtId;
	private String purchaseVirtName;
	private String purchaseUserName;
	private String purchasePhone;

	/**
	 * 物流单号
	 */
	private String expressSn;
	/**
	 * 快递拼音简写
	 */
	private String express;
	/**
	 * 快递名称 eg:京东快递;韵达快运
	 */
	private String expressCompany;


	//	uo.inv_state AS inv_state,
	private Integer invState;
	private String  invStateName;
	private String  invNumber;
	private String  invSn;
	private Date    invApplyTime;
	private Date    invMakeInvoiceTime;


	private String remarks;

	private String recUsername;
	private String recUserphone;
	private String recAddress;

	/****************************************** add by linjinyu at 20201221 start ******************************************/
	private String operAccount;
	private String operName;

	private Date createTime;
	private Date updateTime;
	/**
	 * 订单 支付时间
	 */
	private Date payTime;
	/**
	 * 订单 发货时间
	 */
	private Date sendTime;
	/**
	 * 订单 完成时间
	 */
	private Date finishTime;
	/****************************************** add by linjinyu at 20201221   end ******************************************/


	/****************************************** 商品维度 ******************************************/

	private Long   goodsId;
	private Long   outSnapshotOrderGoodsId;
	private String goodsName;
	private String goodsAlias;


	private String unit;

	/**
	 * 数量
	 */
	private Integer    quantity;
	/**
	 * 成交单价(有可能是销售价也有可能是扣后价)
	 */
	private BigDecimal price;
	/**
	 * 成本价
	 */
	private BigDecimal costPrice;
	/**
	 * 商品小计 成交单价(有可能是销售价也有可能是扣后价) * 数量
	 */
	private BigDecimal goodsAmount;
	/**
	 * 商品小计 商品成本价* 数量
	 */
	private BigDecimal goodsCostAmount;



	private Long    cateIdLv1;
	private String  cateNameLv1;
	private Long    cateIdLv2;
	private String  cateNameLv2;
	private Long    cateIdLv3;
	private String  cateNameLv3;
	/**
	 * 商品规格 add at 20201028
	 */
	private String  selfOption;
	private Integer direction;


	/**
	 * 财务编码
	 */
	private String     fiscalCode;
	/**
	 * 税务编码
	 */
	private String     taxCode;
	/**
	 * 税率 %
	 */
	private BigDecimal taxRate;
	/**
	 * 商户税率ID-20210413-添加
	 */
	private Long       merchTaxId;
	/**
	 * 商户税率编码-20210413-添加
	 */
	private String     merchTaxCode;
	/**
	 * 商户税率-20210413-添加
	 */
	private BigDecimal merchTaxRate;
	/**
	 * 平台税率ID-20210413-添加
	 */
	private Long       operationTaxId;
	/**
	 * 平台税率编码-20210413-添加
	 */
	private String     operationTaxCode;
	/**
	 * 平台税率-20210413-添加
	 */
	private BigDecimal operationTaxRate;


	/****************************************** 商品维度 ******************************************/

}