package cn.superdesk.uniorder.dubbo.facade.accounting;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.accounting.score.customer.AccountingScoreCustomer;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param.accounting.score.customer.AccountingScoreCustomerCreateParam;
import cn.superdesk.uniorder.dto.vo.accounting.score.customer.AccountingScoreCustomerDetailVo;
import cn.superdesk.uniorder.dto.vo.accounting.score.customer.AccountingScoreCustomerHeadVo;
import cn.superdesk.uniorder.dto.vo.accounting.score.customer.AccountingScoreCustomerVo;
import cn.superdesk.uniorder.dto.vo.score.ScoreOrderReconciliationNotYetVo;

import java.util.List;
import java.util.Map;

public interface DubboAccountingScoreCustomerService {


	/****************************************** 积分对账(结算) 对账单 start ******************************************/
	List<Long> getAccountingXCreditIds(Long id);

	R<List<AccountingScoreCustomerVo>> getAccountingList(Map<String, Object> params, int pageNum, int pageSize);

	List<AccountingScoreCustomerVo> getAccountingList(Map<String, Object> params, LoginSysUser loginSysUser);

	AccountingScoreCustomerHeadVo getAccountingListHeadSum(Map<String, Object> params);

	/**
	 * 创建结算单(对账单)(积分) ---- 与 addDzMainNew 对映
	 *
	 * @param userId
	 * @param scoreOrderReconciliationNotYetVoList
	 * @param scoreAccountingCustomerCreateParam
	 * @return
	 * @throws Exception
	 */
	AccountingScoreCustomer createScoreAccountingCustomer(
			Long userId,
			List<ScoreOrderReconciliationNotYetVo> scoreOrderReconciliationNotYetVoList,
			AccountingScoreCustomerCreateParam scoreAccountingCustomerCreateParam) throws Exception;

	/****************************************** 积分对账(结算) 对账单   end ******************************************/

	/****************************************** 积分对账(结算) 对账单 详情 start ******************************************/

	AccountingScoreCustomerDetailVo commonStatementOfAccountDetailDimCredit(Long accountingOrderId, LoginSysUser loginSysUser);

	String exportExcelStatementOfAccountDetailDimCredit(Long accountingOrderId, LoginSysUser loginSysUser);
	/****************************************** 积分对账(结算) 对账单 详情   end ******************************************/

	/****************************************** 积分对账(结算) 对账单 操作 start ******************************************/
	/**
	 * 重新对账
	 *
	 * @param id
	 * @param loginSysUser
	 */
	void opCancelAccounting(Long id, LoginSysUser loginSysUser);

	/**
	 * 拒绝对账
	 *
	 * @param id
	 * @param loginSysUser
	 */
	void opRefuseAccounting(Long id, LoginSysUser loginSysUser);

	/**
	 * 确认对账
	 *
	 * @param id
	 * @param loginSysUser
	 */
	void opConfirmAccounting(Long id, LoginSysUser loginSysUser);

	void opDeleteAccounting(Long id);

	/****************************************** 积分对账(结算) 对账单 操作 start ******************************************/


	void deleteObj(Long id);

	void updateObj(AccountingScoreCustomer scoreAccountingCustomer, LoginSysUser loginSysUser);

	void updateFieldRemark(AccountingScoreCustomer scoreAccountingCustomer, LoginSysUser loginSysUser);



	AccountingScoreCustomer findById(Long id);

	void addObj(AccountingScoreCustomer scoreAccountingCustomer);

	List<AccountingScoreCustomer> findAll(Map<String, Object> queryMap);
}
