package cn.superdesk.uniorder.dubbo.facade.base;

import cn.superdesk.uniorder.common.pagination.PageQueryParam;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrder;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param._function.select.SelectOptionDepartmentCriteria;
import cn.superdesk.uniorder.dto.param.accounting.unified.customer.ExportCustomerStatementOfAccountDetailCriteria;
import cn.superdesk.uniorder.dto.param.accounting.unified.supplier.AccountingSupplierNotYetDimGoodsCriteria;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.UnifiedLnssOrderAdd;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.flashdeliver.FlashDeliverOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.flashdeliver.FlashDeliverRefundOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.meetingroomreservation.MeetingRoomReservationOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.proxyclient.ProxyClientOrderOptBecomeInvalidQueryCriteria;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.score.ScoreOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.score.refund.ScoreOrderRefundReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.unified.UnifiedOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.unified.refund.UnifiedOrderRefundReceiveParam;
import cn.superdesk.uniorder.dto.vo._function.select.SelectOptionDepartment;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.CustomerUnAccountingDimGoodsVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.UnifiedOrderCustomerHeadSumVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.UnifiedOrderCustomerNotCheckVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.notyet.UnifiedOrderJoinGoodsOfSupplierStatementOfAccount;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.notyet.UnifiedOrderSupplierHeadSumVo;
import cn.superdesk.uniorder.dto.vo.order.Org2VirtStatisticsVo;
import cn.superdesk.uniorder.dto.vo.score.ScoreOrderReconciliationNotYetHeadVo;
import cn.superdesk.uniorder.dto.vo.score.ScoreOrderReconciliationNotYetVo;
import cn.superdesk.uniorder.dto.vo.unified.*;
import cn.superdesk.uniorder.dto.vo.wechat.WxBillOrder;
import cn.superdesk.uniorder.dto.vo.wechat.WxBillVirt;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 2020/10/27 下午8:58
 * @UpdateUser: linjinyu
 * @UpdateDate: 2020/10/27 下午8:58
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface DubboUnifiedOrderService {


	List<SelectOptionDepartment> getSelectPurchaseDepartment(SelectOptionDepartmentCriteria criteria, LoginSysUser loginSysUser);


	Map<String, Object> addObjTran(UnifiedLnssOrderAdd unifiedLnssOrderAdd);

	void updateObj(UnifiedOrder unifiedOrder);


	/****************************************** 客户结算 对账单 详情 start ******************************************/

//	accountingUnifiedCustomerDubboConsumerService.getCustomerStatementOfAccountDetailDimOrder2Goods(id);
//	accountingUnifiedCustomerDubboConsumerService.getCustomerStatementOfAccountDetailDimGoods2Goods(id);

	String exportCustomerStatementOfAccountDetailCompatible(ExportCustomerStatementOfAccountDetailCriteria criteria, LoginSysUser loginSysUser);

	/****************************************** 客户结算 对账单 详情   end ******************************************/


	/****************************************** 供应商结算 对账单 详情 start ******************************************/
	/**
	 * 供应商 对账单 详情 订单维度
	 *
	 * @param params
	 * @return
	 */
	List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierStatementOfAccountDetailDimOrder2Goods(Map<String, Object> params);

	/**
	 * 供应商 对账单
	 * 1. 详情 商品维度
	 * 2. 详情 导出
	 *
	 * @param params
	 * @return
	 */
	List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierStatementOfAccountDetailDimGoods2Goods(Map<String, Object> params);

	String exportSupplierStatementOfAccountDetailCompatible(Map<String, Object> params, LoginSysUser loginSysUser);

	/****************************************** 供应商结算 对账单 详情   end ******************************************/

	UnifiedOrder findByOrderSn(String sn);

	UnifiedOrderGoodsDetail getGoodsDetail(Long id);


	/****************************************** 1. 页面-客户结算对账 未对账商品 start ******************************************/
	/**
	 * 列表
	 *
	 * @param params
	 * @return
	 */
	List<UnifiedOrderJoinGoodsDetailVo> getUnifiedOrderJoinGoodsDetailVoList(Map<String, Object> params);

	/**
	 * 导出
	 *
	 * @param params
	 * @param loginSysUser
	 * @return
	 */
	String exportExcelAccountingCustomerNotYetDimOrder(Map<String, Object> params, LoginSysUser loginSysUser);

	String exportExcelAccountingCustomerNotYetDimGoods(Map<String, Object> params, LoginSysUser loginSysUser);

	/****************************************** 1. 页面-客户结算对账 未对账商品   end ******************************************/


	List<UnifiedOrder> findAll(Map<String, Object> queryMap);

	R<List<UnifiedOrder>> patchFlashDeliverPatchUnifiedOrderFieldOutVirt(PageQueryParam pageQueryParam);

	Integer countAll(Map<String, Object> queryMap);


	Integer getOrderCount(Map<String, Object> queryMap);


	/****************************************** kafka 一般订单 start ******************************************/

	R<String> httpUnifiedOrderReceive(UnifiedOrderReceiveParam unifiedOrderReceiveParam);

	R<String> httpUnifiedOrderRefundReceive(UnifiedOrderRefundReceiveParam unifiedOrderRefundReceiveParam);

	/**
	 * 商城 订单 正常
	 *
	 * @param message
	 */
	void kafkaUnifiedOrderReceive(String message);

	void kafkaUnifiedOrderRefundReceive(String message);
	/****************************************** kafka 一般订单   end ******************************************/


	/****************************************** kafka 积分订单 start ******************************************/

	/**
	 * http 积分订单 mark by linjinyu at 20210308
	 *
	 * @param orderReceiveParam
	 * @return
	 */
	R<String> httpScoreOrderReceive(ScoreOrderReceiveParam orderReceiveParam);

	R<String> httpScoreOrderRefundReceive(ScoreOrderRefundReceiveParam refundOrderReceiveParam);

	/**
	 * 商城 订单 侨城汇(积分订单)
	 *
	 * @param message
	 */
	void kafkaScoreOrderReceive(String message);

	void kafkaScoreOrderRefundReceive(String message);

	/****************************************** kafka 积分订单   end ******************************************/

	/****************************************** kafka 代客下单 start ******************************************/

	void kafkaProxyClientOrderReceive(String message);

	R<String> proxyClientOrderOptBecomeInvalid(ProxyClientOrderOptBecomeInvalidQueryCriteria queryCriteria);
	/****************************************** kafka 代客下单   end ******************************************/

	/****************************************** kafka 服务之窗 楼闪送 start ******************************************/

	R<String> httpFlashDeliverOrderReceive(FlashDeliverOrderReceiveParam orderReceiveParam);

	R<String> httpFlashDeliverOrderRefundReceive(FlashDeliverRefundOrderReceiveParam refundOrderReceiveParam);

	void kafkaFlashDeliverOrderReceive(String message);

	void kafkaFlashDeliverOrderRefundReceive(String message);

	void kafkaFlashDeliverOrderReceiveStateUpdate(String message);

	/****************************************** kafka 服务之窗 楼闪送   end ******************************************/

	/****************************************** kafka patchUnifiedOrderFieldOutVirt start ******************************************/
	void kafkaFlashDeliverPatchUnifiedOrderFieldOutVirt(String message);
	/****************************************** kafka patchUnifiedOrderFieldOutVirt   end ******************************************/

	/****************************************** kafka 服务之窗 小邮局订单 start ******************************************/
	void kafkaPostOfficeOrderMergeReceive(String message);

	void kafkaPostOfficeOrderDeleteReceive(String message);
	/****************************************** kafka 服务之窗 小邮局订单   end ******************************************/


	/****************************************** kafka 服务之窗 会议室预约 start ******************************************/

	R<String> httpMeetingRoomReservationOrderMergeReceive(MeetingRoomReservationOrderReceiveParam meetingRoomReservationOrderReceiveParam);

	void kafkaMeetingRoomReservationOrderMergeReceive(String message);

	void kafkaMeetingRoomReservationOrderDeleteReceive(String message);
	/****************************************** kafka 服务之窗 会议室预约   end ******************************************/


	/****************************************** 订单管理 start ******************************************/
	UnifiedOrderCommonHeadSum getOrderManagerGoodsPageHead(Map<String, Object> params);

	/**
	 * 用于 订单管理 订单管理
	 *
	 * @param params
	 * @return
	 */
	List<ViewUnifiedOrderGoods> getOrderManagerGoodsView(Map<String, Object> params);

	/****************************************** 订单管理-列表数据导出 export excel start ******************************************/

	String exportExcelOrderManagerGoodsData(Map<String, Object> params, LoginSysUser loginSysUser);

	String exportExcelOrderManagerGoodsCostPrice(Map<String, Object> params, LoginSysUser loginSysUser);

	/****************************************** 订单管理-列表数据导出 export excel   end ******************************************/

	R<List<Org2VirtStatisticsVo>> getOrg2VirtStatistics(Map<String, Object> params, int pageNum, int pageSize);


	/**
	 * 一般订单 得未结算数据 商品维度
	 * getGoodsByPage
	 * getScoreOrderReconciliationNotYet
	 *
	 * @param params
	 * @param pageNum
	 * @param pageSize
	 * @return
	 */
	R<List<ViewUnifiedOrderGoods>> getOrderManagerGoodsByPage(Map<String, Object> params, int pageNum, int pageSize);

	/****************************************** 订单管理   end ******************************************/


	/****************************************** 客户结算 dim order 未对账 订单 start ******************************************/
	UnifiedOrderCommonHeadSum getCustomerUnAccountingDimOrderHeadSum(Map<String, Object> params);

	R<List<UnifiedOrderCustomerNotCheckVo>> getCustomerUnAccountingDimOrderList(Map<String, Object> params, int pageNum, int pageSize);
	/****************************************** 客户结算 dim order 未对账 订单   end ******************************************/


	/****************************************** 客户结算 dim goods 未对账 商品 start ******************************************/
	UnifiedOrderCustomerHeadSumVo getCustomerUnAccountingDimGoodsHeadSum(String token, Map<String, Object> params);

	List<CustomerUnAccountingDimGoodsVo> getCustomerUnAccountingDimGoodsList(String token, Map<String, Object> params);

	R<List<CustomerUnAccountingDimGoodsVo>> getCustomerUnAccountingDimGoodsList(String token, Map<String, Object> params, int pageNo, int pageSize);
	/****************************************** 客户结算 dim goods 未对账 商品   end ******************************************/


	/****************************************** 积分结算 未对账 流水 start ******************************************/
	/**
	 * 积分订单 得未结算数据 积分流水维度
	 * getGoodsByPage
	 * getScoreOrderReconciliationNotYet
	 *
	 * @param token
	 * @param params
	 * @param pageNum
	 * @param pageSize
	 * @return
	 */
	R<List<ScoreOrderReconciliationNotYetVo>> getScoreOrderReconciliationNotYet(String token, Map<String, Object> params, int pageNum, int pageSize);

	List<ScoreOrderReconciliationNotYetVo> getScoreOrderReconciliationNotYet(String token, Map<String, Object> params);

	String exportExcelScoreOrderReconciliationNotYet(Map<String, Object> params, LoginSysUser loginSysUser);

	ScoreOrderReconciliationNotYetHeadVo getScoreOrderReconciliationNotYetHeadSum(String token, Map<String, Object> params);

	/****************************************** 积分结算 未对账 流水   end ******************************************/


	/****************************************** 供应商结算 dim order 未对账 订单 start ******************************************/
	R<List<UnifiedOrderSupplierDimOrderNotCheckVo>> getSupplierUnAccountingDimOrderList(Map<String, Object> params, int pageNum, int pageSize);

	List<UnifiedOrderSupplierDimOrderNotCheckVo> getSupplierUnAccountingDimOrderList(Map<String, Object> params);

	String exportExcelAccountingSupplierNotYetDimGoods(AccountingSupplierNotYetDimGoodsCriteria criteria, LoginSysUser loginSysUser);

	UnifiedOrderSupplierHeadSumVo getSupplierUnAccountingDimOrderHeadSum(Map<String, Object> params);

	List<UnifiedOrderSupplierNotCheckDetail2GoodsVo> getSupplierUnAccountingDetail2Goods(Map<String, Object> params);


	/****************************************** 供应商结算 dim order 未对账 订单   end ******************************************/


	/****************************************** 供应商结算 dim goods 未对账 订单 start ******************************************/
	UnifiedOrderSupplierHeadSumVo getSupplierUnAccountingDimGoodsHeadSum(AccountingSupplierNotYetDimGoodsCriteria criteria);

	List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierUnAccountingDimGoodsList(AccountingSupplierNotYetDimGoodsCriteria criteria);

	R<List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount>> getSupplierUnAccountingDimGoodsListByPageQuery(AccountingSupplierNotYetDimGoodsCriteria criteria);
	/****************************************** 供应商结算 dim goods 未对账 订单   end ******************************************/


	/**
	 * ******************************************** 微信端 start ***********************************************
	 **/
	/**
	 * 消费总额
	 *
	 * @param amountQuery
	 * @return
	 */
	BigDecimal getAmount(Map<String, Object> amountQuery);

	/**
	 * 待付款总额
	 *
	 * @param unPayMap
	 * @return
	 */
	BigDecimal getPayAmount(Map<String, Object> unPayMap);

	/**
	 * 企业订单
	 *
	 * @param params
	 * @return
	 */
	List<WxBillOrder> getVirtOrder(Map<String, Object> params);

	WxBillVirt getVirtBill(Long virtId, int syear);

	/**
	 * ******************************************** 微信端  end  ***********************************************
	 **/


}
