package cn.superdesk.uniorder.dubbo.facade.invoice.customer;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.exception.UnifiedOrderRuntimeException;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.dao.entity.order.ExpressCompany;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param.invoice.ExportExcelInvoiceApplyQueryCriteria;
import cn.superdesk.uniorder.dto.param.invoice.customer.InvoiceApplyCommonParams;
import cn.superdesk.uniorder.dto.vo.invoice.customer.*;

import java.util.List;
import java.util.Map;

/**
 * @Description: 发票申请
 * @Author: linjinyu
 * @CreateDate: 7/1/20 2:44 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 7/1/20 2:44 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface DubboInvoiceApplyService {

	InvoiceApply findById(Long invoiceApplyId);

	int updateInvoiceApplyByPrimaryKeySelective(InvoiceApply invoiceApply);

	/**
	 * 一般订单 发票申请 前的
	 *
	 * @param params
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	List<InvoiceApplySelectScoreVo> invoiceApplySelectFocusUnifiedDimOrder(Map<String, Object> params) throws UnifiedOrderRuntimeException;

	List<InvoiceApplySelectScoreVo> invoiceApplySelectFocusUnifiedDimGoods(Map<String, Object> params) throws UnifiedOrderRuntimeException;

	/**
	 * 积分订单 发票申请 前的
	 *
	 * @param criteria
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	List<InvoiceApplySelectScoreVo> invoiceApplySelectFocusScoreDimCredit(ExportExcelInvoiceApplyQueryCriteria criteria) throws UnifiedOrderRuntimeException;

	/**
	 * 开票申请 提交
	 *
	 * @param token
	 * @param params
	 * @throws UnifiedOrderRuntimeException
	 */
	void invoiceApply(String token, InvoiceApplyCommonParams params) throws UnifiedOrderRuntimeException;


	/****************************************** 发票申请管理 start ******************************************/

	R<List<InvoiceApplyPage>> findViewByPageFocusUnified(Map<String, Object> params, int pageNum, int pageSize) throws UnifiedOrderRuntimeException;

	InvoiceApplyDataVo findViewHeadDataFocusUnified(Map<String, Object> params) throws UnifiedOrderRuntimeException;


	R<List<InvoiceApplyPage>> findViewByPageFocusScore(ExportExcelInvoiceApplyQueryCriteria criteria, int pageNum, int pageSize) throws UnifiedOrderRuntimeException;

	InvoiceApplyDataVo findViewHeadDataFocusScore(ExportExcelInvoiceApplyQueryCriteria criteria) throws UnifiedOrderRuntimeException;

	/****************************************** 发票申请管理  end ******************************************/


	List<ExportExcelInvoiceApplyForceUnifiedDimGoodsVo> findInvoiceApplyFocusUnifiedDimGoods(Map<String, Object> params) throws UnifiedOrderRuntimeException;

	/**
	 * 积分结算-发票申请管理-opt 导出报表
	 *
	 * @param criteria
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	List<ExportExcelInvoiceApplyForceScoreDimCreditVo> findInvoiceApplyFocusScoreDimCredit(ExportExcelInvoiceApplyQueryCriteria criteria) throws UnifiedOrderRuntimeException;

	String exportExcelInvoiceApplyFocusUnifiedDimGoods(Map<String, Object> params, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException;

	String exportExcelInvoiceApplyFocusScoreDimCredit(ExportExcelInvoiceApplyQueryCriteria criteria, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException;


	/****************************************** 发票申请管理 查看详情 start ******************************************/
	/**
	 * @param params
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	InvoiceApplyDetailDimGoodsVo getUnifiedCustomerInvoice2GoodsDetail(Map<String, Object> params) throws UnifiedOrderRuntimeException;

	String exportExcelUnifiedCustomerInvoice2GoodsDetail(Map<String, Object> params, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException;

	/**
	 * @param criteria
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	InvoiceApplyDetailDimCreditVo getUnifiedCustomerInvoice2CreditDetail(ExportExcelInvoiceApplyQueryCriteria criteria, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException;

	//

	/**
	 * mark by linjinyu at 20210223 未开始做
	 * mark by linjinyu at 20211112 已完成
	 *
	 * @param criteria
	 * @param loginSysUser
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	String exportExcelUnifiedCustomerInvoice2CreditDetail(ExportExcelInvoiceApplyQueryCriteria criteria, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException;

	/****************************************** 发票申请管理 查看详情   end ******************************************/

	/****************************************** 第三方软件导出类 start ******************************************/
	String exportExcelDimUnifiedInvoiceRegister4E6(Long invoiceApplyId, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException;

	/****************************************** 第三方软件导出类   end ******************************************/


	String importInvoiceExcel(String token, List<Map<String, Object>> list) throws UnifiedOrderRuntimeException;

	String importSendInvoiceExcel(String token, List<Map<String, Object>> list) throws UnifiedOrderRuntimeException;


	List<ExpressCompany> findExpressCompany() throws UnifiedOrderRuntimeException;

	R<List<InvoiceApply>> findInvoiceByPageNew(Map<String, Object> params, int pageNum, int pageSize);


	/**
	 * 通过 orderSn 查找 开票状态 单个
	 *
	 * @param invQuery
	 * @return
	 */
	List<InvoiceApply> findInvoiceByOrderSn(Map<String, Object> invQuery);

	/**
	 * 通过 orderSn 查找 开票状态 批量
	 *
	 * @param orderSnList
	 * @return
	 */
	Map<String, InvoiceApply> findInvoiceByOrderSnList(List<String> orderSnList);


	void validatedInvoiceApplyRelationTable();

	void opDelete(Long invoiceApplyId, LoginSysUser loginSysUser);

	void opAudit(Map<String, Object> params, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException;

	/**
	 * opt 开票登记
	 *
	 * @param params
	 * @param loginSysUser
	 * @throws UnifiedOrderRuntimeException
	 */
	void opRegister(Map<String, Object> params, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException;

	void opAgain(Map<String, Object> params, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException;

	/**
	 * 操作-opt 寄票登记
	 *
	 * @param sendInvoiceRegisterList
	 * @param loginSysUser
	 * @throws UnifiedOrderRuntimeException
	 */
	void sendInvoiceRegister(List<Map> sendInvoiceRegisterList, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException;


}
