package cn.superdesk.uniorder.dubbo.facade.invoice.supplier;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.invoice.supplier.UnifiedSupplierInv;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.vo.unified.InvoiceApplySupplierSelectGoodsVo;
import cn.superdesk.uniorder.dto.vo.unified.UnifiedInvHE;
import cn.superdesk.uniorder.dto.vo.invoice.supplier.UnifiedSupplierInvoiceAddParams;
import cn.superdesk.uniorder.dto.vo.invoice.supplier.UnifiedSupplierInvDetail;

import java.util.List;
import java.util.Map;

/**
 * @Description: 重构 供应商 开票申请
 * @Author: linjinyu
 * @CreateDate: 2020/11/4 上午10:02
 * @UpdateUser: linjinyu
 * @UpdateDate: 2020/11/4 上午10:02
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface DubboUnifiedSupplierInvService {

    R<List<UnifiedSupplierInv>> getInvoiceApplyList(Map<String, Object> params, int pageNum, int pageSize);

    UnifiedInvHE getInvoiceApplyListHeadSum(Map<String, Object> params);

    UnifiedSupplierInvDetail getInvoiceDetail(Long id);

    List<InvoiceApplySupplierSelectGoodsVo> getStatementOfAccountGoodsListByAccountingOrderSn(String accountingOrderSn);

    List<InvoiceApplySupplierSelectGoodsVo> getStatementOfAccountGoodsListBySysUnifiedOrderGoodsIds(String accountingOrderSn,List<Long> processSysUnifiedOrderGoodsIds);

    /****************************************** 开票申请 start ******************************************/

    List<InvoiceApplySupplierSelectGoodsVo> invoiceApplySelectFocusUnified(String accountingOrderSn);

//    UnifiedSupplierInv opInvoiceApply(UnifiedSupplierInvoiceAddParams add, String userid, String username, String roletype);
    // mark by linjinyu at 20210312
    UnifiedSupplierInv opInvoiceApply(UnifiedSupplierInvoiceAddParams add, LoginSysUser loginSysUser);

    /****************************************** 开票申请   end ******************************************/

    UnifiedSupplierInv updateObj(UnifiedSupplierInv update);

    void opAgain(Long id);
    void opDelete(Long id);



    void patchInvoiceApplyFieldStatistics();



}
