package cn.superdesk.uniorder.dubbo.provider.accounting;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.accounting.jd.AccountingUnifiedSupplierOrderJd;
import cn.superdesk.uniorder.dto.param.accounting.jd.AccountingUnifiedSupplierOrderJdImportExcelRow;
import cn.superdesk.uniorder.dto.param.accounting.jd.AccountingUnifiedSupplierOrderJdParam;
import cn.superdesk.uniorder.dto.param.accounting.jd.AccountingUnifiedSupplierOrderJdQueryCriteria;
import cn.superdesk.uniorder.dubbo.facade.accounting.DubboAccountingUnifiedSupplierOrderJdService;
import cn.superdesk.uniorder.service.accounting.jd.AccountingUnifiedSupplierOrderJdService;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import com.alibaba.dubbo.config.annotation.Service;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboAccountingUnifiedSupplierOrderJdServiceImpl implements DubboAccountingUnifiedSupplierOrderJdService {

	@Autowired
	private AccountingUnifiedSupplierOrderJdService accountingUnifiedSupplierOrderJdService;


	/****************************************** extends BaseService 部分 start ******************************************/

	@Override
	public void addObj(AccountingUnifiedSupplierOrderJdParam param) {

		AccountingUnifiedSupplierOrderJd accountingUnifiedSupplierOrderJd = AnBeanUtils.copy(param, AccountingUnifiedSupplierOrderJd.class);
		accountingUnifiedSupplierOrderJdService.addObj(accountingUnifiedSupplierOrderJd);

	}

	@Override
	public void updateObj(AccountingUnifiedSupplierOrderJdParam param) {

		AccountingUnifiedSupplierOrderJd accountingUnifiedSupplierOrderJd = AnBeanUtils.copy(param, AccountingUnifiedSupplierOrderJd.class);
		accountingUnifiedSupplierOrderJdService.updateObj(accountingUnifiedSupplierOrderJd);
	}

	@Override
	public void deleteObj(Long id) {
		accountingUnifiedSupplierOrderJdService.deleteObj(id);
	}

	@Override
	public AccountingUnifiedSupplierOrderJd findById(Long id) {
		return accountingUnifiedSupplierOrderJdService.findById(id);
	}

	@Override
	public PageInfo<AccountingUnifiedSupplierOrderJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
		return accountingUnifiedSupplierOrderJdService.findByPaging(conditions, pageNun, pageSize);
	}

	@Override
	public List<AccountingUnifiedSupplierOrderJd> findAll(Map<String, Object> queryMap) {

		return accountingUnifiedSupplierOrderJdService.findAll(queryMap);
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	@Override
	public void addAccountingUnifiedSupplierOrderJd(AccountingUnifiedSupplierOrderJdParam param) {

		AccountingUnifiedSupplierOrderJd accountingUnifiedSupplierOrderJd = AnBeanUtils.copy(param, AccountingUnifiedSupplierOrderJd.class);
		accountingUnifiedSupplierOrderJdService.addAccountingUnifiedSupplierOrderJd(accountingUnifiedSupplierOrderJd);
	}

	@Override
	public void updateAccountingUnifiedSupplierOrderJd(AccountingUnifiedSupplierOrderJdParam param) {

		AccountingUnifiedSupplierOrderJd accountingUnifiedSupplierOrderJd = AnBeanUtils.copy(param, AccountingUnifiedSupplierOrderJd.class);
		accountingUnifiedSupplierOrderJdService.updateAccountingUnifiedSupplierOrderJd(accountingUnifiedSupplierOrderJd);
	}

	@Override
	public void deleteAccountingUnifiedSupplierOrderJd(Long id) {
		accountingUnifiedSupplierOrderJdService.deleteAccountingUnifiedSupplierOrderJd(id);
	}

	@Override
	public AccountingUnifiedSupplierOrderJd findAccountingUnifiedSupplierOrderJdById(Long id) {
		return accountingUnifiedSupplierOrderJdService.findAccountingUnifiedSupplierOrderJdById(id);
	}

	@Override
	public R<List<AccountingUnifiedSupplierOrderJd>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {
		return accountingUnifiedSupplierOrderJdService.pageQuery(conditions, pageNun, pageSize);
	}

	@Override
	public R<List<AccountingUnifiedSupplierOrderJd>> pageQueryGenericParam(AccountingUnifiedSupplierOrderJdQueryCriteria criteria) {
		return accountingUnifiedSupplierOrderJdService.pageQueryGenericParam(criteria);
	}


	/****************************************** excel import start start ******************************************/

	@Override
	public void saveOrUpdate4ThirdPartJdReconciliationScheduleExcelRow(AccountingUnifiedSupplierOrderJdImportExcelRow excelRow, LoginSysUser loginSysUser) {

		if (null == excelRow) {
			return;
		}
		accountingUnifiedSupplierOrderJdService.saveOrUpdate4ThirdPartJdReconciliationScheduleExcelRow(excelRow, loginSysUser);
	}

	@Override
	public void saveOrUpdate4ThirdPartJdReconciliationScheduleExcelRowList(List<AccountingUnifiedSupplierOrderJdImportExcelRow> excelRowList, LoginSysUser loginSysUser) {

		accountingUnifiedSupplierOrderJdService.saveOrUpdate4ThirdPartJdReconciliationScheduleExcelRowList(excelRowList, loginSysUser);
	}

	/****************************************** excel import start   end ******************************************/

}
