package cn.superdesk.uniorder.dubbo.provider.accounting;

import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderGoods;
import cn.superdesk.uniorder.service.accounting.unified.supplier.*;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.accounting.unified.supplier.AccountingUnifiedSupplier;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrder;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param.accounting.unified.supplier.UnifiedSupplierCreateDimGoodsParam;
import cn.superdesk.uniorder.dto.param.accounting.unified.supplier.UnifiedSupplierCreateDimOrderParam;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.AccountingUnifiedSuplierHead;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.AccountingUnifiedSupplierStatementOfAccountFixVoDimGoods;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.AccountingUnifiedSupplierStatementOfAccountFixVoDimOrder;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.UnifiedSupplierStatementOfAccountVo;
import cn.superdesk.uniorder.dubbo.facade.accounting.DubboAccountingUnifiedSupplierService;
import com.alibaba.dubbo.config.annotation.Service;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;


/**
 * @Description: 供应商
 * @Author: linjinyu 补充 修改
 * @CreateDate: 4/28/20 5:02 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 4/28/20 5:02 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboAccountingUnifiedSupplierServiceImpl implements DubboAccountingUnifiedSupplierService {


	@Autowired
	private AccountingUnifiedSupplierService                 accountingUnifiedSupplierService;
	@Autowired
	private AccountingUnifiedSupplierServiceOpCreateDimOrder accountingUnifiedSupplierServiceOpCreateDimOrder;
	@Autowired
	private AccountingUnifiedSupplierServiceOpCreateDimGoods accountingUnifiedSupplierServiceOpCreateDimGoods;
	@Autowired
	private AccountingUnifiedSupplierServiceOpEditDimOrder   accountingUnifiedSupplierServiceOpEditDimOrder;
	@Autowired
	private AccountingUnifiedSupplierServiceOpEditDimGoods   accountingUnifiedSupplierServiceOpEditDimGoods;


	/**
	 * 供应商结算-对账单
	 *
	 * @param params
	 * @param pageNum
	 * @param pageSize
	 * @return
	 */
	@Override
	public R<List<UnifiedSupplierStatementOfAccountVo>> getStatementOfAccountList(Map<String, Object> params, int pageNum, int pageSize) {

		return accountingUnifiedSupplierService.getStatementOfAccountList(params, pageNum, pageSize);
	}

	@Override
	public AccountingUnifiedSuplierHead getStatementOfAccountHeadSum(Map<String, Object> params) {


		return accountingUnifiedSupplierService.getStatementOfAccountHeadSum(params);
	}


	@Override
	public AccountingUnifiedSupplier findById(Long id) {

		return accountingUnifiedSupplierService.findById(id);
	}

	@Override
	public AccountingUnifiedSupplier findByAccountingOrderSn(String accountingOrderSn) {
		return accountingUnifiedSupplierService.findByAccountingOrderSn(accountingOrderSn);
	}

	@Override
	public void updateObj(AccountingUnifiedSupplier update) {

		accountingUnifiedSupplierService.updateObj(update);
	}

	@Override
	public void opEditAccountingDimOrder(AccountingUnifiedSupplier statementOfAccount, UnifiedOrder unifiedOrder, String add, LoginSysUser loginSysUser) {

		accountingUnifiedSupplierServiceOpEditDimOrder.opEditAccountingDimOrder(statementOfAccount, unifiedOrder, add, loginSysUser);
	}

	@Override
	public void opEditAccountingDimGoods(AccountingUnifiedSupplier statementOfAccount, UnifiedOrder unifiedOrder, UnifiedOrderGoods unifiedOrderGoods, String add, LoginSysUser loginSysUser) {
		accountingUnifiedSupplierServiceOpEditDimGoods.opEditAccountingDimGoods(statementOfAccount, unifiedOrder, unifiedOrderGoods, add, loginSysUser);
	}

	/**
	 * 供应商结算 > 未对账订单 opt 创建对账单
	 *
	 * @param unifiedSupplierCreateDimOrderParam
	 * @param loginSysUser
	 * @return
	 */
	@Deprecated
	@Override
	public AccountingUnifiedSupplier opCreateAccountingDimOrder(UnifiedSupplierCreateDimOrderParam unifiedSupplierCreateDimOrderParam, LoginSysUser loginSysUser) {

		return accountingUnifiedSupplierServiceOpCreateDimOrder.opCreateAccountingDimOrderPreProcess(unifiedSupplierCreateDimOrderParam, loginSysUser);
	}


	/**
	 * 供应商结算 > 未对账商品 opt 创建对账单 商品维度
	 *
	 * @param unifiedSupplierCreateDimGoodsParam
	 * @param loginSysUser
	 * @return
	 */
	@Override
	public R<AccountingUnifiedSupplier> opCreateAccountingDimGoods(UnifiedSupplierCreateDimGoodsParam unifiedSupplierCreateDimGoodsParam, LoginSysUser loginSysUser) {

		return accountingUnifiedSupplierServiceOpCreateDimGoods.opCreateAccountingDimGoodsPreProcess(unifiedSupplierCreateDimGoodsParam, loginSysUser);
	}

	@Override
	public void opRejectAccounting(AccountingUnifiedSupplier statementOfAccount) {
		accountingUnifiedSupplierService.opRejectAccounting(statementOfAccount);
	}

	@Override
	public void opCancelAccounting(AccountingUnifiedSupplier statementOfAccount) {
		accountingUnifiedSupplierService.opCancelAccounting(statementOfAccount);
	}

	@Override
	public void opAgainAccounting(AccountingUnifiedSupplier statementOfAccount) {
		accountingUnifiedSupplierService.opAgainAccounting(statementOfAccount);
	}

	@Override
	public void opDelete(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {
		accountingUnifiedSupplierService.opDelete(statementOfAccount, loginSysUser);
	}

	/****************************************** 状态机 start ******************************************/
	// 创建操作 -> 对账单状态 -> 待提交(3, "待提交"),
	public void opCreate(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {

	}

	// 提交操作 -> 对账单状态 -> 未确认(0, "未确认"),// 已提交
	public void opSubmit(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {
		accountingUnifiedSupplierService.opSubmit(statementOfAccount, loginSysUser);
	}

	// 取消操作 -> 对账单状态 -> 已取消(-1, "已取消"),
	public void opCancel(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {
		accountingUnifiedSupplierService.opCancel(statementOfAccount, loginSysUser);
	}


	// 重新对账操作 -> 对账单状态 -> 已取消(-1, "已取消"),
	public void opAgain(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {
		accountingUnifiedSupplierService.opAgain(statementOfAccount, loginSysUser);
	}

	// 确认操作 -> 对账单状态 -> 已确认(1, "已确认"),
	public void opConfirm(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {
		accountingUnifiedSupplierService.opConfirm(statementOfAccount, loginSysUser);
	}

	// 申诉操作 -> 对账单状态 -> 已拒绝(2, "已拒绝"),
	public void opAppeal(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {
		accountingUnifiedSupplierService.opAppeal(statementOfAccount, loginSysUser);
	}

	/****************************************** 状态机   end ******************************************/

	public AccountingUnifiedSupplierStatementOfAccountFixVoDimOrder checkAmountErrorForFixDimOrder(Map<String, Object> params) {
		return accountingUnifiedSupplierService.checkAmountErrorForFixDimOrder(params);
	}

	public AccountingUnifiedSupplierStatementOfAccountFixVoDimGoods checkAmountErrorForFixDimGoods(Map<String, Object> params) {
		return accountingUnifiedSupplierService.checkAmountErrorForFixDimGoods(params);
	}

	public void patchXDimOrder2DimGoods(String accountingOrderSn) {
		accountingUnifiedSupplierService.patchXDimOrder2DimGoods(accountingOrderSn);
	}

	public String patchXCheckAndFix(String accountingOrderSn) {
		return accountingUnifiedSupplierService.patchXCheckAndFix(accountingOrderSn);
	}
}
