package cn.superdesk.uniorder.dubbo.provider.base;

import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.dubbo.facade.base.DubboUnifiedOrderGoodsService;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderGoods;
import cn.superdesk.uniorder.dto.dubbo.base.UnifiedOrderGoodsParam;
import cn.superdesk.uniorder.service.base.UnifiedOrderGoodsService;
import com.alibaba.dubbo.config.annotation.Service;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-01-06 20:55:13
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-01-06 20:55:13
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Service(version = "1.0.0", retries = -1, timeout = 60000)
public class DubboUnifiedOrderGoodsServiceImpl implements DubboUnifiedOrderGoodsService {

	@Autowired
	private UnifiedOrderGoodsService unifiedOrderGoodsService;


	/****************************************** extends BaseService 部分 start ******************************************/

	@Override
	public void addObj(UnifiedOrderGoodsParam param) {

		UnifiedOrderGoods unifiedOrderGoods = AnBeanUtils.copy(param, UnifiedOrderGoods.class);
		unifiedOrderGoodsService.addObj(unifiedOrderGoods);

	}

	@Override
	public void updateObj(UnifiedOrderGoodsParam param) {

		UnifiedOrderGoods unifiedOrderGoods = AnBeanUtils.copy(param, UnifiedOrderGoods.class);
		unifiedOrderGoodsService.updateObj(unifiedOrderGoods);
	}

	@Override
	public void deleteObj(Long id) {
		unifiedOrderGoodsService.deleteObj(id);
	}

	@Override
	public UnifiedOrderGoods findById(Long id) {
		return unifiedOrderGoodsService.findById(id);
	}

	@Override
	public PageInfo<UnifiedOrderGoods> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
		return unifiedOrderGoodsService.findByPaging(conditions, pageNun, pageSize);
	}

	@Override
	public List<UnifiedOrderGoods> findAll(Map<String, Object> queryMap) {

		return unifiedOrderGoodsService.findAll(queryMap);
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	@Override
	public void addUnifiedOrderGoods(UnifiedOrderGoodsParam param) {

		UnifiedOrderGoods unifiedOrderGoods = AnBeanUtils.copy(param, UnifiedOrderGoods.class);
		unifiedOrderGoodsService.addUnifiedOrderGoods(unifiedOrderGoods);
	}

	@Override
	public void updateUnifiedOrderGoods(UnifiedOrderGoodsParam param) {

		UnifiedOrderGoods unifiedOrderGoods = AnBeanUtils.copy(param, UnifiedOrderGoods.class);
		unifiedOrderGoodsService.updateUnifiedOrderGoods(unifiedOrderGoods);
	}

	@Override
	public void deleteUnifiedOrderGoods(Long id) {
		unifiedOrderGoodsService.deleteUnifiedOrderGoods(id);
	}

	@Override
	public UnifiedOrderGoods findUnifiedOrderGoodsById(Long id) {
		return unifiedOrderGoodsService.findUnifiedOrderGoodsById(id);
	}

	@Override
	public R<List<UnifiedOrderGoods>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {
		return unifiedOrderGoodsService.pageQuery(conditions, pageNun, pageSize);

	}


	/****************************************** 补丁部分 mark by linjinyu at 20210323 start ******************************************/
	@Override
	public String checkAndFixFixTaxRateTaxCodeFiscalCode() {
		return unifiedOrderGoodsService.checkAndFixFixTaxRateTaxCodeFiscalCode();
	}
}
