package cn.superdesk.uniorder.dubbo.provider.base;

import cn.hutool.core.util.StrUtil;
import cn.superdesk.uniorder.common.enums.UnifiedCode;
import cn.superdesk.uniorder.common.enums.common.CommonAccountingLockingEnum;
import cn.superdesk.uniorder.common.enums.common.CommonAccountingStateEnum;
import cn.superdesk.uniorder.common.enums.common.CommonOrderGoodsDirectionEnum;
import cn.superdesk.uniorder.common.enums.order.UnifiedOrderCompletStateEnum;
import cn.superdesk.uniorder.common.enums.statement.AccountingOrderDimCreateByEnum;
import cn.superdesk.uniorder.common.exception.utils.ExceptionUtils;
import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.common.numerical.*;
import cn.superdesk.uniorder.common.pagination.PageQueryParam;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.accounting.unified.customer.AccountingUnifiedCustomer;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrder;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderGoods;
import cn.superdesk.uniorder.dao.entity.organisation.SysEnterprise;
import cn.superdesk.uniorder.dao.entity.organisation.SysOrganization;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dto.param._function.select.SelectOptionDepartmentCriteria;
import cn.superdesk.uniorder.dto.param.accounting.unified.customer.ExportCustomerStatementOfAccountDetailCriteria;
import cn.superdesk.uniorder.dto.param.accounting.unified.supplier.AccountingSupplierNotYetDimGoodsCriteria;
import cn.superdesk.uniorder.dto.param.operation.UnifiedOrderIssuesFlowingParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.UnifiedLnssOrderAdd;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.UnifiedLnssOrderGoodsAdd;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.flashdeliver.FlashDeliverOrderPatchUnifiedOrderFieldOutVirt;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.flashdeliver.FlashDeliverOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.flashdeliver.FlashDeliverRefundOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.flashdeliver.FlashDeliverOrderStatusUpdateReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.ipostoffice.PostOfficeOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.meetingroomreservation.MeetingRoomReservationOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.proxyclient.ProxyClientOrderOptBecomeInvalidQueryCriteria;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.proxyclient.ProxyClientOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.score.ScoreOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.score.refund.ScoreOrderRefundReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.unified.UnifiedOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.unified.refund.UnifiedOrderRefundReceiveParam;
import cn.superdesk.uniorder.dto.vo._function.select.SelectOptionDepartment;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.CustomerUnAccountingDimGoodsVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.UnifiedOrderCustomerHeadSumVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.UnifiedOrderCustomerNotCheckVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.statement.CustomerStatementOfAccountDetailVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.notyet.UnifiedOrderJoinGoodsOfSupplierStatementOfAccount;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.notyet.UnifiedOrderSupplierHeadSumVo;
import cn.superdesk.uniorder.dto.vo.order.Org2VirtStatisticsVo;
import cn.superdesk.uniorder.dto.vo.score.ScoreOrderReconciliationNotYetHeadVo;
import cn.superdesk.uniorder.dto.vo.score.ScoreOrderReconciliationNotYetVo;
import cn.superdesk.uniorder.dto.vo.unified.*;
import cn.superdesk.uniorder.dto.vo.wechat.WxBillOrder;
import cn.superdesk.uniorder.dto.vo.wechat.WxBillVirt;
import cn.superdesk.uniorder.dto.vo.wechat.WxBillVirtItem;
import cn.superdesk.uniorder.dubbo.facade.base.DubboUnifiedOrderService;
import cn.superdesk.uniorder.dubbo.facade.operation.DubboUnifiedOrderIssuesService;
import cn.superdesk.uniorder.dubbo.facade.sys.notify.DubboSysNotifyService;
import cn.superdesk.uniorder.event.CommonEventPublisher;
import cn.superdesk.uniorder.service.accounting.unified.customer.AccountingUnifiedCustomerService;
import cn.superdesk.uniorder.service.accounting.unified.customer.AccountingUnifiedCustomerServiceCommon;
import cn.superdesk.uniorder.service.accounting.unified.supplier.AccountingUnifiedSupplierXGoodsService;
import cn.superdesk.uniorder.service.base.ScoreOrderService;
import cn.superdesk.uniorder.service.base.UnifiedOrderExportExcelService;
import cn.superdesk.uniorder.service.base.UnifiedOrderGoodsService;
import cn.superdesk.uniorder.service.base.UnifiedOrderService;
import cn.superdesk.uniorder.service.base.receive.*;
import cn.superdesk.uniorder.service.marketing.UnifiedStatisticsVirtCommonService;
import cn.superdesk.uniorder.service.organisation.SysEnterpriseService;
import cn.superdesk.uniorder.service.organisation.SysOrganizationService;
import cn.superdesk.uniorder.service.setting.UnifiedSnConfigService;
import com.alibaba.dubbo.config.annotation.Reference;
import com.alibaba.dubbo.config.annotation.Service;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.*;
import java.util.concurrent.CompletableFuture;

/**
 * @Description: 订单管理
 * @Author: linjinyu
 * @CreateDate: 2021/3/5 下午2:45
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/3/5 下午2:45
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service(version = "1.0.0", retries = -1, timeout = 180000)
public class DubboUnifiedOrderServiceImpl implements DubboUnifiedOrderService {

	@Autowired
	private UnifiedOrderService      unifiedOrderService;
	@Autowired
	private UnifiedOrderGoodsService unifiedOrderGoodsService;

	@Autowired
	private ScoreOrderService scoreOrderService;


	/****************************************** kafka 处理类 start ******************************************/

	@Autowired
	private UnifiedOrderReceiveKafkaService       unifiedOrderReceiveKafkaService;
	@Autowired
	private UnifiedOrderRefundReceiveKafkaService unifiedOrderRefundReceiveKafkaService;

	@Autowired
	private ScoreOrderReceiveKafkaService       scoreOrderReceiveKafkaService;
	@Autowired
	private ScoreOrderRefundReceiveKafkaService scoreOrderRefundReceiveKafkaService;

	@Autowired
	private ProxyClientOrderReceiveKafkaService proxyClientOrderReceiveKafkaService;

	@Autowired
	private FlashDeliverOrderReceiveKafkaService       flashDeliverOrderReceiveKafkaService;
	@Autowired
	private FlashDeliverOrderRefundReceiveKafkaService flashDeliverOrderRefundReceiveKafkaService;

	@Autowired
	private PostOfficeOrderReceiveKafkaService postOfficeOrderReceiveKafkaService;

	@Autowired
	private MeetingRoomReservationOrderReceiveKafkaService meetingRoomReservationOrderReceiveKafkaService;

	/****************************************** kafka 处理类   end ******************************************/

	@Autowired
	private AccountingUnifiedCustomerService       accountingUnifiedCustomerService;
	@Autowired
	private AccountingUnifiedCustomerServiceCommon accountingUnifiedCustomerServiceCommon;
	@Autowired
	private AccountingUnifiedSupplierXGoodsService accountingUnifiedSupplierXGoodsService;


	@Autowired
	private UnifiedSnConfigService             unifiedSnConfigService;
	@Autowired
	private UnifiedStatisticsVirtCommonService unifiedStatisticsVirtService;

	@Autowired
	private CommonEventPublisher commonEventPublisher;

	@Autowired
	private SysOrganizationService sysOrganizationService;
	@Autowired
	private SysEnterpriseService   sysEnterpriseService;

	/****************************************** export excel start ******************************************/
	@Autowired
	private UnifiedOrderExportExcelService unifiedOrderExportExcelService;

	/****************************************** 引用自身 Dubbo provider start ******************************************/
	@Reference(version = "1.0.0", timeout = 10000, retries = -1)
	private DubboSysNotifyService          dubboSysNotifyService;
	@Reference(version = "1.0.0", timeout = 10000, retries = -1)
	private DubboUnifiedOrderIssuesService dubboUnifiedOrderIssuesService;


	@Override
	public List<SelectOptionDepartment> getSelectPurchaseDepartment(SelectOptionDepartmentCriteria criteria, LoginSysUser loginSysUser) {

		return unifiedOrderService.getSelectPurchaseDepartment(criteria, loginSysUser);
	}

	/**
	 * 楼闪送 添加订单会被调用
	 *
	 * @param unifiedLnssOrderAdd
	 * @returnl
	 */
	@Override
	public Map<String, Object> addObjTran(UnifiedLnssOrderAdd unifiedLnssOrderAdd) {

		Map<String, Object> response     = new HashMap<>();
		UnifiedOrder        unifiedOrder = new UnifiedOrder();


		/****************************************** 章银洞单问题改的逻辑 mark by linjinyu at 20201209 start ******************************************/
		String orderSn = null;

		if (null != unifiedLnssOrderAdd.getOrderSn()) {
			orderSn = unifiedLnssOrderAdd.getOrderSn();

			UnifiedOrder checkIsExist = unifiedOrderService.findByOrderSn(orderSn);

			if (null != checkIsExist) {
				response.put("code", 50000);
				response.put("msg", "订单已存在");
				return response;
			}

		} else {
			orderSn = unifiedSnConfigService.getSnQuoteDatabase(unifiedLnssOrderAdd.getServiceNo());
		}
		/****************************************** 章银洞单问题改的逻辑 mark by linjinyu at 20201209   end ******************************************/


		if (StringUtils.isEmpty(orderSn)) {
			response.put("code", UnifiedCode.SERVICENO_ERROR.getCode());
			response.put("msg", UnifiedCode.SERVICENO_ERROR.getMsg());
			return response;
		}

		if (AnCollectionUtils.isEmpty(unifiedLnssOrderAdd.getGoods())) {
			response.put("code", UnifiedCode.GOODS_EMPTY.getCode());
			response.put("msg", UnifiedCode.GOODS_EMPTY.getMsg());
			return response;
		}

		try {
			unifiedOrder.setOrderSn(orderSn);
			// TODO 写死
			unifiedOrder.setInvState(2);
			unifiedOrder.setOrderLockingCustomer(CommonAccountingLockingEnum.正常.getKey());
			unifiedOrder.setOrderLockingSupplier(CommonAccountingLockingEnum.正常.getKey());
			unifiedOrder.setAccountingStateCustomer(CommonAccountingStateEnum.未对账.getKey());
			unifiedOrder.setAccountingStateSupplier(CommonAccountingStateEnum.未对账.getKey());

			// 楼闪送-评价状态
			if (StringUtils.isNotEmpty(unifiedLnssOrderAdd.getAppraiseState())) {
				unifiedOrder.setAppraiseState(Integer.valueOf(unifiedLnssOrderAdd.getAppraiseState()));
			} else {
				// TODO 写死
				unifiedOrder.setAppraiseState(2);
			}

			unifiedOrder.setCompletState(UnifiedOrderCompletStateEnum.未完成.getKey());


			// 销售金额
			unifiedOrder.setAmount(unifiedLnssOrderAdd.getAmount());
			// 成本金额
			unifiedOrder.setCostAmount(unifiedLnssOrderAdd.getCostAmount());

			unifiedOrder.setCreateTime(new Date());

			// TODO 未确认 linjinyu 订单状态 start
			unifiedOrder.setOrderState(Integer.valueOf(unifiedLnssOrderAdd.getOrderState()));
			unifiedOrder.setOrderStateName(unifiedLnssOrderAdd.getOrderStateName());
			// TODO 未确认 linjinyu 订单状态 end


			/**
			 *
			 * jsonParam.put("service_no", "LNSS");
			 */
			unifiedOrder.setServiceNo(unifiedLnssOrderAdd.getServiceNo());
			// TODO 楼内送 的 order_type 直接过来? 20200601 对，就是直接过来的 还是个中文 闪送订单
			unifiedOrder.setServiceName(unifiedLnssOrderAdd.getServiceName());


			unifiedOrder.setOtherParams(unifiedLnssOrderAdd.getOtherParams());
			unifiedOrder.setOrderSnOutTrade(unifiedLnssOrderAdd.getOutSn());

			unifiedOrder.setPayType(Integer.valueOf(unifiedLnssOrderAdd.getPayType()));

			if (StringUtils.isNotEmpty(unifiedLnssOrderAdd.getPayState())) {
				unifiedOrder.setPayState(Integer.valueOf(unifiedLnssOrderAdd.getPayState()));
			} else {
				unifiedOrder.setPayState(2);
			}

			unifiedOrder.setProjectId(Long.parseLong(unifiedLnssOrderAdd.getProjectId()));
			SysOrganization org = sysOrganizationService.getByOutOrgId(unifiedOrder.getProjectId());
			if (org != null) {
				unifiedOrder.setProjectName(org.getOrganizationName());
			} else {
				response.put("code", UnifiedCode.PROJECT_ERROR.getCode());
				response.put("msg", UnifiedCode.PROJECT_ERROR.getMsg());
				return response;
			}

			// 企业判断
			if (StringUtils.isNotEmpty(unifiedLnssOrderAdd.getPurchaseVirt())) {
				String[] purchaseVirt = unifiedLnssOrderAdd.getPurchaseVirt().split("_");
				unifiedOrder.setPurchaseVirtId(Long.parseLong(purchaseVirt[1]));
				unifiedOrder.setPurchaseVirtName(purchaseVirt[0]);
			}

			/**
			 * 下单人信息
			 * jsonParam.put("purchase_user", String.format("%s_%d", headerParam.getUserName(), headerParam.getUserId()));
			 */
			String[] purchaseUser = unifiedLnssOrderAdd.getPurchaseUser().split("_");
			int      length       = purchaseUser.length;
			unifiedOrder.setPurchaseUserId(AnLongUtils.getLong(purchaseUser[length-1]));
			unifiedOrder.setPurchaseUserName(purchaseUser[0]);


			/****************************************** add by linjinyu 20200903 ******************************************/

			/**
			 * 下单人信息
			 */
			unifiedOrder.setPurchaseVirtId(unifiedLnssOrderAdd.getPurchaseVirtId());
			unifiedOrder.setPurchaseVirtName(unifiedLnssOrderAdd.getPurchaseVirtName());
			unifiedOrder.setPurchaseUserId(unifiedLnssOrderAdd.getPurchaseUserId());
			unifiedOrder.setPurchaseUserName(unifiedLnssOrderAdd.getPurchaseUserName());
			unifiedOrder.setPurchasePhone(unifiedLnssOrderAdd.getPurchasePhone());

			/**
			 * 收货人信息
			 */
			unifiedOrder.setRecUserid(unifiedLnssOrderAdd.getRecUserId());
			unifiedOrder.setRecUsername(unifiedLnssOrderAdd.getRecUserName());
			unifiedOrder.setRecAddress(unifiedLnssOrderAdd.getRecAddress());
			unifiedOrder.setRecUserphone(unifiedLnssOrderAdd.getRecUserPhone());

			/****************************************** add by linjinyu 20200903 ******************************************/


			/**
			 * 卖方 销售方 信息
			 * jsonParam.put("sale", String.format("%s_%d", saleParam.getSaleName(), saleParam.getSaleId()));
			 */
			String[] sale = unifiedLnssOrderAdd.getSale().split("_");
			unifiedOrder.setSaleId(Long.parseLong(sale[1]));
			unifiedOrder.setSaleName(sale[0]);


			/**
			 * jsonParam.put("settlement_type", "");
			 */
			if (StringUtils.isNotEmpty(unifiedLnssOrderAdd.getSettlementType())) {
				unifiedOrder.setSettlementType(Integer.valueOf(unifiedLnssOrderAdd.getSettlementType()));
			} else {
				// TODO 写死
				unifiedOrder.setSettlementType(2);
			}

			unifiedOrder.setSourceChannel(Integer.valueOf(unifiedLnssOrderAdd.getSourceChannel()));
			unifiedOrder.setTransportAmount(unifiedLnssOrderAdd.getTransportAmount());

			unifiedOrder.setUpdateTime(new Date());
			unifiedOrder.setUserName(unifiedLnssOrderAdd.getUserName());
			unifiedOrder.setUserType(unifiedLnssOrderAdd.getUserType());

			List<UnifiedOrderGoods> unifiedOrderGoodsList = new ArrayList<>();

			for (UnifiedLnssOrderGoodsAdd item : unifiedLnssOrderAdd.getGoods()) {

				UnifiedOrderGoods unifiedOrderGoods = new UnifiedOrderGoods();

				unifiedOrderGoods.setOrderSn(unifiedOrder.getOrderSn());

				unifiedOrderGoods.setDirection(CommonOrderGoodsDirectionEnum.正向.getKey());// 1 为正向 -1 为负向

				unifiedOrderGoods.setGoodsLockingCustomer(CommonAccountingLockingEnum.正常.getKey());
				unifiedOrderGoods.setGoodsLockingSupplier(CommonAccountingLockingEnum.正常.getKey());

				unifiedOrderGoods.setAccountingStateCustomer(CommonAccountingStateEnum.未对账.getKey());
				unifiedOrderGoods.setAccountingStateSupplier(CommonAccountingStateEnum.未对账.getKey());

				/**
				 * jsonGood.put("goods_name", String.format("%s_%d", productEntity.getProductName(), productEntity.getId()));
				 */
				String[] goods = item.getGoods_name().split("_");
				unifiedOrderGoods.setGoodsId(Long.parseLong(goods[1]));
				unifiedOrderGoods.setGoodsName(goods[0]);

				unifiedOrderGoods.setGoodsParams(item.getGoods_params());

				unifiedOrderGoods.setPrice(new BigDecimal(item.getPrice()));
				unifiedOrderGoods.setCostPrice(new BigDecimal(item.getCost_price()));

				unifiedOrderGoods.setQuantity(Integer.parseInt(item.getQuantity()));

				unifiedOrderGoods.setCreateTime(new Date());
				unifiedOrderGoods.setUpdateTime(new Date());

				unifiedOrderGoodsList.add(unifiedOrderGoods);
			}

			UnifiedOrder resUnifiedOrder = unifiedOrderService.addObjTran(unifiedOrder, unifiedOrderGoodsList);

			if (resUnifiedOrder.getId() > 0) {
				response.put("code", 1);
				response.put("sn", resUnifiedOrder.getOrderSn());
				return response;
			} else {
				response.put("code", UnifiedCode.OTHER_ERROR.getCode());
				response.put("msg", UnifiedCode.OTHER_ERROR.getMsg());
				return response;
			}

		} catch (Exception e) {

			e.printStackTrace();

			response.put("code", UnifiedCode.OTHER_ERROR.getCode());
			response.put("msg", "请检查参数");

			return response;
		}
	}

	@Override
	public void updateObj(UnifiedOrder unifiedOrder) {
		unifiedOrderService.updateObj(unifiedOrder);
	}


	/****************************************** 客户结算 对账单 详情 start ******************************************/

//	accountingUnifiedCustomerDubboConsumerService.getCustomerStatementOfAccountDetailDimOrder2Goods(id);
//	accountingUnifiedCustomerDubboConsumerService.getCustomerStatementOfAccountDetailDimGoods2Goods(id);
	public String exportCustomerStatementOfAccountDetailCompatible(ExportCustomerStatementOfAccountDetailCriteria criteria, LoginSysUser loginSysUser) {

		log.info("\n异步操作 包裹 外层 exportCustomerStatementOfAccountDetailCompatible params: \n{}", JsonUtils.toJson(criteria));

		CompletableFuture.runAsync(() -> {
			try {

				// 三步走
				// 1. 数据
				AccountingUnifiedCustomer accountingUnifiedCustomer = accountingUnifiedCustomerService.findById(criteria.getAccountingOrderId());

				CustomerStatementOfAccountDetailVo exportData = null;

				if (null != accountingUnifiedCustomer) {
					switch (AccountingOrderDimCreateByEnum.get(accountingUnifiedCustomer.getDimCreateBy())) {
						case 订单:
							exportData = accountingUnifiedCustomerServiceCommon.getCustomerStatementOfAccountDetailDimOrder2Goods(criteria.getAccountingOrderId());
							break;
						case 商品:
							exportData = accountingUnifiedCustomerServiceCommon.getCustomerStatementOfAccountDetailDimGoods2Goods(criteria.getAccountingOrderId());
							break;
						case 流水:
							log.info("case 流水 exportData 未支持");
							break;
						default:
							log.info("default exportData 未支持");
							break;
					}
				}

				if (null != exportData.getBankInfo()) {
					exportData.setBankInfoCompanyName(exportData.getBankInfo().getCompanyName());
					exportData.setBankInfoBankAccount(exportData.getBankInfo().getBankAccount());
					exportData.setBankInfoBankName(exportData.getBankInfo().getBankName());
					exportData.setBankInfoSupplyName(exportData.getBankInfo().getSupplyName());
					exportData.setBankInfoTel(exportData.getBankInfo().getTel());
					exportData.setBankInfoAddress(exportData.getBankInfo().getAddress());
				}

				exportData.setAccountingAmountStr(new DecimalFormat("###,###.00").format(exportData.getAccountingAmount()));

				// yyyy-MM-dd HH:mm:ss
				exportData.setStartTimeStr(AnDateUtils.format(exportData.getStartTime(), "yyyy年MM月dd日"));
				exportData.setEndTimeStr(AnDateUtils.format(exportData.getEndTime(), "yyyy年MM月dd日"));
				exportData.setCreateTimeStr(AnDateUtils.format(exportData.getCreateTime(), "yyyy年MM月dd日 HH:mm:ss"));


				// 2. 生成excel
				SysNotify sysNotify = unifiedOrderExportExcelService.exportCustomerStatementOfAccountDetailCompatible(accountingUnifiedCustomer.getAccountingOrderSn(), exportData);

				// 3. 通知
				dubboSysNotifyService.notifyExportCustomerStatementOfAccountDetailCompatible(sysNotify, loginSysUser);

			} catch (Exception e2) {
				log.error("\n异步操作 包裹 内层 exportCustomerStatementOfAccountDetailCompatible{} -> 执行 异常:{}", JsonUtils.toJson(criteria), e2);
			}
		});

		return "导出任务已经接收，正在处理中...";
	}

	/****************************************** 客户结算 对账单 详情   end ******************************************/

	/****************************************** 供应商结算 对账单 详情 start ******************************************/

	@Override
	public List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierStatementOfAccountDetailDimOrder2Goods(Map<String, Object> params) {

		return unifiedOrderService.getSupplierStatementOfAccountDetailDimOrder2Goods(params);
	}

	/**
	 * input accountingOrderSn (供应商结算对账 对账单编号)
	 *
	 * @param params
	 * @return
	 */
	@Override
	public List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierStatementOfAccountDetailDimGoods2Goods(/* 实际上只有 String accountingOrderSn */Map<String, Object> params) {

		String accountingOrderSn = AnStringUtils.getString(params.get("accountingOrderSn"));

		return unifiedOrderService.getSupplierStatementOfAccountDetailDimGoods2Goods(accountingOrderSn);
	}

	@Override
	public String exportSupplierStatementOfAccountDetailCompatible(Map<String, Object> params, LoginSysUser loginSysUser) {

		log.info("\n异步操作 包裹 外层 exportSupplierStatementOfAccountDetailCompatible params: \n{}", JsonUtils.toJson(params));

		String accountingOrderSn = AnStringUtils.getString(params.get("accountingOrderSn"));

		CompletableFuture.runAsync(() -> {

			try {

				// 三步走
				// 1. 数据
				// 2. 生成excel
				// 3. 通知
				List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> exportData = getSupplierStatementOfAccountDetailDimGoods2Goods(params);

				SysNotify sysNotify = unifiedOrderExportExcelService.exportSupplierStatementOfAccountDetailCompatible(accountingOrderSn, exportData);

				// 通知
				dubboSysNotifyService.notifyExportSupplierStatementOfAccountDetailCompatible(sysNotify, loginSysUser);

			} catch (Exception e2) {
				log.error("\n异步操作 包裹 内层 exportSupplierStatementOfAccountDetailCompatible{} -> 执行 异常:{}", JsonUtils.toJson(params), e2);
			}
		});

		return "导出任务已经接收，正在处理中...";
	}

	/****************************************** 供应商结算 对账单 详情   end ******************************************/


	@Override
	public UnifiedOrder findByOrderSn(String orderSn) {

		return unifiedOrderService.findByOrderSn(orderSn);
	}


	/****************************************** kafka 一般订单 start ******************************************/

	@Override
	public R<String> httpUnifiedOrderReceive(UnifiedOrderReceiveParam unifiedOrderReceiveParam) {

		R<String> response = new R<>();

		String uid = AnStringUtils.getUUID();
		unifiedOrderReceiveParam.setUid(uid);
		dubboUnifiedOrderIssuesService.developCall(JsonUtils.toJson(unifiedOrderReceiveParam), JsonUtils.toJson(unifiedOrderReceiveParam), unifiedOrderReceiveParam.getOrderSn(), uid);

		UnifiedOrderIssuesFlowingParam callback = unifiedOrderReceiveKafkaService.kafkaUnifiedOrderReceive(unifiedOrderReceiveParam);
		if (StrUtil.isNotBlank(unifiedOrderReceiveParam.getMessageId())) {
			callback.setMessageId(unifiedOrderReceiveParam.getMessageId());
		}

		commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		return response;
	}

	@Override
	public R<String> httpUnifiedOrderRefundReceive(UnifiedOrderRefundReceiveParam unifiedOrderRefundReceiveParam) {

		R<String> response = new R<>();

		String uid = AnStringUtils.getUUID();
		unifiedOrderRefundReceiveParam.setUid(uid);
		dubboUnifiedOrderIssuesService.developCall(JsonUtils.toJson(unifiedOrderRefundReceiveParam), JsonUtils.toJson(unifiedOrderRefundReceiveParam), unifiedOrderRefundReceiveParam.getOrder().getRefundSn(), uid);

		UnifiedOrderIssuesFlowingParam callback = unifiedOrderRefundReceiveKafkaService.kafkaUnifiedOrderRefundReceive(unifiedOrderRefundReceiveParam);

		commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		return response;
	}


	@Override
	public void kafkaUnifiedOrderReceive(String message) {

		log.info("##################### kafkaUnifiedOrderReceive start #####################\n原始:\n{}", message);

		try {

			UnifiedOrderReceiveParam unifiedOrderReceiveParam = JsonUtils.toObject(message, UnifiedOrderReceiveParam.class);
			log.info("\n转换:\n{}", JsonUtils.toJson(unifiedOrderReceiveParam));

			// TODO 在这里写吧
			String uid = AnStringUtils.getUUID();
			unifiedOrderReceiveParam.setUid(uid);
			dubboUnifiedOrderIssuesService.developCall(message, JsonUtils.toJson(unifiedOrderReceiveParam), unifiedOrderReceiveParam.getOrderSn(), uid);

			UnifiedOrderIssuesFlowingParam callback = unifiedOrderReceiveKafkaService.kafkaUnifiedOrderReceive(unifiedOrderReceiveParam);
			if (StrUtil.isNotBlank(unifiedOrderReceiveParam.getMessageId())) {
				callback.setMessageId(unifiedOrderReceiveParam.getMessageId());
			}

			commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		} catch (Exception e) {

			log.error("kafka 商城 订单 超级前台(一般) 正单 同步 错误 \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}
	}

	@Override
	public void kafkaUnifiedOrderRefundReceive(String message) {

		log.info("\n##################### kafkaUnifiedOrderRefundReceive start #####################\n原始:\n{}", message);

		try {

			UnifiedOrderRefundReceiveParam unifiedOrderRefundReceiveParam = JsonUtils.toObject(message, UnifiedOrderRefundReceiveParam.class);
			log.info("\n转换:\n{}", JsonUtils.toJson(unifiedOrderRefundReceiveParam));

			// TODO 在这里写吧
			String uid = AnStringUtils.getUUID();
			unifiedOrderRefundReceiveParam.setUid(uid);
			dubboUnifiedOrderIssuesService.developCall(message, JsonUtils.toJson(unifiedOrderRefundReceiveParam), unifiedOrderRefundReceiveParam.getOrder().getRefundSn(), uid);

			UnifiedOrderIssuesFlowingParam callback = unifiedOrderRefundReceiveKafkaService.kafkaUnifiedOrderRefundReceive(unifiedOrderRefundReceiveParam);

			commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		} catch (Exception e) {

			log.error("kafka 商城 订单 超级前台(一般) 退单 同步 错误 \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}


	}

	/****************************************** kafka 一般订单   end ******************************************/


	/****************************************** kafka 积分订单 start ******************************************/


	/**
	 * http 积分订单 mark by linjinyu at 20210308
	 *
	 * @param orderReceiveParam
	 * @return
	 */
	@Override
	public R<String> httpScoreOrderReceive(ScoreOrderReceiveParam orderReceiveParam) {

		R<String> response = new R<>();

		String uid = AnStringUtils.getUUID();
		orderReceiveParam.setUid(uid);
		dubboUnifiedOrderIssuesService.developCall(JsonUtils.toJson(orderReceiveParam), JsonUtils.toJson(orderReceiveParam), orderReceiveParam.getOrderSn(), uid);

		UnifiedOrderIssuesFlowingParam callback = scoreOrderReceiveKafkaService.kafkaScoreOrderReceive(orderReceiveParam);

		commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		return response;
	}

	/**
	 * http 积分订单 mark by linjinyu at 20210308
	 *
	 * @param refundOrderReceiveParam
	 * @return
	 */
	@Override
	public R<String> httpScoreOrderRefundReceive(ScoreOrderRefundReceiveParam refundOrderReceiveParam) {

		R<String> response = new R<>();

		String uid = AnStringUtils.getUUID();
		refundOrderReceiveParam.setUid(uid);
		dubboUnifiedOrderIssuesService.developCall(JsonUtils.toJson(refundOrderReceiveParam), JsonUtils.toJson(refundOrderReceiveParam), refundOrderReceiveParam.getOrder().getRefundNo(), uid);

		UnifiedOrderIssuesFlowingParam callback = scoreOrderRefundReceiveKafkaService.kafkaScoreOrderRefundReceive(refundOrderReceiveParam);

		commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		return response;
	}

	@Override
	public void kafkaScoreOrderReceive(String message) {

		log.info("##################### kafkaScoreOrderReceive start #####################\n原始:\n{}", message);

		try {

			ScoreOrderReceiveParam scoreOrderReceiveParam = JsonUtils.toObject(message, ScoreOrderReceiveParam.class);
			log.info("\n转换:\n{}", JsonUtils.toJson(scoreOrderReceiveParam));

			// TODO 在这里写吧
			String uid = AnStringUtils.getUUID();
			scoreOrderReceiveParam.setUid(uid);
			dubboUnifiedOrderIssuesService.developCall(message, JsonUtils.toJson(scoreOrderReceiveParam), scoreOrderReceiveParam.getOrderSn(), uid);

			UnifiedOrderIssuesFlowingParam callback = scoreOrderReceiveKafkaService.kafkaScoreOrderReceive(scoreOrderReceiveParam);

			commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		} catch (Exception e) {

			log.error("kafka 商城 订单 侨城汇(积分) 正单 同步 错误 \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}
	}

	@Override
	public void kafkaScoreOrderRefundReceive(String message) {

		log.info("##################### kafkaScoreOrderRefundReceive start #####################\n原始:\n{}", message);

		try {

			ScoreOrderRefundReceiveParam scoreOrderRefundReceiveParam = JsonUtils.toObject(message, ScoreOrderRefundReceiveParam.class);
			log.info("\n转换:\n{}", JsonUtils.toJson(scoreOrderRefundReceiveParam));


			// TODO 在这里写吧
			String uid = AnStringUtils.getUUID();
			scoreOrderRefundReceiveParam.setUid(uid);
			dubboUnifiedOrderIssuesService.developCall(message, JsonUtils.toJson(scoreOrderRefundReceiveParam), scoreOrderRefundReceiveParam.getOrder().getRefundNo(), uid);

			UnifiedOrderIssuesFlowingParam callback = scoreOrderRefundReceiveKafkaService.kafkaScoreOrderRefundReceive(scoreOrderRefundReceiveParam);

			commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		} catch (Exception e) {
			log.error("kafka 商城 订单 侨城汇(积分) 退单 同步 错误 \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}

	}
	/****************************************** kafka 积分订单   end ******************************************/

	/****************************************** kafka 服务之窗 楼闪送 start ******************************************/

	@Override
	public R<String> httpFlashDeliverOrderReceive(FlashDeliverOrderReceiveParam orderReceiveParam) {

		R<String> response = new R<>();

		String uid = AnStringUtils.getUUID();
		orderReceiveParam.setUid(uid);
		dubboUnifiedOrderIssuesService.developCall(JsonUtils.toJson(orderReceiveParam), JsonUtils.toJson(orderReceiveParam), orderReceiveParam.getOrderSn(), uid);

		UnifiedOrderIssuesFlowingParam callback = flashDeliverOrderReceiveKafkaService.kafkaFlashdeliverOrderReceive(orderReceiveParam);

		commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		return response;
	}

	@Override
	public R<String> httpFlashDeliverOrderRefundReceive(FlashDeliverRefundOrderReceiveParam refundOrderReceiveParam) {

		R<String> response = new R<>();

		String uid = AnStringUtils.getUUID();
		refundOrderReceiveParam.setUid(uid);
		dubboUnifiedOrderIssuesService.developCall(JsonUtils.toJson(refundOrderReceiveParam), JsonUtils.toJson(refundOrderReceiveParam), refundOrderReceiveParam.getOrder().getRefundOrderSn(), uid);

		UnifiedOrderIssuesFlowingParam callback = flashDeliverOrderRefundReceiveKafkaService.kafkaFlashdeliverOrderRefundReceive(refundOrderReceiveParam);

		commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		return response;
	}

	@Override
	public void kafkaFlashDeliverOrderReceive(String message) {

		log.info("##################### kafkaFlashdeliverOrderReceive start #####################\n原始:\n{}", message);

		try {

			FlashDeliverOrderReceiveParam flashdeliverOrderReceiveParam = JsonUtils.toObject(message, FlashDeliverOrderReceiveParam.class);
			log.info("\n转换:\n{}", JsonUtils.toJson(flashdeliverOrderReceiveParam));

			// TODO 在这里写吧
			String uid = AnStringUtils.getUUID();
			flashdeliverOrderReceiveParam.setUid(uid);
			dubboUnifiedOrderIssuesService.developCall(message, JsonUtils.toJson(flashdeliverOrderReceiveParam), flashdeliverOrderReceiveParam.getOrderSn(), uid);

			UnifiedOrderIssuesFlowingParam callback = flashDeliverOrderReceiveKafkaService.kafkaFlashdeliverOrderReceive(flashdeliverOrderReceiveParam);

			commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		} catch (Exception e) {

			log.error("kafka 楼闪送 订单 同步 错误 \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}
	}

	@Override
	public void kafkaFlashDeliverOrderRefundReceive(String message) {

		log.info("##################### kafkaFlashdeliverOrderRefundReceive start #####################\n原始:\n{}", message);

		try {

			FlashDeliverRefundOrderReceiveParam flashdeliverOrderRefundReceiveParam = JsonUtils.toObject(message, FlashDeliverRefundOrderReceiveParam.class);
			log.info("\n转换:\n{}", JsonUtils.toJson(flashdeliverOrderRefundReceiveParam));


			// TODO 在这里写吧
			String uid = AnStringUtils.getUUID();
			flashdeliverOrderRefundReceiveParam.setUid(uid);
			dubboUnifiedOrderIssuesService.developCall(message, JsonUtils.toJson(flashdeliverOrderRefundReceiveParam), flashdeliverOrderRefundReceiveParam.getOrder().getRefundOrderSn(), uid);

			UnifiedOrderIssuesFlowingParam callback = flashDeliverOrderRefundReceiveKafkaService.kafkaFlashdeliverOrderRefundReceive(flashdeliverOrderRefundReceiveParam);

			commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		} catch (Exception e) {
			log.error("kafka 楼闪送 退单 同步 错误 \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}
	}

	@Override
	public void kafkaFlashDeliverOrderReceiveStateUpdate(String message) {

		log.info("##################### kafkaFlashDeliverOrderStateUpdate start #####################\n原始:\n{}", message);

		try {
			FlashDeliverOrderStatusUpdateReceiveParam flashdeliverOrderStatusUpdateReceiveParam = JsonUtils.toObject(message, FlashDeliverOrderStatusUpdateReceiveParam.class);

			flashDeliverOrderReceiveKafkaService.kafkaFlashDeliverOrderReceiveStateUpdate(flashdeliverOrderStatusUpdateReceiveParam);

		} catch (Exception e) {

			log.error("kafka 楼闪送 订单 超级前台(一般) 正单 同步 错误 \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}

	}
	/****************************************** kafka 服务之窗 楼闪送   end ******************************************/

	/****************************************** kafka patchUnifiedOrderFieldOutVirt start ******************************************/
	public void kafkaFlashDeliverPatchUnifiedOrderFieldOutVirt(String message) {

		try {

			FlashDeliverOrderPatchUnifiedOrderFieldOutVirt patchUnifiedOrderFieldOutVirt = JsonUtils.toObject(message, FlashDeliverOrderPatchUnifiedOrderFieldOutVirt.class);
			log.info("\n转换:\n{}", JsonUtils.toJson(patchUnifiedOrderFieldOutVirt));

			// TODO 在这里写吧
			String uid = AnStringUtils.getUUID();
			patchUnifiedOrderFieldOutVirt.setUid(uid);
			dubboUnifiedOrderIssuesService.developCall(message, JsonUtils.toJson(patchUnifiedOrderFieldOutVirt), patchUnifiedOrderFieldOutVirt.getOrderSn(), uid);

			UnifiedOrderIssuesFlowingParam callback = flashDeliverOrderReceiveKafkaService.kafkaFlashDeliverPatchUnifiedOrderFieldOutVirt(patchUnifiedOrderFieldOutVirt);

			commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		} catch (Exception e) {
			log.error("kafka 小邮局 同步 错误 \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}
	}
	/****************************************** kafka patchUnifiedOrderFieldOutVirt   end ******************************************/

	/****************************************** kafka 服务之窗 小邮局订单 start ******************************************/
	@Override
	public void kafkaPostOfficeOrderMergeReceive(String message) {

		try {

			PostOfficeOrderReceiveParam postOfficeOrderReceiveParam = JsonUtils.toObject(message, PostOfficeOrderReceiveParam.class);
			log.info("\n转换:\n{}", JsonUtils.toJson(postOfficeOrderReceiveParam));

			// TODO 在这里写吧
			String uid = AnStringUtils.getUUID();
			postOfficeOrderReceiveParam.setUid(uid);
			dubboUnifiedOrderIssuesService.developCall(message, JsonUtils.toJson(postOfficeOrderReceiveParam), postOfficeOrderReceiveParam.getOrderSn(), uid);

			UnifiedOrderIssuesFlowingParam callback = postOfficeOrderReceiveKafkaService.kafkaPostOfficeOrderMergeReceive(postOfficeOrderReceiveParam);

			commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		} catch (Exception e) {
			log.error("kafka 小邮局 同步 错误 \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}
	}

	@Override
	public void kafkaPostOfficeOrderDeleteReceive(String message) {

		try {
			postOfficeOrderReceiveKafkaService.kafkaPostOfficeOrderDeleteReceive(message);
		} catch (Exception e) {
			log.error("kafka 小邮局 订单 退单 同步 错误 \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}
	}
	/****************************************** kafka 服务之窗 小邮局订单   end ******************************************/

	/****************************************** kafka 服务之窗 会议室预约 start ******************************************/

	@Override
	public R<String> httpMeetingRoomReservationOrderMergeReceive(MeetingRoomReservationOrderReceiveParam meetingRoomReservationOrderReceiveParam) {

		R<String> response = new R<>();

		String uid = AnStringUtils.getUUID();
		meetingRoomReservationOrderReceiveParam.setUid(uid);
		dubboUnifiedOrderIssuesService.developCall(JsonUtils.toJson(meetingRoomReservationOrderReceiveParam), JsonUtils.toJson(meetingRoomReservationOrderReceiveParam), meetingRoomReservationOrderReceiveParam.getOrderSn(), uid);

		UnifiedOrderIssuesFlowingParam callback = meetingRoomReservationOrderReceiveKafkaService.kafkaMeetingRoomReservationOrderMergeReceive(meetingRoomReservationOrderReceiveParam);

		commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		return response;
	}

	@Override
	public void kafkaMeetingRoomReservationOrderMergeReceive(String message) {

		// TODO 20210927 ...

		try {

			MeetingRoomReservationOrderReceiveParam meetingRoomReservationOrderReceiveParam = JsonUtils.toObject(message, MeetingRoomReservationOrderReceiveParam.class);
			log.info("\n转换:\n{}", JsonUtils.toJson(meetingRoomReservationOrderReceiveParam));

			// TODO 在这里写吧
			String uid = AnStringUtils.getUUID();
			meetingRoomReservationOrderReceiveParam.setUid(uid);
			dubboUnifiedOrderIssuesService.developCall(message, JsonUtils.toJson(meetingRoomReservationOrderReceiveParam), meetingRoomReservationOrderReceiveParam.getOrderSn(), uid);

			UnifiedOrderIssuesFlowingParam callback = meetingRoomReservationOrderReceiveKafkaService.kafkaMeetingRoomReservationOrderMergeReceive(meetingRoomReservationOrderReceiveParam);

			commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		} catch (Exception e) {
			log.error("kafka 会议室预约订单 kafkaMeetingRoomReservationOrderMergeReceive \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}
	}

	@Override
	public void kafkaMeetingRoomReservationOrderDeleteReceive(String message) {

		// TODO 20210927 ...

		try {
			meetingRoomReservationOrderReceiveKafkaService.kafkaMeetingRoomReservationOrderDeleteReceive(message);
		} catch (Exception e) {
			log.error("kafka 会议室预约订单 kafkaMeetingRoomReservationOrderDeleteReceive \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}
	}

	/****************************************** kafka 服务之窗 会议室预约 start ******************************************/

	/****************************************** kafka 代客下单 start ******************************************/

	@Override
	public void kafkaProxyClientOrderReceive(String message) {

		log.info("##################### kafkaProxyClientOrderReceive start #####################\n原始:\n{}", message);

		try {

			ProxyClientOrderReceiveParam proxyClientOrderReceiveParam = JsonUtils.toObject(message, ProxyClientOrderReceiveParam.class);
			log.info("\n转换:\n{}", JsonUtils.toJson(proxyClientOrderReceiveParam));

			// TODO 在这里写吧
			String uid = AnStringUtils.getUUID();
			proxyClientOrderReceiveParam.setUid(uid);

			dubboUnifiedOrderIssuesService.developCall(message, JsonUtils.toJson(proxyClientOrderReceiveParam), proxyClientOrderReceiveParam.getOrderSn(), uid);

			UnifiedOrderIssuesFlowingParam callback = proxyClientOrderReceiveKafkaService.kafkaProxyClientOrderReceive(proxyClientOrderReceiveParam);

			commonEventPublisher.triggerUnifiedOrderDevelopCallBack(callback);

		} catch (Exception e) {

			log.error("kafka 代客下单 订单 正负零单 同步 错误 \n " + ExceptionUtils.getMessage(e));

			e.printStackTrace();
		}
	}

	@Override
	public R<String> proxyClientOrderOptBecomeInvalid(ProxyClientOrderOptBecomeInvalidQueryCriteria queryCriteria) {


		return unifiedOrderService.proxyClientOrderOptBecomeInvalid(queryCriteria);

	}
	/****************************************** kafka 代客下单   end ******************************************/


	/****************************************** 订单管理 start ******************************************/
	@Override
	public UnifiedOrderCommonHeadSum getOrderManagerGoodsPageHead(Map<String, Object> params) {

		return unifiedOrderService.getOrderManagerGoodsPageHead(params);
	}

	@Override
	public List<ViewUnifiedOrderGoods> getOrderManagerGoodsView(Map<String, Object> params) {

		return unifiedOrderService.getOrderManagerGoodsView(params);
	}

	/****************************************** 订单管理-列表数据导出 export excel start ******************************************/

	@Override
	public String exportExcelOrderManagerGoodsData(Map<String, Object> params, LoginSysUser loginSysUser) {

		// 异步操作 包裹 mark by linjinyu at 20210305
		log.info("\n异步操作 包裹 外层 exportExcelOrderManagerGoodsData params: \n{}", JsonUtils.toJson(params));

		CompletableFuture.runAsync(() -> {

			try {

				// 三步走 mark by linjinyu at 20210305
				// 1. 数据
				// 2. 生成excel
				// 3. 通知
				// TODO 排序 订单 create_time 升
				params.put("orderBy", "uo.create_time asc , uo.order_sn asc, uog.id asc");
				List<ViewUnifiedOrderGoods> exportData = getOrderManagerGoodsView(params);

				SysNotify sysNotify = unifiedOrderExportExcelService.exportExcelOrderManagerGoodsData(exportData);

				// 通知
				dubboSysNotifyService.notifyExportExcelOrderManagerGoodsData(sysNotify, loginSysUser);


			} catch (Exception e2) {
				log.error("\n异步操作 包裹 内层 exportExcelOrderManagerGoodsData{} -> 执行 异常:{}", JsonUtils.toJson(params), e2);
			}
		});

		return "导出任务已经接收，正在处理中...";
	}

	@Override
	public String exportExcelOrderManagerGoodsCostPrice(Map<String, Object> params, LoginSysUser loginSysUser) {

		// 异步操作 包裹 mark by linjinyu at 20210305
		log.info("\n异步操作 包裹 外层 exportExcelOrderManagerGoodsCostPrice params: \n{}", JsonUtils.toJson(params));

		CompletableFuture.runAsync(() -> {

			try {

				// 三步走 mark by linjinyu at 20210305
				// 1. 数据
				// 2. 生成excel
				// 3. 通知
				// TODO 排序 订单 create_time 升
				params.put("orderBy", "uo.create_time asc , uo.order_sn asc, uog.id asc");
				List<ViewUnifiedOrderGoods> exportData = getOrderManagerGoodsView(params);

				SysNotify sysNotify = unifiedOrderExportExcelService.exportExcelOrderManagerGoodsCostPrice(exportData);

				// 通知
				dubboSysNotifyService.notifyExportExcelOrderManagerGoodsCostPrice(sysNotify, loginSysUser);


			} catch (Exception e2) {
				log.error("\n异步操作 包裹 内层 exportExcelOrderManagerGoodsCostPrice{} -> 执行 异常:{}", JsonUtils.toJson(params), e2);
			}
		});

		return "导出任务已经接收，正在处理中...";

	}

	/****************************************** 订单管理-列表数据导出 export excel   end ******************************************/

	@Override
	public R<List<Org2VirtStatisticsVo>> getOrg2VirtStatistics(Map<String, Object> params, int pageNum, int pageSize) {

		R<List<Org2VirtStatisticsVo>> response = unifiedOrderService.getOrg2VirtStatistics(params, pageNum, pageSize);

		if (AnCollectionUtils.isNotEmpty(response.getData())) {
			response.getData().forEach(item -> {
				if (null == item.getVirtId() && null == item.getVirtName()) {
					item.setVirtName("无企业，游客?");
				} else if (null != item.getVirtId() && null == item.getVirtName()) {
					item.setVirtName(StrUtil.format("企业[{}]数据异常", item.getVirtId()));
				}
			});
		}

		return response;
	}


	/**
	 * 一般订单 得未结算数据 商品维度
	 *
	 * @param params
	 * @param pageNum
	 * @param pageSize
	 * @return
	 */
	@Override
	public R<List<ViewUnifiedOrderGoods>> getOrderManagerGoodsByPage(Map<String, Object> params, int pageNum,
	                                                                 int pageSize) {

		return unifiedOrderService.getOrderManagerGoodsByPage(params, pageNum, pageSize);
	}
	/****************************************** 订单管理   end ******************************************/


	/****************************************** 客户结算 dim order 未对账 订单 start ******************************************/
	@Override
	public UnifiedOrderCommonHeadSum getCustomerUnAccountingDimOrderHeadSum(Map<String, Object> params) {

		return unifiedOrderService.getCustomerUnAccountingDimOrderHeadSum(params);
	}

	@Override
	public R<List<UnifiedOrderCustomerNotCheckVo>> getCustomerUnAccountingDimOrderList(Map<String, Object> params, int pageNum, int pageSize) {

		return unifiedOrderService.getCustomerUnAccountingDimOrderList(params, pageNum, pageSize);
	}

	@Override
	public String exportExcelAccountingCustomerNotYetDimOrder(Map<String, Object> params, LoginSysUser loginSysUser) {

		log.info("\n异步操作 包裹 外层 exportExcelAccountingCustomerNotYetDimOrder params: \n{}", JsonUtils.toJson(params));

		CompletableFuture.runAsync(() -> {

			try {

				// 三步走
				// 1. 数据
				// 2. 生成excel
				// 3. 通知
				List<UnifiedOrderJoinGoodsDetailVo> exportData = unifiedOrderGoodsService.getUnifiedOrderJoinGoodsDetailVoList(params);

				SysNotify sysNotify = unifiedOrderExportExcelService.exportExcelAccountingCustomerNotYetDimOrder(exportData);

				// 通知
				dubboSysNotifyService.notifyExportExcelAccountingCustomerNotYetDimOrder(sysNotify, loginSysUser);

			} catch (Exception e2) {
				log.error("\n异步操作 包裹 内层 exportExcelAccountingCustomerNotYetDimOrder {} -> 执行 异常:{}", JsonUtils.toJson(params), e2);
			}
		});

		return "导出任务已经接收，正在处理中...";
	}

	/****************************************** 客户结算 dim order 未对账 订单   end ******************************************/

	/****************************************** 客户结算 dim goods 未对账 商品 start ******************************************/
	@Override
	public UnifiedOrderCustomerHeadSumVo getCustomerUnAccountingDimGoodsHeadSum(String token, Map<String, Object> params) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		return unifiedOrderService.getCustomerUnAccountingDimGoodsHeadSum(params, loginSysUser);
	}

	@Override
	public List<CustomerUnAccountingDimGoodsVo> getCustomerUnAccountingDimGoodsList(String token, Map<String, Object> params) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		// TODO 排序 订单 create_time 倒 默认
//		params.put("orderBy", "uo.create_time desc , uo.order_sn desc, uog.id asc");
		return unifiedOrderService.getCustomerUnAccountingDimGoodsList(params, loginSysUser);
	}

	/**
	 * 新版导出
	 *
	 * @param params
	 * @param loginSysUser
	 * @return
	 */
	@Override
	public String exportExcelAccountingCustomerNotYetDimGoods(Map<String, Object> params, LoginSysUser loginSysUser) {

		log.info("\n异步操作 包裹 外层 exportExcelAccountingCustomerNotYetDimGoods params: \n{}", JsonUtils.toJson(params));

		CompletableFuture.runAsync(() -> {

			try {

				// 三步走
				// 1. 数据
				// 2. 生成excel
				// 3. 通知
				// TODO 排序 订单 create_time 升
				params.put("orderBy", "uo.create_time asc , uo.order_sn asc, uog.id asc");
				List<CustomerUnAccountingDimGoodsVo> exportData = unifiedOrderService.getCustomerUnAccountingDimGoodsList(params, loginSysUser);

				SysNotify sysNotify = unifiedOrderExportExcelService.exportExcelAccountingCustomerNotYetDimGoods(exportData);

				// 通知
				dubboSysNotifyService.notifyExportExcelAccountingCustomerNotYetDimGoods(sysNotify, loginSysUser);

			} catch (Exception e2) {
				log.error("\n异步操作 包裹 内层 exportExcelAccountingCustomerNotYetDimGoods {} -> 执行 异常:{}", JsonUtils.toJson(params), e2);
			}
		});

		return "导出任务已经接收，正在处理中...";
	}

	@Override
	public R<List<CustomerUnAccountingDimGoodsVo>> getCustomerUnAccountingDimGoodsList(String token, Map<String, Object> params, int pageNo, int pageSize) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		return unifiedOrderService.getCustomerUnAccountingDimGoodsList(params, pageNo, pageSize, loginSysUser);
	}

	/****************************************** 客户结算 dim goods 未对账 商品   end ******************************************/


	/****************************************** 积分结算 dim credit 未对账 流水 start ******************************************/

	public ScoreOrderReconciliationNotYetHeadVo getScoreOrderReconciliationNotYetHeadSum(String token, Map<String, Object> params) {
		return scoreOrderService.getScoreOrderReconciliationNotYetHeadSum(params);
	}

	/**
	 * 积分订单 得未结算数据 积分流水维度
	 *
	 * @param token
	 * @param params
	 * @param pageNum
	 * @param pageSize
	 * @return
	 */
	public R<List<ScoreOrderReconciliationNotYetVo>> getScoreOrderReconciliationNotYet(String token, Map<String, Object> params, int pageNum, int pageSize) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		return scoreOrderService.getScoreOrderReconciliationNotYet(params, pageNum, pageSize, loginSysUser);
	}

	public List<ScoreOrderReconciliationNotYetVo> getScoreOrderReconciliationNotYet(String token, Map<String, Object> params) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		return scoreOrderService.getScoreOrderReconciliationNotYet(params, loginSysUser);
	}

	@Override
	public String exportExcelScoreOrderReconciliationNotYet(Map<String, Object> params, LoginSysUser loginSysUser) {

		log.info("\n异步操作 包裹 外层 exportExcelScoreOrderReconciliationNotYet params: \n{}", JsonUtils.toJson(params));

		CompletableFuture.runAsync(() -> {

			try {

				List<ScoreOrderReconciliationNotYetVo> exportData = scoreOrderService.getScoreOrderReconciliationNotYet(params, loginSysUser);

				SysNotify sysNotify = unifiedOrderExportExcelService.exportExcelScoreOrderReconciliationNotYet(exportData);

				// 通知
				dubboSysNotifyService.notifyExportExcelScoreOrderReconciliationNotYet(sysNotify, loginSysUser);


			} catch (Exception e2) {
				log.error("\n异步操作 包裹 内层 exportExcelScoreOrderReconciliationNotYet {} -> 执行 异常:{}", JsonUtils.toJson(params), e2);
			}
		});

		return "导出任务已经接收，正在处理中...";
	}
	/****************************************** 积分结算 dim credit 未对账 流水   end ******************************************/


	/****************************************** 供应商结算 dim order 未对账 订单 start ******************************************/
	@Override
	public UnifiedOrderSupplierHeadSumVo getSupplierUnAccountingDimOrderHeadSum(Map<String, Object> params) {

		return unifiedOrderService.getSupplierUnAccountingDimOrderHeadSum(params);
	}

	@Override
	public R<List<UnifiedOrderSupplierDimOrderNotCheckVo>> getSupplierUnAccountingDimOrderList(Map<String, Object> params, int pageNum, int pageSize) {

		return unifiedOrderService.getSupplierUnAccountingDimOrderList(params, pageNum, pageSize);
	}

	@Override
	public List<UnifiedOrderSupplierDimOrderNotCheckVo> getSupplierUnAccountingDimOrderList(Map<String, Object> params) {

		return unifiedOrderService.getSupplierUnAccountingDimOrderList(params);
	}


	@Override
	public List<UnifiedOrderSupplierNotCheckDetail2GoodsVo> getSupplierUnAccountingDetail2Goods(Map<String, Object> params) {

		return unifiedOrderService.getSupplierUnAccountingDetail2Goods(params);
	}

	/****************************************** 供应商结算 dim order 未对账 订单   end ******************************************/


	/****************************************** 供应商结算 dim goods 未对账 商品 start ******************************************/

	@Override
	public UnifiedOrderSupplierHeadSumVo getSupplierUnAccountingDimGoodsHeadSum(AccountingSupplierNotYetDimGoodsCriteria criteria) {
		return unifiedOrderService.getSupplierUnAccountingDimGoodsHeadSum(criteria);
	}

	@Override
	public List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierUnAccountingDimGoodsList(AccountingSupplierNotYetDimGoodsCriteria criteria) {
		return unifiedOrderService.getSupplierUnAccountingDimGoodsList(criteria);
	}

	public R<List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount>> getSupplierUnAccountingDimGoodsListByPageQuery(AccountingSupplierNotYetDimGoodsCriteria criteria) {
		return unifiedOrderService.getSupplierUnAccountingDimGoodsListByPageQuery(criteria);
	}

	@Override
	public String exportExcelAccountingSupplierNotYetDimGoods(AccountingSupplierNotYetDimGoodsCriteria criteria, LoginSysUser loginSysUser) {

		log.info("\n异步操作 包裹 外层 exportExcelAccountingSupplierNotYetDimGoods params: \n{}", JsonUtils.toJson(criteria));

		CompletableFuture.runAsync(() -> {

			try {

				// 三步走 mark by linjinyu at 20210305
				// 1. 数据
				// 2. 生成excel
				// 3. 通知

				List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> exportData = getSupplierUnAccountingDimGoodsList(criteria);

				SysNotify sysNotify = unifiedOrderExportExcelService.exportExcelAccountingSupplierNotYetDimGoods(exportData);

				// 通知
				dubboSysNotifyService.notifyExportExcelAccountingSupplierNotYetDimGoods(sysNotify, loginSysUser);


			} catch (Exception e2) {
				log.error("\n异步操作 包裹 内层 exportExcelAccountingSupplierNotYetDimGoods{} -> 执行 异常:{}", JsonUtils.toJson(criteria), e2);
			}
		});

		return "导出任务已经接收，正在处理中...";
	}
	/****************************************** 供应商结算 dim goods 未对账 商品   end ******************************************/


	/**
	 * 这个有个报错 ， 数据问题， 里边的东西有可能为空 大概是goods的问题
	 *
	 * @param id
	 * @return
	 */
	@Override
	public UnifiedOrderGoodsDetail getGoodsDetail(Long id) {

		UnifiedOrderGoods orderGoods = unifiedOrderGoodsService.findById(id);

		UnifiedOrder order = unifiedOrderService.findByOrderSn(orderGoods.getOrderSn());

		UnifiedOrderGoodsDetail unifiedOrderGoodsDetail = AnConvertBeanUtil.copyBean(order, UnifiedOrderGoodsDetail.class);

		unifiedOrderGoodsDetail.setGoodsName(orderGoods.getGoodsName());
		unifiedOrderGoodsDetail.setGoodsParams(orderGoods.getGoodsParams());
		unifiedOrderGoodsDetail.setPrice(orderGoods.getPrice());
		unifiedOrderGoodsDetail.setQuantity(orderGoods.getQuantity());

		return unifiedOrderGoodsDetail;
	}

	/****************************************** 1. 页面-客户结算对账 未对账商品 start ******************************************/
	/**
	 * 列表
	 *
	 * @param params
	 * @return
	 */
	@Override
	public List<UnifiedOrderJoinGoodsDetailVo> getUnifiedOrderJoinGoodsDetailVoList(Map<String, Object> params) {

		return unifiedOrderGoodsService.getUnifiedOrderJoinGoodsDetailVoList(params);
	}


	/****************************************** 1. 页面-客户结算对账 未对账商品   end ******************************************/

	@Override
	public List<UnifiedOrder> findAll(Map<String, Object> queryMap) {

		return unifiedOrderService.findAll(queryMap);
	}

	@Override
	public R<List<UnifiedOrder>> patchFlashDeliverPatchUnifiedOrderFieldOutVirt(PageQueryParam pageQueryParam) {
		return unifiedOrderService.patchFlashDeliverPatchUnifiedOrderFieldOutVirt(pageQueryParam);
	}

	@Override
	public Integer countAll(Map<String, Object> queryMap) {
		return unifiedOrderService.countAll(queryMap);
	}

	@Override
	public List<WxBillOrder> getVirtOrder(Map<String, Object> params) {
		return unifiedOrderService.getVirtOrder(params);
	}


	@Override
	public BigDecimal getAmount(Map<String, Object> amountQuery) {

		return unifiedOrderService.getAmount(amountQuery);
	}

	@Override
	public WxBillVirt getVirtBill(Long virtId, int year) {

		Map<String, Object> params = new HashMap<>();
		params.put("virtId", virtId);
		params.put("syear", year);
		WxBillVirt wxBillVirt = unifiedStatisticsVirtService.getVirtBill(params);

		SysEnterprise sysEnterprise = sysEnterpriseService.findByOutVirtId(virtId);

		if (wxBillVirt == null) {
			wxBillVirt = new WxBillVirt();
			wxBillVirt.setAmount(new BigDecimal(0));
			wxBillVirt.setUpayamount(new BigDecimal(0));
			wxBillVirt.setVirtId(virtId);

		}

		wxBillVirt.setVirtName(sysEnterprise.getEnterpriseName());

		List<WxBillVirtItem> items = unifiedStatisticsVirtService.getVirtItemBill(params);
		wxBillVirt.setItems(items);

		return wxBillVirt;
	}

	@Override
	public BigDecimal getPayAmount(Map<String, Object> unPayMap) {

		return unifiedOrderService.getPayAmount(unPayMap);
	}

	@Override
	public Integer getOrderCount(Map<String, Object> queryMap) {
		return unifiedOrderService.getOrderCount(queryMap);
	}


}
