package cn.superdesk.uniorder.dubbo.provider.invoice;

import cn.superdesk.uniorder.common.enums.common.CommonEnabledEnum;
import cn.superdesk.uniorder.common.enums.common.CommonSoftDeleteEnum;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.invoice.InvoiceBankInfo;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dubbo.facade.invoice.DubboInvoiceBankInfoService;
import cn.superdesk.uniorder.service.invoice.InvoiceBankInfoService;
import com.alibaba.dubbo.config.annotation.Service;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboInvoiceBankInfoServiceImpl implements DubboInvoiceBankInfoService {

	@Autowired
	private InvoiceBankInfoService unifiedBankInfoService;

	@Override
	public Map<String, Object> addObj(InvoiceBankInfo param, LoginSysUser loginSysUser) {

		Map<String, Object> returnMap = new HashMap<>();

		param.setCreateTime(new Date());
		param.setEnabled(CommonEnabledEnum.启用.getKey());
		param.setCreateUserId(loginSysUser.getSysUserId());
		param.setParam1("n");
		param.setIsDefault(0);
		param.setDeleted(CommonSoftDeleteEnum.正常.getKey());

		unifiedBankInfoService.addObj(param);

		returnMap.put("code", "1");
		returnMap.put("data", param);

		return returnMap;
	}

	@Override
	public Map<String, Object> updateObj(InvoiceBankInfo param, LoginSysUser loginSysUser) {

		Map<String, Object> returnMap = new HashMap<>();

		param.setUpdateTime(new Date());
		param.setUpdateUserId(loginSysUser.getSysUserId());

		unifiedBankInfoService.updateObj(param);

		returnMap.put("code", "1");
		returnMap.put("data", param);

		return returnMap;
	}

	@Override
	public void delObj(Long id) {
		unifiedBankInfoService.deleteObj(id);
	}

	@Override
	public R<List<InvoiceBankInfo>> getDataByPage(Map<String, Object> params, int pageNum, int pageSize) {
		return unifiedBankInfoService.getDataByPage(params, pageNum, pageSize);
	}

	@Override
	public void updateAuto(Long id) {
		unifiedBankInfoService.updateObjAuto();
		InvoiceBankInfo info = new InvoiceBankInfo();
		info.setId(id);
		info.setParam1("y");
		unifiedBankInfoService.updateObj(info);
	}

	/****************************************** 缓存 start ******************************************/
	@Override
	public void cacheInit() {

		unifiedBankInfoService.cacheInit();
	}

	@Override
	public void cacheRefresh() {
		unifiedBankInfoService.cacheRefresh();
	}

	@Override
	public void cacheRemove() {
		unifiedBankInfoService.cacheRemove();
	}

	@Override
	public String cacheGet(String hashTable, String keyField) {
		return unifiedBankInfoService.cacheGet(hashTable, keyField);
	}
}
