package cn.superdesk.uniorder.dubbo.provider.invoice;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.invoice.InvoiceType;
import cn.superdesk.uniorder.dto.param.invoice.InvoiceTypeCacheCriteria;
import cn.superdesk.uniorder.dto.param.invoice.InvoiceTypeParam;
import cn.superdesk.uniorder.dubbo.facade.invoice.DubboInvoiceTypeService;
import cn.superdesk.uniorder.service.invoice.InvoiceTypeService;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import com.alibaba.dubbo.config.annotation.Service;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-07-23 15:30:45
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-07-23 15:30:45
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboInvoiceTypeServiceImpl implements DubboInvoiceTypeService {

	@Autowired
	private InvoiceTypeService invoiceTypeService;


	/****************************************** extends BaseService 部分 start ******************************************/

	@Override
	public void addObj(InvoiceTypeParam param) {

		InvoiceType invoiceType = AnBeanUtils.copy(param, InvoiceType.class);
		invoiceTypeService.addObj(invoiceType);

	}

	@Override
	public void updateObj(InvoiceTypeParam param) {

		InvoiceType invoiceType = AnBeanUtils.copy(param, InvoiceType.class);
		invoiceTypeService.updateObj(invoiceType);
	}

	@Override
	public void deleteObj(Long id) {
		invoiceTypeService.deleteObj(id);
	}

	@Override
	public InvoiceType findById(Long id) {
		return invoiceTypeService.findById(id);
	}

	@Override
	public PageInfo<InvoiceType> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
		return invoiceTypeService.findByPaging(conditions, pageNun, pageSize);
	}

	@Override
	public List<InvoiceType> findAll(Map<String, Object> queryMap) {

		return invoiceTypeService.findAll(queryMap);
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	@Override
	public void addInvoiceType(InvoiceTypeParam param) {

		InvoiceType invoiceType = AnBeanUtils.copy(param, InvoiceType.class);
		invoiceTypeService.addInvoiceType(invoiceType);
	}

	@Override
	public void updateInvoiceType(InvoiceTypeParam param) {

		InvoiceType invoiceType = AnBeanUtils.copy(param, InvoiceType.class);
		invoiceTypeService.updateInvoiceType(invoiceType);
	}

	@Override
	public void deleteInvoiceType(Long id) {
		invoiceTypeService.deleteInvoiceType(id);
	}

	@Override
	public InvoiceType findInvoiceTypeById(Long id) {
		return invoiceTypeService.findInvoiceTypeById(id);
	}

	@Override
	public R<List<InvoiceType>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {
		return invoiceTypeService.pageQuery(conditions, pageNun, pageSize);

	}

	/****************************************** 缓存 start ******************************************/

	@Override
	public void cacheInit(InvoiceTypeCacheCriteria criteria) {

		invoiceTypeService.cacheInit(criteria);
	}

	@Override
	public void cacheRefresh(InvoiceTypeCacheCriteria criteria) {
		invoiceTypeService.cacheRefresh(criteria);
	}

	@Override
	public void cacheRemove(InvoiceTypeCacheCriteria criteria) {
		invoiceTypeService.cacheRemove(criteria);
	}

	@Override
	public String cacheGet(InvoiceTypeCacheCriteria criteria) {
		return invoiceTypeService.cacheGet(criteria);
	}

	/****************************************** 缓存   end ******************************************/
}
