package cn.superdesk.uniorder.dubbo.provider.invoice.customer;

import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.dubbo.facade.invoice.customer.DubboInvoiceApplyFieldBackAccountStatusService;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyFieldBackAccountStatusService;
import com.alibaba.dubbo.config.annotation.Service;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;


/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboInvoiceApplyFieldBackAccountStatusServiceImpl implements DubboInvoiceApplyFieldBackAccountStatusService {

	@Autowired
	private InvoiceApplyFieldBackAccountStatusService invoiceApplyFieldBackAccountStatusService;

	/****************************************** 状态机 外部使用 类门面 start ******************************************/
	// 状态流转为 未回款(0, "未回款")
	@Override
	public void opInit(InvoiceApply entity, LoginSysUser loginSysUser) {
		invoiceApplyFieldBackAccountStatusService.opInit(entity, loginSysUser);
	}

	// 状态流转为 部分回款(1, "部分回款")
	@Override
	public void opPart(InvoiceApply entity, LoginSysUser loginSysUser) {
		invoiceApplyFieldBackAccountStatusService.opPart(entity, loginSysUser);
	}

	// 状态流转为 已回款(2, "已回款")
	@Override
	public void opComplete(InvoiceApply entity, LoginSysUser loginSysUser) {
		invoiceApplyFieldBackAccountStatusService.opComplete(entity, loginSysUser);
	}

	/****************************************** 状态机 外部使用 类门面   end ******************************************/


}
