package cn.superdesk.uniorder.dubbo.provider.invoice.customer;

import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.dubbo.facade.invoice.customer.DubboInvoiceApplyFieldInvoiceProgressingStatusService;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyFieldInvoiceProgressingStatusService;
import com.alibaba.dubbo.config.annotation.Service;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;


/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboInvoiceApplyFieldInvoiceProgressingStatusServiceImpl implements DubboInvoiceApplyFieldInvoiceProgressingStatusService {

	@Autowired
	private InvoiceApplyFieldInvoiceProgressingStatusService invoiceApplyFieldInvoiceProgressingStatusService;

	/****************************************** 状态机 外部使用 类门面 start ******************************************/
	// 状态流转为 待开票(0, "待开票")
	@Override
	public void opInit(InvoiceApply entity, LoginSysUser loginSysUser) {
		invoiceApplyFieldInvoiceProgressingStatusService.opInit(entity, loginSysUser);
	}

	// 状态流转为 已作废(2, "已作废")
	@Override
	public void opBecomeInvalid(InvoiceApply entity, LoginSysUser loginSysUser) {
		invoiceApplyFieldInvoiceProgressingStatusService.opBecomeInvalid(entity, loginSysUser);
	}

	// 状态流转为 开票中(10, "开票中")
	@Override
	public void opOngoing(InvoiceApply entity, LoginSysUser loginSysUser) {
		invoiceApplyFieldInvoiceProgressingStatusService.opOngoing(entity, loginSysUser);
	}

	// 状态流转为 已开票(11, "已开票")
	@Override
	public void opComplete(InvoiceApply entity, LoginSysUser loginSysUser) {
		invoiceApplyFieldInvoiceProgressingStatusService.opComplete(entity, loginSysUser);
	}

	/****************************************** 状态机 外部使用 类门面   end ******************************************/


}
