package cn.superdesk.uniorder.dubbo.provider.operationCenter.order;

import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.operationCenter.OperationCenterOrder;
import cn.superdesk.uniorder.dto.param.operationCenter.order.OperationCenterOrderParam;
import cn.superdesk.uniorder.dto.vo.operationCenter.order.OperationCenterOrderDetailsVo;
import cn.superdesk.uniorder.dto.vo.operationCenter.order.OperationCenterOrderFormVo;
import cn.superdesk.uniorder.dto.vo.operationCenter.order.OperationCenterOrderVo;
import cn.superdesk.uniorder.dubbo.facade.operationCenter.order.DubboOperationCenterOrderService;
import cn.superdesk.uniorder.service.operationCenter.order.OperationCenterOrderService;
import com.alibaba.dubbo.config.annotation.Service;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;

/**
 * @Author : zx
 * @Create : 2023/3/24 16:34
 * Description : 运营中心 订单管理页面 接口
 */
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboOperationCenterOrderServiceImpl implements DubboOperationCenterOrderService {

    @Autowired
    private OperationCenterOrderService operationCenterOrderService;
    @Override
    public R<OperationCenterOrderFormVo> list(OperationCenterOrderParam param) {
        return operationCenterOrderService.list(param);
    }

    @Override
    public R<OperationCenterOrderDetailsVo> getOperationCenterOrderDetails(Long id) {
        R<OperationCenterOrderDetailsVo> result = new R<>();
        if (null == id) {
            return result;
        }
        OperationCenterOrder operationCenterOrderEntity = operationCenterOrderService.findById(id);
        OperationCenterOrderDetailsVo vo =new OperationCenterOrderDetailsVo();

        BeanUtils.copyProperties(operationCenterOrderEntity, vo);
        result.setData(vo);
        return result;
    }
}
