package cn.superdesk.uniorder.dubbo.provider.scheduler;

import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.scheduler.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.dubbo.facade.scheduler.DubboSysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService;
import cn.superdesk.uniorder.service.scheduler.SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService;
import com.alibaba.dubbo.config.annotation.Service;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;


/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboSysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusServiceImpl implements DubboSysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService {

	@Autowired
	private SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService sysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService;

	/****************************************** 状态机 外部使用 类门面 start ******************************************/

	// 状态流转为 已取消(-1, "已取消")
	@Override
	public void opCancel(SysQuartzScheduleTaskStatementOfAccountJd entity, LoginSysUser loginSysUser) {
		sysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService.opCancel(entity, loginSysUser);
	}

	// 状态流转为 待确认(0, "待确认")
	@Override
	public void opInitOrReset(SysQuartzScheduleTaskStatementOfAccountJd entity, LoginSysUser loginSysUser) {
		sysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService.opInitOrReset(entity, loginSysUser);
	}

	// 状态流转为 已确认(1, "已确认")
	@Override
	public void opConfirm(SysQuartzScheduleTaskStatementOfAccountJd entity, LoginSysUser loginSysUser) {
		sysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService.opConfirm(entity, loginSysUser);
	}

	/****************************************** 状态机 外部使用 类门面   end ******************************************/


}
