package cn.superdesk.uniorder.dubbo.provider.scheduler;

import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.rest.response.ResponseResultOuterUtils;
import cn.superdesk.uniorder.dao.entity.accounting.jd.AccountingUnifiedSupplierOrderJd;
import cn.superdesk.uniorder.dao.entity.scheduler.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.dto.param.accounting.jd.AccountingUnifiedSupplierOrderJdQueryCriteria;
import cn.superdesk.uniorder.dto.param.scheduler.SysQuartzScheduleTaskStatementOfAccountJdParam;
import cn.superdesk.uniorder.dto.param.scheduler.SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria;
import cn.superdesk.uniorder.dto.param.scheduler.SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm;
import cn.superdesk.uniorder.dubbo.facade.scheduler.DubboSysQuartzScheduleTaskStatementOfAccountJdService;
import cn.superdesk.uniorder.service.accounting.jd.AccountingUnifiedSupplierOrderJdCheckUpReportService;
import cn.superdesk.uniorder.service.accounting.jd.AccountingUnifiedSupplierOrderJdService;
import cn.superdesk.uniorder.service.scheduler.SysQuartzScheduleTaskStatementOfAccountJdService;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import com.alibaba.dubbo.config.annotation.Service;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;
import java.util.concurrent.CompletableFuture;

/**
 * @Description: 定时任务-时刻任务-对账单
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service(version = "1.0.0", retries = -1, timeout = 10000)
public class DubboSysQuartzScheduleTaskStatementOfAccountJdServiceImpl implements DubboSysQuartzScheduleTaskStatementOfAccountJdService {

	@Autowired
	private SysQuartzScheduleTaskStatementOfAccountJdService sysQuartzScheduleTaskStatementOfAccountJdService;

	@Autowired
	private AccountingUnifiedSupplierOrderJdService              accountingUnifiedSupplierOrderJdService;
	@Autowired
	private AccountingUnifiedSupplierOrderJdCheckUpReportService accountingUnifiedSupplierOrderJdCheckUpReportService;


	/****************************************** extends BaseService 部分 start ******************************************/

	@Override
	public void addObj(SysQuartzScheduleTaskStatementOfAccountJdParam param) {

		SysQuartzScheduleTaskStatementOfAccountJd sysQuartzScheduleTaskStatementOfAccountJd = AnBeanUtils.copy(param, SysQuartzScheduleTaskStatementOfAccountJd.class);
		sysQuartzScheduleTaskStatementOfAccountJdService.addObj(sysQuartzScheduleTaskStatementOfAccountJd);

	}

	@Override
	public void updateObj(SysQuartzScheduleTaskStatementOfAccountJdParam param) {

		SysQuartzScheduleTaskStatementOfAccountJd sysQuartzScheduleTaskStatementOfAccountJd = AnBeanUtils.copy(param, SysQuartzScheduleTaskStatementOfAccountJd.class);
		sysQuartzScheduleTaskStatementOfAccountJdService.updateObj(sysQuartzScheduleTaskStatementOfAccountJd);
	}

	@Override
	public void deleteObj(Long id) {
		sysQuartzScheduleTaskStatementOfAccountJdService.deleteObj(id);
	}

	@Override
	public SysQuartzScheduleTaskStatementOfAccountJd findById(Long id) {
		return sysQuartzScheduleTaskStatementOfAccountJdService.findById(id);
	}

	@Override
	public PageInfo<SysQuartzScheduleTaskStatementOfAccountJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
		return sysQuartzScheduleTaskStatementOfAccountJdService.findByPaging(conditions, pageNun, pageSize);
	}

	@Override
	public List<SysQuartzScheduleTaskStatementOfAccountJd> findAll(Map<String, Object> queryMap) {

		return sysQuartzScheduleTaskStatementOfAccountJdService.findAll(queryMap);
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	@Override
	public void addSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJdParam param) {

		SysQuartzScheduleTaskStatementOfAccountJd sysQuartzScheduleTaskStatementOfAccountJd = AnBeanUtils.copy(param, SysQuartzScheduleTaskStatementOfAccountJd.class);
		sysQuartzScheduleTaskStatementOfAccountJdService.addSysQuartzScheduleTaskStatementOfAccountJd(sysQuartzScheduleTaskStatementOfAccountJd);
	}

	@Override
	public void updateSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJdParam param) {

		SysQuartzScheduleTaskStatementOfAccountJd sysQuartzScheduleTaskStatementOfAccountJd = AnBeanUtils.copy(param, SysQuartzScheduleTaskStatementOfAccountJd.class);
		sysQuartzScheduleTaskStatementOfAccountJdService.updateSysQuartzScheduleTaskStatementOfAccountJd(sysQuartzScheduleTaskStatementOfAccountJd);
	}

	@Override
	public void deleteSysQuartzScheduleTaskStatementOfAccountJd(Long id) {
		sysQuartzScheduleTaskStatementOfAccountJdService.deleteSysQuartzScheduleTaskStatementOfAccountJd(id);
	}

	@Override
	public SysQuartzScheduleTaskStatementOfAccountJd findSysQuartzScheduleTaskStatementOfAccountJdById(Long id) {
		return sysQuartzScheduleTaskStatementOfAccountJdService.findSysQuartzScheduleTaskStatementOfAccountJdById(id);
	}

	@Override
	public R<List<SysQuartzScheduleTaskStatementOfAccountJd>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {
		return sysQuartzScheduleTaskStatementOfAccountJdService.pageQuery(conditions, pageNun, pageSize);
	}

	@Override
	public R<List<SysQuartzScheduleTaskStatementOfAccountJd>> pageQueryGenericParam(SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria criteria) {
		return sysQuartzScheduleTaskStatementOfAccountJdService.pageQueryGenericParam(criteria);
	}

	/****************************************** 检查 start ******************************************/


	private void opCheckUpProcess(List<AccountingUnifiedSupplierOrderJd> resultList) {

		CompletableFuture.runAsync(() -> {
			resultList.forEach(orderJd -> {

//				log.info("{}", JsonUtils.toJson(orderJd));

				try {
					accountingUnifiedSupplierOrderJdCheckUpReportService.checkUpReport(orderJd);
				} catch (Exception e) {
					e.printStackTrace();
				}

			});
		});
	}

	/**
	 * 步骤3:通过京东的订单数据-比对统一订单数据-生成报告
	 *
	 * @param form
	 * @return
	 */
	@Override
	public R<String> opCheckUp(SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form) {

		log.info("opCheckUp params {}", JsonUtils.toJson(form));

		List<AccountingUnifiedSupplierOrderJd> resultList = accountingUnifiedSupplierOrderJdService.queryGenericParam(AccountingUnifiedSupplierOrderJdQueryCriteria
				.builder()
				.batchId(form.getBatchId())
				.build()
		);

		log.info("\n################ opCheckUp todo list size {} start ################################", resultList.size());

		opCheckUpProcess(resultList);

		log.info("\n################ opCheckUp todo list size {}   end ################################", resultList.size());

		return ResponseResultOuterUtils.createSuccesResult();
	}

	/**
	 * 步骤3:通过报告的异常数据-重新比对统一订单数据-生成报告
	 *
	 * @param form
	 * @return
	 */
	@Override
	public R<String> opCheckUpException(SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form) {

		log.info("opCheckUp params {}", JsonUtils.toJson(form));

		List<AccountingUnifiedSupplierOrderJd> resultList = accountingUnifiedSupplierOrderJdService.queryGenericParam(AccountingUnifiedSupplierOrderJdQueryCriteria
				.builder()
				.batchId(form.getBatchId())
				.onlyCheckUpException(1)
				.build()
		);

		log.info("\n################ opCheckUp todo list size {} start ################################", resultList.size());

		opCheckUpProcess(resultList);

		log.info("\n################ opCheckUp todo list size {}   end ################################", resultList.size());

		return ResponseResultOuterUtils.createSuccesResult();

	}
}