package cn.superdesk.uniorder.event;

import cn.superdesk.uniorder.common.enums.statement.AccountingOrderTypeDimEnum;
import cn.superdesk.uniorder.event.invoiceApplyTrigger.TailUpdateAccountingOrderInvoiceStatusEvent;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.stereotype.Component;

import java.util.List;

@Slf4j
@Component
public class InvoiceApplyTriggerEventPublisher {

	@Autowired
	private ApplicationContext applicationContext;

	public void triggerTailUpdateAccountingOrderInvoiceStatus(List<Long> affectedAccountingOrderIds, AccountingOrderTypeDimEnum dim) {
		log.info("InvoiceApplyTriggerEventPublisher->triggerTailUpdateAccountingOrderInvoiceStatus 事件触发 ...");
		applicationContext.publishEvent(TailUpdateAccountingOrderInvoiceStatusEvent
				.builder()
				.affectedAccountingOrderIds(affectedAccountingOrderIds)
				.dim(dim)
				.build()
		);
	}

	public void triggerTailUpdateAccountingOrderInvoiceStatus(TailUpdateAccountingOrderInvoiceStatusEvent event) {
		log.info("InvoiceApplyTriggerEventPublisher->triggerTailUpdateAccountingOrderInvoiceStatus 事件触发 ...");
		applicationContext.publishEvent(event);
	}

}
