package cn.superdesk.uniorder.event.invoiceApplyTrigger;

import cn.superdesk.uniorder.common.enums.statement.AccountingOrderTypeDimEnum;
import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.event.EventListener;
import org.springframework.scheduling.annotation.Async;
import org.springframework.stereotype.Component;

import java.util.List;

@Slf4j
@Component
public class TailUpdateAccountingOrderInvoiceStatusListener {

	@Autowired
	private InvoiceApplyService invoiceApplyService;

	@Async
	@EventListener
	public void handleTailUpdateAccountingOrderInvoiceStatusEvent(TailUpdateAccountingOrderInvoiceStatusEvent event) {

		log.info("handleTailUpdateAccountingOrderInvoiceStatusEvent -> TailUpdateAccountingOrderInvoiceStatusEvent -> {}", JsonUtils.toJson(event));

		// 如果为空就没必要下一步了
		List<Long>                 affectedAccountingOrderIds = event.getAffectedAccountingOrderIds();
		AccountingOrderTypeDimEnum dim                        = event.getDim();

		invoiceApplyService.processTailUpdateAccountingOrderInvoiceStatus(affectedAccountingOrderIds, dim);

	}

}
