package cn.superdesk.uniorder.pattern.state.accounting.supplier.accountingStatus.state.concrete;

import cn.superdesk.uniorder.dao.entity.accounting.unified.supplier.AccountingUnifiedSupplier;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.pattern.state.accounting.supplier.accountingStatus.context.StatementOfAccountContext;
import cn.superdesk.uniorder.pattern.state.accounting.supplier.accountingStatus.state.StatementOfAccountState;
import cn.superdesk.uniorder.service.accounting.unified.supplier.AccountingUnifiedSupplierService;
import cn.superdesk.uniorder.common.spring.SpringContextHolder;
import lombok.AllArgsConstructor;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 9/23/20 2:00 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 9/23/20 2:00 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@ToString
@AllArgsConstructor
//@Component
public class State_2_已拒绝 implements StatementOfAccountState {

	private AccountingUnifiedSupplierService accountingUnifiedSupplierService;

	private StatementOfAccountContext context;

	public State_2_已拒绝(StatementOfAccountContext context) {
		this.context = context;
		this.accountingUnifiedSupplierService = (AccountingUnifiedSupplierService) SpringContextHolder.getBean(AccountingUnifiedSupplierService.class);
	}

	// 创建操作 -> 对账单状态 -> 待提交(3, "待提交"),
	public void opCreate() {
		log.info("创建操作 -> 对账单状态{} -> 待提交(3, \"待提交\")", getClass().getName());
	}

	// 提交操作 -> 对账单状态 -> 未确认(0, "未确认"),// 已提交
	public void opSubmit() {

		log.info("提交操作 -> 对账单状态{} -> 未确认(0, \"未确认\")", getClass().getName());

		AccountingUnifiedSupplier statementOfAccount = context.getEntity();
		LoginSysUser              loginSysUser       = context.getLoginSysUser();

		accountingUnifiedSupplierService.opSubmitByStateMachine(statementOfAccount, loginSysUser);
	}

	// 取消操作 -> 对账单状态 -> 已取消(-1, "已取消"),
	public void opCancel() {

		log.info("取消操作 -> 对账单状态{} -> 已取消(-1, \"已取消\")", getClass().getName());

		AccountingUnifiedSupplier statementOfAccount = context.getEntity();
		LoginSysUser              loginSysUser       = context.getLoginSysUser();

		accountingUnifiedSupplierService.opCancelByStateMachine(statementOfAccount, loginSysUser);

	}

	// 重新对账操作 -> 对账单状态 -> 已取消(-1, "已取消"),
	public void opAgain() {

		log.info("重新对账操作 -> 对账单状态{} -> 已取消(-1, \"已取消\")", getClass().getName());

		AccountingUnifiedSupplier statementOfAccount = context.getEntity();
		LoginSysUser              loginSysUser       = context.getLoginSysUser();

		accountingUnifiedSupplierService.opAgainByStateMachine(statementOfAccount, loginSysUser);
	}

	// 确认操作 -> 对账单状态 -> 已确认(1, "已确认"),
	public void opConfirm() {

		log.info("确认操作 -> 对账单状态{} -> 已确认(1, \"已确认\")", getClass().getName());

		AccountingUnifiedSupplier statementOfAccount = context.getEntity();
		LoginSysUser              loginSysUser       = context.getLoginSysUser();

		accountingUnifiedSupplierService.opConfirmByStateMachine(statementOfAccount, loginSysUser);
	}

	// 申诉操作 -> 对账单状态 -> 已拒绝(2, "已拒绝"),
	public void opAppeal() {
		log.info("申诉操作 -> 对账单状态{} -> 已拒绝(2, \"已拒绝\")", getClass().getName());

		AccountingUnifiedSupplier statementOfAccount = context.getEntity();
		LoginSysUser              loginSysUser       = context.getLoginSysUser();


		accountingUnifiedSupplierService.opAppealByStateMachine(statementOfAccount, loginSysUser);
	}


}
