package cn.superdesk.uniorder.pattern.state.accounting.supplier.accountingStatusJd.context;

import cn.superdesk.uniorder.common.enums.common.CommonAuditStatusEnum;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.scheduler.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.pattern.state.accounting.supplier.accountingStatusJd.state.SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusState;
import cn.superdesk.uniorder.pattern.state.accounting.supplier.accountingStatusJd.state.concrete.SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusConcreteState_0_待确认;
import cn.superdesk.uniorder.pattern.state.accounting.supplier.accountingStatusJd.state.concrete.SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusConcreteState_1_已确认;
import cn.superdesk.uniorder.pattern.state.accounting.supplier.accountingStatusJd.state.concrete.SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusConcreteState_minus1_已取消;
import lombok.Data;

/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusContext {

	private SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusState state_minus1_已取消;
	private SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusState state_0_待确认;
	private SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusState state_1_已确认;

	private SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusState state;

	private SysQuartzScheduleTaskStatementOfAccountJd entity;

	private LoginSysUser loginSysUser;


	public SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusContext(SysQuartzScheduleTaskStatementOfAccountJd entity, LoginSysUser loginSysUser) {

		this.state_minus1_已取消 = new SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusConcreteState_minus1_已取消(this);
		this.state_0_待确认 = new SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusConcreteState_0_待确认(this);
		this.state_1_已确认 = new SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusConcreteState_1_已确认(this);


		this.entity = entity;
		this.loginSysUser = loginSysUser;

		switch (CommonAuditStatusEnum.get(this.entity.getAccountingStatus())) {

			case 已取消:
				state = state_minus1_已取消;
				break;
			case 待确认:
				state = state_0_待确认;
				break;
			case 已确认:
				state = state_1_已确认;
				break;

			default:
				state = state_0_待确认;
				break;

		}
	}

	// 已取消(-1, "已取消"),
	public void opCancel() {
		state.opCancel();
	}

	// 待确认(0, "待确认"),
	public void opInitOrReset() {
		state.opInitOrReset();
	}

	// 已确认(1, "已确认"),
	public void opConfirm() {
		state.opConfirm();
	}


	@Override
	public String toString() {
		return "状态 :" + getState().getClass().getName();
	}
}