package cn.superdesk.uniorder.pattern.state.accounting.supplier.accountingStatusJd.state.concrete;

import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.scheduler.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.pattern.state.accounting.supplier.accountingStatusJd.context.SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusContext;
import cn.superdesk.uniorder.pattern.state.accounting.supplier.accountingStatusJd.state.SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusState;
import cn.superdesk.uniorder.service.scheduler.SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService;
import cn.superdesk.uniorder.service.scheduler.SysQuartzScheduleTaskStatementOfAccountJdService;
import cn.superdesk.uniorder.common.spring.SpringContextHolder;
import lombok.AllArgsConstructor;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 9/23/20 2:00 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 9/23/20 2:00 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@ToString
@AllArgsConstructor
public class SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusConcreteState_minus1_已取消 implements SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusState {

	private SysQuartzScheduleTaskStatementOfAccountJdService                      sysQuartzScheduleTaskStatementOfAccountJdService;
	private SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService sysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService;

	private SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusContext context;

	public SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusConcreteState_minus1_已取消(SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusContext context) {
		this.context = context;
		this.sysQuartzScheduleTaskStatementOfAccountJdService = (SysQuartzScheduleTaskStatementOfAccountJdService) SpringContextHolder.getBean(SysQuartzScheduleTaskStatementOfAccountJdService.class);
		this.sysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService = (SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService) SpringContextHolder.getBean(SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService.class);
	}

	// 取消对账单任务 -> 状态 -> 已取消(-1, "已取消")
	public void opCancel() {

		log.info("取消对账单任务 -> 状态 -> {} -> 已取消(-1, \"已取消\")", getClass().getName());

		SysQuartzScheduleTaskStatementOfAccountJd entity       = context.getEntity();
		LoginSysUser                              loginSysUser = context.getLoginSysUser();

		sysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService.opCancelByStateMachine(entity, loginSysUser);
	}

	// 创建或重置 -> 状态 -> 待确认(0, "待确认")
	public void opInitOrReset() {

		log.info("创建或重置 -> 状态 -> {} -> 待确认(0, \"待确认\")", getClass().getName());

		SysQuartzScheduleTaskStatementOfAccountJd entity       = context.getEntity();
		LoginSysUser                              loginSysUser = context.getLoginSysUser();

		sysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService.opInitOrResetByStateMachine(entity, loginSysUser);
	}

	// 确认对账单任务 -> 状态 -> 已确认(1, "已确认")
	public void opConfirm() {

		log.info("确认对账单任务 -> 状态 -> {} -> 已确认(1, \"已确认\")", getClass().getName());

		SysQuartzScheduleTaskStatementOfAccountJd entity       = context.getEntity();
		LoginSysUser                              loginSysUser = context.getLoginSysUser();

		sysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService.opConfirmByStateMachine(entity, loginSysUser);
	}

}