package cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.backAccountStatus.state.concrete;

import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.backAccountStatus.context.InvoiceApplyFieldBackAccountStatusContext;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.backAccountStatus.state.InvoiceApplyFieldBackAccountStatusState;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyFieldBackAccountStatusService;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyService;
import cn.superdesk.uniorder.common.spring.SpringContextHolder;
import lombok.AllArgsConstructor;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 9/23/20 2:00 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 9/23/20 2:00 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@ToString
@AllArgsConstructor
public class InvoiceApplyFieldBackAccountStatusConcreteState_1_部分回款 implements InvoiceApplyFieldBackAccountStatusState {

	private InvoiceApplyService                       invoiceApplyService;
	private InvoiceApplyFieldBackAccountStatusService invoiceApplyFieldBackAccountStatusService;

	private InvoiceApplyFieldBackAccountStatusContext context;

	public InvoiceApplyFieldBackAccountStatusConcreteState_1_部分回款(InvoiceApplyFieldBackAccountStatusContext context) {
		this.context = context;
		this.invoiceApplyService = (InvoiceApplyService) SpringContextHolder.getBean(InvoiceApplyService.class);
		this.invoiceApplyFieldBackAccountStatusService = (InvoiceApplyFieldBackAccountStatusService) SpringContextHolder.getBean(InvoiceApplyFieldBackAccountStatusService.class);
	}

	// 运营领票后跟进回款 -> 状态 -> 未回款(0, "未回款")
	public void opInit() {

		log.info("运营领票后跟进回款 -> 状态 -> {} -> 未回款(0, \"未回款\")", getClass().getName());

		InvoiceApply entity       = context.getEntity();
		LoginSysUser loginSysUser = context.getLoginSysUser();

		invoiceApplyFieldBackAccountStatusService.opInitByStateMachine(entity, loginSysUser);
	}

	// 运营领票后跟进回款 部分回款 -> 状态 -> 部分回款(1, "部分回款")
	public void opPart() {

		log.info("运营领票后跟进回款 部分回款 -> 状态 -> {} -> 部分回款(1, \"部分回款\")", getClass().getName());

		InvoiceApply entity       = context.getEntity();
		LoginSysUser loginSysUser = context.getLoginSysUser();

		invoiceApplyFieldBackAccountStatusService.opPartByStateMachine(entity, loginSysUser);
	}

	// 运营收款后登记回款 全部回款 -> 状态 -> 已回款(2, "已回款")
	public void opComplete() {

		log.info("运营收款后登记回款 全部回款 -> 状态 -> {} -> 已回款(2, \"已回款\")", getClass().getName());

		InvoiceApply entity       = context.getEntity();
		LoginSysUser loginSysUser = context.getLoginSysUser();

		invoiceApplyFieldBackAccountStatusService.opCompleteByStateMachine(entity, loginSysUser);
	}

}