package cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.invoiceProgressingStatus.context;

import cn.superdesk.uniorder.common.enums.invoice.InvoiceApplyInvoiceProgressingStatusEnum;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.invoiceProgressingStatus.state.InvoiceApplyFieldInvoiceProgressingStatusState;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.invoiceProgressingStatus.state.concrete.InvoiceApplyFieldInvoiceProgressingStatusConcreteState_0_待开票;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.invoiceProgressingStatus.state.concrete.InvoiceApplyFieldInvoiceProgressingStatusConcreteState_10_开票中;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.invoiceProgressingStatus.state.concrete.InvoiceApplyFieldInvoiceProgressingStatusConcreteState_11_已开票;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.invoiceProgressingStatus.state.concrete.InvoiceApplyFieldInvoiceProgressingStatusConcreteState_2_已作废;
import lombok.Data;

/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class InvoiceApplyFieldInvoiceProgressingStatusContext {

	private InvoiceApplyFieldInvoiceProgressingStatusState state_0_待开票;
	private InvoiceApplyFieldInvoiceProgressingStatusState state_2_已作废;
	private InvoiceApplyFieldInvoiceProgressingStatusState state_10_开票中;
	private InvoiceApplyFieldInvoiceProgressingStatusState state_11_已开票;

	private InvoiceApplyFieldInvoiceProgressingStatusState state;

	private InvoiceApply entity;

	private LoginSysUser loginSysUser;


	public InvoiceApplyFieldInvoiceProgressingStatusContext(InvoiceApply entity, LoginSysUser loginSysUser) {

		this.state_0_待开票 = new InvoiceApplyFieldInvoiceProgressingStatusConcreteState_0_待开票(this);
		this.state_2_已作废 = new InvoiceApplyFieldInvoiceProgressingStatusConcreteState_2_已作废(this);
		this.state_10_开票中 = new InvoiceApplyFieldInvoiceProgressingStatusConcreteState_10_开票中(this);
		this.state_11_已开票 = new InvoiceApplyFieldInvoiceProgressingStatusConcreteState_11_已开票(this);


		this.entity = entity;
		this.loginSysUser = loginSysUser;

//		switch (InvoiceApplyInvoiceProgressingStatusEnum.get(this.entity.getInvoiceProgressingStatus())) {
		switch (InvoiceApplyInvoiceProgressingStatusEnum.get(this.entity.getInvoiceStatus())) {

			case 待开票:
				state = state_0_待开票;
				break;
			case 已作废:
				state = state_2_已作废;
				break;
			case 开票中:
				state = state_10_开票中;
				break;
			case 已开票:
				state = state_11_已开票;
				break;

			default:
//				state = state_3_待提交;
				break;

		}
	}

	// 待开票(0, "待开票"),
	public void opInit() {
		state.opInit();
	}

	// 已作废(2, "已作废"),
	public void opBecomeInvalid() {
		state.opBecomeInvalid();
	}

	// 开票中(10, "开票中"),
	public void opOngoing() {
		state.opOngoing();
	}

	// 已开票(11, "已开票"),
	public void opComplete() {
		state.opComplete();
	}


	@Override
	public String toString() {
		return "状态 :" + getState().getClass().getName();
	}
}