package cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.invoiceProgressingStatus.state.concrete;

import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.invoiceProgressingStatus.context.InvoiceApplyFieldInvoiceProgressingStatusContext;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.invoiceProgressingStatus.state.InvoiceApplyFieldInvoiceProgressingStatusState;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyFieldInvoiceProgressingStatusService;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyService;
import cn.superdesk.uniorder.common.spring.SpringContextHolder;
import lombok.AllArgsConstructor;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 9/23/20 2:00 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 9/23/20 2:00 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@ToString
@AllArgsConstructor
public class InvoiceApplyFieldInvoiceProgressingStatusConcreteState_2_已作废 implements InvoiceApplyFieldInvoiceProgressingStatusState {

	private InvoiceApplyService                              invoiceApplyService;
	private InvoiceApplyFieldInvoiceProgressingStatusService invoiceApplyFieldInvoiceProgressingStatusService;

	private InvoiceApplyFieldInvoiceProgressingStatusContext context;

	public InvoiceApplyFieldInvoiceProgressingStatusConcreteState_2_已作废(InvoiceApplyFieldInvoiceProgressingStatusContext context) {
		this.context = context;
		this.invoiceApplyService = (InvoiceApplyService) SpringContextHolder.getBean(InvoiceApplyService.class);
		this.invoiceApplyFieldInvoiceProgressingStatusService = (InvoiceApplyFieldInvoiceProgressingStatusService) SpringContextHolder.getBean(InvoiceApplyFieldInvoiceProgressingStatusService.class);
	}

	// 财务-待开票 -> 状态 -> 待开票(0, "待开票")
	public void opInit() {

		log.info("财务-待开票 -> 状态 -> {} -> 待开票(0, \"待开票\")", getClass().getName());

		InvoiceApply entity       = context.getEntity();
		LoginSysUser loginSysUser = context.getLoginSysUser();

		invoiceApplyFieldInvoiceProgressingStatusService.opInitByStateMachine(entity, loginSysUser);
	}

	// 财务-作废票 -> 状态 -> 已作废(2, "已作废")
	public void opBecomeInvalid() {

		log.info("财务-作废票 -> 状态 -> {} -> 已作废(2, \"已作废\")", getClass().getName());

		InvoiceApply entity       = context.getEntity();
		LoginSysUser loginSysUser = context.getLoginSysUser();

		invoiceApplyFieldInvoiceProgressingStatusService.opBecomeInvalidByStateMachine(entity, loginSysUser);
	}

	// 财务-发起开票 -> 状态 -> 开票中(10, "开票中")
	public void opOngoing() {

		log.info("财务-发起开票 -> 状态 -> {} -> 开票中(10, \"开票中\")", getClass().getName());

		InvoiceApply entity       = context.getEntity();
		LoginSysUser loginSysUser = context.getLoginSysUser();

		invoiceApplyFieldInvoiceProgressingStatusService.opOngoingByStateMachine(entity, loginSysUser);
	}

	// 财务-确认开票 -> 状态 -> 已开票(11, "已开票")
	public void opComplete() {

		log.info("财务-确认开票 -> 状态 -> {} -> 已开票(11, \"已开票\")", getClass().getName());

		InvoiceApply entity       = context.getEntity();
		LoginSysUser loginSysUser = context.getLoginSysUser();

		invoiceApplyFieldInvoiceProgressingStatusService.opCompleteByStateMachine(entity, loginSysUser);
	}

}