package cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.mailTickStatus.state.concrete;

import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.mailTickStatus.context.InvoiceApplyFieldMailTickStatusContext;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.mailTickStatus.state.InvoiceApplyFieldMailTickStatusState;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyFieldMailTickStatusService;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyService;
import cn.superdesk.uniorder.common.spring.SpringContextHolder;
import lombok.AllArgsConstructor;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 9/23/20 2:00 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 9/23/20 2:00 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@ToString
@AllArgsConstructor
public class InvoiceApplyFieldMailTickStatusConcreteState_0_未邮寄 implements InvoiceApplyFieldMailTickStatusState {

	private InvoiceApplyService                    invoiceApplyService;
	private InvoiceApplyFieldMailTickStatusService invoiceApplyFieldMailTickStatusService;

	private InvoiceApplyFieldMailTickStatusContext context;

	public InvoiceApplyFieldMailTickStatusConcreteState_0_未邮寄(InvoiceApplyFieldMailTickStatusContext context) {
		this.context = context;
		this.invoiceApplyService = (InvoiceApplyService) SpringContextHolder.getBean(InvoiceApplyService.class);
		this.invoiceApplyFieldMailTickStatusService = (InvoiceApplyFieldMailTickStatusService) SpringContextHolder.getBean(InvoiceApplyFieldMailTickStatusService.class);
	}

	// 运营领票后准备寄出 -> 状态 -> 未邮寄(0, "未邮寄")
	public void opInit() {

		log.info("运营领票后准备寄出 -> 状态 -> {} -> 未邮寄(0, \"未邮寄\")", getClass().getName());

		InvoiceApply entity       = context.getEntity();
		LoginSysUser loginSysUser = context.getLoginSysUser();

		invoiceApplyFieldMailTickStatusService.opInitByStateMachine(entity, loginSysUser);
	}

	// 运营寄出发票 -> 状态 -> 已邮寄(1, "已邮寄")
	public void opComplete() {

		log.info("运营寄出发票 -> 状态 -> {} -> 已邮寄(1, \"已邮寄\")", getClass().getName());

		InvoiceApply entity       = context.getEntity();
		LoginSysUser loginSysUser = context.getLoginSysUser();

		invoiceApplyFieldMailTickStatusService.opCompleteByStateMachine(entity, loginSysUser);
	}

}