package cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.receiveInvoiceStatus.context;

import cn.superdesk.uniorder.common.enums.invoice.InvoiceApplyReceiveInvoiceStatusEnum;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.receiveInvoiceStatus.state.InvoiceApplyFieldReceiveInvoiceStatusState;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.receiveInvoiceStatus.state.concrete.InvoiceApplyFieldReceiveInvoiceStatusConcreteState_0_未领票;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.receiveInvoiceStatus.state.concrete.InvoiceApplyFieldReceiveInvoiceStatusConcreteState_1_已领票;
import lombok.Data;

/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Data
public class InvoiceApplyFieldReceiveInvoiceStatusContext {

	private InvoiceApplyFieldReceiveInvoiceStatusState state_0_未领票;
	private InvoiceApplyFieldReceiveInvoiceStatusState state_1_已领票;

	private InvoiceApplyFieldReceiveInvoiceStatusState state;

	private InvoiceApply entity;

	private LoginSysUser loginSysUser;


	public InvoiceApplyFieldReceiveInvoiceStatusContext(InvoiceApply entity, LoginSysUser loginSysUser) {

		this.state_0_未领票 = new InvoiceApplyFieldReceiveInvoiceStatusConcreteState_0_未领票(this);
		this.state_1_已领票 = new InvoiceApplyFieldReceiveInvoiceStatusConcreteState_1_已领票(this);


		this.entity = entity;
		this.loginSysUser = loginSysUser;

		switch (InvoiceApplyReceiveInvoiceStatusEnum.get(this.entity.getReceiveInvoiceStatus())) {

			case 未领票:
				state = state_0_未领票;
				break;
			case 已领票:
				state = state_1_已领票;
				break;

			default:
//				state = state_3_待提交;
				break;

		}
	}

	// 未领票(0, "未领票"),
	public void opInit() {
		state.opInit();
	}
	// 已领票(1, "已领票"),
	public void opReceive() {
		state.opReceive();
	}


	@Override
	public String toString() {
		return "状态 :" + getState().getClass().getName();
	}
}