package cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.receiveInvoiceStatus.state.concrete;

import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.receiveInvoiceStatus.context.InvoiceApplyFieldReceiveInvoiceStatusContext;
import cn.superdesk.uniorder.pattern.state.invoice.customer.invoiceApply.receiveInvoiceStatus.state.InvoiceApplyFieldReceiveInvoiceStatusState;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyFieldReceiveInvoiceStatusService;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyService;
import cn.superdesk.uniorder.common.spring.SpringContextHolder;
import lombok.AllArgsConstructor;
import lombok.ToString;
import lombok.extern.slf4j.Slf4j;

/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 9/23/20 2:00 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 9/23/20 2:00 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@ToString
@AllArgsConstructor
public class InvoiceApplyFieldReceiveInvoiceStatusConcreteState_1_已领票 implements InvoiceApplyFieldReceiveInvoiceStatusState {

	private InvoiceApplyService                          invoiceApplyService;
	private InvoiceApplyFieldReceiveInvoiceStatusService invoiceApplyFieldReceiveInvoiceStatusService;

	private InvoiceApplyFieldReceiveInvoiceStatusContext context;

	public InvoiceApplyFieldReceiveInvoiceStatusConcreteState_1_已领票(InvoiceApplyFieldReceiveInvoiceStatusContext context) {
		this.context = context;
		this.invoiceApplyService = (InvoiceApplyService) SpringContextHolder.getBean(InvoiceApplyService.class);
		this.invoiceApplyFieldReceiveInvoiceStatusService = (InvoiceApplyFieldReceiveInvoiceStatusService) SpringContextHolder.getBean(InvoiceApplyFieldReceiveInvoiceStatusService.class);
	}

	// 财务开票结束后运营待领票 -> 状态 -> 未领票(0, "未领票")
	public void opInit() {

		log.info("财务开票结束后运营待领票 -> 状态 -> {} -> 未领票(0, \"未领票\")", getClass().getName());

		InvoiceApply entity       = context.getEntity();
		LoginSysUser loginSysUser = context.getLoginSysUser();

		invoiceApplyFieldReceiveInvoiceStatusService.opInitByStateMachine(entity, loginSysUser);
	}

	// 运营领票 -> 状态 -> 已领票(1, "已领票")
	public void opReceive() {

		log.info("运营领票 -> 状态 -> {} -> 已领票(1, \"已领票\")", getClass().getName());

		InvoiceApply entity       = context.getEntity();
		LoginSysUser loginSysUser = context.getLoginSysUser();

		invoiceApplyFieldReceiveInvoiceStatusService.opReceiveByStateMachine(entity, loginSysUser);
	}

}