package cn.superdesk.uniorder.service.accounting.jd.impl;

import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.date.DateUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.json.JSONUtil;
import cn.superdesk.uniorder.common.enums.common.CommonAccountingStateEnum;
import cn.superdesk.uniorder.common.enums.common.CommonOrderCompletStateEnum;
import cn.superdesk.uniorder.common.enums.common.CommonProcessResultEnum;
import cn.superdesk.uniorder.common.enums.jd.JdAfterSaleStateEnum;
import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.rest.response.ResponseResultOuterUtils;
import cn.superdesk.uniorder.dao.entity.accounting.jd.AccountingUnifiedSupplierOrderJd;
import cn.superdesk.uniorder.dao.entity.accounting.jd.AccountingUnifiedSupplierOrderJdCheckUpReport;
import cn.superdesk.uniorder.dao.entity.accounting.jd.AccountingUnifiedSupplierOrderJdCheckUpReportExample;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrder;
import cn.superdesk.uniorder.dao.mapper.accounting.jd.AccountingUnifiedSupplierOrderJdCheckUpReportMapper;
import cn.superdesk.uniorder.dao.mapper.accounting.jd.AccountingUnifiedSupplierOrderJdCheckUpReportMapperEx;
import cn.superdesk.uniorder.dao.mapper.base.*;
import cn.superdesk.uniorder.dto.param.accounting.jd.AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria;
import cn.superdesk.uniorder.dto.param.accounting.jd.AccountingUnifiedSupplierOrderJdCheckUpReportTaskQueryCriteria;
import cn.superdesk.uniorder.dto.param.accounting.unified.supplier.UnifiedSupplierCreateDimGoodsParamJsonStruct;
import cn.superdesk.uniorder.service.accounting.jd.AccountingUnifiedSupplierOrderJdCheckUpReportService;
import cn.superdesk.uniorder.service.base.UnifiedOrderReturnService;
import cn.superdesk.uniorder.service.base.UnifiedOrderService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-14 17:04:08
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-14 17:04:08
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class AccountingUnifiedSupplierOrderJdCheckUpReportServiceImpl implements AccountingUnifiedSupplierOrderJdCheckUpReportService {

	@Autowired
	private AccountingUnifiedSupplierOrderJdCheckUpReportMapper   accountingUnifiedSupplierOrderJdCheckUpReportMapper;
	@Autowired
	private AccountingUnifiedSupplierOrderJdCheckUpReportMapperEx accountingUnifiedSupplierOrderJdCheckUpReportMapperEx;

	/****************************************** 正单/退单 start ******************************************/
	@Autowired
	private UnifiedOrderMapper                   unifiedOrderMapper;
	@Autowired
	private UnifiedOrderMapperEx                 unifiedOrderMapperEx;
	@Autowired
	private UnifiedOrderMapperExSupplierDimOrder unifiedOrderMapperExSupplierDimOrder;
	@Autowired
	private UnifiedOrderMapperExSupplierDimGoods unifiedOrderMapperExSupplierDimGoods;

	@Autowired
	private UnifiedOrderService unifiedOrderService;

	/****************************************** 退单 start ******************************************/

	@Autowired
	private UnifiedOrderReturnMapper   unifiedOrderReturnMapper;
	@Autowired
	private UnifiedOrderReturnMapperEx unifiedOrderReturnMapperEx;
	@Autowired
	private UnifiedOrderReturnService  unifiedOrderReturnService;


	/****************************************** extends BaseService 部分 start ******************************************/
	@Override
	public void addObj(AccountingUnifiedSupplierOrderJdCheckUpReport entity) {
		accountingUnifiedSupplierOrderJdCheckUpReportMapper.insert(entity);
	}

	@Override
	public void updateObj(AccountingUnifiedSupplierOrderJdCheckUpReport entity) {
		accountingUnifiedSupplierOrderJdCheckUpReportMapper.updateByPrimaryKeySelective(entity);
	}

	@Override
	public void deleteObj(Long id) {
	}

	@Override
	public AccountingUnifiedSupplierOrderJdCheckUpReport findById(Long id) {
		return accountingUnifiedSupplierOrderJdCheckUpReportMapper.selectByPrimaryKey(id);
	}

	@Override
	public PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReport> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
		return null;
	}

	@Override
	public List<AccountingUnifiedSupplierOrderJdCheckUpReport> findAll(Map<String, Object> queryMap) {
		return null;
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	public void addAccountingUnifiedSupplierOrderJdCheckUpReport(AccountingUnifiedSupplierOrderJdCheckUpReport entity) {
		accountingUnifiedSupplierOrderJdCheckUpReportMapper.insertSelective(entity);
	}

	public void updateAccountingUnifiedSupplierOrderJdCheckUpReport(AccountingUnifiedSupplierOrderJdCheckUpReport entity) {
		AccountingUnifiedSupplierOrderJdCheckUpReport originEntity = accountingUnifiedSupplierOrderJdCheckUpReportMapper.selectByPrimaryKey(entity.getId());
//		AssertUtil.notNull(originEntity);
		AnBeanUtils.copy(entity, originEntity);
		accountingUnifiedSupplierOrderJdCheckUpReportMapper.updateByPrimaryKey(originEntity);
	}

	public void deleteAccountingUnifiedSupplierOrderJdCheckUpReport(Long id) {
		accountingUnifiedSupplierOrderJdCheckUpReportMapper.deleteByPrimaryKey(id);
	}

	public AccountingUnifiedSupplierOrderJdCheckUpReport findAccountingUnifiedSupplierOrderJdCheckUpReportById(Long id) {
		AccountingUnifiedSupplierOrderJdCheckUpReport entity = accountingUnifiedSupplierOrderJdCheckUpReportMapper.selectByPrimaryKey(id);
//		AssertUtil.notNull(entity);
		return entity;
	}

	public AccountingUnifiedSupplierOrderJdCheckUpReport findByBatchIdJdOrderSn(String batchId, String jdOrderSn) {

		AccountingUnifiedSupplierOrderJdCheckUpReportExample          example  = new AccountingUnifiedSupplierOrderJdCheckUpReportExample();
		AccountingUnifiedSupplierOrderJdCheckUpReportExample.Criteria criteria = example.createCriteria();

		criteria
				.andBatchIdEqualTo(batchId)
				.andJdOrderSnEqualTo(jdOrderSn);

		List<AccountingUnifiedSupplierOrderJdCheckUpReport> resultList = accountingUnifiedSupplierOrderJdCheckUpReportMapper.selectByExampleWithBLOBs(example);

		if (CollUtil.isNotEmpty(resultList)) {
			return resultList.get(0);
		} else {
			return null;
		}

	}

	public R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

		AccountingUnifiedSupplierOrderJdCheckUpReportExample          example  = new AccountingUnifiedSupplierOrderJdCheckUpReportExample();
		AccountingUnifiedSupplierOrderJdCheckUpReportExample.Criteria criteria = example.createCriteria();

		// TODO 喜欢用Map 还是 Bean 自己喜欢... 后期添加 转 AccountingUnifiedSupplierOrderJdCheckUpReportExample.Criteria
		// AccountingUnifiedSupplierOrderJdCheckUpReport accountingUnifiedSupplierOrderJdCheckUpReportConditions = AnBeanUtils.mapToBean(conditions,AccountingUnifiedSupplierOrderJdCheckUpReport.class);

		PageHelper.startPage(pageNun, pageSize);
		List<AccountingUnifiedSupplierOrderJdCheckUpReport>     resultList = accountingUnifiedSupplierOrderJdCheckUpReportMapper.selectByExample(example);
		PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReport> page       = new PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReport>(resultList);
		PageHelper.clearPage();

		return new R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

	}

	public R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>> pageQueryGenericParam(AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria) {

		PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());

		List<AccountingUnifiedSupplierOrderJdCheckUpReport> resultList = queryGenericParam(queryCriteria);

		PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReport> page = new PageInfo<AccountingUnifiedSupplierOrderJdCheckUpReport>(resultList);
		PageHelper.clearPage();

		return new R<List<AccountingUnifiedSupplierOrderJdCheckUpReport>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

	}

	public List<AccountingUnifiedSupplierOrderJdCheckUpReport> queryGenericParam(AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria queryCriteria) {

		if (ObjectUtil.isEmpty(queryCriteria.getBatchId())) {
			return null;
		}

		AccountingUnifiedSupplierOrderJdCheckUpReportExample          example  = new AccountingUnifiedSupplierOrderJdCheckUpReportExample();
		AccountingUnifiedSupplierOrderJdCheckUpReportExample.Criteria criteria = example.createCriteria();

		// TODO 添加条件... 后期添加 queryCriteria 转 AccountingUnifiedSupplierOrderJdCheckUpReportExample.Criteria
		criteria.andBatchIdEqualTo(queryCriteria.getBatchId());

		List<AccountingUnifiedSupplierOrderJdCheckUpReport> resultList = accountingUnifiedSupplierOrderJdCheckUpReportMapper.selectByExampleWithBLOBs(example);

//		resultList.forEach(item -> {
//			log.info("{}", JSONUtil.toJsonStr(item));
//		});

		return resultList;
	}


	/****************************************** 检查 start ******************************************/


	/**
	 * 单个检查
	 *
	 * @param entityImportRow
	 * @return
	 */
	public R<String> checkUpReport(AccountingUnifiedSupplierOrderJd entityImportRow) {

		try {

			// TODO 1. 比对 订单金额 2. 统一订单中的完成状态 3. 统一订单的商品 供应商对账状态 mark by linjinyu at 20211014

			// 只能去侨城汇生产环境先验证sql
			// SELECT * FROM `unified_order` WHERE express_sn = '215952302659'


			AccountingUnifiedSupplierOrderJdCheckUpReport entityCheckUpReport = null;

			entityCheckUpReport = findByBatchIdJdOrderSn(entityImportRow.getBatchId(), entityImportRow.getJdOrderSn());

			if (ObjectUtil.isNull(entityCheckUpReport)) {
				entityCheckUpReport = new AccountingUnifiedSupplierOrderJdCheckUpReport();
			}


//			entityCheckUpReport.setId(entityImportRow.getId());
			entityCheckUpReport.setBatchId(entityImportRow.getBatchId());

			/****************************************** 京东对账单 - 订单信息 start ******************************************/

			entityCheckUpReport.setJdAccountingOrderSn(entityImportRow.getJdAccountingOrderSn());

			entityCheckUpReport.setJdOrderSn(entityImportRow.getJdOrderSn());
			entityCheckUpReport.setJdOriginalOrderSn(entityImportRow.getJdOriginalOrderSn());
			entityCheckUpReport.setJdOrderAmount(entityImportRow.getJdOrderAmount());
			entityCheckUpReport.setJdRepaymentAmount(entityImportRow.getJdRepaymentAmount());
			entityCheckUpReport.setJdRefundAmount(entityImportRow.getJdRefundAmount());
			entityCheckUpReport.setJdOutStandingAmount(entityImportRow.getJdOutStandingAmount());
			entityCheckUpReport.setJdOrderState(entityImportRow.getJdOrderState());
			entityCheckUpReport.setJdOrderStateName(entityImportRow.getJdOrderStateName());
			entityCheckUpReport.setWereAccountedState(entityImportRow.getWereAccountedState());
			entityCheckUpReport.setWereAccountedStateName(entityImportRow.getWereAccountedStateName());
			entityCheckUpReport.setAfterSaleState(entityImportRow.getAfterSaleState());
			entityCheckUpReport.setAfterSaleStateName(entityImportRow.getAfterSaleStateName());

			/****************************************** 京东对账单 - 订单信息   end ******************************************/

			/****************************************** 统一订单 start ******************************************/

			StringBuffer processReport = new StringBuffer();
			Integer      processResult = CommonProcessResultEnum.初始.getKey();

			UnifiedOrder orderFromDB = unifiedOrderMapperEx.findByJdOrderSn(entityImportRow.getJdOrderSn());

			// 情况1 :  订单都没找到
			if (ObjectUtil.isNull(orderFromDB)) {

				entityCheckUpReport.setOrderSn("NO_FOUND");

				entityCheckUpReport.setOrderAmount(BigDecimal.ZERO);
				entityCheckUpReport.setOrderCostAmount(BigDecimal.ZERO);

				entityCheckUpReport.setRefundOrderAmount(BigDecimal.ZERO);
				entityCheckUpReport.setRefundOrderCostAmount(BigDecimal.ZERO);

				entityCheckUpReport.setTransportAmount(BigDecimal.ZERO);
				entityCheckUpReport.setTransportMerchantAssumeAmount(BigDecimal.ZERO);

				entityCheckUpReport.setGoodsAmount(BigDecimal.ZERO);
				entityCheckUpReport.setGoodsCostAmount(BigDecimal.ZERO);

				entityCheckUpReport.setRefundGoodsAmount(BigDecimal.ZERO);
				entityCheckUpReport.setRefundGoodsCostAmount(BigDecimal.ZERO);

				entityCheckUpReport.setOrderState(0);
				entityCheckUpReport.setCompletState(0);

				processReport.append("订单 No Found;同步京东订单;");
				processResult = CommonProcessResultEnum.异常_数据本身问题.getKey();

			}
			// 情况1 :  订单找到后才能开始做判定逻辑
			else {

				entityCheckUpReport.setOrderSn(orderFromDB.getOrderSn());

				entityCheckUpReport.setOrderAmount(orderFromDB.getAmount());
				entityCheckUpReport.setOrderCostAmount(orderFromDB.getCostAmount());

				entityCheckUpReport.setTransportAmount(orderFromDB.getTransportAmount());
				entityCheckUpReport.setTransportMerchantAssumeAmount(orderFromDB.getTransportMerchantAssumeAmount());

				entityCheckUpReport.setGoodsAmount(orderFromDB.getGoodsAmount());
				entityCheckUpReport.setGoodsCostAmount(orderFromDB.getGoodsCostAmount());

				// TODO 退单相关字段先初始化 后边再验证
				entityCheckUpReport.setRefundOrderAmount(BigDecimal.ZERO);
				entityCheckUpReport.setRefundOrderCostAmount(BigDecimal.ZERO);

				entityCheckUpReport.setRefundGoodsAmount(BigDecimal.ZERO);
				entityCheckUpReport.setRefundGoodsCostAmount(BigDecimal.ZERO);

				entityCheckUpReport.setOrderState(orderFromDB.getOrderState());
				entityCheckUpReport.setCompletState(orderFromDB.getCompletState());


				/****************************************** 统一订单 订单层面 start ******************************************/

				// 已完成(1,"已完成"), 未完成(2,"未完成"), 已作废(3,"已作废"),
				if (ObjectUtil.isNotNull(orderFromDB.getCompletState())
						&& orderFromDB.getCompletState().compareTo(CommonOrderCompletStateEnum.已作废.getKey()) == 0) {

					processReport.append("订单 CompletState = 已作废_已取消;");
					processResult = CommonProcessResultEnum.异常_数据本身问题.getKey();

				}

				if (ObjectUtil.isNotNull(orderFromDB.getAccountingStateSupplier())
						&& orderFromDB.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.已对账.getKey()) == 0) {

					processReport.append("订单 供应商对账状态 = 已对账;");
					processResult = CommonProcessResultEnum.异常_数据本身问题.getKey();

				}

				/****************************************** 统一订单 订单层面   end ******************************************/

				switch (JdAfterSaleStateEnum.getByDesc(entityImportRow.getAfterSaleStateName())) {


					case 已进售后:

					case 售后完成:

						// 思路还是要改 相信京东 京东已经告诉你 有售后
						// 明天查 getByOrderSnAndCheckUpAndFixField 关键字


						break;

					case 未进售后:
						break;
					default:

						processReport.append("售后状态-目前只能处理京东售后状态为(未进售后|售后完成|已进售后),超出处理范围;");
						processResult = CommonProcessResultEnum.异常_数据本身问题.getKey();
						break;
				}


				// afterSaleStateName 售后状态 未进售后 售后完成 已进售后
				// jdOrderStateName 京东 订单状态 已完成 部分退货
				// wereAccountedStateName 京东 入账状态 已入账
				// settledStateName 京东 结清状态 未结清

//					京东 : 订单金额 - 退款金额 - 还款金额 = 未结清(应付)
//					判定 : 订单金额(京东 jdOrderAmount) 按理等于 订单成本金额(统一 orderCostAmount)
//					判定 : 订单金额(京东 jdOrderAmount) - 退款金额(京东 jdRefundAmount) 按理等于 订单成本金额(统一 orderCostAmount) - 退款成本金额(统一 refundGoodsCostAmount)

//					SELECT
//						*
//					FROM
//						accounting_unified_supplier_order_jd_check_up_report
//					WHERE
//						process_result = 2
//						AND after_sale_state_name in ('售后完成','已进售后')
//						AND process_report LIKE '订单差异金额%'

//					问题样例
//					京东 子单 213037923494
//					京东 主单 213026092641
//					商城 单号 ME20210709214104186712


				/****************************************** 注意 以下判定未考量 京东 还款金额 大于 0.00 的情况，假定没有这样的情况 start ******************************************/


//					1. 问题记录 getOrderCostAmount 有的等于 有的不等于 getTransportMerchantAssumeAmount + getGoodsCostAmount 这种问题存在于 大概是 运费双向结算的订单 要再进一步验证
//					2. getTransportMerchantAssumeAmount + getGoodsCostAmount = getJdOrderAmount

//					SELECT
//					    `id`,
//					    `batch_id`,
//					    `jd_accounting_order_sn`,
//					    `jd_order_sn`,
//					    `jd_original_order_sn`,
//					    `order_sn`,
//					    `jd_order_amount`,
//					    `jd_repayment_amount`,
//					    `jd_refund_amount`,
//					    `jd_out_standing_amount`,
//					    `order_cost_amount`,
//					    `refund_order_cost_amount`,
//					    `transport_merchant_assume_amount`,
//					    `goods_cost_amount`,
//					    `refund_goods_cost_amount`,
//					    `order_state`,
//					    `complet_state`,
//					    `create_time`,
//					    `process_result`,
//					    `process_report`
//					FROM
//					    `accounting_unified_supplier_order_jd_check_up_report`
//					WHERE
//					    `process_result` = 1

				if (entityCheckUpReport.getJdOrderAmount().compareTo(
						entityCheckUpReport.getGoodsCostAmount().add(entityCheckUpReport.getTransportMerchantAssumeAmount())
				) == 0
						&& entityCheckUpReport.getJdRefundAmount().compareTo(entityCheckUpReport.getRefundOrderCostAmount()) == 0
						&& entityCheckUpReport.getJdRefundAmount().compareTo(entityCheckUpReport.getRefundGoodsCostAmount()) == 0) {

					processReport.append("");
					processResult = CommonProcessResultEnum.正常.getKey();

				}

//					差异金额：列表中的“京东结算金额”减“订单结算金额”

				if (entityCheckUpReport.getJdOrderAmount().compareTo(
						entityCheckUpReport.getGoodsCostAmount().add(entityCheckUpReport.getTransportMerchantAssumeAmount())
				) != 0) {

					processReport.append(StrUtil.format("订单差异金额 {}; 排查订单明细，找出金额异常原因;",
							entityCheckUpReport.getJdOrderAmount().subtract(
									entityCheckUpReport.getGoodsCostAmount().add(entityCheckUpReport.getTransportMerchantAssumeAmount())
							)));
					processResult = CommonProcessResultEnum.异常_数据本身问题.getKey();

				}

				if (entityCheckUpReport.getJdRefundAmount().compareTo(entityCheckUpReport.getRefundOrderCostAmount()) != 0
						|| entityCheckUpReport.getJdRefundAmount().compareTo(entityCheckUpReport.getRefundGoodsCostAmount()) != 0) {

					processReport.append(StrUtil.format("退款差异金额 {} {}; 排查订单明细，找出金额异常原因;",
							entityCheckUpReport.getJdRefundAmount().subtract(entityCheckUpReport.getRefundOrderCostAmount()),
							entityCheckUpReport.getJdRefundAmount().subtract(entityCheckUpReport.getRefundGoodsCostAmount())));

					processResult = CommonProcessResultEnum.异常_数据本身问题.getKey();

				}


			}

//		entityCheckUpReport.setOrderSn();
//		entityCheckUpReport.setOrderAmount();
//		entityCheckUpReport.setOrderCostAmount();
//		entityCheckUpReport.setTransportAmount();
//		entityCheckUpReport.setTransportMerchantAssumeAmount();
//		entityCheckUpReport.setGoodsAmount();
//		entityCheckUpReport.setGoodsCostAmount();
//		entityCheckUpReport.setRefundAmount();
//		entityCheckUpReport.setRefundGoodsAmount();
//		entityCheckUpReport.setRefundGoodsCostAmount();
//		entityCheckUpReport.setOrderState();
//		entityCheckUpReport.setCompletState();

			/****************************************** 报告 start ******************************************/


			entityCheckUpReport.setProcessResult(processResult);
			entityCheckUpReport.setProcessReport(processReport.toString());

			if (ObjectUtil.isNull(entityCheckUpReport.getId())) {

				entityCheckUpReport.setCreateTime(DateUtil.date());
				accountingUnifiedSupplierOrderJdCheckUpReportMapper.insertSelective(entityCheckUpReport);
			} else {
				entityCheckUpReport.setCreateTime(DateUtil.date());
				accountingUnifiedSupplierOrderJdCheckUpReportMapper.updateByPrimaryKeyWithBLOBs(entityCheckUpReport);
			}

			log.info("checkUpReport {}", JsonUtils.toJson(entityImportRow));

		} catch (Exception e) {
			e.printStackTrace();
		}


		return ResponseResultOuterUtils.createSuccesResult();
	}

	public List<UnifiedSupplierCreateDimGoodsParamJsonStruct> findUnifiedSupplierCreateDimGoodsParam(AccountingUnifiedSupplierOrderJdCheckUpReportTaskQueryCriteria queryCriteria) {

		return accountingUnifiedSupplierOrderJdCheckUpReportMapperEx.findUnifiedSupplierCreateDimGoodsParam(queryCriteria);

	}

	/****************************************** 检查   end ******************************************/

}