package cn.superdesk.uniorder.service.accounting.jd.impl;

import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.accounting.jd.AccountingUnifiedSupplierOrderJd;
import cn.superdesk.uniorder.dao.entity.accounting.jd.AccountingUnifiedSupplierOrderJdExample;
import cn.superdesk.uniorder.dao.mapper.accounting.jd.AccountingUnifiedSupplierOrderJdMapper;
import cn.superdesk.uniorder.dao.mapper.accounting.jd.AccountingUnifiedSupplierOrderJdMapperEx;
import cn.superdesk.uniorder.dto.param.accounting.jd.AccountingUnifiedSupplierOrderJdImportExcelRow;
import cn.superdesk.uniorder.dto.param.accounting.jd.AccountingUnifiedSupplierOrderJdQueryCriteria;
import cn.superdesk.uniorder.service.accounting.jd.AccountingUnifiedSupplierOrderJdService;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class AccountingUnifiedSupplierOrderJdServiceImpl implements AccountingUnifiedSupplierOrderJdService {

	@Autowired
	private AccountingUnifiedSupplierOrderJdMapper   accountingUnifiedSupplierOrderJdMapper;
	@Autowired
	private AccountingUnifiedSupplierOrderJdMapperEx accountingUnifiedSupplierOrderJdMapperEx;

	/****************************************** extends BaseService 部分 start ******************************************/
	@Override
	public void addObj(AccountingUnifiedSupplierOrderJd entity) {
		accountingUnifiedSupplierOrderJdMapper.insert(entity);
	}

	@Override
	public void updateObj(AccountingUnifiedSupplierOrderJd entity) {
		accountingUnifiedSupplierOrderJdMapper.updateByPrimaryKeySelective(entity);
	}

	@Override
	public void deleteObj(Long id) {
	}

	@Override
	public AccountingUnifiedSupplierOrderJd findById(Long id) {
		return accountingUnifiedSupplierOrderJdMapper.selectByPrimaryKey(id);
	}

	@Override
	public PageInfo<AccountingUnifiedSupplierOrderJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
		return null;
	}

	@Override
	public List<AccountingUnifiedSupplierOrderJd> findAll(Map<String, Object> queryMap) {
		return null;
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	public void addAccountingUnifiedSupplierOrderJd(AccountingUnifiedSupplierOrderJd entity) {
		accountingUnifiedSupplierOrderJdMapper.insertSelective(entity);
	}

	public void updateAccountingUnifiedSupplierOrderJd(AccountingUnifiedSupplierOrderJd entity) {
		AccountingUnifiedSupplierOrderJd originEntity = accountingUnifiedSupplierOrderJdMapper.selectByPrimaryKey(entity.getId());
//		AssertUtil.notNull(originEntity);
		AnBeanUtils.copy(entity, originEntity);
		accountingUnifiedSupplierOrderJdMapper.updateByPrimaryKeySelective(originEntity);
	}

	public void updateAccountingUnifiedSupplierOrderJdByPrimaryKeySelective(AccountingUnifiedSupplierOrderJd entity) {

		accountingUnifiedSupplierOrderJdMapper.updateByPrimaryKeySelective(entity);
	}

	public void deleteAccountingUnifiedSupplierOrderJd(Long id) {
		accountingUnifiedSupplierOrderJdMapper.deleteByPrimaryKey(id);
	}

	public AccountingUnifiedSupplierOrderJd findAccountingUnifiedSupplierOrderJdById(Long id) {
		AccountingUnifiedSupplierOrderJd entity = accountingUnifiedSupplierOrderJdMapper.selectByPrimaryKey(id);
//		AssertUtil.notNull(entity);
		return entity;
	}

	public R<List<AccountingUnifiedSupplierOrderJd>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

		AccountingUnifiedSupplierOrderJdExample          example  = new AccountingUnifiedSupplierOrderJdExample();
		AccountingUnifiedSupplierOrderJdExample.Criteria criteria = example.createCriteria();

		// TODO 喜欢用Map 还是 Bean 自己喜欢... 后期添加 转 AccountingUnifiedSupplierOrderJdExample.Criteria
		// AccountingUnifiedSupplierOrderJd accountingUnifiedSupplierOrderJdConditions = AnBeanUtils.mapToBean(conditions,AccountingUnifiedSupplierOrderJd.class);

		PageHelper.startPage(pageNun, pageSize);
		List<AccountingUnifiedSupplierOrderJd>     resultList = accountingUnifiedSupplierOrderJdMapper.selectByExample(example);
		PageInfo<AccountingUnifiedSupplierOrderJd> page       = new PageInfo<AccountingUnifiedSupplierOrderJd>(resultList);
		PageHelper.clearPage();

		return new R<List<AccountingUnifiedSupplierOrderJd>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

	}

	public R<List<AccountingUnifiedSupplierOrderJd>> pageQueryGenericParam(AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria) {

//		AccountingUnifiedSupplierOrderJdExample          example  = new AccountingUnifiedSupplierOrderJdExample();
//		AccountingUnifiedSupplierOrderJdExample.Criteria criteria = example.createCriteria();

		// TODO 添加条件... 后期添加 queryCriteria 转 AccountingUnifiedSupplierOrderJdExample.Criteria

		PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());

//		List<AccountingUnifiedSupplierOrderJd>     resultList = accountingUnifiedSupplierOrderJdMapper.selectByExample(example);
		List<AccountingUnifiedSupplierOrderJd> resultList = accountingUnifiedSupplierOrderJdMapperEx.pageQueryGenericParam(queryCriteria);

		PageInfo<AccountingUnifiedSupplierOrderJd> page = new PageInfo<AccountingUnifiedSupplierOrderJd>(resultList);
		PageHelper.clearPage();

		return new R<List<AccountingUnifiedSupplierOrderJd>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

	}

	public List<AccountingUnifiedSupplierOrderJd> queryGenericParam(AccountingUnifiedSupplierOrderJdQueryCriteria queryCriteria) {

		log.info("{}", JsonUtils.toJson(queryCriteria));

		List<AccountingUnifiedSupplierOrderJd> resultList = accountingUnifiedSupplierOrderJdMapperEx.pageQueryGenericParam(queryCriteria);

		return resultList;
	}


	/****************************************** excel import start start ******************************************/

	@Override
	public void saveOrUpdate4ThirdPartJdReconciliationScheduleExcelRow(AccountingUnifiedSupplierOrderJdImportExcelRow excelRow, LoginSysUser loginSysUser) {

		if (null == excelRow) {
			return;
		}

//		AccountingUnifiedSupplierOrderJd entity = new AccountingUnifiedSupplierOrderJd();
//		Dto2EntityConvertUtils.taxationAccountingUnifiedSupplierOrderJdExcelRow2AccountingUnifiedSupplierOrderJdEntity(excelRow, entity);
		AccountingUnifiedSupplierOrderJd entity = AnBeanUtils.copy(excelRow, AccountingUnifiedSupplierOrderJd.class);


		log.info("saveOrUpdate4ThirdPartJdReconciliationScheduleExcelRow\n{}\n{}", JsonUtils.toJson(excelRow), JsonUtils.toJson(entity));

//		InvoiceInvoiced checkIsExist = findInvoiceInvoicedByInvoiceNumber(entity.getInvoiceNumber());
//
//		if (null == checkIsExist) {
//			addInvoiceInvoiced(entity);
//		} else {
//			updateInvoiceInvoiced(entity);
//		}

		addAccountingUnifiedSupplierOrderJd(entity);
	}

	@Override
	public void saveOrUpdate4ThirdPartJdReconciliationScheduleExcelRowList(List<AccountingUnifiedSupplierOrderJdImportExcelRow> excelRowList, LoginSysUser loginSysUser) {

		excelRowList.forEach(excelRow -> {
			saveOrUpdate4ThirdPartJdReconciliationScheduleExcelRow(excelRow, loginSysUser);
		});
	}

	/****************************************** excel import start   end ******************************************/

}