package cn.superdesk.uniorder.service.accounting.score.customer;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.accounting.score.customer.AccountingScoreCustomer;
import cn.superdesk.uniorder.dao.entity.accounting.score.customer.AccountingScoreCustomerXCredit;
import cn.superdesk.uniorder.dto.vo.accounting.score.customer.AccountingScoreCustomerDetailVo;
import cn.superdesk.uniorder.dto.vo.accounting.score.customer.AccountingScoreCustomerHeadVo;
import cn.superdesk.uniorder.dto.vo.accounting.score.customer.AccountingScoreCustomerVo;
import cn.superdesk.uniorder.service.base.BaseService;

import java.util.List;
import java.util.Map;


/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 2021/4/15 下午3:21
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/4/15 下午3:21
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface AccountingScoreCustomerService extends BaseService<AccountingScoreCustomer> {

	/****************************************** 积分对账(结算) 对账单 start ******************************************/


	List<Long> getAccountingXCreditIds(Long id);

	/**
	 * @param params
	 * @param pageNum
	 * @param pageSize
	 * @return
	 */
	R<List<AccountingScoreCustomerVo>> getAccountingList(Map<String, Object> params, int pageNum, int pageSize);

	List<AccountingScoreCustomerVo> getAccountingList(Map<String, Object> params, LoginSysUser loginSysUser);

	/**
	 * @param params
	 * @return
	 */
	AccountingScoreCustomerHeadVo getAccountingListHeadSum(Map<String, Object> params);

	/****************************************** 积分对账(结算) 对账单   end ******************************************/


	/****************************************** 积分对账(结算) 对账单 详情 start ******************************************/

	AccountingScoreCustomerDetailVo commonStatementOfAccountDetailDimCredit(Long accountingOrderId, LoginSysUser loginSysUser);
	/****************************************** 积分对账(结算) 对账单 详情   end ******************************************/


	/****************************************** 积分对账(结算) 对账单 操作 start ******************************************/

	AccountingScoreCustomer createScoreAccountingCustomer(AccountingScoreCustomer scoreAccountingCustomer, List<AccountingScoreCustomerXCredit> scoreAccountingCustomerXCreditList);

	/**
	 * 已取消(-1, "已取消"), V
	 * 未确认(0, "未确认"),
	 * 已确认(1, "已确认"),
	 * 已拒绝(2, "已拒绝"), V
	 * 待提交(3, "待提交"),
	 *
	 * @param id
	 * @param accountingStatus
	 */
	void cancelAccounting(Long id, Integer accountingStatus);

	void deleteAccounting(Long id);

	/****************************************** 积分对账(结算) 对账单 操作   end ******************************************/


	AccountingScoreCustomer findByAccountingOrderSn(String accountingOrderSn);

}
