package cn.superdesk.uniorder.service.accounting.score.customer.impl;


import cn.hutool.core.io.FileUtil;
import cn.superdesk.uniorder.common.enums.scheduler.SysQuartzScheduleTaskStatementOfAccountRunStateEnum;
import cn.superdesk.uniorder.common.excel.ExcelResponse;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dto.env.provider.excel.ExcelExportConstant;
import cn.superdesk.uniorder.dto.vo.accounting.score.customer.AccountingScoreCustomerDetailVo;
import cn.superdesk.uniorder.notify.NotifyUtils;
import cn.superdesk.uniorder.service.accounting.score.customer.AccountingScoreCustomerExportExcelService;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.builder.ExcelWriterBuilder;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.excel.write.metadata.fill.FillConfig;
import com.alibaba.excel.write.metadata.fill.FillWrapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.File;
import java.util.Date;

/**
 * @Description: 侨城汇 客户结算(对账) Export Excel
 * @Author: linjinyu
 * @CreateDate: 2021/4/15 下午4:05
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/4/15 下午4:05
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class AccountingScoreCustomerExportExcelServiceImpl implements AccountingScoreCustomerExportExcelService {

	@Autowired
	private ExcelExportConstant excelExportConstant;


	private static final String TEMPLATE_EXCEL_EXPORT_STATEMENTOFACCOUNT_DETAIL_DIM_CREDIT = "exportExcelStatementOfAccountDetailDimCredit.xlsx";

	/**
	 * @param exportData
	 * @return
	 * @link UnifiedOrderExportExcelServiceImpl.exportCustomerStatementOfAccountDetailCompatible
	 */
	public SysNotify exportExcelStatementOfAccountDetailDimCredit(AccountingScoreCustomerDetailVo exportData) {

		String excelExportPathRoot             = excelExportConstant.getPathRoot();
		String excelExportRelativePathTemplate = excelExportConstant.getPathTemplate();
		String excelExportRelativePathStorage  = excelExportConstant.getPathStorage();

		String relativePath = File.separator + "excel" + File.separator + "accounting" + File.separator + "score" + File.separator + "customer" + File.separator;

		String templateRelativePath = excelExportPathRoot + excelExportRelativePathTemplate + relativePath;
		String templateFullPath;

		String targetFullPath = excelExportPathRoot + excelExportRelativePathStorage;

		String targetFileName          = "客户结算(对账)" + "_" + "对账单详情_" + "电子账单" + ExcelResponse.addTail() + ".xlsx";
		String targetWriteFileFullPath = targetFullPath + relativePath + targetFileName;

//		if (!FileUtil.exist(targetWriteFileFullPath)) {
//			FileUtil.mkdir(targetWriteFileFullPath);
//		}
		FileUtil.touch(targetWriteFileFullPath);

		ExcelWriterBuilder excelWriterBuilder = EasyExcel.write(targetWriteFileFullPath);
		ExcelWriter        excelWriter        = null;

		WriteSheet writeSheet0 = EasyExcel.writerSheet(0, "面单").build();
		WriteSheet writeSheet1 = EasyExcel.writerSheet(1, "明细").build();
		FillConfig fillConfig  = FillConfig.builder().forceNewRow(Boolean.FALSE).build();

		templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_STATEMENTOFACCOUNT_DETAIL_DIM_CREDIT;

		excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();

		excelWriter.fill(new FillWrapper("detail", exportData.getCreditList()), fillConfig, writeSheet1);
		excelWriter.fill(exportData.getAccounting(), writeSheet0);


		// 别忘记关闭流
		excelWriter.finish();

		return NotifyUtils.createSysNotify(targetFileName, relativePath + targetFileName, SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功);
	}

}
