package cn.superdesk.uniorder.service.accounting.unified.supplier;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.accounting.unified.supplier.AccountingUnifiedSupplier;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.AccountingUnifiedSuplierHead;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.AccountingUnifiedSupplierStatementOfAccountFixVoDimGoods;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.AccountingUnifiedSupplierStatementOfAccountFixVoDimOrder;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.UnifiedSupplierStatementOfAccountVo;
import cn.superdesk.uniorder.service.base.BaseService;

import java.util.List;
import java.util.Map;

/**
 * @Description: 供应商 对账
 * @Author: linjinyu
 * @CreateDate: 9/23/20 10:46 AM
 * @UpdateUser: linjinyu
 * @UpdateDate: 9/23/20 10:46 AM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface AccountingUnifiedSupplierService extends BaseService<AccountingUnifiedSupplier> {

	AccountingUnifiedSupplier findByAccountingOrderSn(String accountingOrderSn);

	/**
	 * 供应商结算-对账单
	 *
	 * @param params
	 * @param pageNum
	 * @param pageSize
	 * @return
	 */
	R<List<UnifiedSupplierStatementOfAccountVo>> getStatementOfAccountList(Map<String, Object> params, int pageNum, int pageSize);

	AccountingUnifiedSuplierHead getStatementOfAccountHeadSum(Map<String, Object> params);


	/****************************************** 更新状态类 且有关联操作 start ******************************************/








	@Deprecated
	void opRejectAccounting(AccountingUnifiedSupplier statementOfAccount);

	@Deprecated
	void opAgainAccounting(AccountingUnifiedSupplier statementOfAccount);

	@Deprecated
	void opCancelAccounting(AccountingUnifiedSupplier statementOfAccount);


//    void opRejectFaceInner(AccountingUnifiedSupplier statementOfAccount);

	/****************************************** 更新状态类 且有关联操作   end ******************************************/


	/****************************************** 状态机 公共方法 机内使用 重用 start ******************************************/

	void opCancelByStateMachine(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser);

	void opAgainByStateMachine(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser);

	void opSubmitByStateMachine(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser);

	void opConfirmByStateMachine(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser);

	void opAppealByStateMachine(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser);

	/****************************************** 状态机 公共方法 机内使用 实际流转 重用   end ******************************************/

	void opDelete(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser);

	/****************************************** 状态机 外部使用 类门面 start ******************************************/
	// 创建操作 -> 对账单状态 -> 待提交(3, "待提交"),
	void opCreate(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser);

	// 提交操作 -> 对账单状态 -> 未确认(0, "未确认"),// 已提交
	void opSubmit(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser);

	// 取消操作 -> 对账单状态 -> 已取消(-1, "已取消"),
	void opCancel(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser);

	// 重新对账操作 -> 对账单状态 -> 已取消(-1, "已取消"),
	void opAgain(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser);

	// 确认操作 -> 对账单状态 -> 已确认(1, "已确认"),
	void opConfirm(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser);

	// 申诉操作 -> 对账单状态 -> 已拒绝(2, "已拒绝"),
	void opAppeal(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser);

	/****************************************** 状态机 外部使用 类门面   end ******************************************/


	AccountingUnifiedSupplierStatementOfAccountFixVoDimOrder checkAmountErrorForFixDimOrder(Map<String, Object> params);

	AccountingUnifiedSupplierStatementOfAccountFixVoDimGoods checkAmountErrorForFixDimGoods(Map<String, Object> params);

	void patchXDimOrder2DimGoods(String accountingOrderSn);

	String patchXCheckAndFix(String accountingOrderSn);

}
