package cn.superdesk.uniorder.service.accounting.unified.supplier.Impl;

import cn.superdesk.uniorder.common.enums.common.CommonOrderGoodsDirectionEnum;
import cn.superdesk.uniorder.common.enums.statement.*;
import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.service.setting.UnifiedSnConfigService;
import cn.superdesk.uniorder.common.numerical.AnCollectionUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.enums.common.CommonAccountingStateEnum;
import cn.superdesk.uniorder.common.exception.UnifiedOrderRuntimeException;
import cn.superdesk.uniorder.dao.entity.accounting.unified.supplier.*;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrder;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderExample;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderGoods;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderGoodsExample;
import cn.superdesk.uniorder.dao.mapper.accounting.unified.supplier.*;
import cn.superdesk.uniorder.dao.mapper.base.*;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.*;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.UnifiedSupplierStatementOfAccountVo;
import cn.superdesk.uniorder.pattern.state.accounting.supplier.accountingStatus.context.StatementOfAccountContext;
import cn.superdesk.uniorder.service.accounting.unified.supplier.AccountingUnifiedSupplierService;
import cn.superdesk.uniorder.service.accounting.unified.supplier.AccountingUnifiedSupplierXGoodsService;
import cn.superdesk.uniorder.service.base.UnifiedOrderCreditService;
import cn.superdesk.uniorder.service.base.UnifiedOrderGoodsService;
import cn.superdesk.uniorder.service.base.UnifiedOrderService;
import cn.superdesk.uniorder.common.lamda.AnLamdaUtils;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.math.BigDecimal;
import java.util.*;
import java.util.function.Predicate;
import java.util.stream.Collectors;


/**
 * @Description: 供应商结算-对账单
 * @Author: linjinyu 补充与修改
 * @CreateDate: 4/24/20 2:16 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 4/24/20 2:16 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class AccountingUnifiedSupplierServiceImpl implements AccountingUnifiedSupplierService {

	@Autowired
	private UnifiedOrderMapper                   unifiedOrderMapper;
	@Autowired
	private UnifiedOrderMapperEx                 unifiedOrderMapperEx;
	@Autowired
	private UnifiedOrderMapperExSupplierDimOrder unifiedOrderMapperExSupplierDimOrder;
	@Autowired
	private UnifiedOrderService                  unifiedOrderService;

	@Autowired
	private UnifiedOrderGoodsMapper   unifiedOrderGoodsMapper;
	@Autowired
	private UnifiedOrderGoodsMapperEx unifiedOrderGoodsMapperEx;
	@Autowired
	private UnifiedOrderGoodsService  unifiedOrderGoodsService;

	@Autowired
	private UnifiedOrderCreditMapper  unifiedOrderCreditMapper;
	@Autowired
	private UnifiedOrderCreditService unifiedOrderCreditService;

	@Autowired
	private AccountingUnifiedSupplierMapper   accountingUnifiedSupplierMapper;
	@Autowired
	private AccountingUnifiedSupplierMapperEx accountingUnifiedSupplierMapperEx;

	@Autowired
	private AccountingUnifiedSupplierOrderMapper    accountingUnifiedSupplierOrderMapper;
	@Autowired
	private AccountingUnifiedSupplierXOrderMapperEx accountingUnifiedSupplierXOrderMapperEx;

	@Autowired
	private AccountingUnifiedSupplierXGoodsMapper   accountingUnifiedSupplierXGoodsMapper;
	@Autowired
	private AccountingUnifiedSupplierXGoodsMapperEx accountingUnifiedSupplierXGoodsMapperEx;

	@Autowired
	private AccountingUnifiedSupplierXGoodsService accountingUnifiedSupplierXGoodsService;

	@Autowired
	private UnifiedSnConfigService unifiedSnConfigService;

	@Override
	public PageInfo<AccountingUnifiedSupplier> findByPaging(Map<String, Object> params, Integer pageNo, Integer pageSize) {

		return null;
	}

	@Override
	public void deleteObj(Long id) {

		accountingUnifiedSupplierMapper.deleteByPrimaryKey(id);
	}

	@Override
	public void updateObj(AccountingUnifiedSupplier statementOfAccount) {

		accountingUnifiedSupplierMapper.updateByPrimaryKeySelective(statementOfAccount);
	}

	@Override
	public AccountingUnifiedSupplier findById(Long id) {

		return accountingUnifiedSupplierMapper.selectByPrimaryKey(id);
	}

	@Override
	public AccountingUnifiedSupplier findByAccountingOrderSn(String accountingOrderSn) {
		AccountingUnifiedSupplierExample example = new AccountingUnifiedSupplierExample();
		example.createCriteria()
				.andAccountingOrderSnEqualTo(accountingOrderSn);

		List<AccountingUnifiedSupplier> result = accountingUnifiedSupplierMapper.selectByExample(example);

		if (AnCollectionUtils.isNotEmpty(result)) {
			return result.get(0);
		}

		return null;


	}

	@Override
	public void addObj(AccountingUnifiedSupplier statementOfAccount) {

		accountingUnifiedSupplierMapper.insert(statementOfAccount);
	}

	@Override
	public List<AccountingUnifiedSupplier> findAll(Map<String, Object> queryMap) {

		return null;
	}

	@Override
	public R<List<UnifiedSupplierStatementOfAccountVo>> getStatementOfAccountList(Map<String, Object> params, int pageNo,
	                                                                              int pageSize) {

		PageHelper.startPage(pageNo, pageSize);

		List<UnifiedSupplierStatementOfAccountVo> ls = accountingUnifiedSupplierMapperEx.getStatementOfAccountList(params);

		PageInfo<UnifiedSupplierStatementOfAccountVo> page = new PageInfo<UnifiedSupplierStatementOfAccountVo>(ls);
		PageHelper.clearPage();
		return new R<List<UnifiedSupplierStatementOfAccountVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), ls);
	}

	@Override
	public AccountingUnifiedSuplierHead getStatementOfAccountHeadSum(Map<String, Object> params) {

		return accountingUnifiedSupplierMapperEx.getStatementOfAccountHeadSum(params);
	}


	@Transactional
	@Override
	public void opRejectAccounting(AccountingUnifiedSupplier statementOfAccount) {

	}

	@Transactional
	@Override
	public void opAgainAccounting(AccountingUnifiedSupplier statementOfAccount) {

	}

	@Transactional
	@Override
	public void opCancelAccounting(AccountingUnifiedSupplier statementOfAccount) {

	}

	/**
	 * 拒绝接受;不予考虑
	 * <p>
	 * 重新对账 取消对账 申诉对账 等 操作指向
	 * <p>
	 * 取消操作 -> 对账单状态 -> 已取消(-1, "已取消"), void opCancel(AccountingUnifiedSupplier statementOfAccount);
	 * 重新对账 -> 对账单状态 -> 已取消(-1, "已取消"), void opAgain(AccountingUnifiedSupplier statementOfAccount);
	 *
	 * @param statementOfAccount
	 * @param loginSysUser
	 */
	@Transactional
	private void opRejectFaceInner(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {

		log.info("##################### cn/superdesk/uniorder/service/unified/impl/UnifiedSupplierDzServiceImpl.java start #####################");
		log.info("params UnifiedSupplierDz:\n" + JsonUtils.toPrettyJson(statementOfAccount));

		// 重新对帐嘛 这边先是更新一下这个 供应商对帐单 状态 状态是什么呢? 这个是要查一下
//        accountingUnifiedSupplierMapper.updateByPrimaryKeySelective(statementOfAccount);


		/****************************************** 更新 供应商 对账单 状态 start ******************************************/
		AccountingUnifiedSupplier forUpdate = new AccountingUnifiedSupplier();
		forUpdate.setId(statementOfAccount.getId());
		forUpdate.setAccountingStatus(AccountingOrderAccountingStatusEnum.已取消.getKey());
		forUpdate.setUpdateTime(new Date());
		forUpdate.setUpdateUserId(loginSysUser.getSysUserId());

		updateObj(forUpdate);
		/****************************************** 更新 供应商 对账单 状态   end ******************************************/

		List<String> processOrderSn                 = new ArrayList<>();
		List<Long>   processSysUnifiedOrderGoodsIds = new ArrayList<>();
		List<Long>   processOutGoodsIds             = new ArrayList<>();


		switch (AccountingOrderDimCreateByEnum.get(statementOfAccount.getDimCreateBy())) {

			case 订单:

				// 拿 供应商对帐单 sn 来查出 这个对帐单 的订单
				Map<String, Object> params = new HashMap<>();
				params.put("accountingOrderSn", statementOfAccount.getAccountingOrderSn());

				// 此为一个中间表吧 反正不是原始的订单
				// 只有四个字段
				// 1. 供应商对帐单SN
				// 2. 原始订单SN(来源各业务系统)
				// 3. 销售价?(整个订单?包含运费什么的吗?)
				// 4. 成品价?
				List<AccountingUnifiedSupplierOrder> statementOfAccountXOrders = accountingUnifiedSupplierXOrderMapperEx.findAll(params);

				if (AnCollectionUtils.isNotEmpty(statementOfAccountXOrders)) {
					processOrderSn = statementOfAccountXOrders.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getOrderSn())).map(AccountingUnifiedSupplierOrder::getOrderSn).collect(Collectors.toList());

					// 更新 订单 供应商对账状态
					unifiedOrderService.updateAccountingStateSupplierByOrderSns(processOrderSn, CommonAccountingStateEnum.未对账);

					// 更新 商品 供应商对账状态
					unifiedOrderGoodsService.updateAccountingStateSupplierByOrderSn(processOrderSn, CommonAccountingStateEnum.未对账);

					// 更新 流水 供应商对账状态 20200925 供应商结算 创建对账单 如果 积分流水 有的话 关联 更新状态 为 已对账状态
					unifiedOrderCreditService.updateAccountingStateSupplierByOrderSn(processOrderSn, CommonAccountingStateEnum.未对账);
				}


				break;

			case 商品:

				List<AccountingUnifiedSupplierXGoods> statementOfAccountXGoods = accountingUnifiedSupplierXGoodsService.findByAccountingOrderSn(statementOfAccount.getAccountingOrderSn());

				if (AnCollectionUtils.isNotEmpty(statementOfAccountXGoods)) {

					processOrderSn = statementOfAccountXGoods.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getOrderSn())).map(AccountingUnifiedSupplierXGoods::getOrderSn).collect(Collectors.toList());
					processSysUnifiedOrderGoodsIds = statementOfAccountXGoods.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getUnifiedOrderGoodsId())).map(AccountingUnifiedSupplierXGoods::getUnifiedOrderGoodsId).collect(Collectors.toList());
					processOutGoodsIds = statementOfAccountXGoods.stream().filter(o -> o.getGoodsId() != null).filter(AnLamdaUtils.distinctByKey(o -> o.getGoodsId())).map(AccountingUnifiedSupplierXGoods::getGoodsId).collect(Collectors.toList());

					// 更新 订单 供应商对账状态 -> 已对账 这个是错的，商品维度可能有部分对账的情况
					unifiedOrderService.updateAccountingStateSupplierByOrderSns(processOrderSn, CommonAccountingStateEnum.未对账);

					// 更新 商品 供应商对账状态 -> 已对账
					unifiedOrderGoodsService.updateAccountingStateSupplierByOrderSnAndSysUnifiedOrderGoodsIds(processOrderSn, processSysUnifiedOrderGoodsIds, CommonAccountingStateEnum.未对账);

					// 更新 流水 供应商对账状态  -> 已对账 20200925 供应商结算 创建对账单 如果 积分 流水 有的话 关联 更新状态 为 已对账状态
					unifiedOrderCreditService.updateAccountingStateSupplierByOrderSnAndOutGoodsIds(processOrderSn, processOutGoodsIds, CommonAccountingStateEnum.未对账);
				}


				break;

			case 流水:

				throw new UnifiedOrderRuntimeException(500, "供应商结算(对账) 对账单 目前不支持 流水维度");
			default:
				break;
		}


		// TODO 20200925 供应商结算 对账单 重新对账 如果 积分 流水 有的话 关联 更新状态 为 未对账状态


		/****************************************** 重构 上边的逻辑 20200925   end ******************************************/

		log.info("##################### cn/superdesk/uniorder/service/unified/impl/UnifiedSupplierDzServiceImpl.java end   #####################");
	}

	@Transactional
	@Override
	public void opDelete(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {

		opRejectFaceInner(statementOfAccount, loginSysUser);

		accountingUnifiedSupplierMapper.deleteByPrimaryKey(statementOfAccount.getId());

	}


	/****************************************** 状态机 公共方法 机内使用 实际流转 重用 start ******************************************/

	@Transactional
	@Override
	public void opCancelByStateMachine(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {

		opRejectFaceInner(statementOfAccount, loginSysUser);
	}

	@Transactional
	@Override
	public void opAgainByStateMachine(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {

		opRejectFaceInner(statementOfAccount, loginSysUser);
	}

	@Transactional
	@Override
	public void opSubmitByStateMachine(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {

		AccountingUnifiedSupplier forUpdate = new AccountingUnifiedSupplier();
		forUpdate.setId(statementOfAccount.getId());
		forUpdate.setAccountingStatus(AccountingOrderAccountingStatusEnum.未确认.getKey());
		forUpdate.setUpdateTime(new Date());
		forUpdate.setUpdateUserId(loginSysUser.getSysUserId());

		updateObj(forUpdate);
	}

	@Transactional
	@Override
	public void opConfirmByStateMachine(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {

		AccountingUnifiedSupplier forUpdate = new AccountingUnifiedSupplier();
		forUpdate.setId(statementOfAccount.getId());
		forUpdate.setAccountingStatus(AccountingOrderAccountingStatusEnum.已确认.getKey());
		forUpdate.setUpdateTime(new Date());
		forUpdate.setUpdateUserId(loginSysUser.getSysUserId());

		updateObj(forUpdate);
	}

	@Transactional
	@Override
	public void opAppealByStateMachine(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {

		AccountingUnifiedSupplier forUpdate = new AccountingUnifiedSupplier();
		forUpdate.setId(statementOfAccount.getId());
		forUpdate.setAccountingStatus(AccountingOrderAccountingStatusEnum.已拒绝.getKey());
		forUpdate.setUpdateTime(new Date());
		forUpdate.setUpdateUserId(loginSysUser.getSysUserId());

		updateObj(forUpdate);
	}
	/****************************************** 状态机 公共方法 机内使用 实际流转 重用   end ******************************************/


	/****************************************** 状态机 外部使用 类门面 start ******************************************/
	// 创建操作 -> 对账单状态 -> 待提交(3, "待提交"),
	public void opCreate(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {


	}

	// 提交操作 -> 对账单状态 -> 未确认(0, "未确认"),// 已提交
	public void opSubmit(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {
		StatementOfAccountContext context = new StatementOfAccountContext(statementOfAccount, loginSysUser);
		context.opSubmit();
	}

	// 取消操作 -> 对账单状态 -> 已取消(-1, "已取消"),
	public void opCancel(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {
		StatementOfAccountContext context = new StatementOfAccountContext(statementOfAccount, loginSysUser);
		context.opCancel();
	}

	// 重新对账操作 -> 对账单状态 -> 已取消(-1, "已取消"),
	public void opAgain(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {
		StatementOfAccountContext context = new StatementOfAccountContext(statementOfAccount, loginSysUser);
		context.opAgain();
	}

	// 确认操作 -> 对账单状态 -> 已确认(1, "已确认"),
	public void opConfirm(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {
		StatementOfAccountContext context = new StatementOfAccountContext(statementOfAccount, loginSysUser);
		context.opConfirm();
	}

	// 申诉操作 -> 对账单状态 -> 已拒绝(2, "已拒绝"),
	public void opAppeal(AccountingUnifiedSupplier statementOfAccount, LoginSysUser loginSysUser) {
		StatementOfAccountContext context = new StatementOfAccountContext(statementOfAccount, loginSysUser);
		context.opAppeal();
	}

	/****************************************** 状态机 外部使用 类门面   end ******************************************/


	/**
	 * 对账单 详情 订单维度
	 *
	 * @param params
	 * @return
	 */
	public AccountingUnifiedSupplierStatementOfAccountFixVoDimOrder checkAmountErrorForFixDimOrder(Map<String, Object> params) {
//        return accountingUnifiedSupplierXOrderMapperEx.checkAmountErrorForFixDimOrder(params);


		log.error("checkAmountErrorForFixDimOrder\n\n\n{}\n\n\n", JsonUtils.toJson(params));


		// 先得出一份 对账单 X 商品 的数据
		List<AccountingUnifiedSuplierCheckAmountErrorForFixDimOrder> result = accountingUnifiedSupplierXOrderMapperEx.checkAmountErrorForFixDimOrder(params);

		/****************************************** 正商品 start ******************************************/
		List<Predicate<AccountingUnifiedSuplierCheckAmountErrorForFixDimOrder>> predicatesByPlusGoods = new ArrayList<>();

		// 方法1
//        predicatesByPlusGoods.add(r -> r.getGoodsId() != null && r.getGoodsId() != 0 && r.getDirection() == 1);
		// 方法2
		predicatesByPlusGoods.add(r -> r.getGoodsName() != null && !r.getGoodsName().equals("运费") && r.getDirection().equals(1));
		/****************************************** 正商品   end ******************************************/

		/****************************************** 负商品 start ******************************************/
		List<Predicate<AccountingUnifiedSuplierCheckAmountErrorForFixDimOrder>> predicatesByMinusGoods = new ArrayList<>();
		predicatesByMinusGoods.add(r -> r.getDirection() != null && r.getDirection().equals(-1));

//        统一订单-开发|测试-rm-wz949306t03an8m8s4o-ordermanager_uat/ordermanger_qch/accounting_unified_supplier_order/		http://192.168.1.223/phpMyAdmin/sql.php?db=ordermanger_qch&table=accounting_unified_supplier_order&server=3&pos=0
//        正在显示第 0- 0 行 (共 1 行, 查询花费 0.0866 秒。)
//
//        SELECT * FROM `accounting_unified_supplier_order` WHERE id = 40841
//        40841	0	0	FLSC_QCH-DZ202010200001	0	ME20201020085329284388	161.0000	127.7400	0.0000	0.0000
		// ME20201020085329284388 存在这个单 被删除了


		/****************************************** 负商品   end ******************************************/

		/****************************************** 运费 start ******************************************/
		List<Predicate<AccountingUnifiedSuplierCheckAmountErrorForFixDimOrder>> predicatesByTransportGoods = new ArrayList<>();

		// 方法1
//        predicatesByTransportGoods.add(r -> r.getGoodsId() != null && r.getGoodsId() == 0 && r.getDirection() == 1);
		// 方法2
		predicatesByPlusGoods.add(r -> r.getGoodsName() != null && r.getGoodsName().equals("运费") && r.getDirection().equals(1));
		/****************************************** 运费   end ******************************************/


		List<AccountingUnifiedSuplierCheckAmountErrorForFixDimOrder> predicatesByPlusGoodsFilter      = AnLamdaUtils.filters(result, predicatesByPlusGoods);
		List<AccountingUnifiedSuplierCheckAmountErrorForFixDimOrder> predicatesByMinusGoodsFilter     = AnLamdaUtils.filters(result, predicatesByMinusGoods);
		List<AccountingUnifiedSuplierCheckAmountErrorForFixDimOrder> predicatesByTransportGoodsFilter = AnLamdaUtils.filters(result, predicatesByTransportGoods);

		BigDecimal orderCostAmount       = BigDecimal.ZERO;
		BigDecimal orderTransportAmount  = BigDecimal.ZERO;
		BigDecimal goodsCostAmount       = BigDecimal.ZERO;
		BigDecimal goodsRefundCostAmount = BigDecimal.ZERO;
		BigDecimal goodsTransportAmount  = BigDecimal.ZERO;

		if (AnCollectionUtils.isNotEmpty(predicatesByPlusGoodsFilter)) {
			goodsCostAmount = predicatesByPlusGoodsFilter
					.stream()
					.map(item -> item.getCostPrice() == null ? BigDecimal.ZERO : item.getCostPrice().multiply(new BigDecimal(item.getQuantity())))
					.reduce(BigDecimal.ZERO, BigDecimal::add);
		}

		if (AnCollectionUtils.isNotEmpty(predicatesByMinusGoodsFilter)) {
			goodsRefundCostAmount = predicatesByMinusGoodsFilter
					.stream()
					.map(item -> item.getCostPrice() == null ? BigDecimal.ZERO : item.getCostPrice().multiply(new BigDecimal(item.getQuantity())))
					.reduce(BigDecimal.ZERO, BigDecimal::add);
		}

		if (AnCollectionUtils.isNotEmpty(predicatesByTransportGoodsFilter)) {
			goodsTransportAmount = predicatesByTransportGoodsFilter
					.stream()
					.map(item -> item.getCostPrice() == null ? BigDecimal.ZERO : item.getCostPrice().multiply(new BigDecimal(item.getQuantity())))
					.reduce(BigDecimal.ZERO, BigDecimal::add);
		}

		BigDecimal newAmount            = goodsCostAmount.add(goodsRefundCostAmount);
		BigDecimal newAmountWithFreight = newAmount.add(goodsTransportAmount);

		log.info("核算 : \norderCostAmount: {}\norderTransportAmount: {}\ngoodsCostAmount: {}\ngoodsRefundCostAmount: {}\ngoodsTransportAmount: {}\nnewAmount: {}\nnewAmountWithFreight: {}",
				orderCostAmount, orderTransportAmount, goodsCostAmount, goodsRefundCostAmount, goodsTransportAmount, newAmount, newAmountWithFreight);


		AccountingUnifiedSupplierStatementOfAccountFixVoDimOrder statementOfAccountStatisticsVo = new AccountingUnifiedSupplierStatementOfAccountFixVoDimOrder();


		statementOfAccountStatisticsVo.setOrderCostAmount(orderCostAmount);
		statementOfAccountStatisticsVo.setOrderTransportAmount(orderTransportAmount);

		statementOfAccountStatisticsVo.setGoodsCostAmount(goodsCostAmount);
		statementOfAccountStatisticsVo.setGoodsRefundCostAmount(goodsRefundCostAmount);
		statementOfAccountStatisticsVo.setGoodsTransportAmount(goodsTransportAmount);

		return statementOfAccountStatisticsVo;
	}

	/**
	 * 对账单 详情 商品维度
	 *
	 * @param params
	 * @return
	 */
	public AccountingUnifiedSupplierStatementOfAccountFixVoDimGoods checkAmountErrorForFixDimGoods(Map<String, Object> params) {

		log.info("对账单 详情 商品维度 {}", JsonUtils.toJson(params));

		// 先得出一份 对账单 X 商品 的数据
		List<AccountingUnifiedSuplierCheckAmountErrorForFixDimGoods> result = accountingUnifiedSupplierXGoodsMapperEx.checkAmountErrorForFixDimGoods(params);


		/****************************************** 正商品 start ******************************************/
		List<Predicate<AccountingUnifiedSuplierCheckAmountErrorForFixDimGoods>> predicatesByPlusGoods = new ArrayList<>();

		// 方法1
//        predicatesByPlusGoods.add(r -> r.getGoodsId() != null && r.getGoodsId() != 0 && r.getDirection() == 1);
		// 方法2
		predicatesByPlusGoods.add(r -> r.getGoodsName() != null && !r.getGoodsName().equals("运费") && r.getDirection().equals(CommonOrderGoodsDirectionEnum.正向.getKey()));
		/****************************************** 正商品   end ******************************************/

		/****************************************** 负商品 start ******************************************/
		List<Predicate<AccountingUnifiedSuplierCheckAmountErrorForFixDimGoods>> predicatesByMinusGoods = new ArrayList<>();
		predicatesByMinusGoods.add(r -> null != r.getDirection() && r.getDirection().equals(CommonOrderGoodsDirectionEnum.负向.getKey()));

		/****************************************** 负商品   end ******************************************/

		/****************************************** 运费 start ******************************************/
		List<Predicate<AccountingUnifiedSuplierCheckAmountErrorForFixDimGoods>> predicatesByTransportGoods = new ArrayList<>();

		// 方法1
//        predicatesByTransportGoods.add(r -> r.getGoodsId() != null && r.getGoodsId() == 0 && r.getDirection() == 1);
		// 方法2
		predicatesByPlusGoods.add(r -> r.getGoodsName() != null && r.getGoodsName().equals("运费") && r.getDirection() == 1);
		/****************************************** 运费   end ******************************************/


		List<AccountingUnifiedSuplierCheckAmountErrorForFixDimGoods> predicatesByPlusGoodsFilter      = AnLamdaUtils.filters(result, predicatesByPlusGoods);
		List<AccountingUnifiedSuplierCheckAmountErrorForFixDimGoods> predicatesByMinusGoodsFilter     = AnLamdaUtils.filters(result, predicatesByMinusGoods);
		List<AccountingUnifiedSuplierCheckAmountErrorForFixDimGoods> predicatesByTransportGoodsFilter = AnLamdaUtils.filters(result, predicatesByTransportGoods);

		BigDecimal orderCostAmount       = BigDecimal.ZERO;
		BigDecimal orderTransportAmount  = BigDecimal.ZERO;
		BigDecimal goodsCostAmount       = BigDecimal.ZERO;
		BigDecimal goodsRefundCostAmount = BigDecimal.ZERO;
		BigDecimal goodsTransportAmount  = BigDecimal.ZERO;

		if (AnCollectionUtils.isNotEmpty(predicatesByPlusGoodsFilter)) {
			goodsCostAmount = predicatesByPlusGoodsFilter
					.stream()
					.map(item -> item.getCostPrice() == null ? BigDecimal.ZERO : item.getCostPrice().multiply(new BigDecimal(item.getQuantity())))
					.reduce(BigDecimal.ZERO, BigDecimal::add);
		}

		if (AnCollectionUtils.isNotEmpty(predicatesByMinusGoodsFilter)) {
			goodsRefundCostAmount = predicatesByMinusGoodsFilter
					.stream()
					.map(item -> item.getCostPrice() == null ? BigDecimal.ZERO : item.getCostPrice().multiply(new BigDecimal(item.getQuantity())))
					.reduce(BigDecimal.ZERO, BigDecimal::add);
		}

		if (AnCollectionUtils.isNotEmpty(predicatesByTransportGoodsFilter)) {
			goodsTransportAmount = predicatesByTransportGoodsFilter
					.stream()
					.map(item -> item.getCostPrice() == null ? BigDecimal.ZERO : item.getCostPrice().multiply(new BigDecimal(item.getQuantity())))
					.reduce(BigDecimal.ZERO, BigDecimal::add);
		}

		BigDecimal newAmount            = goodsCostAmount.add(goodsRefundCostAmount);
		BigDecimal newAmountWithFreight = newAmount.add(goodsTransportAmount);

		log.info("核算 : \norderCostAmount: {}\norderTransportAmount: {}\ngoodsCostAmount: {}\ngoodsRefundCostAmount: {}\ngoodsTransportAmount: {}\nnewAmount: {}\nnewAmountWithFreight: {}",
				orderCostAmount, orderTransportAmount, goodsCostAmount, goodsRefundCostAmount, goodsTransportAmount, newAmount, newAmountWithFreight);


		AccountingUnifiedSupplierStatementOfAccountFixVoDimGoods unifiedSupplierStatementOfAccountVo = new AccountingUnifiedSupplierStatementOfAccountFixVoDimGoods();


		unifiedSupplierStatementOfAccountVo.setOrderCostAmount(orderCostAmount);
		unifiedSupplierStatementOfAccountVo.setOrderTransportAmount(orderTransportAmount);

		unifiedSupplierStatementOfAccountVo.setGoodsCostAmount(goodsCostAmount);
		unifiedSupplierStatementOfAccountVo.setGoodsRefundCostAmount(goodsRefundCostAmount);
		unifiedSupplierStatementOfAccountVo.setGoodsTransportAmount(goodsTransportAmount);

		return unifiedSupplierStatementOfAccountVo;


	}

	/**
	 * 补丁程序
	 * 侨城汇
	 * 大概是可以与超级前台的逻辑共用，还是要查证一下
	 */
	public void patchXDimOrder2DimGoods(String accountingOrderSn) {

		// TODO 先找出 全部 对账单(有效) X orders

		AccountingUnifiedSupplierExample          example00 = new AccountingUnifiedSupplierExample();
		AccountingUnifiedSupplierExample.Criteria criteria  = example00.createCriteria();

		criteria.andDimCreateByEqualTo(0)
				.andAccountingStatusNotEqualTo(AccountingOrderAccountingStatusEnum.已取消.getKey());

		if (StringUtils.isNotBlank(accountingOrderSn)) {
			criteria.andAccountingOrderSnEqualTo(accountingOrderSn);
		}

		List<AccountingUnifiedSupplier> accountingUnifiedSupplierList = accountingUnifiedSupplierMapper.selectByExample(example00);

		if (AnCollectionUtils.isNotEmpty(accountingUnifiedSupplierList)) {

			for (AccountingUnifiedSupplier item00 : accountingUnifiedSupplierList) {

				AccountingUnifiedSupplierOrderExample example1 = new AccountingUnifiedSupplierOrderExample();
				example1.clear();
				example1.createCriteria()
						.andAccountingOrderSnEqualTo(item00.getAccountingOrderSn());
				List<AccountingUnifiedSupplierOrder> accountingUnifiedSupplierOrderList = accountingUnifiedSupplierOrderMapper.selectByExample(example1);

				for (AccountingUnifiedSupplierOrder item01 : accountingUnifiedSupplierOrderList) {

					// TODO 坑位？ 这个 createCriteria 没作用？
					UnifiedOrderGoodsExample example2 = new UnifiedOrderGoodsExample();
					example2.clear();
					example2.createCriteria()
							.andOrderSnEqualTo(item01.getOrderSn());
					List<UnifiedOrderGoods> unifiedOrderGoodsList = unifiedOrderGoodsMapper.selectByExample(example2);

					// TODO 坑位？ 这个 createCriteria 没作用？
					UnifiedOrderExample example3 = new UnifiedOrderExample();
					example3.createCriteria()
							.andOrderSnEqualTo(item01.getOrderSn());
					List<UnifiedOrder> unifiedOrderList = unifiedOrderMapper.selectByExample(example3);

					UnifiedOrder item03 = unifiedOrderList.get(0);

					for (UnifiedOrderGoods item02 : unifiedOrderGoodsList) {

						AccountingUnifiedSupplierXGoods xGoods = new AccountingUnifiedSupplierXGoods();

						xGoods.setDimCreateBy(AccountingOrderDimCreateByEnum.订单.getKey());

						xGoods.setAccountingOrderId(item00.getId());
						xGoods.setAccountingOrderSn(item00.getAccountingOrderSn());

						xGoods.setUnifiedOrderId(item03.getId());
						xGoods.setOrderSn(item01.getOrderSn());

						xGoods.setUnifiedOrderGoodsId(item02.getId());
						xGoods.setGoodsId(item02.getGoodsId());
						xGoods.setOutSnapshotOrderGoodsId(item02.getOutSnapshotOrderGoodsId());

						xGoods.setCreateUserId(1L);
						xGoods.setCreateTime(new Date());
						xGoods.setUpdateUserId(1L);
						xGoods.setCreateTime(new Date());

						accountingUnifiedSupplierXGoodsMapper.insert(xGoods);

					}

					// 基于 orderSn 来更新 供应商对账状态
					UnifiedOrderGoods goods = new UnifiedOrderGoods();
					goods.setAccountingStateSupplier(CommonAccountingStateEnum.已对账.getKey());
					unifiedOrderGoodsMapper.updateByExampleSelective(goods, example2);
				}

			}
		}


		// 再按 orders 去更新 goods?


	}

	/**
	 * 供应商 patchXCheckAndFix
	 * <p>
	 * 1. 首先 输入的 供应商对账单 SN ! 已确认 ！不存在
	 * <p>
	 * 2. 对账单 关联关系 去 AccountingUnifiedSupplierXGoods 找关系
	 * 关联关系 不存在 问题对账单
	 * 关联关系 Size
	 * <p>
	 * 3. 对账单 关联 商品 通过 存的 AccountingUnifiedSupplierXGoods 分别过滤出 订单 与 商品
	 * <p>
	 * 4. 过滤出 问题数据 已经生成对账单 但状态还是未对账
	 * 关联商品 供应商对账状态-未对账 不存在 不需要修正
	 * 关联商品 供应商对账状态-未对账 存在 Size
	 * <p>
	 * 5. 修正状态
	 * 商品-供应商 对账状态-已对账
	 *
	 * @param accountingOrderSn
	 */
	@Transactional
	public String patchXCheckAndFix(String accountingOrderSn) {


		StringBuffer report = new StringBuffer();

		report.append("对账单编号 : ").append(accountingOrderSn);

		/****************************************** 对账单 start ******************************************/


//		AccountingUnifiedSupplierExample          example00                         = new AccountingUnifiedSupplierExample();
//		AccountingUnifiedSupplierExample.Criteria accountingUnifiedSupplierCriteria = example00.createCriteria();
//
//		// 先屏蔽
////		accountingUnifiedSupplierCriteria
//////				.andDimCreateByEqualTo(0)
////				.andAccountingStatusEqualTo(AccountingOrderAccountingStatusEnum.已确认.getKey());
//
//		if (StringUtils.isNotBlank(accountingOrderSn)) {
//			accountingUnifiedSupplierCriteria.andAccountingOrderSnEqualTo(accountingOrderSn);
//		}

//		AccountingUnifiedSupplierExample          example00                         = new AccountingUnifiedSupplierExample();
//		example00.createCriteria().andAccountingOrderSnEqualTo(accountingOrderSn);
//
//		List<AccountingUnifiedSupplier> accountingUnifiedSupplierList = accountingUnifiedSupplierMapper.selectByExample(example00);


//		if (AnCollectionUtils.isEmpty(accountingUnifiedSupplierList)) {
//			// 就是说明 这个对账单 是不一个有作用的对账单
//
//			// 返回错误的信息
//
//			report.append("AnCollectionUtils.isEmpty(accountingUnifiedSupplierList:true:不存在:").append(JsonUtils.toJson(accountingUnifiedSupplierList));
//
//			log.info(report.toString());
//
//			return report.toString();
//		}
		/****************************************** 对账单   end ******************************************/


		/****************************************** 交叉逻辑 mark by linjinyu at 20210205 start ******************************************/
//		AccountingUnifiedSupplier accountingUnifiedSupplier = accountingUnifiedSupplierList.get(0);


		AccountingUnifiedSupplier accountingUnifiedSupplier = accountingUnifiedSupplierMapperEx.getByAnnountingOrderSn(accountingOrderSn);

		if (null == accountingUnifiedSupplier) {
			report.append("null:accountingUnifiedSupplier:不存在:").append(JsonUtils.toJson(accountingUnifiedSupplier));
			log.info(report.toString());

			return report.toString();
		}

		final CommonAccountingStateEnum beFilter;
		final CommonAccountingStateEnum beUpdate;
		switch (AccountingOrderAccountingStatusEnum.get(accountingUnifiedSupplier.getAccountingStatus())) {
			case 待提交:

				beFilter = CommonAccountingStateEnum.未对账;
				beUpdate = CommonAccountingStateEnum.已对账;
				break;
			case 未确认:
				beFilter = CommonAccountingStateEnum.未对账;
				beUpdate = CommonAccountingStateEnum.已对账;
				break;
			case 已确认:
				beFilter = CommonAccountingStateEnum.未对账;
				beUpdate = CommonAccountingStateEnum.已对账;
				break;
			case 已取消:
				beFilter = CommonAccountingStateEnum.已对账;
				beUpdate = CommonAccountingStateEnum.未对账;
				break;
			case 已拒绝:
				beFilter = CommonAccountingStateEnum.已对账;
				beUpdate = CommonAccountingStateEnum.未对账;
				break;
			default:
				throw new UnifiedOrderRuntimeException(500, "没命中?出问题");

		}


		/****************************************** 对账单 关联关系 start ******************************************/

		AccountingUnifiedSupplierXGoodsExample          exampleX                                       = new AccountingUnifiedSupplierXGoodsExample();
		AccountingUnifiedSupplierXGoodsExample.Criteria accountingUnifiedSupplierXGoodsExampleCriteria = exampleX.createCriteria();

		accountingUnifiedSupplierXGoodsExampleCriteria.andAccountingOrderSnEqualTo(accountingOrderSn);

		List<AccountingUnifiedSupplierXGoods> accountingUnifiedSupplierXGoodsList = accountingUnifiedSupplierXGoodsMapper.selectByExample(exampleX);

		if (AnCollectionUtils.isEmpty(accountingUnifiedSupplierXGoodsList)) {
			report.append(" : 关联关系 不存在 问题对账单");

			return report.toString();
		} else {
			report.append(" : 关联关系 Size : ").append(accountingUnifiedSupplierXGoodsList.size());
		}

		/****************************************** 对账单 关联关系   end ******************************************/


		/****************************************** 对账单 关联 商品 start ******************************************/
		List<String> processUnifiedOrderSns         = accountingUnifiedSupplierXGoodsList.stream().filter(o -> null != o.getOrderSn()).map(o -> o.getOrderSn()).collect(Collectors.toList());
		List<Long>   processUnifiedOrderGoodsIdFull = accountingUnifiedSupplierXGoodsList.stream().filter(o -> null != o.getUnifiedOrderGoodsId()).map(o -> o.getUnifiedOrderGoodsId()).collect(Collectors.toList());

		UnifiedOrderGoodsExample example = new UnifiedOrderGoodsExample();
		example.createCriteria()
				.andIdIn(processUnifiedOrderGoodsIdFull);
		List<UnifiedOrderGoods> unifiedOrderGoodsList = unifiedOrderGoodsMapper.selectByExample(example);

		if (AnCollectionUtils.isEmpty(unifiedOrderGoodsList)) {
			report.append(" : 关联商品 不存在 问题对账单");

			return report.toString();
		} else {
			report.append(" : 关联商品 Size : ").append(unifiedOrderGoodsList.size());
		}

		/****************************************** 对账单 关联 商品 start ******************************************/


		/****************************************** 过滤出 问题数据 已经生成对账单 但状态还是未对账 start ******************************************/
		List<Predicate<UnifiedOrderGoods>> predicatesByAccountingStateSupplierEq2 = new ArrayList<>();
		predicatesByAccountingStateSupplierEq2.add(r -> r.getAccountingStateSupplier() != null && r.getAccountingStateSupplier().equals(beFilter.getKey()));
		List<UnifiedOrderGoods> processUnifiedOrderGoodsByAccountingStateSupplierEq2 = AnLamdaUtils.filters(unifiedOrderGoodsList, predicatesByAccountingStateSupplierEq2);

		List<Long> processUnifiedOrderGoodsIdsByAccountingStateSupplierEq2 = processUnifiedOrderGoodsByAccountingStateSupplierEq2.stream().filter(o -> null != o.getId()).map(o -> o.getId()).collect(Collectors.toList());

		if (AnCollectionUtils.isEmpty(processUnifiedOrderGoodsIdsByAccountingStateSupplierEq2)) {
			report.append(" : 关联商品 供应商对账状态-未对账 不存在 不需要修正");

			return report.toString();
		} else {
			report.append(" : 关联商品 供应商对账状态-未对账 存在 Size : ").append(processUnifiedOrderGoodsIdsByAccountingStateSupplierEq2.size());
		}

		/****************************************** 过滤出 问题数据 已经生成对账单 但状态还是未对账   end ******************************************/


		/****************************************** 修正状态 start ******************************************/
		// 供应商对账状态
		unifiedOrderGoodsService.updateAccountingStateSupplierByOrderSnAndSysUnifiedOrderGoodsIds(processUnifiedOrderSns, processUnifiedOrderGoodsIdsByAccountingStateSupplierEq2, beUpdate);
		/****************************************** 修正状态   end ******************************************/


		return report.toString();


	}

}
