package cn.superdesk.uniorder.service.base;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.enums.common.CommonAccountingStateEnum;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderCredit;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApplyXGoods;
import com.github.pagehelper.PageInfo;

import java.util.List;
import java.util.Map;


/**
 * @Description: 流水
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2020-09-23 15:16:04
 * @UpdateUser: linjinyu
 * @UpdateDate: 2020-09-23 15:16:04
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface UnifiedOrderCreditService extends BaseService<UnifiedOrderCredit> {


	/****************************************** extends BaseService 部分 start ******************************************/

	@Deprecated
	void addObj(UnifiedOrderCredit entity);

	@Deprecated
	void updateObj(UnifiedOrderCredit entity);

	@Deprecated
	void deleteObj(Long id);

	@Deprecated
	UnifiedOrderCredit findById(Long id);

	@Deprecated
	PageInfo<UnifiedOrderCredit> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize);

	@Deprecated
	List<UnifiedOrderCredit> findAll(Map<String, Object> queryMap);

	/****************************************** extends BaseService 部分   end ******************************************/


	void addUnifiedOrderCredit(UnifiedOrderCredit entity);

	void updateUnifiedOrderCredit(UnifiedOrderCredit entity);

	void deleteUnifiedOrderCredit(Long id);

	UnifiedOrderCredit findUnifiedOrderCreditById(Long id);

	R<List<UnifiedOrderCredit>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize);


	Map<String, Integer> checkStatement(Map<String, Object> conditions);

	/****************************************** 关于 供应商结算 对账单 设置 对账状态 或 恢复 对账状态 start ******************************************/
	/**
	 * 订单维度
	 *
	 * @param processOrderSn
	 * @param state
	 */
	void updateAccountingStateSupplierByOrderSn(List<String> processOrderSn, CommonAccountingStateEnum state);

	/**
	 * 商品维度
	 *
	 * @param processOrderSn
	 * @param processOutGoodsIds
	 * @param state
	 */
	void updateAccountingStateSupplierByOrderSnAndOutGoodsIds(List<String> processOrderSn, List<Long> processOutGoodsIds, CommonAccountingStateEnum state);
	/****************************************** 关于 供应商结算 对账单 设置 对账状态 或 恢复 对账状态   end ******************************************/


	/****************************************** 关于 客户结算 对账单 设置 对账状态 或 恢复 对账状态 start ******************************************/
    /**
     * 订单维度
     * @param processOrderSn
     * @param state
     */
	void updateAccountingStateCustomerByOrderSn(List<String> processOrderSn, CommonAccountingStateEnum state);

    /**
     * 商品维度
     * @param processOrderSn
     * @param processOutGoodsIds
     * @param state
     */
	void updateAccountingStateCustomerByOrderSnAndOutGoodsIds(List<String> processOrderSn, List<Long> processOutGoodsIds, CommonAccountingStateEnum state);
	/****************************************** 关于 客户结算 对账单 设置 对账状态 或 恢复 对账状态   end ******************************************/

	/****************************************** 流水 状态 回款状态 start ******************************************/
	void updateFieldBackAccountStatusByInvoiceX(List<InvoiceApplyXGoods> invoiceX);

	/****************************************** 流水 状态 回款状态   end ******************************************/


	/****************************************** 补丁程序 start ******************************************/
	String checkAndFixAccountingStateCustomer(/*积分批次号*/String batchs);
	/****************************************** 补丁程序   end ******************************************/


}