package cn.superdesk.uniorder.service.base;

import cn.superdesk.uniorder.common.pagination.PageQueryParam;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.enums.common.CommonAccountingStateEnum;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrder;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderGoods;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApplyXGoods;
import cn.superdesk.uniorder.dto.param._function.select.SelectOptionDepartmentCriteria;
import cn.superdesk.uniorder.dto.param.accounting.unified.supplier.AccountingSupplierNotYetDimGoodsCriteria;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.proxyclient.ProxyClientOrderOptBecomeInvalidQueryCriteria;
import cn.superdesk.uniorder.dto.vo._function.select.SelectOptionDepartment;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.CustomerUnAccountingDimGoodsVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.UnifiedOrderCustomerHeadSumVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.UnifiedOrderCustomerNotCheckVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.notyet.UnifiedOrderJoinGoodsOfSupplierStatementOfAccount;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.notyet.UnifiedOrderSupplierHeadSumVo;
import cn.superdesk.uniorder.dto.vo.order.Org2VirtStatisticsVo;
import cn.superdesk.uniorder.dto.vo.unified.*;
import cn.superdesk.uniorder.dto.vo.wechat.WxBillOrder;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @Description: 基本数据 订单
 * @Author: linjinyu 重构 完善
 * @CreateDate: 2021/1/6 下午8:56
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/1/6 下午8:56
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface UnifiedOrderService extends BaseService<UnifiedOrder> {

	List<SelectOptionDepartment> getSelectPurchaseDepartment(SelectOptionDepartmentCriteria criteria, LoginSysUser loginSysUser);

	UnifiedOrder addObjTran(UnifiedOrder order, List<UnifiedOrderGoods> unifiedOrderGoodsList);

	UnifiedOrder findByOrderSn(String orderSn);

	UnifiedOrder findByJdOrderSn(String jdOrderSn);

	List<UnifiedOrder> findAll(Map<String, Object> queryMap);

	R<List<UnifiedOrder>> patchFlashDeliverPatchUnifiedOrderFieldOutVirt(PageQueryParam pageQueryParam);

	Integer countAll(Map<String, Object> queryMap);


	/****************************************** 供应商结算 dim order 未对账 订单 start ******************************************/

	UnifiedOrderSupplierHeadSumVo getSupplierUnAccountingDimOrderHeadSum(Map<String, Object> params);

	R<List<UnifiedOrderSupplierDimOrderNotCheckVo>> getSupplierUnAccountingDimOrderList(Map<String, Object> params, int pageNum, int pageSize);

	List<UnifiedOrderSupplierDimOrderNotCheckVo> getSupplierUnAccountingDimOrderList(Map<String, Object> params);

	List<UnifiedOrderSupplierNotCheckDetail2GoodsVo> getSupplierUnAccountingDetail2Goods(Map<String, Object> params);

	/****************************************** 供应商结算 dim order 未对账 订单   end ******************************************/


	/****************************************** 供应商结算 dim goods 未对账 商品 start ******************************************/

	UnifiedOrderSupplierHeadSumVo getSupplierUnAccountingDimGoodsHeadSum(AccountingSupplierNotYetDimGoodsCriteria criteria);

	List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierUnAccountingDimGoodsList(AccountingSupplierNotYetDimGoodsCriteria criteria);

	R<List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount>> getSupplierUnAccountingDimGoodsListByPageQuery(AccountingSupplierNotYetDimGoodsCriteria criteria);

	/****************************************** 供应商结算 dim goods 未对账 商品   end ******************************************/

	/****************************************** 供应商结算 对账单详情 start ******************************************/

	List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierStatementOfAccountDetailDimOrder2Goods(Map<String, Object> params);

	List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierStatementOfAccountDetailDimGoods2Goods(String accountingOrderSn);

	/****************************************** 供应商结算 对账单详情   end ******************************************/


	/****************************************** 关于 供应商结算 对账单 设置 对账状态 或 恢复 对账状态 start ******************************************/

	void updateAccountingStateSupplierBySysUnifiedOrderIds(List<Long> sysUnifiedOrderIds, CommonAccountingStateEnum state);

	void updateAccountingStateSupplierByOrderSns(List<String> orderSns, CommonAccountingStateEnum state);

	/****************************************** 关于 供应商结算 对账单 设置 对账状态 或 恢复 对账状态   end ******************************************/

	/****************************************** 关于 客户结算 对账单 设置 对账状态 或 恢复 对账状态 start ******************************************/

	void updateAccountingStateCustomerBySysUnifiedOrderIds(List<Long> sysUnifiedOrderIds, CommonAccountingStateEnum state);

	void updateAccountingStateCustomerByOrderSns(List<String> orderSns, CommonAccountingStateEnum state);

	/****************************************** 关于 客户结算 对账单 设置 对账状态 或 恢复 对账状态   end ******************************************/


	/****************************************** 客户结算 dim order 未对账 订单 start ******************************************/

	UnifiedOrderCommonHeadSum getCustomerUnAccountingDimOrderHeadSum(Map<String, Object> params);

	List<UnifiedOrderCustomerNotCheckVo> getCustomerUnAccountingDimOrderList(Map<String, Object> params);

	R<List<UnifiedOrderCustomerNotCheckVo>> getCustomerUnAccountingDimOrderList(Map<String, Object> params, int pageNum, int pageSize);

	/****************************************** 客户结算 dim order 未对账 订单   end ******************************************/

	/****************************************** 客户结算 dim goods 未对账 商品 start ******************************************/

	UnifiedOrderCustomerHeadSumVo getCustomerUnAccountingDimGoodsHeadSum(Map<String, Object> params, LoginSysUser loginSysUser);

	List<CustomerUnAccountingDimGoodsVo> getCustomerUnAccountingDimGoodsList(Map<String, Object> params, LoginSysUser loginSysUser);

	R<List<CustomerUnAccountingDimGoodsVo>> getCustomerUnAccountingDimGoodsList(Map<String, Object> params, int pageNo, int pageSize, LoginSysUser loginSysUser);

	/****************************************** 客户结算 dim goods 未对账 商品   end ******************************************/


	/****************************************** 订单管理 start ******************************************/

	UnifiedOrderCommonHeadSum getOrderManagerGoodsPageHead(Map<String, Object> params);

	List<ViewUnifiedOrderGoods> getOrderManagerGoodsView(Map<String, Object> params);

	R<List<Org2VirtStatisticsVo>> getOrg2VirtStatistics(Map<String, Object> params, int pageNum, int pageSize);

	R<List<ViewUnifiedOrderGoods>> getOrderManagerGoodsByPage(Map<String, Object> params, int pageNum, int pageSize);

	/****************************************** 订单管理   end ******************************************/

	/****************************************** 订单 状态 回款状态 start ******************************************/

	void updateFieldBackAccountStatusByInvoiceX(List<InvoiceApplyXGoods> invoiceX);

	R<String> proxyClientOrderOptBecomeInvalid(ProxyClientOrderOptBecomeInvalidQueryCriteria queryCriteria);

	/****************************************** 订单 状态 回款状态   end ******************************************/


	BigDecimal getAmount(Map<String, Object> query);

	BigDecimal getPayAmount(Map<String, Object> upaymap);

	Integer getOrderCount(Map<String, Object> queryMap);

	List<WxBillOrder> getVirtOrder(Map<String, Object> params);

	/**
	 * 存在问题 这个是什么对账单
	 *
	 * @param params
	 * @return
	 */
	List<UnifiedOrder> findByDzId(Map<String, Object> params);

	List<UnifiedOrder> findBySysUnifiedOrderIds(List<Long> sysUnifiedOrderIds);

	List<UnifiedOrder> findByOrderSns(List<String> orderSns);


	/****************************************** 工具方法 sysUnifiedOrderIds 推导 start ******************************************/

	List<String> convertSysUnifiedOrderIds2OrderSn(List<Long> sysUnifiedOrderIds);

	Map<Long, String> convertSysUnifiedOrderIds2MapSysUnifiedOrderId2OrderSn(List<Long> sysUnifiedOrderIds);

	Map<Long, UnifiedOrder> convertSysUnifiedOrderIds2MapSysUnifiedOrderId2Entity(List<Long> sysUnifiedOrderIds);

	Map<String, UnifiedOrder> convertSysUnifiedOrderIds2MapOrderSn2Entity(List<Long> sysUnifiedOrderIds);

	Map<String, Long> convertSysUnifiedOrderIds2MapOrderSn2SysUnifiedOrderId(List<Long> sysUnifiedOrderIds);

	/****************************************** 工具方法 sysUnifiedOrderIds 推导   end ******************************************/

	/****************************************** 工具方法 orderSns 推导 start ******************************************/

	Map<String, Long> convertOrderSns2MapOrderSn2SysUnifiedOrderId(List<String> orderSns);

	/****************************************** 工具方法 orderSns 推导   end ******************************************/
}
