package cn.superdesk.uniorder.service.base.impl;

import cn.superdesk.uniorder.common.enums.common.CommonAccountingStateEnum;
import cn.superdesk.uniorder.common.enums.credit.UnifiedOrderCreditBackStatusEnum;
import cn.superdesk.uniorder.common.enums.credit.UnifiedOrderCreditInvoiceApplyStatusEnum;
import cn.superdesk.uniorder.common.enums.credit.UnifiedOrderCreditInvoiceMakeStatusEnum;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrder;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderReturn;
import cn.superdesk.uniorder.dao.entity.channel.UnifiedChannelProfitSync;
import cn.superdesk.uniorder.dao.entity.unified.UnifiedOrderProfit;
import cn.superdesk.uniorder.dao.mapper.base.*;
import cn.superdesk.uniorder.dao.mapper.channel.UnifiedChannelProfitSyncMapper;
import cn.superdesk.uniorder.dao.mapper.channel.UnifiedChannelProfitSyncMapperEx;
import cn.superdesk.uniorder.dao.mapper.unified.UnifiedOrderProfitMapper;
import cn.superdesk.uniorder.dao.mapper.unified.UnifiedOrderProfitMapperEx;
import cn.superdesk.uniorder.dto.vo.score.ScoreOrderReconciliationNotYetHeadVo;
import cn.superdesk.uniorder.dto.vo.score.ScoreOrderReconciliationNotYetVo;
import cn.superdesk.uniorder.service.base.CommonOrderProcessService;
import cn.superdesk.uniorder.service.base.ScoreOrderService;
import cn.superdesk.uniorder.common.numerical.AnCollectionUtils;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.*;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 6/12/20 3:14 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 6/12/20 3:14 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class ScoreOrderServiceImpl implements ScoreOrderService {

	@Autowired
	private UnifiedOrderMapper                    unifiedOrderMapper;
	@Autowired
	private UnifiedOrderMapperEx                  unifiedOrderMapperEx;
	@Autowired
	private UnifiedOrderMapperExCustomerDimCredit unifiedOrderMapperExScore;
	@Autowired
	private UnifiedOrderGoodsMapper               unifiedOrderGoodsMapper;
	@Autowired
	private UnifiedOrderGoodsMapperEx             unifiedOrderGoodsMapperEx;
	@Autowired
	private UnifiedOrderCreditMapper              unifiedOrderCreditMapper;

	@Autowired
	private CommonOrderProcessService commonOrderProcessService;

	/****************************************** 退单部分 ******************************************/
	@Autowired
	private UnifiedOrderReturnMapper        unifiedOrderReturnMapper;
	@Autowired
	private UnifiedOrderReturnMapperEx      unifiedOrderReturnMapperEx;
	@Autowired
	private UnifiedOrderReturnGoodsMapper   unifiedOrderReturnGoodsMapper;
	@Autowired
	private UnifiedOrderReturnGoodsMapperEx unifiedOrderReturnGoodsMapperEx;
	@Autowired
	private UnifiedOrderReturnCreditMapper  unifiedOrderReturnCreditMapper;
	/****************************************** 退单部分 ******************************************/


	/****************************************** 分润部分 ******************************************/
	@Autowired
	private UnifiedOrderProfitMapper         unifiedOrderProfitMapper;
	@Autowired
	private UnifiedOrderProfitMapperEx       unifiedOrderProfitMapperEx;
	@Autowired
	private UnifiedChannelProfitSyncMapper   unifiedChannelProfitSyncMapper;
	@Autowired
	private UnifiedChannelProfitSyncMapperEx unifiedChannelProfitSyncMapperEx;

	/****************************************** 分润部分 ******************************************/


	@Override
	public PageInfo<UnifiedOrder> findByPaging(Map<String, Object> params, Integer pageNo, Integer pageSize) {
		return null;
	}

	@Override
	public void deleteObj(Long id) {

	}

	@Override
	public void updateObj(UnifiedOrder scoreOrder) {

	}

	@Override
	public UnifiedOrder findById(Long id) {
		return null;
	}

	@Override
	public void addObj(UnifiedOrder scoreOrder) {

	}

	@Override
	public List<UnifiedOrder> findAll(Map<String, Object> queryMap) {
		return null;
	}

	@Override
	public R<List<ScoreOrderReconciliationNotYetVo>> getScoreOrderReconciliationNotYet(Map<String, Object> params,
	                                                                                   int pageNo,
	                                                                                   int pageSize, LoginSysUser loginSysUser) {

		PageHelper.startPage(pageNo, pageSize);

//		List<ScoreOrderReconciliationNotYetVo> scoreOrderReconciliationNotYetVoList = unifiedOrderMapperExScore.getScoreOrderReconciliationNotYet(params);
//		// 附加信息
//		additionalInfoGetScoreOrderReconciliationNotYet(scoreOrderReconciliationNotYetVoList);

		List<ScoreOrderReconciliationNotYetVo> scoreOrderReconciliationNotYetVoList = getScoreOrderReconciliationNotYet(params, loginSysUser);

		PageInfo<ScoreOrderReconciliationNotYetVo> page = new PageInfo<ScoreOrderReconciliationNotYetVo>(scoreOrderReconciliationNotYetVoList);
		PageHelper.clearPage();

		return new R<List<ScoreOrderReconciliationNotYetVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), scoreOrderReconciliationNotYetVoList);
	}

	@Override
	public List<ScoreOrderReconciliationNotYetVo> getScoreOrderReconciliationNotYet(Map<String, Object> params, LoginSysUser loginSysUser) {

		List<ScoreOrderReconciliationNotYetVo> scoreOrderReconciliationNotYetVoList = new ArrayList<>();

		scoreOrderReconciliationNotYetVoList = unifiedOrderMapperExScore.getScoreOrderReconciliationNotYet(params);

		// 附加信息
		additionalInfoGetScoreOrderReconciliationNotYet(scoreOrderReconciliationNotYetVoList);

		return scoreOrderReconciliationNotYetVoList;

	}

	/**
	 * 附加信息
	 *
	 * @param scoreOrderReconciliationNotYetVoList
	 */
	private void additionalInfoGetScoreOrderReconciliationNotYet(List<ScoreOrderReconciliationNotYetVo> scoreOrderReconciliationNotYetVoList) {

		if (AnCollectionUtils.isEmpty(scoreOrderReconciliationNotYetVoList)) {
			return;
		}

		// 修数据
		for (ScoreOrderReconciliationNotYetVo vo : scoreOrderReconciliationNotYetVoList) {
			// 对账单状态
			vo.setAccountingStateCustomerName(CommonAccountingStateEnum.getDesc(vo.getAccountingStateCustomer()));
			// 票类状态
			vo.setInvoiceApplyStatusName(UnifiedOrderCreditInvoiceApplyStatusEnum.getDesc(vo.getInvoiceApplyStatus()));
			vo.setInvoiceMakeStatusName(UnifiedOrderCreditInvoiceMakeStatusEnum.getDesc(vo.getInvoiceMakeStatus()));
			// 回款类状态
			vo.setBackStatusName(UnifiedOrderCreditBackStatusEnum.getDesc(vo.getBackStatus()));
		}


	}

	public ScoreOrderReconciliationNotYetHeadVo getScoreOrderReconciliationNotYetHeadSum(Map<String, Object> params) {
		return unifiedOrderMapperExScore.getScoreOrderReconciliationNotYetHeadSum(params);
	}


	/**
	 * 要重构这个方法
	 *
	 * @param unifiedOrderReturn
	 */
	private void processProfit(UnifiedOrderReturn unifiedOrderReturn) {

		// TODO mark by linjinyu 重构 分润 start =================================
		Map<String, Object> profitQuery = new HashMap<>();
		profitQuery.put("projectId", unifiedOrderReturn.getProjectId());
		List<UnifiedChannelProfitSync> channelProfitSyncs = unifiedChannelProfitSyncMapperEx.findAll(profitQuery);
		if (AnCollectionUtils.isNotEmpty(channelProfitSyncs)) {

			// 如果有分润的 更新分润表
			UnifiedChannelProfitSync channelProfitSync = channelProfitSyncs.get(0);

			UnifiedOrderProfit profit = new UnifiedOrderProfit();

			profit.setBusinessCode(channelProfitSync.getBusinessCode());
			profit.setChannelId(channelProfitSync.getChannelId());
			profit.setCreateTime(new Date());
			profit.setOrgId(channelProfitSync.getOrganizationId());

			profit.setProfitAmount(new BigDecimal(unifiedOrderReturn.getAmount().doubleValue() * channelProfitSync.getProportion().doubleValue() / 100).negate());
			profit.setProportion(channelProfitSync.getProportion());

			profit.setOrderSn(unifiedOrderReturn.getOrderSn());
			profit.setOrderSnReturn(unifiedOrderReturn.getReturnSn());

			UnifiedOrderProfit searchProfit = unifiedOrderProfitMapperEx.selectByReturnSn(unifiedOrderReturn.getReturnSn());

			if (searchProfit != null) {
				profit.setId(searchProfit.getId());
				unifiedOrderProfitMapper.updateByPrimaryKeySelective(profit);
			} else {
				unifiedOrderProfitMapper.insert(profit);
			}
		}
		// TODO mark by linjinyu 重构 分润  end  =================================
	}


}
