package cn.superdesk.uniorder.service.base.impl;

import cn.superdesk.uniorder.common.enums.common.CommonServiceEnum;
import cn.superdesk.uniorder.common.enums.order.UnifiedOrderCompletStateEnum;
import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.common.pagination.PageQueryParam;
import cn.superdesk.uniorder.common.rest.response.ResponseResultOuterUtils;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.param._function.select.SelectOptionDepartmentCriteria;
import cn.superdesk.uniorder.dto.param.accounting.unified.supplier.AccountingSupplierNotYetDimGoodsCriteria;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.proxyclient.ProxyClientOrderOptBecomeInvalidQueryCriteria;
import cn.superdesk.uniorder.dto.vo._function.select.SelectOptionDepartment;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.notyet.UnifiedOrderJoinGoodsOfSupplierStatementOfAccount;
import cn.superdesk.uniorder.service.base.*;
import cn.superdesk.uniorder.common.numerical.AnCollectionUtils;
import cn.superdesk.uniorder.common.enums.order.UnifiedOrderInvoiceStateEnum;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.enums.common.CommonAccountingStateEnum;
import cn.superdesk.uniorder.common.enums.order.UnifiedOrderBackStatusEnum;
import cn.superdesk.uniorder.dao.entity.accounting.unified.customer.AccountingUnifiedCustomerOrder;
import cn.superdesk.uniorder.dao.entity.accounting.unified.supplier.AccountingUnifiedSupplierXGoods;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrder;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderExample;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderGoods;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApplyXGoods;
import cn.superdesk.uniorder.dao.mapper.base.*;
import cn.superdesk.uniorder.dao.mapper.channel.UnifiedChannelProfitSyncMapper;
import cn.superdesk.uniorder.dao.mapper.channel.UnifiedChannelProfitSyncMapperEx;
import cn.superdesk.uniorder.dao.mapper.unified.UnifiedOrderProfitMapper;
import cn.superdesk.uniorder.dao.mapper.unified.UnifiedOrderProfitMapperEx;
import cn.superdesk.uniorder.dto.vo._function.select.SelectOptionVirt;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.CustomerUnAccountingDimGoodsVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.UnifiedOrderCustomerHeadSumVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.UnifiedOrderCustomerNotCheckVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.notyet.UnifiedOrderSupplierHeadSumVo;
import cn.superdesk.uniorder.dto.vo.order.Org2VirtStatisticsVo;
import cn.superdesk.uniorder.dto.vo.unified.*;
import cn.superdesk.uniorder.dto.vo.wechat.WxBillOrder;
import cn.superdesk.uniorder.event.CommonEventPublisher;
import cn.superdesk.uniorder.service.accounting.unified.customer.AccountingUnifiedCustomerOrderService;
import cn.superdesk.uniorder.service.accounting.unified.supplier.AccountingUnifiedSupplierXGoodsService;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyService;
import cn.superdesk.uniorder.service.organisation.SysEnterpriseService;
import cn.superdesk.uniorder.common.lamda.AnLamdaUtils;
import cn.superdesk.uniorder.common.numerical.AnIntegerUtils;
import cn.superdesk.uniorder.common.numerical.AnLongUtils;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * @Description: 订单
 * @Author: linjinyu
 * @CreateDate: 2020/10/27 下午4:28
 * @UpdateUser: linjinyu
 * @UpdateDate: 2020/10/27 下午4:28
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class UnifiedOrderServiceImpl implements UnifiedOrderService {


	@Autowired
	private UnifiedOrderMapper                   unifiedOrderMapper;
	@Autowired
	private UnifiedOrderMapperEx                 unifiedOrderMapperEx;
	@Autowired
	private UnifiedOrderMapperExCustomerDimOrder unifiedOrderMapperExCustomerDimOrder;
	@Autowired
	private UnifiedOrderMapperExCustomerDimGoods unifiedOrderMapperExCustomerDimGoods;
	@Autowired
	private UnifiedOrderMapperExSupplierDimOrder unifiedOrderMapperExSupplierDimOrder;
	@Autowired
	private UnifiedOrderMapperExSupplierDimGoods unifiedOrderMapperExSupplierDimGoods;

	@Autowired
	private AccountingUnifiedCustomerOrderService  accountingUnifiedCustomerOrderService;
	@Autowired
	private AccountingUnifiedSupplierXGoodsService accountingUnifiedSupplierXGoodsService;

	@Autowired
	private UnifiedOrderGoodsMapper   unifiedOrderGoodsMapper;
	@Autowired
	private UnifiedOrderGoodsMapperEx unifiedOrderGoodsMapperEx;
	@Autowired
	private UnifiedOrderGoodsService  unifiedOrderGoodsService;

	@Autowired
	private CommonOrderProcessService            commonOrderProcessService;
	@Autowired
	private CommonMergeOrderGoodsProcessService  commonOrderGoodsMergeProcessService;
	@Autowired
	private CommonMergeOrderCreditProcessService commonOrderCreditMergeProcessService;


	/****************************************** 退单部分 ******************************************/
	@Autowired
	private UnifiedOrderReturnMapper        unifiedOrderReturnMapper;
	@Autowired
	private UnifiedOrderReturnMapperEx      unifiedOrderReturnMapperEx;
	@Autowired
	private UnifiedOrderReturnGoodsMapper   unifiedOrderReturnGoodsMapper;
	@Autowired
	private UnifiedOrderReturnGoodsMapperEx unifiedOrderReturnGoodsMapperEx;
	/****************************************** 退单部分 ******************************************/


	/****************************************** 楼闪送专用 目前是这样 20200706 ******************************************/
	@Autowired
	private UnifiedOrderUpdateMapper   unifiedOrderUpdateMapper;
	@Autowired
	private UnifiedOrderUpdateMapperEx unifiedOrderUpdateMapperEx;
	/****************************************** 楼闪送专用 目前是这样 20200706 ******************************************/


	/****************************************** 分润部分 ******************************************/
	@Autowired
	private UnifiedOrderProfitMapper         unifiedOrderProfitMapper;
	@Autowired
	private UnifiedOrderProfitMapperEx       unifiedOrderProfitMapperEx;
	@Autowired
	private UnifiedChannelProfitSyncMapper   unifiedChannelProfitSyncMapper;
	@Autowired
	private UnifiedChannelProfitSyncMapperEx unifiedChannelProfitSyncMapperEx;
	/****************************************** 分润部分 ******************************************/

	/****************************************** 开票申请 发票 start ******************************************/
	@Autowired
	private InvoiceApplyService  invoiceApplyService;
	/****************************************** 开票申请 发票 start ******************************************/


	@Autowired
	private SysEnterpriseService sysEnterpriseService;


	@Autowired
	private CommonEventPublisher commonEventPublisher;

	@Override
	public PageInfo<UnifiedOrder> findByPaging(Map<String, Object> params, Integer pageNo, Integer pageSize) {

		return null;
	}

	@Override
	public void deleteObj(Long id) {


	}

	@Override
	public void updateObj(UnifiedOrder t) {

		unifiedOrderMapper.updateByPrimaryKeySelective(t);
	}

	@Override
	public UnifiedOrder findById(Long id) {

		return unifiedOrderMapper.selectByPrimaryKey(id);
	}

	@Override
	public void addObj(UnifiedOrder t) {


	}

	@Override
	public List<UnifiedOrder> findAll(Map<String, Object> queryMap) {

		return unifiedOrderMapperEx.findAll(queryMap);
	}

	@Override
	public List<SelectOptionDepartment> getSelectPurchaseDepartment(SelectOptionDepartmentCriteria criteria, LoginSysUser loginSysUser) {
		return unifiedOrderMapperEx.getSelectPurchaseDepartment(criteria);
	}

	@Override
	public R<List<UnifiedOrder>> patchFlashDeliverPatchUnifiedOrderFieldOutVirt(PageQueryParam pageQueryParam) {

		Integer pageNumber = pageQueryParam.getPageNo();
		Integer pageSize   = pageQueryParam.getPageSize();

		PageHelper.startPage(pageNumber, pageSize);

		UnifiedOrderExample example = new UnifiedOrderExample();
		example.createCriteria()
				.andServiceNoEqualTo(CommonServiceEnum.LNSS.getServiceNo())
				.andPurchaseVirtIdIsNull()/* 采购人企业Id IsNull */;
		List<UnifiedOrder>     resultList = unifiedOrderMapper.selectByExample(example);
		PageInfo<UnifiedOrder> pageInfo   = new PageInfo<UnifiedOrder>(resultList);

		PageHelper.clearPage();

		return new R<List<UnifiedOrder>>(pageInfo.getPageNum(), pageInfo.getPageSize(), (int) pageInfo.getTotal(), resultList);

	}

	@Override
	public Integer countAll(Map<String, Object> queryMap) {
		return unifiedOrderMapperEx.countAll(queryMap);
	}

	/**
	 * 新增 统一订单 好像只有楼闪送在用
	 *
	 * @param unifiedOrder
	 * @param unifiedOrderGoodsList
	 * @return
	 */
	@Transactional
	@Override
	public UnifiedOrder addObjTran(UnifiedOrder unifiedOrder, List<UnifiedOrderGoods> unifiedOrderGoodsList) {

		unifiedOrderMapper.insert(unifiedOrder);

		for (UnifiedOrderGoods unifiedOrderGoods : unifiedOrderGoodsList) {
			unifiedOrderGoodsMapper.insert(unifiedOrderGoods);
		}


		// TODO mark by linjinyu 重构 分润 start =================================

		commonEventPublisher.triggerUnifiedOrderProfitCalculationEvent(unifiedOrder);

		// 1209 -- 计算分润
//		Map<String, Object> profitQuery = new HashMap<>();
//
//		profitQuery.put("projectId", unifiedOrder.getProjectId());
//		profitQuery.put("serviceNo", unifiedOrder.getServiceNo());
//
//		List<UnifiedChannelProfitSync> channelProfitSyncs = unifiedChannelProfitSyncMapperEx.findAll(profitQuery);
//
//		if (channelProfitSyncs != null && channelProfitSyncs.size() > 0) {
//
//			// 插入分润表
//			UnifiedChannelProfitSync channelProfitSync = channelProfitSyncs.get(0);
//
//			UnifiedOrderProfit profit = new UnifiedOrderProfit();
//
//			profit.setBusinessCode(channelProfitSync.getBusinessCode());
//			profit.setChannelId(channelProfitSync.getChannelId());
//			profit.setCreateTime(new Date());
//			profit.setOrgId(channelProfitSync.getOrganizationId());
//
//			profit.setProfitAmount(new BigDecimal(unifiedOrder.getAmount().doubleValue() * channelProfitSync.getProportion().doubleValue() / 100));
//			profit.setProportion(channelProfitSync.getProportion());
//
//			profit.setOrderSn(unifiedOrder.getSn());
//
//			UnifiedOrderProfit unifiedOrderProfit = unifiedOrderProfitMapper.selectBySn(unifiedOrder.getSn());
//
//			if (unifiedOrderProfit != null) {
//				profit.setId(unifiedOrderProfit.getId());
//				unifiedOrderProfitMapper.updateByPrimaryKeySelective(profit);
//			} else {
//				unifiedOrderProfitMapper.insert(profit);
//			}
//		}

		// TODO mark by linjinyu 重构 分润  end  =================================


		return unifiedOrder;
	}

	@Override
	public UnifiedOrder findByOrderSn(String orderSn) {

		return unifiedOrderMapperEx.findByOrderSn(orderSn);
	}

	@Override
	public UnifiedOrder findByJdOrderSn(String jdOrderSn) {
		return unifiedOrderMapperEx.findByJdOrderSn(jdOrderSn);
	}


	/****************************************** 供应商结算 dim order 未对账 订单 start ******************************************/
	@Override
	public UnifiedOrderSupplierHeadSumVo getSupplierUnAccountingDimOrderHeadSum(Map<String, Object> params) {

		return unifiedOrderMapperExSupplierDimOrder.getSupplierUnAccountingDimOrderHeadSum(params);
	}

	@Override
	public List<UnifiedOrderSupplierDimOrderNotCheckVo> getSupplierUnAccountingDimOrderList(Map<String, Object> params) {

		return unifiedOrderMapperExSupplierDimOrder.getSupplierUnAccountingDimOrderList(params);
	}

	@Override
	public R<List<UnifiedOrderSupplierDimOrderNotCheckVo>> getSupplierUnAccountingDimOrderList(Map<String, Object> params, int pageNo, int pageSize) {

		PageHelper.startPage(pageNo, pageSize);

		List<UnifiedOrderSupplierDimOrderNotCheckVo> ls = unifiedOrderMapperExSupplierDimOrder.getSupplierUnAccountingDimOrderList(params);

		PageInfo<UnifiedOrderSupplierDimOrderNotCheckVo> page = new PageInfo<UnifiedOrderSupplierDimOrderNotCheckVo>(ls);

		PageHelper.clearPage();

		return new R<List<UnifiedOrderSupplierDimOrderNotCheckVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), ls);

	}

	@Override
	public List<UnifiedOrderSupplierNotCheckDetail2GoodsVo> getSupplierUnAccountingDetail2Goods(Map<String, Object> params) {

		log.info("\n\n\n\ngetSupplierUnAccountDataGoods params \n{}\n\n\n\n", JsonUtils.toJson(params));

		return unifiedOrderMapperExSupplierDimOrder.getSupplierUnAccountingDetail2Goods(params);
	}
	/****************************************** 供应商结算 dim order 未对账 订单   end ******************************************/


	/****************************************** 供应商结算 dim goods 未对账 商品 start ******************************************/
	@Override
	public UnifiedOrderSupplierHeadSumVo getSupplierUnAccountingDimGoodsHeadSum(AccountingSupplierNotYetDimGoodsCriteria criteria) {

		return unifiedOrderMapperExSupplierDimGoods.getSupplierUnAccountingDimGoodsHeadSum(criteria);
	}

	@Override
	public List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierUnAccountingDimGoodsList(AccountingSupplierNotYetDimGoodsCriteria criteria) {

		return unifiedOrderMapperExSupplierDimGoods.getSupplierUnAccountingDimGoodsList(criteria);
	}

	@Override
	public R<List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount>> getSupplierUnAccountingDimGoodsListByPageQuery(AccountingSupplierNotYetDimGoodsCriteria criteria) {

		PageHelper.startPage(criteria.getPageNumber(), criteria.getPageSize());

		List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> result = unifiedOrderMapperExSupplierDimGoods.getSupplierUnAccountingDimGoodsList(criteria);

		PageInfo<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> page = new PageInfo<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount>(result);

		PageHelper.clearPage();

		return new R<List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), result);

	}
	/****************************************** 供应商结算 dim goods 未对账 商品   end ******************************************/

	/****************************************** 供应商结算 对账单详情 start ******************************************/

	@Override
	public List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierStatementOfAccountDetailDimOrder2Goods(Map<String, Object> params) {

		return unifiedOrderGoodsMapperEx.getSupplierStatementOfAccountDetailDimOrder2Goods(params);
	}

	@Override
	public List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierStatementOfAccountDetailDimGoods2Goods(String accountingOrderSn) {

		log.info("供应商结算 对账单详情 getSupplierStatementOfAccountDetailDimGoods2Goods {}", accountingOrderSn);

		List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> result = new ArrayList<>();

		if (StringUtils.isBlank(accountingOrderSn)) {
			return result;
		}

		List<AccountingUnifiedSupplierXGoods> statementOfAccountXGoods = accountingUnifiedSupplierXGoodsService.findByAccountingOrderSn(accountingOrderSn);

		List<Long> processSysUnifiedOrderGoodsIds = new ArrayList<>();

		processSysUnifiedOrderGoodsIds = statementOfAccountXGoods.stream()
				.filter(AnLamdaUtils.distinctByKey(o -> o.getUnifiedOrderGoodsId()))
				.map(AccountingUnifiedSupplierXGoods::getUnifiedOrderGoodsId)
				.collect(Collectors.toList());

		if (AnCollectionUtils.isNotEmpty(processSysUnifiedOrderGoodsIds)) {
//			Map<String, Object> searchParams = new HashMap<>();
//			searchParams.put("unifiedOrderGoodsIds", processSysUnifiedOrderGoodsIds);

			AccountingSupplierNotYetDimGoodsCriteria criteria = new AccountingSupplierNotYetDimGoodsCriteria();
			criteria.setUnifiedOrderGoodsIds(processSysUnifiedOrderGoodsIds);
			result = getSupplierUnAccountingDimGoodsList(criteria);
		}

		return result;

	}
	/****************************************** 供应商结算 对账单详情   end ******************************************/


	/****************************************** 关于 供应商结算 对账单 设置 对账状态 或 恢复 对账状态 start ******************************************/
	@Override
	public void updateAccountingStateSupplierBySysUnifiedOrderIds(List<Long> sysUnifiedOrderIds, CommonAccountingStateEnum state) {

//        弃用 20201029
//        Map<String, Object> forUpdateOrderAccountingStateparams = new HashMap<>();
//        forUpdateOrderAccountingStateparams.put("ids", sysUnifiedOrderIds);// ids.split(",")
//        // 更新 订单 对账状态 update unified_order set accounting_state_supplier = 1 UnifiedOrderAccountingState.已对账.getKey() where id in (ids)
//        // 已对账(1, "已对账"),
//        // 未对账(2, "未对账"),
//        // 已作废(3, "已作废"),// 20200713 添加 by linjinyu 原因 老是说要作废什么订单
//        unifiedOrderMapperExSupplierDimOrder.updateAccountingStateSupplier(forUpdateOrderAccountingStateparams);

		if (AnCollectionUtils.isEmpty(sysUnifiedOrderIds)) {
			log.error("updateAccountingStateSupplierBySysUnifiedOrderIds sysUnifiedOrderIds isEmpty = true");
			return;
		}

		UnifiedOrderExample forUpdateAccountingStateOrderExample = new UnifiedOrderExample();
		forUpdateAccountingStateOrderExample.createCriteria()
				.andIdIn(sysUnifiedOrderIds);

		UnifiedOrder forUpdateAccountingStateOrderEntity = new UnifiedOrder();
		forUpdateAccountingStateOrderEntity.setAccountingStateSupplier(state.getKey());

		unifiedOrderMapper.updateByExampleSelective(forUpdateAccountingStateOrderEntity, forUpdateAccountingStateOrderExample);
	}

	@Override
	public void updateAccountingStateSupplierByOrderSns(List<String> orderSns, CommonAccountingStateEnum state) {
		if (AnCollectionUtils.isEmpty(orderSns)) {
			log.error("updateAccountingStateSupplierBySysUnifiedOrderIds sysUnifiedOrderIds isEmpty = true");
			return;
		}

		UnifiedOrderExample forUpdateAccountingStateOrderExample = new UnifiedOrderExample();
		forUpdateAccountingStateOrderExample.createCriteria()
				.andOrderSnIn(orderSns);

		UnifiedOrder forUpdateAccountingStateOrderEntity = new UnifiedOrder();
		forUpdateAccountingStateOrderEntity.setAccountingStateSupplier(state.getKey());

		unifiedOrderMapper.updateByExampleSelective(forUpdateAccountingStateOrderEntity, forUpdateAccountingStateOrderExample);
	}

	/****************************************** 关于 供应商结算 对账单 设置 对账状态 或 恢复 对账状态   end ******************************************/


	/****************************************** 关于 客户结算 对账单 设置 对账状态 或 恢复 对账状态 start ******************************************/
	/**
	 * 更新 字段 对账状态 By List<Long> sysUnifiedOrderIds
	 * 不对账(-1, "不对账"),
	 * 已对账(1, "已对账"),
	 * 未对账(2, "未对账"),
	 * 已作废(3, "已作废"),
	 *
	 * @param sysUnifiedOrderIds
	 * @param state
	 */
	@Override
	public void updateAccountingStateCustomerBySysUnifiedOrderIds(List<Long> sysUnifiedOrderIds, CommonAccountingStateEnum state) {


		if (AnCollectionUtils.isEmpty(sysUnifiedOrderIds)) {
			log.error("updateAccountingStateCustomerBySysUnifiedOrderIds sysUnifiedOrderIds isEmpty = true");
			return;
		}

		UnifiedOrderExample forUpdateAccountingStateOrderExample = new UnifiedOrderExample();
		forUpdateAccountingStateOrderExample.createCriteria()
				.andIdIn(sysUnifiedOrderIds);

		UnifiedOrder forUpdateAccountingStateOrderEntity = new UnifiedOrder();
		forUpdateAccountingStateOrderEntity.setAccountingStateCustomer(state.getKey());

		unifiedOrderMapper.updateByExampleSelective(forUpdateAccountingStateOrderEntity, forUpdateAccountingStateOrderExample);
	}

	/**
	 * 更新 字段 对账状态 By List<String> orderSns
	 * 不对账(-1, "不对账"),
	 * 已对账(1, "已对账"),
	 * 未对账(2, "未对账"),
	 * 已作废(3, "已作废"),
	 *
	 * @param orderSns
	 * @param state
	 */
	@Override
	public void updateAccountingStateCustomerByOrderSns(List<String> orderSns, CommonAccountingStateEnum state) {

		if (AnCollectionUtils.isEmpty(orderSns)) {
			log.error("updateAccountingStateSupplierBySysUnifiedOrderIds sysUnifiedOrderIds isEmpty = true");
			return;
		}

		UnifiedOrderExample forUpdateAccountingStateOrderExample = new UnifiedOrderExample();
		forUpdateAccountingStateOrderExample.createCriteria()
				.andOrderSnIn(orderSns);

		UnifiedOrder forUpdateAccountingStateOrderEntity = new UnifiedOrder();
		forUpdateAccountingStateOrderEntity.setAccountingStateCustomer(state.getKey());

		unifiedOrderMapper.updateByExampleSelective(forUpdateAccountingStateOrderEntity, forUpdateAccountingStateOrderExample);
	}

	/****************************************** 关于 客户结算 对账单 设置 对账状态 或 恢复 对账状态   end ******************************************/

	/****************************************** 订单 状态 回款状态 start ******************************************/
	@Override
	public void updateFieldBackAccountStatusByInvoiceX(List<InvoiceApplyXGoods> invoiceX) {

		// 需证明
		// accounting_order_type=1 dim_create_by=0 代表 accounting_unified_customer_order.id (accounting_unified_customer_order_goods.id|unified_order_goods.id)
		// 不必证明
		// accounting_order_type=1 dim_create_by=1 代表 unified_order.id unified_order_goods.id
		// accounting_order_type=2 dim_create_by=2 代表 unified_order.id unified_order_goods.id

		// 先要得出到底是什么情况(上边的情况之一),如果存大多种情况，这个就不能处理了
		Map<String, List<InvoiceApplyXGoods>> transferMapGroupByAccountingOrderTypeAndDimCreateBy = invoiceX.parallelStream()
				.collect(Collectors.groupingBy(e -> fetchGroupKeyByAccountingOrderTypeAndDimCreateBy(e), Collectors.toList()));

		Integer typeCount = transferMapGroupByAccountingOrderTypeAndDimCreateBy.size();

		if (typeCount.compareTo(1) > 0) {
			log.error("updateFieldBackAccountStatusByInvoiceX 先要得出到底是什么情况(上边的情况之一),如果存大多种情况，这个就不能处理了");
			return;
		}

		/****************************************** 得出类型 start ******************************************/

		String[] c = new String[0];
		String   type;
		transferMapGroupByAccountingOrderTypeAndDimCreateBy.keySet().toArray(c);
		type = c[0];

		/****************************************** 得出回款状态 start ******************************************/
		Map<Long, List<InvoiceApplyXGoods>> transferMapGroupByUnknowOrderId = invoiceX.parallelStream()
				.collect(Collectors.groupingBy(e -> fetchGroupKeyByUnknowOrderId(e), Collectors.toList()));

		// 每份订单的数据 Key unKnowOrderId -> List<InvoiceOrder>
		for (Map.Entry<Long, List<InvoiceApplyXGoods>> _entry : transferMapGroupByUnknowOrderId.entrySet()) {

			log.info("正在处理的类型为 : {}", type);

			Long unifiedOrderId = 0L;
			switch (type) {
				case "1_0":

					// 转换 accounting_unified_customer_order.id -> unifiedOrderId
					AccountingUnifiedCustomerOrder accountingUnifiedCustomerOrder = accountingUnifiedCustomerOrderService.findAccountingUnifiedCustomerOrderById(_entry.getKey());
					unifiedOrderId = accountingUnifiedCustomerOrder.getOrderId();
					break;
				case "1_1":
					unifiedOrderId = _entry.getKey();
					break;
				case "2_2":
					unifiedOrderId = _entry.getKey();
					break;
				default:
					break;
			}
			Integer _invoiceXCount                = _entry.getValue().size();
			Integer _invoiceXBackAccountStatusEq1 = AnIntegerUtils.getInteger(_entry.getValue().stream().filter(o -> null != o.getBackStatus() && o.getBackStatus().equals(1)).count());


			int ret = updateFieldBackAccountStatusByCheckRatio(_invoiceXCount, _invoiceXBackAccountStatusEq1, unifiedOrderId);

		}


	}

	/**
	 * 更新 字段 是否回款的问题 判定
	 *
	 * @param fullCount
	 * @param seizeCount
	 * @param unifiedOrderId
	 * @return
	 */
	public int updateFieldBackAccountStatusByCheckRatio(Integer fullCount, Integer seizeCount, Long unifiedOrderId) {

		// return 为 ret 标记 不是计算数量
		if (fullCount.compareTo(0) <= 0) {
			return 0;
		}

		if (seizeCount.compareTo(0) <= 0) {
			return 0;
		}

		UnifiedOrderBackStatusEnum unifiedOrderBackStatusEnum;
		if (fullCount.compareTo(seizeCount) == 0) {
			unifiedOrderBackStatusEnum = UnifiedOrderBackStatusEnum.全部回款;
		} else {
			unifiedOrderBackStatusEnum = UnifiedOrderBackStatusEnum.部分回款;
		}

		return updateFieldBackAccountStatusByUnifiedOrderId(unifiedOrderId, unifiedOrderBackStatusEnum);

	}

	/**
	 * 更新 字段 是否回款的问题
	 *
	 * @param unifiedOrderId
	 * @param unifiedOrderBackStatusEnum
	 * @return
	 */
	public int updateFieldBackAccountStatusByUnifiedOrderId(Long unifiedOrderId, UnifiedOrderBackStatusEnum unifiedOrderBackStatusEnum) {
		UnifiedOrder unifiedOrder = new UnifiedOrder();
		unifiedOrder.setId(unifiedOrderId);
		unifiedOrder.setBackAccountStatus(unifiedOrderBackStatusEnum.getKey());

		return unifiedOrderMapper.updateByPrimaryKeySelective(unifiedOrder);
	}

	/**
	 * 代客下单的接口实现
	 * 作废订单
	 *
	 * @param queryCriteria
	 * @return
	 */
	public R<String> proxyClientOrderOptBecomeInvalid(ProxyClientOrderOptBecomeInvalidQueryCriteria queryCriteria) {

//		①该订单在统一订单中存在&其所有的订单商品当前对账状态均为“未对账/不对账”，允许作废该订单；
//		②若该订单在统一订单中不存在，不允许作废，返回错误内容“该订单在统一订单中心不存在”；
//		③若该订单中部分商品当前对账状态为“已对账”，不允许作废，返回错误内容“该订单已对账，不允许作废”；
//		满足作废订单条件后，即允许作废该订单，该订单完成状态为“已作废”；

		UnifiedOrder processUnifiedOrder = findByOrderSn(queryCriteria.getOrderSn());

		if (null == processUnifiedOrder) {
			return ResponseResultOuterUtils.createErrorResult("500", "该订单在统一订单中心不存在");
		}

		List<UnifiedOrderGoods> processUnifiedOrderGoodsList = unifiedOrderGoodsService.findByOrderSn(queryCriteria.getOrderSn());

		Long isAccountingStateCustomer = processUnifiedOrderGoodsList.stream().filter(o -> null != o.getAccountingStateCustomer() && o.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.已对账.getKey()) == 0).count();
		Long isAccountingStateSupplier = processUnifiedOrderGoodsList.stream().filter(o -> null != o.getAccountingStateCustomer() && o.getAccountingStateSupplier().compareTo(CommonAccountingStateEnum.已对账.getKey()) == 0).count();

		if (isAccountingStateCustomer.compareTo(0L) > 0 || isAccountingStateSupplier.compareTo(0L) > 0) {
			return ResponseResultOuterUtils.createErrorResult("500", "该订单已对账，不允许作废 |" + isAccountingStateCustomer + "|" + isAccountingStateSupplier);
		}

		UnifiedOrder beUpdateUnifiedOrder = new UnifiedOrder();
		beUpdateUnifiedOrder.setId(processUnifiedOrder.getId());
		beUpdateUnifiedOrder.setCompletState(UnifiedOrderCompletStateEnum.已取消.getKey());

		unifiedOrderMapper.updateByPrimaryKeySelective(beUpdateUnifiedOrder);

		return ResponseResultOuterUtils.createSuccesResult();


	}

	/**
	 * 私有方法 用于分组
	 *
	 * @param invoiceOrder
	 * @return
	 */
	private String fetchGroupKeyByAccountingOrderTypeAndDimCreateBy(InvoiceApplyXGoods invoiceOrder) {
		return invoiceOrder.getAccountingOrderType() + "_" + invoiceOrder.getDimCreateBy();
	}

	/**
	 * 私有方法 用于分组
	 *
	 * @param invoiceOrder
	 * @return
	 */
	private Long fetchGroupKeyByUnknowOrderId(InvoiceApplyXGoods invoiceOrder) {
		return invoiceOrder.getAccountingOrderId();
	}
	/****************************************** 订单 状态 回款状态   end ******************************************/


	/****************************************** 客户结算 dim order 未对账 订单 start ******************************************/
	@Override
	public UnifiedOrderCommonHeadSum getCustomerUnAccountingDimOrderHeadSum(Map<String, Object> params) {

		return unifiedOrderMapperExCustomerDimOrder.getCustomerUnAccountingDimOrderHeadSum(params);
	}

	@Override
	public List<UnifiedOrderCustomerNotCheckVo> getCustomerUnAccountingDimOrderList(Map<String, Object> params) {
		return unifiedOrderMapperExCustomerDimOrder.getCustomerUnAccountingDimOrderList(params);
	}

	@Override
	public R<List<UnifiedOrderCustomerNotCheckVo>> getCustomerUnAccountingDimOrderList(Map<String, Object> params, int pageNo, int pageSize) {

		log.info("getCustomerUnAccountingDimOrderList : {}", JsonUtils.toJson(params));

		PageHelper.startPage(pageNo, pageSize);
		List<UnifiedOrderCustomerNotCheckVo>     result = unifiedOrderMapperExCustomerDimOrder.getCustomerUnAccountingDimOrderList(params);
		PageInfo<UnifiedOrderCustomerNotCheckVo> page   = new PageInfo<UnifiedOrderCustomerNotCheckVo>(result);
		PageHelper.clearPage();

		return new R<List<UnifiedOrderCustomerNotCheckVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), result);
	}
	/****************************************** 客户结算 dim order 未对账 订单   end ******************************************/

	/****************************************** 客户结算 dim goods 未对账 商品 start ******************************************/
	@Override
	public UnifiedOrderCustomerHeadSumVo getCustomerUnAccountingDimGoodsHeadSum(Map<String, Object> params, LoginSysUser loginSysUser) {
		return unifiedOrderMapperExCustomerDimGoods.getCustomerUnAccountingDimGoodsHeadSum(params);
	}

	@Override
	public List<CustomerUnAccountingDimGoodsVo> getCustomerUnAccountingDimGoodsList(Map<String, Object> params, LoginSysUser loginSysUser) {
		return unifiedOrderMapperExCustomerDimGoods.getCustomerUnAccountingDimGoodsList(params);
	}

	@Override
	public R<List<CustomerUnAccountingDimGoodsVo>> getCustomerUnAccountingDimGoodsList(Map<String, Object> params, int pageNo, int pageSize, LoginSysUser loginSysUser) {

		log.info("传入参数 {}", JsonUtils.toJson(params));

		PageHelper.startPage(pageNo, pageSize);
		List<CustomerUnAccountingDimGoodsVo>     result = unifiedOrderMapperExCustomerDimGoods.getCustomerUnAccountingDimGoodsList(params);
		PageInfo<CustomerUnAccountingDimGoodsVo> page   = new PageInfo<CustomerUnAccountingDimGoodsVo>(result);
		PageHelper.clearPage();

		return new R<List<CustomerUnAccountingDimGoodsVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), result);
	}
	/****************************************** 客户结算 dim goods 未对账 商品   end ******************************************/


	/****************************************** 订单管理 start ******************************************/
	@Override
	public UnifiedOrderCommonHeadSum getOrderManagerGoodsPageHead(Map<String, Object> params) {

		return unifiedOrderMapperEx.getOrderManagerGoodsPageHead(params);
	}

	@Override
	public R<List<ViewUnifiedOrderGoods>> getOrderManagerGoodsByPage(Map<String, Object> params, int pageNo, int pageSize) {

		PageHelper.startPage(pageNo, pageSize);
		List<ViewUnifiedOrderGoods>     result = unifiedOrderMapperEx.getOrderManagerGoodsView(params);
		PageInfo<ViewUnifiedOrderGoods> page   = new PageInfo<ViewUnifiedOrderGoods>(result);
		PageHelper.clearPage();

		return new R<List<ViewUnifiedOrderGoods>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), result);
	}

	/**
	 * Excel导出 取数据
	 * 1. 导出报表
	 * 2. 导出成本
	 *
	 * @param params
	 * @return
	 */
	@Override
	public List<ViewUnifiedOrderGoods> getOrderManagerGoodsView(Map<String, Object> params) {

		/****************************************** 数据加工 本来在controller层 mark by linjinyu at 20210305 重构 start ******************************************/

		List<ViewUnifiedOrderGoods> result = unifiedOrderMapperEx.getOrderManagerGoodsView(params);

		// 附加程序 mark by linjinyu at 20210305 重构
		getOrderManagerGoodsViewAdditional(result);

		/****************************************** 数据加工 本来在controller层 mark by linjinyu at 20210305 重构 start ******************************************/

		return result;
	}


	/**
	 * OrderManagerGoodsView 附加程序 mark by linjinyu at 20210305 重构
	 *
	 * @param dataList
	 */
	private void getOrderManagerGoodsViewAdditional(List<ViewUnifiedOrderGoods> dataList) {

		// 得出 order_sn 集合
		List<String> orderSnList = dataList.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getOrderSn())).map(ViewUnifiedOrderGoods::getOrderSn).collect(Collectors.toList());
		log.info("得出 orderSn 为 \n {}", JsonUtils.toJson(orderSnList));
		Map<String, InvoiceApply> orderSn2InvoiceApplyMap = invoiceApplyService.findInvoiceByOrderSnList(orderSnList);
		log.info("查出 applies 为  \n {}", JsonUtils.toJson(orderSn2InvoiceApplyMap));


		for (ViewUnifiedOrderGoods viewUnifiedOrderGoods : dataList) {

			// 商品别名 mark by linjinyu at 20210520
			if (StringUtils.isNotBlank(viewUnifiedOrderGoods.getGoodsAlias())) {
				viewUnifiedOrderGoods.setGoodsName(viewUnifiedOrderGoods.getGoodsName() + "(" + viewUnifiedOrderGoods.getGoodsAlias() + ")");
			}

			viewUnifiedOrderGoods.setGoodsAmount(new BigDecimal(viewUnifiedOrderGoods.getPrice().doubleValue() * viewUnifiedOrderGoods.getQuantity()));
			viewUnifiedOrderGoods.setGoodsCostAmount(new BigDecimal(viewUnifiedOrderGoods.getCostPrice().doubleValue() * viewUnifiedOrderGoods.getQuantity()));

			// 付款状态 TODO 统一订单不转换 直接 显示第三方过来的
//			viewUnifiedOrderGoods.setPayStateName(UnifiedOrderMixPayAboutName.getPayStateName(viewUnifiedOrderGoods.getServiceNo(), viewUnifiedOrderGoods.getPayState()));

			// 支付方式 TODO 统一订单不转换 直接 显示第三方过来的
//			viewUnifiedOrderGoods.setPayTypeName(UnifiedOrderMixPayAboutName.getPayTypeName(viewUnifiedOrderGoods.getServiceNo(), viewUnifiedOrderGoods.getPayType()));

			// 订单状态  TODO 统一订单不转换 直接 显示第三方过来的
//			viewUnifiedOrderGoods.setOrderStateName();

			// 开票申请 发票状态
			viewUnifiedOrderGoods.setInvStateName(UnifiedOrderInvoiceStateEnum.getDesc(viewUnifiedOrderGoods.getInvState()));

			// 开票申请
			if (null != orderSn2InvoiceApplyMap.get(viewUnifiedOrderGoods.getOrderSn())) {

				InvoiceApply temp = orderSn2InvoiceApplyMap.get(viewUnifiedOrderGoods.getOrderSn());

				log.info("订单号 : {} 查到了发票信息", JsonUtils.toJson(temp));

				viewUnifiedOrderGoods.setInvNumber(temp.getInvoiceNumber());
				viewUnifiedOrderGoods.setInvSn(temp.getInvoiceNo());
				viewUnifiedOrderGoods.setInvApplyTime(temp.getApplyTime());
				viewUnifiedOrderGoods.setInvMakeInvoiceTime(temp.getMakeInvoiceTime());

				viewUnifiedOrderGoods.setInvStateName(UnifiedOrderInvoiceStateEnum.getDesc(temp.getInvoiceStatus()));
			} else {
				log.info("订单号 : {} 没查到发票信息?", viewUnifiedOrderGoods.getOrderSn());
			}
		}
	}

	@Override
	public R<List<Org2VirtStatisticsVo>> getOrg2VirtStatistics(Map<String, Object> params, int pageNum, int pageSize) {


		List<Org2VirtStatisticsVo> result = new ArrayList<>();

		Long orgId  = AnLongUtils.getLong(params.get("projectId"));
		Long virtId = AnLongUtils.getLong(params.get("purchaseVirtId"));

		Integer mode = AnIntegerUtils.getInteger(params.get("mode"));

		List<Long> virtIds = new ArrayList<>();

		// 项目
		if (null != mode && mode.equals(1)) {

			PageHelper.startPage(pageNum, pageSize);

			// 清理 orgId virtId
			params.put("projectId", orgId);
			params.put("purchaseVirtId", null);

			result = unifiedOrderMapperEx.getOrg2VirtStatistics(params);

			PageInfo<Org2VirtStatisticsVo> page = new PageInfo<Org2VirtStatisticsVo>(result);
			PageHelper.clearPage();

			return new R<List<Org2VirtStatisticsVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), result);
		}
		// 企业
		else if (null != mode && mode.equals(2)) {

			PageHelper.startPage(pageNum, pageSize);

			// 清理 orgId virtId
			params.put("projectId", orgId);
			params.put("purchaseVirtId", virtId);

			result = unifiedOrderMapperEx.getOrg2VirtStatistics(params);

			PageInfo<Org2VirtStatisticsVo> page = new PageInfo<Org2VirtStatisticsVo>(result);
			PageHelper.clearPage();

			return new R<List<Org2VirtStatisticsVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), result);
		}
		// 指定 项目
		else if (null != orgId) {

			List<SelectOptionVirt> orgList = sysEnterpriseService.getVirtSelectByOutOrgId(orgId);

			PageHelper.startPage(pageNum, pageSize);
			if (AnCollectionUtils.isNotEmpty(orgList)) {

				virtIds = orgList.stream().filter(o -> o.getVirtId() != null).filter(AnLamdaUtils.distinctByKey(o -> o.getVirtId())).map(SelectOptionVirt::getVirtId).collect(Collectors.toList());

				log.info("outVirtIds # {} #", JsonUtils.toJson(virtIds.toArray()));
				params.put("outVirtIds", virtIds.toArray());
				result = unifiedOrderMapperEx.getOrg2VirtStatistics(params);
			}

			PageInfo<Org2VirtStatisticsVo> page = new PageInfo<Org2VirtStatisticsVo>(result);
			PageHelper.clearPage();

			return new R<List<Org2VirtStatisticsVo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), result);
		}
		// 指定 企业
		else if (null != virtId) {

			virtIds.add(virtId);
			log.info("outVirtIds", JsonUtils.toJson(virtIds.toArray()));
			params.put("outVirtIds", virtIds.toArray());
			result = unifiedOrderMapperEx.getOrg2VirtStatistics(params);

			return new R<List<Org2VirtStatisticsVo>>(1, 1, 1, result);

		}

		//
		else {
			return new R<List<Org2VirtStatisticsVo>>(0, 0, 0, result);
		}

	}

	/****************************************** 订单管理   end ******************************************/

	@Override
	public BigDecimal getPayAmount(Map<String, Object> upaymap) {

		return unifiedOrderMapperEx.getPayAmount(upaymap);
	}

	@Override
	public BigDecimal getAmount(Map<String, Object> query) {

		return unifiedOrderMapperEx.getAmount(query);
	}

	@Override
	public List<WxBillOrder> getVirtOrder(Map<String, Object> params) {
		return unifiedOrderMapperEx.getVirtOrder(params);
	}

	@Override
	public List<UnifiedOrder> findByDzId(Map<String, Object> params) {
		return unifiedOrderMapperEx.findAll(params);
	}

	@Override
	public Integer getOrderCount(Map<String, Object> queryMap) {
		return unifiedOrderMapperEx.getOrderCount(queryMap);
	}


	/**
	 * 统一订单's unified_order.id s
	 *
	 * @param sysUnifiedOrderIds
	 * @return
	 */
	@Override
	public List<UnifiedOrder> findBySysUnifiedOrderIds(List<Long> sysUnifiedOrderIds) {

		UnifiedOrderExample example = new UnifiedOrderExample();
		example.createCriteria()
				.andIdIn(sysUnifiedOrderIds);
		List<UnifiedOrder> result = unifiedOrderMapper.selectByExample(example);
		return result;

	}

	@Override
	public List<UnifiedOrder> findByOrderSns(List<String> orderSns) {

		UnifiedOrderExample example = new UnifiedOrderExample();
		example.createCriteria()
				.andOrderSnIn(orderSns);
		List<UnifiedOrder> result = unifiedOrderMapper.selectByExample(example);
		return result;

	}


	/****************************************** 工具方法 sysUnifiedOrderIds 推导 start ******************************************/
	/**
	 * 工具方法 统一订单's unified_order.id s
	 *
	 * @param sysUnifiedOrderIds
	 * @return
	 */
	@Override
	public List<String> convertSysUnifiedOrderIds2OrderSn(List<Long> sysUnifiedOrderIds) {

		List<String> result = new ArrayList<>();

		List<UnifiedOrder> unifiedOrderList = findBySysUnifiedOrderIds(sysUnifiedOrderIds);

		if (AnCollectionUtils.isNotEmpty(unifiedOrderList)) {
			result = unifiedOrderList.stream()
					.filter(AnLamdaUtils.distinctByKey(o -> o.getOrderSn()))
					.map(UnifiedOrder::getOrderSn)
					.collect(Collectors.toList());
		}

		return result;

	}

	/**
	 * 工具方法
	 *
	 * @param sysUnifiedOrderIds
	 * @return
	 */
	@Override
	public Map<Long, String> convertSysUnifiedOrderIds2MapSysUnifiedOrderId2OrderSn(List<Long> sysUnifiedOrderIds) {

		Map<Long, String> result = new HashMap<>();

		List<UnifiedOrder> unifiedOrderList = findBySysUnifiedOrderIds(sysUnifiedOrderIds);

		if (AnCollectionUtils.isNotEmpty(unifiedOrderList)) {
			result = unifiedOrderList.stream().collect(Collectors.toMap(UnifiedOrder::getId, UnifiedOrder::getOrderSn));
		}

		return result;

	}

	/**
	 * 工具方法
	 *
	 * @param sysUnifiedOrderIds
	 * @return
	 */
	@Override
	public Map<Long, UnifiedOrder> convertSysUnifiedOrderIds2MapSysUnifiedOrderId2Entity(List<Long> sysUnifiedOrderIds) {

		Map<Long, UnifiedOrder> result = new HashMap<>();

		List<UnifiedOrder> unifiedOrderList = findBySysUnifiedOrderIds(sysUnifiedOrderIds);

		if (AnCollectionUtils.isNotEmpty(unifiedOrderList)) {
			result = unifiedOrderList.stream().collect(Collectors.toMap(UnifiedOrder::getId, v -> v, (k, v) -> v));
		}

		return result;

	}

	/**
	 * 工具方法
	 *
	 * @param sysUnifiedOrderIds
	 * @return
	 */
	@Override
	public Map<String, UnifiedOrder> convertSysUnifiedOrderIds2MapOrderSn2Entity(List<Long> sysUnifiedOrderIds) {

		Map<String, UnifiedOrder> result = new HashMap<>();

		List<UnifiedOrder> unifiedOrderList = findBySysUnifiedOrderIds(sysUnifiedOrderIds);

		if (AnCollectionUtils.isNotEmpty(unifiedOrderList)) {
			result = unifiedOrderList.stream().collect(Collectors.toMap(UnifiedOrder::getOrderSn, v -> v, (k, v) -> v));
		}

		return result;

	}

	@Override
	public Map<String, Long> convertSysUnifiedOrderIds2MapOrderSn2SysUnifiedOrderId(List<Long> sysUnifiedOrderIds) {

		Map<String, Long> result = new HashMap<>();

		List<UnifiedOrder> unifiedOrderList = findBySysUnifiedOrderIds(sysUnifiedOrderIds);

		if (AnCollectionUtils.isNotEmpty(unifiedOrderList)) {
			result = unifiedOrderList.stream().collect(Collectors.toMap(UnifiedOrder::getOrderSn, UnifiedOrder::getId));
		}

		return result;
	}

	/****************************************** 工具方法 sysUnifiedOrderIds 推导   end ******************************************/


	/****************************************** 工具方法 orderSns 推导 start ******************************************/
	@Override
	public Map<String, Long> convertOrderSns2MapOrderSn2SysUnifiedOrderId(List<String> orderSns) {

		Map<String, Long> result = new HashMap<>();

		List<UnifiedOrder> unifiedOrderList = findByOrderSns(orderSns);

		if (AnCollectionUtils.isNotEmpty(unifiedOrderList)) {
			result = unifiedOrderList.stream().collect(Collectors.toMap(UnifiedOrder::getOrderSn, UnifiedOrder::getId));
		}

		return result;
	}
	/****************************************** 工具方法 orderSns 推导   end ******************************************/

	/****************************************** 工具方法 accountingUnifiedCustomerOrderIds 推导 start ******************************************/

	// TODO 好像现在没用到

	/****************************************** 工具方法 accountingUnifiedCustomerOrderIds 推导   end ******************************************/

}
