package cn.superdesk.uniorder.service.fund.impl;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.exception.constants.ExceptionMsg;
import cn.superdesk.uniorder.common.exception.UnifiedOrderRuntimeException;
import cn.superdesk.uniorder.dao.entity.fund.SysFundUser;
import cn.superdesk.uniorder.dao.entity.fund.SysFundUserExample;
import cn.superdesk.uniorder.dao.mapper.fund.SysFundUserMapper;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dto.vo.fund.SysFundUserVoExt;
import cn.superdesk.uniorder.service.fund.SysFundUserService;
import cn.superdesk.uniorder.common.numerical.AnDateHelper;
import cn.superdesk.uniorder.common.security.JwtUtil;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class SysFundUserServiceImpl implements SysFundUserService {

	@Autowired
	private SysFundUserMapper sysFundUserMapper;

	@Override
	public PageInfo<SysFundUser> findByPaging(Map<String, Object> params, Integer pageNo, Integer pageSize) {
		return null;
	}

	@Override
	public void deleteObj(Long id) {

	}

	@Override
	public void updateObj(SysFundUser sysFundUser) {
		sysFundUser.setUpdateTime(AnDateHelper.getNow());
		sysFundUserMapper.updateByPrimaryKeySelective(sysFundUser);
	}

	@Override
	public SysFundUser findById(Long id) {
		return sysFundUserMapper.selectByPrimaryKey(id);
	}

	@Override
	public void addObj(SysFundUser sysFundUser) {
		SysFundUserExample example = new SysFundUserExample();
		example.or().andOrganizationIdEqualTo(sysFundUser.getOrganizationId());
		if (sysFundUserMapper.countByExample(example) > 0) {
			throw new UnifiedOrderRuntimeException(ExceptionMsg.SYS_ERROR.getCode(), "该项目已存在采购基金管理员");
		}
		sysFundUser.setCreateTime(AnDateHelper.getNow());
		sysFundUserMapper.insertSelective(sysFundUser);
	}

	@Override
	public List<SysFundUser> findAll(Map<String, Object> queryMap) {
		SysFundUser sysFundUser = new SysFundUser();
		return null;
	}

	@Override
	public void create(String token, SysFundUser sysFundUser) throws UnifiedOrderRuntimeException {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		SysFundUserExample example = new SysFundUserExample();
		example.or().andOrganizationIdEqualTo(sysFundUser.getOrganizationId());

		if (sysFundUserMapper.countByExample(example) > 0) {
			throw new UnifiedOrderRuntimeException(ExceptionMsg.SYS_ERROR.getCode(), "该项目已存在采购基金管理员");
		}

		sysFundUser.setCreateUserId(loginSysUser.getSysUserId());
		sysFundUser.setCreateTime(AnDateHelper.getNow());
		sysFundUserMapper.insertSelective(sysFundUser);
	}

	@Override
	public void update(String token, SysFundUser sysFundUser) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		sysFundUser.setUpdateUserId(loginSysUser.getSysUserId());
		sysFundUser.setUpdateTime(AnDateHelper.getNow());
		sysFundUserMapper.updateByPrimaryKeySelective(sysFundUser);
	}

	@Override
	public R<List<SysFundUserVoExt>> findAllViewPage(Map<String, Object> params, int pageNum, int pageSize) {

		PageHelper.startPage(pageNum, pageSize);
		List<SysFundUserVoExt>     ls   = sysFundUserMapper.selectByCondition(params);
		PageInfo<SysFundUserVoExt> page = new PageInfo<SysFundUserVoExt>(ls);
		PageHelper.clearPage();
		return new R<List<SysFundUserVoExt>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), ls);
	}

	@Override
	public SysFundUserVoExt selectById(Map<String, Object> params) throws UnifiedOrderRuntimeException {

		List<SysFundUserVoExt> ls = sysFundUserMapper.selectByCondition(params);

		if (ls == null || ls.size() == 0) {
			throw new UnifiedOrderRuntimeException(ExceptionMsg.SYS_ERROR.getCode(), "该id不存在");
		}

		return ls.get(0);
	}
}
