package cn.superdesk.uniorder.service.invoice;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.invoice.InvoiceType;
import cn.superdesk.uniorder.dto.param.invoice.InvoiceTypeCacheCriteria;
import cn.superdesk.uniorder.service.base.BaseService;
import com.github.pagehelper.PageInfo;

import java.util.List;
import java.util.Map;

/**
 * @Description: 发票种类
 * @Author: linjinyu
 * @CreateDate: 2021/7/23 下午3:57
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/7/23 下午3:57
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface InvoiceTypeService extends BaseService<InvoiceType> {


	/****************************************** extends BaseService 部分 start ******************************************/

	@Deprecated
	void addObj(InvoiceType entity);

	@Deprecated
	void updateObj(InvoiceType entity);

	@Deprecated
	void deleteObj(Long id);

	@Deprecated
	InvoiceType findById(Long id);

	@Deprecated
	PageInfo<InvoiceType> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize);

	@Deprecated
	List<InvoiceType> findAll(Map<String, Object> queryMap);

	/****************************************** extends BaseService 部分   end ******************************************/


	void addInvoiceType(InvoiceType entity);

	void updateInvoiceType(InvoiceType entity);

	void deleteInvoiceType(Long id);

	InvoiceType findInvoiceTypeById(Long id);

	R<List<InvoiceType>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize);

	/****************************************** 缓存 start ******************************************/

	void cacheInit(InvoiceTypeCacheCriteria criteria);

	void cacheRefresh(InvoiceTypeCacheCriteria criteria);

	void cacheRemove(InvoiceTypeCacheCriteria criteria);

	String cacheGet(InvoiceTypeCacheCriteria criteria);

	InvoiceType cacheGetEntity(InvoiceTypeCacheCriteria criteria);

	/****************************************** 缓存   end ******************************************/

}
