package cn.superdesk.uniorder.service.invoice.customer;

import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;

/**
 * @Description: 开票申请 发票管理
 * @Author: linjinyu 重构
 * @CreateDate: 7/28/20 7:52 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 7/28/20 7:52 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface InvoiceApplyFieldBackAccountStatusService {


	/****************************************** 状态机 公共方法 机内使用 实际流转 重用 start ******************************************/

	// 状态流转为 未回款(0, "未回款")
	void opInitByStateMachine(InvoiceApply entity, LoginSysUser loginSysUser);
	// 状态流转为 部分回款(1, "部分回款")
	void opPartByStateMachine(InvoiceApply entity, LoginSysUser loginSysUser);
	// 状态流转为 已回款(2, "已回款")
	void opCompleteByStateMachine(InvoiceApply entity, LoginSysUser loginSysUser);

	/****************************************** 状态机 公共方法 机内使用 实际流转 重用   end ******************************************/


	/****************************************** 状态机 外部使用 类门面 start ******************************************/

	// 状态流转为 未回款(0, "未回款")
	void opInit(InvoiceApply entity, LoginSysUser loginSysUser);
	// 状态流转为 部分回款(1, "部分回款")
	void opPart(InvoiceApply entity, LoginSysUser loginSysUser);
	// 状态流转为 已回款(2, "已回款")
	void opComplete(InvoiceApply entity, LoginSysUser loginSysUser);

	/****************************************** 状态机 外部使用 类门面   end ******************************************/
}
