package cn.superdesk.uniorder.service.invoice.customer.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.io.FileUtil;
import cn.hutool.core.util.ZipUtil;
import cn.superdesk.uniorder.common.enums.common.CommonServiceEnum;
import cn.superdesk.uniorder.common.enums.scheduler.SysQuartzScheduleTaskStatementOfAccountRunStateEnum;
import cn.superdesk.uniorder.common.enums.statement.AccountingOrderDimCreateByEnum;
import cn.superdesk.uniorder.common.excel.ExcelExportModeEasyExcelUtils;
import cn.superdesk.uniorder.common.excel.ExcelResponse;
import cn.superdesk.uniorder.common.excel.biz.CellWriteHandler;
import cn.superdesk.uniorder.common.exception.utils.ExceptionUtils;
import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.dao.entity.invoice.InvoiceType;
import cn.superdesk.uniorder.dao.entity.sys.notify.SysNotify;
import cn.superdesk.uniorder.dao.mapper.invoice.customer.InvoiceApplyMapperExScore;
import cn.superdesk.uniorder.dao.mapper.invoice.customer.InvoiceApplyMapperExUnified;
import cn.superdesk.uniorder.dto.env.provider.excel.ExcelExportConstant;
import cn.superdesk.uniorder.dto.param.invoice.InvoiceTypeCacheCriteria;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.ViewDzOrder;
import cn.superdesk.uniorder.dto.vo.invoice.customer.*;
import cn.superdesk.uniorder.dto.vo.score.ScoreOrderReconciliationNotYetVo;
import cn.superdesk.uniorder.notify.NotifyUtils;
import cn.superdesk.uniorder.service.invoice.InvoiceTypeService;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyExportExcelService;
import cn.superdesk.uniorder.common.numerical.AnStringUtils;
import cn.superdesk.uniorder.common.numerical.AnCollectionUtils;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.write.builder.ExcelWriterBuilder;
import com.alibaba.excel.write.metadata.WriteSheet;
import com.alibaba.excel.write.metadata.fill.FillConfig;
import com.alibaba.excel.write.metadata.fill.FillWrapper;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.io.File;
import java.math.BigDecimal;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 2021/2/23 下午3:55
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/2/23 下午3:55
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class InvoiceApplyExportExcelServiceImpl implements InvoiceApplyExportExcelService {


	@Autowired
	private InvoiceApplyMapperExScore   invoiceApplyMapperExScore;
	@Autowired
	private InvoiceApplyMapperExUnified invoiceApplyMapperExUnified;


	@Autowired
	private InvoiceTypeService invoiceTypeService;

	@Autowired
	private ExcelExportConstant excelExportConstant;


	/****************************************** 客户结算(对账) 开票申请 列表导出 Excel数据 start ******************************************/

	/**
	 * TODO 未实现
	 *
	 * @param resultList
	 * @return
	 */
	public SysNotify exportExcelInvoiceApplyFocusUnifiedDimGoods(List<ExportExcelInvoiceApplyForceUnifiedDimGoodsVo> resultList) {
		SysNotify sysNotify = new SysNotify();
		return sysNotify;
	}

	private static final String TEMPLATE_EXCEL_EXPORT_INVOICE_APPLY_FOCUS_SCORE_DIM_CREDIT_MODE_1 = "exportExcelInvoiceApplyFocusScoreDimCreditMode1.xlsx";
	private static final String TEMPLATE_EXCEL_EXPORT_INVOICE_APPLY_FOCUS_SCORE_DIM_CREDIT_MODE_2 = "exportExcelInvoiceApplyFocusScoreDimCreditMode2.xlsx";
	private static final String TEMPLATE_EXCEL_EXPORT_INVOICE_APPLY_FOCUS_SCORE_DIM_CREDIT_MODE_3 = "exportExcelInvoiceApplyFocusScoreDimCreditMode3.xlsx";// 导出开票数据

	// 首先这东西分三种情况

//		1. 搜索框 条件 结算集
//		2. 搜索框 条件 结算集 后 界面上 勾选 要以 开票申请编号 分 sheet 分合并前 合并后
//		3. 搜索框 条件 结算集 后 界面上 勾选 要以 开票申请编号 分 sheet 财务专用

	public SysNotify exportExcelInvoiceApplyFocusScoreDimCreditMode1(List<ExportExcelInvoiceApplyForceScoreDimCreditVo> resultList) {


		String excelExportPathRoot             = excelExportConstant.getPathRoot();
		String excelExportRelativePathTemplate = excelExportConstant.getPathTemplate();
		String excelExportRelativePathStorage  = excelExportConstant.getPathStorage();

		String relativePath = File.separator + "excel" + File.separator + "invoice" + File.separator + "customer" + File.separator;

		String templateRelativePath = excelExportPathRoot + excelExportRelativePathTemplate + relativePath;
		String templateFullPath;

		String targetFullPath          = excelExportPathRoot + excelExportRelativePathStorage;
		String targetFileName          = "客户结算(对账)" + "_" + "发票(开票申请)_" + "导出报表" + ExcelResponse.addTail() + ".xlsx";
		String targetWriteFileFullPath = targetFullPath + relativePath + targetFileName;

//		if (!FileUtil.exist(targetWriteFileFullPath)) {
//			FileUtil.mkdir(targetWriteFileFullPath);
//		}
		FileUtil.touch(targetWriteFileFullPath);

		/******************************************  start ******************************************/

		ExcelWriterBuilder excelWriterBuilder = EasyExcel.write(targetWriteFileFullPath);
		ExcelWriter        excelWriter        = null;

		WriteSheet writeSheet0 = EasyExcel.writerSheet(0, "发票申请-结果模式").build();
		FillConfig fillConfig  = FillConfig.builder().forceNewRow(Boolean.FALSE).build();


		// 文件
		templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_INVOICE_APPLY_FOCUS_SCORE_DIM_CREDIT_MODE_1;

		excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();
		excelWriter.fill(new FillWrapper("detail", resultList), fillConfig, writeSheet0);

		// 别忘记关闭流
		excelWriter.finish();


		/******************************************  start ******************************************/

		return NotifyUtils.createSysNotify(targetFileName, relativePath + targetFileName, SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功);
	}

	public SysNotify exportExcelInvoiceApplyFocusScoreDimCreditMode2(List<ExportExcelInvoiceApplyForceScoreDimCreditVo> resultList) {

		String excelExportPathRoot             = excelExportConstant.getPathRoot();
		String excelExportRelativePathTemplate = excelExportConstant.getPathTemplate();
		String excelExportRelativePathStorage  = excelExportConstant.getPathStorage();

		String relativePath = File.separator + "excel" + File.separator + "invoice" + File.separator + "customer" + File.separator;

		String templateRelativePath = excelExportPathRoot + excelExportRelativePathTemplate + relativePath;
		String templateFullPath;


		String targetFullPath = excelExportPathRoot + excelExportRelativePathStorage;
//		String targetFileName          = "客户结算(对账)" + "_" + "发票(开票申请)" + "_" + "勾选导出开票数据" + ExcelResponse.addTail() + ".xlsx";
		// ZIP 积分结算_开票明细_操作导出按钮_202105081028
		String targetZipFileName          = "积分结算" + "_" + "发票(开票申请)" + "_" + "勾选导出报表" + ExcelResponse.addTail() + ".zip";
		String targetZipWriteFileFullPath = targetFullPath + relativePath + targetZipFileName;

//		if (!FileUtil.exist(targetWriteFileFullPath)) {
//			FileUtil.mkdir(targetWriteFileFullPath);
//		}
		FileUtil.touch(targetZipWriteFileFullPath);

		/******************************************  start ******************************************/

//		ExcelWriterBuilder excelWriterBuilder = EasyExcel.write(targetWriteFileFullPath)
////				.inMemory(Boolean.TRUE)
//				;
//		ExcelWriter excelWriter = null;

		templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_INVOICE_APPLY_FOCUS_SCORE_DIM_CREDIT_MODE_2;
//		excelWriter = excelWriterBuilder
////				.withTemplate(templateFullPath)
//				.build();

		// 得到处理后的数据
		Map<String, InvoiceApplyExportExcelFocusScoreDimCreditStruct> resultMap = mergeResultByExcelDebugAndCreateWorkbook(2, resultList);

		// 初始化Excel文件列表
		List<File> excelFileList = new ArrayList<>();

		try {
			int sheetNo = 0;
			for (Map.Entry<String, InvoiceApplyExportExcelFocusScoreDimCreditStruct> _entry : resultMap.entrySet()) {

				String outVirtName = AnStringUtils.stringListConvertToString(_entry.getValue()
						.getTransferListBySheet()
						.stream()
						.map(ExportExcelInvoiceApplyForceScoreDimCreditVo::getEnterpriseName)
						.distinct()
						.collect(Collectors.toList())
				);
				String invoiceNo = _entry.getKey();
				String accountingOrderSn = AnStringUtils.stringListConvertToString(_entry.getValue()
						.getTransferListBySheet()
						.stream()
						.map(ExportExcelInvoiceApplyForceScoreDimCreditVo::getAccountingOrderSn)
						.distinct()
						.collect(Collectors.toList())
				);


				// Excel 企业名称+开票申请单号+结算单编号
//				String targetXlsxFileName          = outVirtName + "_" + invoiceNo + "_" + accountingOrderSn + ExcelResponse.addTail() + ".xlsx";
				String targetXlsxFileName          = outVirtName + "_" + accountingOrderSn + "_" + invoiceNo + ".xlsx";
				String targetXlsxWriteFileFullPath = targetFullPath + relativePath + targetXlsxFileName;


				ExcelWriter excelWriter = EasyExcel
						.write(targetXlsxWriteFileFullPath)
						.inMemory(Boolean.TRUE)
						.registerWriteHandler(CellWriteHandler.builder().startRow(1).matchCell(Arrays.asList(13, 15)).build())
//				        .withTemplate(templateFullPath)
						.build();


				/****************************************** 侨城汇需求 20210922 start ******************************************/
				qchNeed20210922(_entry.getValue().getTransferListBySheet());
				/****************************************** 侨城汇需求 20210922   end ******************************************/

				sheetNo = sheetNo + 1;
				ExcelExportModeEasyExcelUtils.createSheetByWorkbook(
						_entry.getValue().getTransferListBySheet(),
						mapperHead.get(2),
						mapperValue.get(2),
						excelWriter,
						sheetNo,
						_entry.getKey()
				);
				sheetNo = sheetNo + 1;

				/****************************************** 侨城汇需求 20210922 start ******************************************/
//				qchNeed20210922(_entry.getValue().getTransferListBySheetMerge());
				/****************************************** 侨城汇需求 20210922   end ******************************************/

				ExcelExportModeEasyExcelUtils.createSheetByWorkbook(
						_entry.getValue().getTransferListBySheetMerge(),
						mapperHeadMerge.get(2),
						mapperValueMerge.get(2),
						excelWriter,
						sheetNo,
						_entry.getKey() + "_合并"
				);

				// 别忘记关闭流
				excelWriter.finish();

				excelFileList.add(FileUtil.file(targetXlsxWriteFileFullPath));
			}

			// 生成zip
			ZipUtil.zip(FileUtil.file(targetZipWriteFileFullPath), false, excelFileList.toArray(new File[excelFileList.size()]));

		} catch (Exception e) {

			log.error("exportExcelInvoiceApplyFocusScoreDimCreditMode2 \n{}", ExceptionUtils.getMessage(e));
			return NotifyUtils.createSysNotify(targetZipFileName, relativePath + targetZipFileName, SysQuartzScheduleTaskStatementOfAccountRunStateEnum.失败);
		}


		/******************************************  start ******************************************/

		return NotifyUtils.createSysNotify(targetZipFileName, relativePath + targetZipFileName, SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功);
	}

	public SysNotify exportExcelInvoiceApplyFocusScoreDimCreditMode3(List<ExportExcelInvoiceApplyForceScoreDimCreditVo> resultList) {


		String excelExportPathRoot             = excelExportConstant.getPathRoot();
		String excelExportRelativePathTemplate = excelExportConstant.getPathTemplate();
		String excelExportRelativePathStorage  = excelExportConstant.getPathStorage();

		String relativePath = File.separator + "excel" + File.separator + "invoice" + File.separator + "customer" + File.separator;

		String templateRelativePath = excelExportPathRoot + excelExportRelativePathTemplate + relativePath;
		String templateFullPath;


		String targetFullPath = excelExportPathRoot + excelExportRelativePathStorage;
//		String targetFileName          = "客户结算(对账)" + "_" + "发票(开票申请)" + "_" + "勾选导出开票数据" + ExcelResponse.addTail() + ".xlsx";
		// ZIP 积分结算_开票明细_操作导出按钮_202105081028
		String targetZipFileName          = "积分结算" + "_" + "发票(开票申请)" + "_" + "勾选导出开票数据" + ExcelResponse.addTail() + ".zip";
		String targetZipWriteFileFullPath = targetFullPath + relativePath + targetZipFileName;

//		if (!FileUtil.exist(targetWriteFileFullPath)) {
//			FileUtil.mkdir(targetWriteFileFullPath);
//		}
		FileUtil.touch(targetZipWriteFileFullPath);

		/******************************************  start ******************************************/

//		ExcelWriterBuilder excelWriterBuilder = ;

		// 模板文件没在用
		templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_INVOICE_APPLY_FOCUS_SCORE_DIM_CREDIT_MODE_3;


		// 得到处理后的数据
		Map<String, InvoiceApplyExportExcelFocusScoreDimCreditStruct> resultMap = mergeResultByExcelDebugAndCreateWorkbook(3, resultList);

		// 初始化Excel文件列表
		List<File> excelFileList = new ArrayList<>();

		try {

			// 生成 excel
			int sheetNo = 0;
			for (Map.Entry<String, InvoiceApplyExportExcelFocusScoreDimCreditStruct> _entry : resultMap.entrySet()) {

				String outVirtName = AnStringUtils.stringListConvertToString(_entry.getValue()
						.getTransferListBySheet()
						.stream()
						.map(ExportExcelInvoiceApplyForceScoreDimCreditVo::getEnterpriseName)
						.distinct()
						.collect(Collectors.toList())
				);
				String invoiceNo = _entry.getKey();
				String accountingOrderSn = AnStringUtils.stringListConvertToString(_entry.getValue()
						.getTransferListBySheet()
						.stream()
						.map(ExportExcelInvoiceApplyForceScoreDimCreditVo::getAccountingOrderSn)
						.distinct()
						.collect(Collectors.toList())
				);


				// Excel 企业名称+开票申请单号+结算单编号
//				String targetXlsxFileName          = outVirtName + "_" + invoiceNo + "_" + accountingOrderSn + ExcelResponse.addTail() + ".xlsx";
				String targetXlsxFileName          = outVirtName + "_" + accountingOrderSn + "_" + invoiceNo + ".xlsx";
				String targetXlsxWriteFileFullPath = targetFullPath + relativePath + targetXlsxFileName;


				ExcelWriter excelWriter = EasyExcel
						.write(targetXlsxWriteFileFullPath)
						.inMemory(Boolean.TRUE)
						.registerWriteHandler(CellWriteHandler.builder().startRow(1).matchCell(Arrays.asList(11)).build())
//				        .withTemplate(templateFullPath)
						.build();

				/****************************************** 侨城汇需求 20210922 start ******************************************/
				qchNeed20210922(_entry.getValue().getTransferListBySheetMerge());
				/****************************************** 侨城汇需求 20210922   end ******************************************/


				ExcelExportModeEasyExcelUtils.createSheetByWorkbook(
						_entry.getValue().getTransferListBySheetMerge(),
						mapperHeadMerge.get(3),
						mapperValueMerge.get(3),
						excelWriter,
						sheetNo,
						_entry.getKey() + "_合并"
				);

				// 别忘记关闭流
				excelWriter.finish();

				excelFileList.add(FileUtil.file(targetXlsxWriteFileFullPath));

			}

			// 生成zip
			ZipUtil.zip(FileUtil.file(targetZipWriteFileFullPath), false, excelFileList.toArray(new File[excelFileList.size()]));

		} catch (Exception e) {

			log.error("exportExcelInvoiceApplyFocusScoreDimCreditMode2 \n{}", ExceptionUtils.getMessage(e));

			return NotifyUtils.createSysNotify(targetZipFileName, relativePath + targetZipFileName, SysQuartzScheduleTaskStatementOfAccountRunStateEnum.失败);
		}


		/******************************************  start ******************************************/

		return NotifyUtils.createSysNotify(targetZipFileName, relativePath + targetZipFileName, SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功);
	}

	private void qchNeed20210922(List<ExportExcelInvoiceApplyForceScoreDimCreditVo> resultTmp) {
		resultTmp.forEach(vo -> {


			if (null != vo.getOperationTaxRate()) {
				vo.setOperationTaxRate(vo.getOperationTaxRate().divide(new BigDecimal(100L), 2, BigDecimal.ROUND_HALF_UP));
			}

			vo.setEncryptedVersionNumber("33.0");
			vo.setFlagTaxIncentives("0");
			vo.setPersonNameCashier("曾鹏");
			vo.setPersonNameReview("翁浩锐");
			vo.setPurchaserCompanyType("01");
			vo.setFlagTaxIncluded("含税");

			InvoiceType invoiceType = invoiceTypeService.cacheGetEntity(InvoiceTypeCacheCriteria
					.builder()
					.hashTable(InvoiceTypeCacheCriteria.HASHTABLE)
					.hashTableKeyField(InvoiceTypeCacheCriteria.HASHTABLE_KEY_FIELD_ID)
					.keyField(AnStringUtils.getString(vo.getInvoiceType()))
					.build()
			);

			if (null != invoiceType) {
				vo.setInvoiceTypeName(invoiceType.getTypeName());
			}
		});
	}


	/****************************************** 甲方要求减几个字段 mark by linjinyu at 20210317   end ******************************************/

//	private static Map<Integer, Function<String[], List<List<String>>>> modeOfExportExcelInvoiceApplyFocusScoreDimCredit = new HashMap<>();

	private static Map<Integer, String[]> mapperHead  = new HashMap<>();
	private static Map<Integer, String[]> mapperValue = new HashMap<>();

	private static Map<Integer, String[]> mapperHeadMerge  = new HashMap<>();
	private static Map<Integer, String[]> mapperValueMerge = new HashMap<>();

	static {

		// 初始化
//		modeOfExportExcelInvoiceApplyFocusScoreDimCredit.put(1, (mode) -> getHead(fieldHeadMode1Static));
//		modeOfExportExcelInvoiceApplyFocusScoreDimCredit.put(2, (mode) -> getHead(fieldHeadMode2Static));
//		modeOfExportExcelInvoiceApplyFocusScoreDimCredit.put(3, (mode) -> getHead(fieldHeadMode3Static));

		mapperHead.put(1, InvoiceApplyExportExcelFocusScoreDimCreditStatic.fieldHeadMode1Static);
		mapperHead.put(2, InvoiceApplyExportExcelFocusScoreDimCreditStatic.fieldHeadMode2Static);
		mapperHead.put(3, InvoiceApplyExportExcelFocusScoreDimCreditStatic.fieldHeadMode3Static);

		mapperValue.put(1, InvoiceApplyExportExcelFocusScoreDimCreditStatic.fieldValueMode1Static);
		mapperValue.put(2, InvoiceApplyExportExcelFocusScoreDimCreditStatic.fieldValueMode2Static);
		mapperValue.put(3, InvoiceApplyExportExcelFocusScoreDimCreditStatic.fieldValueMode3Static);

//		mapperHeadMerge.put(1, InvoiceApplyExportExcelFocusScoreDimCreditStatic.fieldHeadMode1StaticMerge);
		mapperHeadMerge.put(2, InvoiceApplyExportExcelFocusScoreDimCreditStatic.fieldHeadMode2StaticMerge);
		mapperHeadMerge.put(3, InvoiceApplyExportExcelFocusScoreDimCreditStatic.fieldHeadMode3StaticMerge);

//		mapperValueMerge.put(1, InvoiceApplyExportExcelFocusScoreDimCreditStatic.fieldValueMode1StaticMerge);
		mapperValueMerge.put(2, InvoiceApplyExportExcelFocusScoreDimCreditStatic.fieldValueMode2StaticMerge);
		mapperValueMerge.put(3, InvoiceApplyExportExcelFocusScoreDimCreditStatic.fieldValueMode3StaticMerge);
	}


	/**
	 * 可行 再合并 TODO 现在已经改成只处理数据 markby linjinyu at 202106031203
	 *
	 * @param resultList
	 * @return
	 */
	private Map<String, InvoiceApplyExportExcelFocusScoreDimCreditStruct> mergeResultByExcelDebugAndCreateWorkbook(Integer mode, List<ExportExcelInvoiceApplyForceScoreDimCreditVo> resultList) {


		// 变换
		List<ExportExcelInvoiceApplyForceScoreDimCreditVo> transformList = resultList.parallelStream()
				.filter(o -> "运费".equals(o.getUnit()) && null != o.getGoodsId() && o.getGoodsId().equals(-1L)).collect(Collectors.toList());

		if (AnCollectionUtils.isNotEmpty(transformList)) {

			transformList.forEach(o -> {
				o.setGoodsId(0L);
			});
		}


		log.info("\n\n\nexportExcelInvoiceApplyFocusScoreDimCredit 数据准备 : {}\n\n\n", JsonUtils.toJson(resultList));

//		HSSFWorkbook workbook = new HSSFWorkbook();
		FillConfig fillConfig = FillConfig.builder().forceNewRow(Boolean.FALSE).build();

		Map<String, InvoiceApplyExportExcelFocusScoreDimCreditStruct> resultMap = new HashMap<>();

		if (AnCollectionUtils.isEmpty(resultList)) {
			return resultMap;
		}

		// 得出当前数据 发票申请的 id -> sn
		Map<Long, String> invoiceApplyMap = resultList.stream().collect(Collectors.toMap(
				/* key      */ExportExcelInvoiceApplyForceScoreDimCreditVo::getInvoiceApplyId,
				/* value    */ExportExcelInvoiceApplyForceScoreDimCreditVo::getInvoiceNo,
				/* key重复时 */(key1, key2) -> key2,
				LinkedHashMap::new
		));

		// 因为是可以多选的 所以先按 发票申请Id 分组
		Map<String, List<ExportExcelInvoiceApplyForceScoreDimCreditVo>> transferMapGrouopByInvoiceApplyId = resultList.parallelStream()
				.collect(Collectors.groupingBy(ExportExcelInvoiceApplyForceScoreDimCreditVo::getInvoiceNo, Collectors.toList()));
//				.collect(Collectors.groupingBy(e -> fetchGroupKey(e), Collectors.toList()));

//		List<ExportExcelInvoiceApplyForceScoreDimCreditVo> transferListBySheet      = null;
//		List<ExportExcelInvoiceApplyForceScoreDimCreditVo> transferListBySheetMerge = null;


		int sheetNo = 0;
		// 因为是可以多选的 所以先按 发票申请Id 分组 每个 entry 是 一份
		for (Map.Entry<String, List<ExportExcelInvoiceApplyForceScoreDimCreditVo>> entry : transferMapGrouopByInvoiceApplyId.entrySet()) {

//			transferListBySheet = new ArrayList<>();
//			transferListBySheetMerge = new ArrayList<>();

			InvoiceApplyExportExcelFocusScoreDimCreditStruct struct = new InvoiceApplyExportExcelFocusScoreDimCreditStruct();
			struct.setTransferListBySheet(new ArrayList<>());
			struct.setTransferListBySheetMerge(new ArrayList<>());

			Map<String, List<ExportExcelInvoiceApplyForceScoreDimCreditVo>> transferMapGrouopByInvoiceApplyIdGroupBy = entry.getValue().parallelStream()
					.collect(Collectors.groupingBy(e -> InvoiceApplyExportExcelFocusScoreDimCreditStatic.fetchGroupKeyByName(e), Collectors.toList()));

			for (Map.Entry<String, List<ExportExcelInvoiceApplyForceScoreDimCreditVo>> _entry : transferMapGrouopByInvoiceApplyIdGroupBy.entrySet()) {


				log.info("_groupKey : {} _size : {}", _entry.getKey(), _entry.getValue().size());

				// 为什么是大于1
				if (_entry.getValue().size() > 1) {
//					log.info("\n{}", JsonUtils.toJson(_entry.getValue()));

					// TODO 处理 合并
					ExportExcelInvoiceApplyForceScoreDimCreditVo _merge = new ExportExcelInvoiceApplyForceScoreDimCreditVo();
					BeanUtil.copyProperties(_entry.getValue().get(0), _merge);

					// 商品数量
					_merge.setQuantity(_entry.getValue().stream()
							.map(item -> item.getQuantity() == null ? 0 : item.getQuantity())
							.reduce(0, Integer::sum));
//					// 销售单价
//					_merge.setPrice(_entry.getValue().stream()
//							.map(item -> item.getPrice() == null ? BigDecimal.ZERO : item.getPrice())
//							.reduce(BigDecimal.ZERO, BigDecimal::add));
					// 结算金额(积分)
					_merge.setBalance(_entry.getValue().stream()
							.map(item -> item.getBalance() == null ? BigDecimal.ZERO : item.getBalance())
							.reduce(BigDecimal.ZERO, BigDecimal::add));

//					累加
//					BigDecimal::add

					/****************************************** 侨城汇 合并后数据为0不要了 start ******************************************/
					if (_merge.getQuantity().compareTo(0) != 0 || _merge.getBalance().compareTo(BigDecimal.ZERO) != 0) {
//						transferListBySheetMerge.add(_merge);
						struct.getTransferListBySheetMerge().add(_merge);
					}


				} else {
//					transferListBySheetMerge.addAll(_entry.getValue());
					struct.getTransferListBySheetMerge().addAll(_entry.getValue());
				}

//				transferListBySheet.addAll(_entry.getValue());
				struct.getTransferListBySheet().addAll(_entry.getValue());
			}

			resultMap.put(/* InvoiceNo */entry.getKey(), struct);


			/****************************************** 不在这处理了 start ******************************************/
//			try {
////				ExcelExportModePoiHssfUtils.createSheetByWorkbook(transferListBySheet, fieldHeadMode2Static, fieldValueMode2Static, workbook, invoiceApplyMap.get(entry.getKey()).toString() + "");
////				ExcelExportModePoiHssfUtils.createSheetByWorkbook(transferListBySheetMerge, fieldHeadMode2StaticMerge, fieldValueMode2StaticMerge, workbook, invoiceApplyMap.get(entry.getKey()).toString() + "_合并");
//
//				if (mode.compareTo(2) == 0) {
//
//					log.info("\n\n\n创建 sheet : {} \ntransferListBySheet 数据准备 : {}\n\n\n", invoiceApplyMap.get(entry.getKey()), JsonUtils.toJson(transferListBySheet));
////					WriteSheet writeSheet0 = EasyExcel
////							.writerSheet(sheetNo)
////							.sheetName(invoiceApplyMap.get(entry.getKey()))
////							.head(getHead(mapperHead.get(mode)))
////							.build();
//////					excelWriter.fill(new FillWrapper("detail", transferListBySheet), fillConfig, writeSheet0);
////					excelWriter.write(transferListBySheet, writeSheet0);
//					sheetNo = sheetNo + 1;
//					ExcelExportModeEasyExcelUtils.createSheetByWorkbook(transferListBySheet, mapperHead.get(mode), mapperValue.get(mode), excelWriter, sheetNo, invoiceApplyMap.get(entry.getKey()));
//				}
//
//				log.info("\n\n\n创建 sheet : {} \ntransferListBySheetMerge 数据准备 : {}\n\n\n", invoiceApplyMap.get(entry.getKey()) + "_合并", JsonUtils.toJson(transferListBySheetMerge));
////				WriteSheet writeSheet1 = EasyExcel
////						.writerSheet(sheetNo + 1)
////						.sheetName(invoiceApplyMap.get(entry.getKey()) + "_合并")
////						.head(getHead(mapperHead.get(mode)))
////						.build();
//////				excelWriter.fill(new FillWrapper("detail", transferListBySheetMerge), fillConfig, writeSheet1);
////				excelWriter.write(transferListBySheetMerge, writeSheet1);
//				sheetNo = sheetNo + 1;
//				ExcelExportModeEasyExcelUtils.createSheetByWorkbook(transferListBySheetMerge, mapperHeadMerge.get(mode), mapperValueMerge.get(mode), excelWriter, sheetNo, invoiceApplyMap.get(entry.getKey()) + "_合并");
//
//			} catch (Exception e) {
//
//				e.printStackTrace();
//			}
			/****************************************** 不在这处理了 start ******************************************/

//			sheetNo = sheetNo + 2;
		}

		return resultMap;


	}

	/**
	 * @param result
	 * @return
	 */
	@Deprecated
	private List<ExportExcelInvoiceApplyForceScoreDimCreditVo> mergeResultByExcelDebug(List<ExportExcelInvoiceApplyForceScoreDimCreditVo> result) {

		// 因为是可以多选的 所以先按 发票申请Id 分组
		Map<Long, List<ExportExcelInvoiceApplyForceScoreDimCreditVo>> transferMapGrouopByInvoiceApplyId = result.parallelStream()
				.collect(Collectors.groupingBy(ExportExcelInvoiceApplyForceScoreDimCreditVo::getInvoiceApplyId, Collectors.toList()));
//				.collect(Collectors.groupingBy(e -> fetchGroupKey(e), Collectors.toList()));

		List<ExportExcelInvoiceApplyForceScoreDimCreditVo> transferList = new ArrayList<>();

		// 因为是可以多选的 所以先按 发票申请Id 分组 每个 entry 是 一份
		for (Map.Entry<Long, List<ExportExcelInvoiceApplyForceScoreDimCreditVo>> entry : transferMapGrouopByInvoiceApplyId.entrySet()) {

			Map<String, List<ExportExcelInvoiceApplyForceScoreDimCreditVo>> transferMapGrouopByInvoiceApplyIdGroupBy = entry.getValue().parallelStream()
					.collect(Collectors.groupingBy(e -> InvoiceApplyExportExcelFocusScoreDimCreditStatic.fetchGroupKeyById(e), Collectors.toList()));

			for (Map.Entry<String, List<ExportExcelInvoiceApplyForceScoreDimCreditVo>> _entry : transferMapGrouopByInvoiceApplyIdGroupBy.entrySet()) {

				log.info("_groupKey : {} _size : {}", _entry.getKey(), _entry.getValue().size());

				if (_entry.getValue().size() > 1) {
					log.info("\n{}", JsonUtils.toJson(_entry.getValue()));
				}

				transferList.addAll(_entry.getValue());
			}
		}

		return transferList;

	}

	// TODO
	@Deprecated
	private void mergeResultByExcel(List<ExportExcelInvoiceApplyForceScoreDimCreditVo> result) {

		result.parallelStream()
//				.collect(Collectors.groupingBy(InvoiceApplyExportExcelForceScore::getUnifiedOrderGoodsId, Collectors.toList()))
				.collect(Collectors.groupingBy(e -> InvoiceApplyExportExcelFocusScoreDimCreditStatic.fetchGroupKeyById(e), Collectors.toList()))
				.forEach((groupKey, transferList) -> {


					ExportExcelInvoiceApplyForceScoreDimCreditVo mergeRow = new ExportExcelInvoiceApplyForceScoreDimCreditVo();

					log.info("\ngroupKey : {}\ntransferList : {}", groupKey, JsonUtils.toJson(transferList));

//					authorizedStationInfo.setStationId(k);
//					List<AuthorizedPileInfo> authorizedPileInfos = new ArrayList<>();
//					v.parallelStream().collect(Collectors.groupingBy(CrmAuthorizedInfo::getPileId, Collectors.toList())).forEach((k1, v1) -> {
//						AuthorizedPileInfo authorizedPileInfo = new AuthorizedPileInfo();
//						authorizedPileInfo.setPileId(k1);
//						authorizedPileInfo.setGunIds(v1.stream().map(CrmAuthorizedInfo::getGunId).collect(Collectors.toList()));
//						authorizedPileInfos.add(authorizedPileInfo);
//					});
//					authorizedStationInfo.setPileIds(authorizedPileInfos);

//					authorizedStationInfos.add(authorizedStationInfo);
				});

	}

	/****************************************** 客户结算(对账) 开票申请 列表导出 Excel数据   end ******************************************/


	// 区分 订单类型 为了不改代码
//	private static final String TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_GOODS_2_FLSC = "exportUnifiedCustomerInvoice2GoodsDetailDimGoods2FLSC.xlsx";
//	private static final String TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_GOODS_2_LNSS = "exportUnifiedCustomerInvoice2GoodsDetailDimGoods2LNSS.xlsx";
//	private static final String TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_GOODS_2_QYNG = "exportUnifiedCustomerInvoice2GoodsDetailDimGoods2QYNG.xlsx";
//	private static final String TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_ORDER_2_ALLL = "exportUnifiedCustomerInvoice2GoodsDetailDimOrder2ALLL.xlsx";

	// 不区分 订单类型 mark by linjinyu at 20210526

	private static final String TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_GOODS_2_FLSC = "exportUnifiedCustomerInvoice2GoodsDetailDimGoodsALL20210526.xlsx";
	private static final String TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_GOODS_2_LNSS = "exportUnifiedCustomerInvoice2GoodsDetailDimGoodsALL20210526.xlsx";
	private static final String TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_GOODS_2_QYNG = "exportUnifiedCustomerInvoice2GoodsDetailDimGoodsALL20210526.xlsx";
	private static final String TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_ORDER_2_ALLL = "exportUnifiedCustomerInvoice2GoodsDetailDimGoodsALL20210526.xlsx";

	public SysNotify exportExcelUnifiedCustomerInvoice2GoodsDetail(InvoiceApplyDetailDimGoodsVo invoiceApplyDetailDimGoodsVo) {


//		log.info("/Users/linjinyu/JAVA_HOME/workspace_superdesk/superdesk-uniorder/superdesk-uniorder-service/src/main/resources/template/excel/invoice/customer");

//		String ROOT_RESOURCES_PATH                  = System.getProperty("user.dir");
//		String ROOT_TEMPLATE_EXCEL_PATH             = "/src/main/resources/template/excel/invoice/customer/";

//		exportUnifiedCustomerInvoice2GoodsDetailDimGoods2FLSC.xlsx
//		exportUnifiedCustomerInvoice2GoodsDetailDimGoods2LNSS.xlsx
//		exportUnifiedCustomerInvoice2GoodsDetailDimGoods2QYNG.xlsx
//		exportUnifiedCustomerInvoice2GoodsDetailDimOrder.xlsx


//		log.info("{}{}{}", ROOT_RESOURCES_PATH, ROOT_TEMPLATE_EXCEL_PATH, TEMPLATE_EXCEL_NAME_INVOICE_CUSTOMER);

		// 模板注意 用{} 来表示你要用的变量 如果本来就有"{","}" 特殊字符 用"\{","\}"代替
		// {} 代表普通变量 {.} 代表是list的变量
//		String templateFileName = "/Users/linjinyu/tmp" + File.separator + "template" + File.separator + "excel" + File.separator + "invoice" + File.separator + "customer" + File.separator + "exportUnifiedCustomerInvoice2GoodsDetail.xlsx";
//		String fileName         = "/Users/linjinyu/tmp" + File.separator + "template" + File.separator + "excel" + File.separator + "invoice" + File.separator + "customer" + File.separator + System.currentTimeMillis() + ".xlsx";

//		String templateRootPath     = "/Users/linjinyu/tmp";
		String excelExportPathRoot             = excelExportConstant.getPathRoot();
		String excelExportRelativePathTemplate = excelExportConstant.getPathTemplate();
		String excelExportRelativePathStorage  = excelExportConstant.getPathStorage();

		String relativePath = File.separator + "excel" + File.separator + "invoice" + File.separator + "customer" + File.separator;

		String templateRelativePath = excelExportPathRoot + excelExportRelativePathTemplate + relativePath;
		String templateFullPath;

		String targetFullPath = excelExportPathRoot + excelExportRelativePathStorage;

		String targetFileName          = "客户结算(对账)" + "_" + "开票申请(发票)详情_" + "电子发票" + ExcelResponse.addTail() + ".xlsx";
		String targetWriteFileFullPath = targetFullPath + relativePath + targetFileName;

//		if (!FileUtil.exist(targetWriteFileFullPath)) {
//			FileUtil.mkdir(targetWriteFileFullPath);
//		}
		FileUtil.touch(targetWriteFileFullPath);

//
//		// 这里注意 入参用了forceNewRow 代表在写入list的时候不管list下面有没有空行 都会创建一行，然后下面的数据往后移动。默认 是false，会直接使用下一行，如果没有则创建。
//		// forceNewRow 如果设置了true,有个缺点 就是他会把所有的数据都放到内存了，所以慎用
//		// 简单的说 如果你的模板有list,且list不是最后一行，下面还有数据需要填充 就必须设置 forceNewRow=true 但是这个就会把所有数据放到内存 会很耗内存
//		// 如果数据量大 list不是最后一行 参照下一个
////		FillConfig fillConfig = FillConfig.builder().forceNewRow(Boolean.TRUE).build();
////		excelWriter.fill(data(), fillConfig, writeSheet);
////		excelWriter.fill(data(), fillConfig, writeSheet);
////
////		Map<String, Object> map = new HashMap<String, Object>();
////		map.put("date", "2019年10月9日13:28:28");
////		map.put("total", 1000);
////
////		excelWriter.fill(map, writeSheet);
////		excelWriter.finish();
//
//
//		FillConfig fillConfig = FillConfig.builder().direction(WriteDirectionEnum.HORIZONTAL).build();
//		// 如果有多个list 模板上必须有{前缀.} 这里的前缀就是 data1，然后多个list必须用 FillWrapper包裹
//		excelWriter.fill(new FillWrapper("data1", data()), fillConfig, writeSheet);
//		excelWriter.fill(new FillWrapper("data1", data()), fillConfig, writeSheet);
//		excelWriter.fill(new FillWrapper("data2", data()), writeSheet);
//		excelWriter.fill(new FillWrapper("data2", data()), writeSheet);
//		excelWriter.fill(new FillWrapper("data3", data()), writeSheet);
//		excelWriter.fill(new FillWrapper("data3", data()), writeSheet);
//
//		Map<String, Object> map = new HashMap<String, Object>();
//		map.put("date", "2019年10月9日13:28:28");
//		excelWriter.fill(map, writeSheet);


		ExcelWriterBuilder excelWriterBuilder = EasyExcel.write(targetWriteFileFullPath);
		ExcelWriter        excelWriter        = null;

		WriteSheet writeSheet0 = EasyExcel.writerSheet(0, "面单").build();
		WriteSheet writeSheet1 = EasyExcel.writerSheet(1, "明细").build();
		FillConfig fillConfig  = FillConfig.builder().forceNewRow(Boolean.FALSE).build();

		// accounting_order_type 对账单类型 1-一般;2-积分;
		// dim_create_by 对账单 创建维度:0-订单;1-商品;2-流水;

		switch (AccountingOrderDimCreateByEnum.get(invoiceApplyDetailDimGoodsVo.getDimCreateBy())) {
			case 订单:

				List<ViewDzOrder> dzOrders = invoiceApplyDetailDimGoodsVo.getDzOrders();

				ViewDzOrder sample0 = dzOrders.get(0);

				templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_ORDER_2_ALLL;

				excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();
				excelWriter.fill(new FillWrapper("detail", dzOrders), fillConfig, writeSheet1);
				break;
			case 商品:


				List<InvoiceApplyDetailDimGoodsV3Vo> innerOrderJoinGoodsList = invoiceApplyDetailDimGoodsVo.getInnerOrderJoinGoodsList();

				InvoiceApplyDetailDimGoodsV3Vo sample1 = innerOrderJoinGoodsList.get(0);

				switch (CommonServiceEnum.getByServiceNo(sample1.getServiceNo())) {
					case UNKNOW:
						// TODO 异常情况
						templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_ORDER_2_ALLL;
						excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();

						break;
					case SUPER:
						// TODO 异常情况
						templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_ORDER_2_ALLL;
						excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();
						break;
					case QYNG:
						templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_GOODS_2_QYNG;
						excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();
						break;
					case DKXD:
						templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_GOODS_2_QYNG;
						excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();
						break;
					case FLSC:
						templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_GOODS_2_FLSC;
						excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();
						break;
					case FLSC_QCH:
						templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_GOODS_2_FLSC;
						excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();
						break;
					case LNSS:
						templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_GOODS_2_LNSS;
						excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();
						break;
					default:
						// TODO 异常情况
						templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_UNIFIED_CUSTOMER_INVOICE_2_GOODS_DETAIL_DIM_ORDER_2_ALLL;
						excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();
						break;
				}


				// TODO 要再分 serviceNo 先简单写吧 mark by linjinyu at 20210302
				excelWriter.fill(new FillWrapper("detail", innerOrderJoinGoodsList), fillConfig, writeSheet1);
				break;
			case 流水:
				break;
			default:
				break;
		}


		excelWriter.fill(invoiceApplyDetailDimGoodsVo, writeSheet0);


		// 别忘记关闭流
		excelWriter.finish();

		return NotifyUtils.createSysNotify(targetFileName, relativePath + targetFileName, SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功);
	}


	@Autowired
	private TransformExportExcelDimUnifiedInvoiceRegister4E6Tools transformExportExcelDimUnifiedInvoiceRegister4E6Tools;

	private static final String TEMPLATE_EXCEL_EXPORT_INVOICE_REGISTER_DIM_ORDER_4_E6 = "exportExcelInvoiceRegisterDimOrder4E6.xlsx";
	private static final String TEMPLATE_EXCEL_EXPORT_INVOICE_REGISTER_DIM_GOODS_4_E6 = "exportExcelInvoiceRegisterDimGoods4E6.xlsx";

	private static final String TEMPLATE_EXCEL_EXPORT_INVOICE_REGISTER_4_E6 = "exportExcelInvoiceRegister4E6.xlsx";

	/**
	 * 待重构
	 *
	 * @param invoiceApplyDetailDimGoodsVo
	 * @return
	 */
	public SysNotify exportExcelDimUnifiedInvoiceRegister4E6(InvoiceApplyDetailDimGoodsVo invoiceApplyDetailDimGoodsVo) {

		String excelExportPathRoot             = excelExportConstant.getPathRoot();
		String excelExportRelativePathTemplate = excelExportConstant.getPathTemplate();
		String excelExportRelativePathStorage  = excelExportConstant.getPathStorage();

		String relativePath = File.separator + "excel" + File.separator + "invoice" + File.separator + "customer" + File.separator;

		String templateRelativePath = excelExportPathRoot + excelExportRelativePathTemplate + relativePath;
		String templateFullPath;

		String targetFullPath = excelExportPathRoot + excelExportRelativePathStorage;

		String targetFileName          = "客户结算(对账)" + "_" + "开票申请(发票)税务管理软件E6_" + "ExcelAndTxt组件接口版_开票申请编号_" + invoiceApplyDetailDimGoodsVo.getInvoiceNo() + ExcelResponse.addTail() + ".xlsx";
		String targetWriteFileFullPath = targetFullPath + relativePath + targetFileName;

//		if (!FileUtil.exist(targetWriteFileFullPath)) {
//			FileUtil.mkdir(targetWriteFileFullPath);
//		}
		FileUtil.touch(targetWriteFileFullPath);


		ExcelWriterBuilder excelWriterBuilder = EasyExcel.write(targetWriteFileFullPath);
		ExcelWriter        excelWriter        = null;

		WriteSheet writeSheet1 = EasyExcel.writerSheet(0).build();
		FillConfig fillConfig  = FillConfig.builder().forceNewRow(Boolean.FALSE).build();

		// accounting_order_type 对账单类型 1-一般;2-积分;
		// dim_create_by 对账单 创建维度:0-订单;1-商品;2-流水;


		List<ExportExcelDimUnifiedInvoiceRegister4E6Vo> resultData = transformExportExcelDimUnifiedInvoiceRegister4E6Tools.transform(invoiceApplyDetailDimGoodsVo, AccountingOrderDimCreateByEnum.get(invoiceApplyDetailDimGoodsVo.getDimCreateBy()));
		templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_INVOICE_REGISTER_4_E6;
		excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();
		excelWriter.fill(new FillWrapper("detail", resultData), fillConfig, writeSheet1);


		// 别忘记关闭流
		excelWriter.finish();

		return NotifyUtils.createSysNotify("税务管理软件E6-ExcelAndTxt组件接口版-" + targetFileName, relativePath + targetFileName, SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功);

	}


	private static final String TEMPLATE_EXCEL_EXPORT_SCORE_CUSTOMER_INVOICE_2_CREDIT_DETAIL_DIM_CREDIT_2_FLSC_QCH = "exportScoreCustomerInvoice2CreditDetailDimCredit2FLSC_QCH.xlsx";

	/**
	 * mark by linjinyu at 20211112
	 *
	 * @param invoiceApplyDetailDimCreditVo
	 * @return
	 */
	public SysNotify exportExcelUnifiedCustomerInvoice2CreditDetail(InvoiceApplyDetailDimCreditVo invoiceApplyDetailDimCreditVo) {

		String excelExportPathRoot             = excelExportConstant.getPathRoot();
		String excelExportRelativePathTemplate = excelExportConstant.getPathTemplate();
		String excelExportRelativePathStorage  = excelExportConstant.getPathStorage();

		String relativePath = File.separator + "excel" + File.separator + "invoice" + File.separator + "customer" + File.separator;

		String templateRelativePath = excelExportPathRoot + excelExportRelativePathTemplate + relativePath;
		String templateFullPath;

		String targetFullPath = excelExportPathRoot + excelExportRelativePathStorage;

		String targetFileName          = "积分结算(对账)" + "_" + "开票申请(发票)详情_" + "电子发票_" + invoiceApplyDetailDimCreditVo.getInvoiceNo() + ExcelResponse.addTail() + ".xlsx";
		String targetWriteFileFullPath = targetFullPath + relativePath + targetFileName;

		FileUtil.touch(targetWriteFileFullPath);

		ExcelWriterBuilder excelWriterBuilder = EasyExcel.write(targetWriteFileFullPath);
		ExcelWriter        excelWriter        = null;

		WriteSheet writeSheet0 = EasyExcel.writerSheet(0, "面单").build();
		WriteSheet writeSheet1 = EasyExcel.writerSheet(1, "明细").build();
		FillConfig fillConfig  = FillConfig.builder().forceNewRow(Boolean.FALSE).build();

		// accounting_order_type 对账单类型 1-一般;2-积分;
		// dim_create_by 对账单 创建维度:0-订单;1-商品;2-流水;

		switch (AccountingOrderDimCreateByEnum.get(invoiceApplyDetailDimCreditVo.getDimCreateBy())) {
			case 订单:
				// ...
				break;
			case 商品:
				// ...
				break;
			case 流水:

				List<ScoreOrderReconciliationNotYetVo> dzOrders = invoiceApplyDetailDimCreditVo.getDzOrders();

				templateFullPath = templateRelativePath + TEMPLATE_EXCEL_EXPORT_SCORE_CUSTOMER_INVOICE_2_CREDIT_DETAIL_DIM_CREDIT_2_FLSC_QCH;
				excelWriter = excelWriterBuilder.withTemplate(templateFullPath).build();

				excelWriter.fill(new FillWrapper("detail", dzOrders), fillConfig, writeSheet1);

				break;
			default:
				break;
		}

		excelWriter.fill(invoiceApplyDetailDimCreditVo, writeSheet0);

		// 别忘记关闭流
		excelWriter.finish();

		return NotifyUtils.createSysNotify(targetFileName, relativePath + targetFileName, SysQuartzScheduleTaskStatementOfAccountRunStateEnum.成功);

	}

}
