package cn.superdesk.uniorder.service.invoice.customer.impl;

import cn.superdesk.uniorder.common.exception.constants.ExceptionMsg;
import cn.superdesk.uniorder.common.enums.common.CommonAccountingStateEnum;
import cn.superdesk.uniorder.common.enums.credit.UnifiedOrderCreditBackStatusEnum;
import cn.superdesk.uniorder.common.enums.credit.UnifiedOrderCreditInvoiceApplyStatusEnum;
import cn.superdesk.uniorder.common.enums.credit.UnifiedOrderCreditInvoiceMakeStatusEnum;
import cn.superdesk.uniorder.common.enums.invoice.*;
import cn.superdesk.uniorder.common.enums.statement.AccountingOrderDimCreateByEnum;
import cn.superdesk.uniorder.common.enums.statement.AccountingOrderTypeDimEnum;
import cn.superdesk.uniorder.common.exception.UnifiedOrderRuntimeException;
import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.common.lamda.AnLamdaUtils;
import cn.superdesk.uniorder.common.numerical.*;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.convert.Dto2DtoConvertUtils;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderCredit;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderGoods;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApplyExample;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApplyXGoods;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApplyXGoodsExample;
import cn.superdesk.uniorder.dao.entity.order.ExpressCompany;
import cn.superdesk.uniorder.dao.entity.organisation.SysEnterprise;
import cn.superdesk.uniorder.dao.entity.organisation.SysEnterpriseExtInvoice;
import cn.superdesk.uniorder.dao.entity.sys.SysOderUser;
import cn.superdesk.uniorder.dao.mapper.accounting.score.customer.AccountingScoreCustomerMapper;
import cn.superdesk.uniorder.dao.mapper.accounting.unified.customer.AccountingUnifiedCustomerMapper;
import cn.superdesk.uniorder.dao.mapper.accounting.unified.customer.AccountingUnifiedCustomerMapperEx;
import cn.superdesk.uniorder.dao.mapper.accounting.unified.customer.AccountingUnifiedCustomerOrderGoodsMapper;
import cn.superdesk.uniorder.dao.mapper.accounting.unified.customer.AccountingUnifiedCustomerOrderGoodsMapperEx;
import cn.superdesk.uniorder.dao.mapper.base.UnifiedOrderCreditMapper;
import cn.superdesk.uniorder.dao.mapper.invoice.customer.*;
import cn.superdesk.uniorder.dao.mapper.order.ExpressCompanyMapper;
import cn.superdesk.uniorder.dto.param.invoice.ExportExcelInvoiceApplyQueryCriteria;
import cn.superdesk.uniorder.dto.param.invoice.customer.InvoiceApplyCommonParams;
import cn.superdesk.uniorder.dto.param.invoice.customer.InvoiceApplyOrderGoodsFocusScoreParams;
import cn.superdesk.uniorder.dto.param.invoice.customer.InvoiceApplyOrderGoodsFocusUnifiedParams;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.ViewDzOrder;
import cn.superdesk.uniorder.dto.vo.invoice.customer.*;
import cn.superdesk.uniorder.dto.vo.score.ScoreOrderReconciliationNotYetVo;
import cn.superdesk.uniorder.event.invoiceApplyTrigger.TailUpdateAccountingOrderInvoiceStatusEvent;
import cn.superdesk.uniorder.service.base.ScoreOrderService;
import cn.superdesk.uniorder.service.base.UnifiedOrderGoodsService;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyService;
import cn.superdesk.uniorder.service.invoice.customer.InvoiceApplyXGoodsService;
import cn.superdesk.uniorder.service.organisation.SysEnterpriseExtInvoiceService;
import cn.superdesk.uniorder.service.organisation.SysEnterpriseService;
import cn.superdesk.uniorder.service.setting.UnifiedSnConfigService;
import cn.superdesk.uniorder.service.sys.SysOderUserService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.BeansException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;


@Slf4j
@Service
public class InvoiceApplyServiceImpl implements InvoiceApplyService {


	@Autowired
	private InvoiceApplyMapper                    invoiceApplyMapper;
	@Autowired
	private InvoiceApplyMapperEx                  invoiceApplyMapperEx;
	@Autowired
	private InvoiceApplyMapperExScore             invoiceApplyMapperExScore;
	@Autowired
	private InvoiceApplyMapperExUnified           invoiceApplyMapperExUnified;
	@Autowired
	private InvoiceApplyMapperExUnifiedCompatible invoiceApplyMapperExUnifiedCompatible;
	@Autowired
	private InvoiceApplyMapperExUnifiedClear      invoiceApplyMapperExUnifiedClear;


	@Autowired
	private InvoiceApplyXGoodsMapper   invoiceApplyXGoodsMapper;
	@Autowired
	private InvoiceApplyXGoodsMapperEx invoiceApplyXGoodsMapperEx;
	@Autowired
	private InvoiceApplyXGoodsService  invoiceApplyXGoodsService;

	@Autowired
	private AccountingUnifiedCustomerMapper   accountingUnifiedCustomerMapper;
	@Autowired
	private AccountingUnifiedCustomerMapperEx accountingUnifiedCustomerMapperEx;

	@Autowired
	private AccountingUnifiedCustomerOrderGoodsMapper   accountingUnifiedCustomerOrderGoodsMapper;
	@Autowired
	private AccountingUnifiedCustomerOrderGoodsMapperEx accountingUnifiedCustomerOrderGoodsMapperEx;


	@Autowired
	private AccountingScoreCustomerMapper accountingScoreCustomerMapper;

	@Autowired
	private ScoreOrderService        scoreOrderService;
	@Autowired
	private UnifiedOrderCreditMapper unifiedOrderCreditMapper;

	@Autowired
	private UnifiedOrderGoodsService unifiedOrderGoodsService;

	@Autowired
	private SysOderUserService sysOderUserService;

//	@Autowired
//	private SysConfigService     sysConfigService;

	@Autowired
	private UnifiedSnConfigService unifiedSnConfigService;


	@Autowired
	private ExpressCompanyMapper expressCompanyMapper;


	@Autowired
	private SysEnterpriseService           sysEnterpriseService;
	@Autowired
	private SysEnterpriseExtInvoiceService sysEnterpriseExtInvoiceService;


	public int updateInvoiceApplyByPrimaryKeySelective(InvoiceApply invoiceApply) {

		return invoiceApplyMapper.updateByPrimaryKeySelective(invoiceApply);
	}

	public int updateFieldBackAccountStatusByCheckRatio(Integer fullCount, Integer seizeCount, Long invoiceApplyId) {

		// return 为 ret 标记 不是计算数量
		if (fullCount.compareTo(0) <= 0) {
			return 0;
		}

		if (seizeCount.compareTo(0) <= 0) {
			return 0;
		}

		InvoiceApplyBackAccountStatusEnum invoiceApplyBackAccountStatusEnum;
		if (fullCount.compareTo(seizeCount) == 0) {
			invoiceApplyBackAccountStatusEnum = InvoiceApplyBackAccountStatusEnum.已回款;
		} else {
			invoiceApplyBackAccountStatusEnum = InvoiceApplyBackAccountStatusEnum.部分回款;
		}

		return updateFieldBackAccountStatusByInvoiceApplyId(invoiceApplyId, invoiceApplyBackAccountStatusEnum);

	}

	public int updateFieldBackAccountStatusByInvoiceApplyId(Long invoiceApplyId, InvoiceApplyBackAccountStatusEnum invoiceApplyBackAccountStatusEnum) {
//		InvoiceApplyExample example = new InvoiceApplyExample();
//		example.createCriteria()
//				.andIdEqualTo(invoiceApplyId);
		InvoiceApply invoiceApply = new InvoiceApply();
		invoiceApply.setId(invoiceApplyId);
		invoiceApply.setBackAccountStatus(invoiceApplyBackAccountStatusEnum.getKey());

		return invoiceApplyMapper.updateByPrimaryKeySelective(invoiceApply);
	}

	/**
	 * 发票申请 提交 前的 操作 ---- 订单维度
	 * 过滤 已经申请开票的商品
	 *
	 * @param params
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	public List<InvoiceApplySelectScoreVo> invoiceApplySelectFocusUnifiedDimOrder(Map<String, Object> params) throws UnifiedOrderRuntimeException {
		return invoiceApplyMapperExUnified.invoiceApplySelectFocusUnifiedDimOrder(params);
	}

	/**
	 * 发票申请 提交 前的 操作 ---- 商品维度
	 *
	 * @param params
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	public List<InvoiceApplySelectScoreVo> invoiceApplySelectFocusUnifiedDimGoods(Map<String, Object> params) throws UnifiedOrderRuntimeException {
		return invoiceApplyMapperExUnified.invoiceApplySelectFocusUnifiedDimGoods(params);
	}

	/**
	 * 发票申请 提交 前的 操作 ---- 流水维度
	 * 过滤 已经申请开票的流水
	 *
	 * @param criteria
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	public List<InvoiceApplySelectScoreVo> invoiceApplySelectFocusScoreDimCredit(ExportExcelInvoiceApplyQueryCriteria criteria) throws UnifiedOrderRuntimeException {
		return invoiceApplyMapperExScore.invoiceApplySelectFocusScoreDimCredit(criteria);
	}


	/**
	 * 发票审核 opt btn 提交
	 *
	 * @param token
	 * @param params
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	@Transactional
	public TailUpdateAccountingOrderInvoiceStatusEvent invoiceApply(String token, InvoiceApplyCommonParams params) throws UnifiedOrderRuntimeException {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);


		InvoiceApply invoiceApplyEntity = new InvoiceApply();

		invoiceApplyEntity.setInvoiceNo(unifiedSnConfigService.getCustomerInvoiceApplySnBySnowflake());

		// 对账单 类型:1-一般;2-积分;
		invoiceApplyEntity.setAccountingOrderType(params.getAccountingOrderType());
		// 对账单 创建维度:0-订单;1-商品;2-流水;
		invoiceApplyEntity.setDimCreateBy(params.getDimCreateBy());

		invoiceApplyEntity.setInvoiceTitle(params.getInvoiceTitle());
		invoiceApplyEntity.setInvoiceType(params.getInvoiceType());

		invoiceApplyEntity.setTaxRate(params.getTaxRate());

		invoiceApplyEntity.setInvoiceApplyAmount(params.getInvoiceApplyAmount());
		invoiceApplyEntity.setFreeAmount(params.getFreeAmount());
		invoiceApplyEntity.setRealAmount(params.getRealAmount());
		invoiceApplyEntity.setNoCheckCount(params.getNoCheckCount());

		invoiceApplyEntity.setRemark(params.getRemark());

		invoiceApplyEntity.setApplyUserId(loginSysUser.getSysUserId());
		invoiceApplyEntity.setApplyTime(AnDateHelper.getNow());

		invoiceApplyEntity.setRemark2("");

		invoiceApplyMapper.insertSelective(invoiceApplyEntity);

		List<Long> toDoUpdateAccountingOrderInvoiceStatusList = new ArrayList<>();


		switch (AccountingOrderTypeDimEnum.get(params.getAccountingOrderType())) {
			case 一般订单:

				List<InvoiceApplyOrderGoodsFocusUnifiedParams> applyOrderGoodsFocusUnifiedParamsList = params.getApplyOrderGoodsFocusUnifiedParamsList();

				if (AnCollectionUtils.isNotEmpty(applyOrderGoodsFocusUnifiedParamsList)) {

					toDoUpdateAccountingOrderInvoiceStatusList = applyOrderGoodsFocusUnifiedParamsList.stream()
							.filter(AnLamdaUtils.distinctByKey(o -> o.getAccountingOrderId()))
							.map(o -> o.getAccountingOrderId()).collect(Collectors.toList());

					// TODO 如果有多个对账单 最好还是 验证一下 是否同一个企业为好
					for (InvoiceApplyOrderGoodsFocusUnifiedParams invoiceApplyOrderGoodsFocusUnifiedParams : applyOrderGoodsFocusUnifiedParamsList) {

						InvoiceApplyXGoods invoiceOrder = new InvoiceApplyXGoods();

						// 反正都是 iterator 就写这里了
//						toDoUpdateAccountingOrderInvoiceStatusList.add(invoiceApplyOrderGoodsFocusUnifiedParams.getAccountingOrderId());

						// 获取刚刚insert的Id
						invoiceOrder.setInvoiceApplyId(invoiceApplyEntity.getId());

						invoiceOrder.setAccountingOrderType(AccountingOrderTypeDimEnum.一般订单.getKey());
						// 在 controller 写死了
						invoiceOrder.setDimCreateBy(params.getDimCreateBy());

						// unified_order_goods.id 非第三方系统传过来的goodsId 是系统自增生成的 Id
						invoiceOrder.setUnifiedOrderGoodsId(invoiceApplyOrderGoodsFocusUnifiedParams.getUnifiedOrderGoodsId());
						// accounting_unified_customer_order.id 中间表的 订单Id
						invoiceOrder.setUnifiedOrderId(invoiceApplyOrderGoodsFocusUnifiedParams.getUnifiedOrderId());
						// accounting_unified_customer.id
						invoiceOrder.setAccountingOrderId(invoiceApplyOrderGoodsFocusUnifiedParams.getAccountingOrderId());

						invoiceApplyXGoodsMapper.insertSelective(invoiceOrder);

					}
				}
				break;

			case 积分订单:

				List<InvoiceApplyOrderGoodsFocusScoreParams> applyOrderGoodsFocusScoreParamsList = params.getApplyOrderGoodsFocusScoreParamsList();

				if (AnCollectionUtils.isNotEmpty(applyOrderGoodsFocusScoreParamsList)) {

					toDoUpdateAccountingOrderInvoiceStatusList = applyOrderGoodsFocusScoreParamsList.stream()
							.filter(AnLamdaUtils.distinctByKey(o -> o.getAccountingOrderId()))
							.map(o -> o.getAccountingOrderId())
							.collect(Collectors.toList());

					for (InvoiceApplyOrderGoodsFocusScoreParams invoiceApplyOrderGoodsFocusScoreParams : applyOrderGoodsFocusScoreParamsList) {

						InvoiceApplyXGoods invoiceOrder = new InvoiceApplyXGoods();

						// 反正都是 iterator 就写这里了
//						toDoUpdateAccountingOrderInvoiceStatusList.add(invoiceApplyOrderGoodsFocusScoreParams.getAccountingOrderId());

						// 获取刚刚insert的Id
						invoiceOrder.setInvoiceApplyId(invoiceApplyEntity.getId());

						invoiceOrder.setAccountingOrderType(AccountingOrderTypeDimEnum.积分订单.getKey());
						// 在 controller 写死了
						invoiceOrder.setDimCreateBy(params.getDimCreateBy());

						invoiceOrder.setUnifiedOrderCreditId(invoiceApplyOrderGoodsFocusScoreParams.getUnifiedOrderCreditId());
						// unified_order_goods.id 非商城传过来的goodsId 是系统自增生成的 Id
						invoiceOrder.setUnifiedOrderGoodsId(invoiceApplyOrderGoodsFocusScoreParams.getUnifiedOrderGoodsId());
						// accounting_unified_customer_order.id 中间表的 订单Id
						invoiceOrder.setUnifiedOrderId(invoiceApplyOrderGoodsFocusScoreParams.getUnifiedOrderId());
						// accounting_unified_customer.id
						invoiceOrder.setAccountingOrderId(invoiceApplyOrderGoodsFocusScoreParams.getAccountingOrderId());

						invoiceApplyXGoodsMapper.insertSelective(invoiceOrder);

						// 更新 流水的开票 状态
						UnifiedOrderCredit update4InvoiceApplyStatus = new UnifiedOrderCredit();
						update4InvoiceApplyStatus.setId(invoiceApplyOrderGoodsFocusScoreParams.getUnifiedOrderCreditId());
						update4InvoiceApplyStatus.setInvoiceApplyStatus(UnifiedOrderCreditInvoiceApplyStatusEnum.已申请.getKey());
						unifiedOrderCreditMapper.updateByPrimaryKeySelective(update4InvoiceApplyStatus);

					}
				}

				break;
		}


		/**
		 * 通过 对账单 ids(得出受影响的对账单 ids)
		 * 再去 较验 对账单 发票状态
		 */
//		processTailUpdateAccountingOrderInvoiceStatus(toDoUpdateAccountingOrderInvoiceStatusList, AccountingOrderTypeDimEnum.get(params.getAccountingOrderType()));
//		invoiceApplyTriggerEventPublisher.triggerTailUpdateAccountingOrderInvoiceStatus(toDoUpdateAccountingOrderInvoiceStatusList, AccountingOrderTypeDimEnum.get(params.getAccountingOrderType()));

		return TailUpdateAccountingOrderInvoiceStatusEvent
				.builder()
				.affectedAccountingOrderIds(toDoUpdateAccountingOrderInvoiceStatusList)
				.dim(AccountingOrderTypeDimEnum.get(params.getAccountingOrderType()))
				.build();

	}


	/****************************************** 开票申请 列表的导出Excel数据 start ******************************************/
	/**
	 * 客户结算-发票申请管理-opt 导出报表 TODO 目前这个有个问题 Mapper 里边还是 订单维度的 表关联方式 mark by linjinyu 20210317 发现
	 *
	 * @param params
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	public List<ExportExcelInvoiceApplyForceUnifiedDimGoodsVo> findInvoiceApplyFocusUnifiedDimGoods(Map<String, Object> params) throws UnifiedOrderRuntimeException {
		return invoiceApplyMapperExUnified.exportExcelInvoiceApplyFocusUnified(params);
	}

	/**
	 * 积分结算-发票申请管理-opt 导出报表
	 *
	 * @param criteria
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	public List<ExportExcelInvoiceApplyForceScoreDimCreditVo> findInvoiceApplyFocusScoreDimCredit(ExportExcelInvoiceApplyQueryCriteria criteria) throws UnifiedOrderRuntimeException {


		List<ExportExcelInvoiceApplyForceScoreDimCreditVo> result = invoiceApplyMapperExScore.exportExcelInvoiceApplyFocusScore(criteria);

		List<Long> outVirtIds = result.stream().map(ExportExcelInvoiceApplyForceScoreDimCreditVo::getEnterpriseId).distinct().collect(Collectors.toList());

		Map<Long, SysEnterprise>           optionSysEnterprise           = sysEnterpriseService.findByOutVirtIdsConvertKV(outVirtIds);
		Map<Long, SysEnterpriseExtInvoice> optionSysEnterpriseExtInvoice = sysEnterpriseExtInvoiceService.findByOutVirtIdsConvertKV(outVirtIds);


		// TODO  "enterpriseName", "companyName", "invoiceBank", "invoiceAccount"
		// TODO  "购方名称", "购方税号", "购方地址电话", "购方银行账号"

		for (ExportExcelInvoiceApplyForceScoreDimCreditVo vo : result) {

			if (null != optionSysEnterprise.get(vo.getEnterpriseId())) {
				vo.setEnterpriseName(optionSysEnterprise.get(vo.getEnterpriseId()).getEnterpriseName());
			}

			if (null != optionSysEnterpriseExtInvoice.get(vo.getEnterpriseId())) {

				vo.setCompanyName(optionSysEnterpriseExtInvoice.get(vo.getEnterpriseId()).getCompanyName());

				vo.setTaxpayersIDCode(optionSysEnterpriseExtInvoice.get(vo.getEnterpriseId()).getTaxpayersIDCode());

				vo.setInvoiceBank(optionSysEnterpriseExtInvoice.get(vo.getEnterpriseId()).getInvoiceBank());
				vo.setInvoiceAccount(optionSysEnterpriseExtInvoice.get(vo.getEnterpriseId()).getInvoiceAccount());
			}

			FixUnifiedOrderGoodsTaxRate(vo);

		}

		return result;
	}

	private void FixUnifiedOrderGoodsTaxRate(ExportExcelInvoiceApplyForceScoreDimCreditVo vo) {

		if (null == vo.getUnifiedOrderGoodsTaxRate()) {
			vo.setUnifiedOrderGoodsTaxRate(BigDecimal.ZERO);
		} else {
			BigDecimal temp = vo.getUnifiedOrderGoodsTaxRate().divide(new BigDecimal(100), 2, BigDecimal.ROUND_HALF_UP);
			vo.setUnifiedOrderGoodsTaxRate(temp);
		}


		log.info("修正税率 : {}", vo.getUnifiedOrderGoodsTaxCode());
	}

	/****************************************** 开票申请 列表的导出Excel数据   end ******************************************/


	/****************************************** 发票申请管理 start ******************************************/
	@Override
	public R<List<InvoiceApplyPage>> findViewByPageFocusUnified(Map<String, Object> params, int pageNum, int pageSize) throws UnifiedOrderRuntimeException {

		PageHelper.startPage(pageNum, pageSize);

		List<InvoiceApplyPage> invoiceApplyPageList = invoiceApplyMapperExUnified.selectByCondition(params);

		PageInfo<InvoiceApplyPage> page = new PageInfo<InvoiceApplyPage>(invoiceApplyPageList);
		PageHelper.clearPage();

		return new R<List<InvoiceApplyPage>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), invoiceApplyPageList);
	}

	@Override
	public InvoiceApplyDataVo findViewHeadDataFocusUnified(Map<String, Object> params) throws UnifiedOrderRuntimeException {
		return invoiceApplyMapperExUnified.findViewHeadDataFocusUnified(params);
	}

	@Override
	public R<List<InvoiceApplyPage>> findViewByPageFocusScore(ExportExcelInvoiceApplyQueryCriteria criteria, int pageNum, int pageSize) throws UnifiedOrderRuntimeException {

		PageHelper.startPage(pageNum, pageSize);

		List<InvoiceApplyPage>     invoiceApplyPageList = invoiceApplyMapperExScore.findViewByPage(criteria);
		PageInfo<InvoiceApplyPage> page                 = new PageInfo<InvoiceApplyPage>(invoiceApplyPageList);
		PageHelper.clearPage();

		return new R<List<InvoiceApplyPage>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), invoiceApplyPageList);
	}

	@Override
	public InvoiceApplyDataVo findViewHeadDataFocusScore(ExportExcelInvoiceApplyQueryCriteria criteria) throws UnifiedOrderRuntimeException {
		return invoiceApplyMapperExScore.findViewHeadData(criteria);
	}
	/****************************************** 发票申请管理   end ******************************************/


	/**
	 * 审核?-操作 opt 同意?拒绝 TODO 写死 1-未审核;2-同意;3-拒绝;
	 *
	 * @param params
	 * @param loginSysUser
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	@Transactional
	public TailUpdateAccountingOrderInvoiceStatusEvent opAudit(Map<String, Object> params, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException {

		List<Long> affectedAccountingOrderIds = new ArrayList<>();

//		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		Long    invoiceApplyId = AnLongUtils.getLong(params.get("id"));
		Integer auditStatus    = AnIntegerUtils.getInteger(params.get("auditStatus"));

		InvoiceApply invoiceApply = invoiceApplyMapper.selectByPrimaryKey(invoiceApplyId);

		if (null == invoiceApply) {
			return TailUpdateAccountingOrderInvoiceStatusEvent
					.builder()
					.affectedAccountingOrderIds(affectedAccountingOrderIds)
					.dim(AccountingOrderTypeDimEnum.未知订单)
					.build();
		}

		// 更新 审核人 信息
		InvoiceApply invoiceApply4Update = new InvoiceApply();

		invoiceApply4Update.setId(invoiceApplyId);
		invoiceApply4Update.setAuditUserId(loginSysUser.getSysUserId());
		invoiceApply4Update.setAuditTime(AnDateHelper.getNow());
		invoiceApply4Update.setAuditStatus(auditStatus);

		invoiceApplyMapper.updateByPrimaryKeySelective(invoiceApply4Update);


		/****************************************** 连带更新这个发票申请 的 对账单 的 开发票状态 ******************************************/

//		InvoiceApplyAuditStatusEnum
//		未审核(1, "未审核"),
//		同意(2, "同意"),
//		拒绝(3, "拒绝");
		// TODO 写死 1-未审核;2-同意;3-拒绝;
		if (auditStatus.compareTo(InvoiceApplyAuditStatusEnum.拒绝.getKey()) == 0) {

			// 得出受影响的对账单 ids
			affectedAccountingOrderIds = invoiceApplyXGoodsService.getAffectedAccountingOrderIdsByInvoiceApplyId(invoiceApplyId);

			/**
			 * 通过 对账单 ids(得出受影响的对账单 ids)
			 * 再去 较验 对账单 发票状态
			 */
//			processTailUpdateAccountingOrderInvoiceStatus(affectedAccountingOrderIds, AccountingOrderTypeDimEnum.get(invoiceApply.getAccountingOrderType()));
//			invoiceApplyTriggerEventPublisher.triggerTailUpdateAccountingOrderInvoiceStatus(affectedAccountingOrderIds, AccountingOrderTypeDimEnum.get(invoiceApply.getAccountingOrderType()));


		}

		return TailUpdateAccountingOrderInvoiceStatusEvent
				.builder()
				.affectedAccountingOrderIds(affectedAccountingOrderIds)
				.dim(AccountingOrderTypeDimEnum.get(invoiceApply.getAccountingOrderType()))
				.build();

		/****************************************** 连带更新这个发票申请 的 对账单 的 开发票状态 ******************************************/
	}


	/**
	 * 通过 对账单 ids 来 再查
	 * 再去 较验 对账单 发票状态
	 *
	 * @param affectedAccountingOrderIds
	 */
	public void processTailUpdateAccountingOrderInvoiceStatus(List<Long> affectedAccountingOrderIds, AccountingOrderTypeDimEnum dim) {

		// 提前结束
		if (AnCollectionUtils.isEmpty(affectedAccountingOrderIds)) {
			return;
		}

		// xml
		// 0 未开票
		// 1 全部开票
		// 2 部分开票
		// 0-未开票;1-已开票;2-部分开票;

		for (Long accountingOrderId : affectedAccountingOrderIds) {

			switch (dim) {
				case 一般订单:
					// 更新 对账单 开票状态
					invoiceApplyXGoodsService.checkInvoiceStatusByAccountingOrderIdAndUpdateAccountingEntityFocusUnified(accountingOrderId);
					break;
				case 积分订单:
					// TODO 按 对账单id 去查 发票状态 的方法还没有做
					// 更新 对账单 开票状态
					invoiceApplyXGoodsService.checkInvoiceStatusByAccountingOrderIdAndUpdateAccountingEntityFocusScore(accountingOrderId);
					break;
			}
		}
	}


	private static String fetchGroupKeyByInvoiceOrderIdAndOrderSnAndDzOrderIdAndDzOrderGoodsId(ViewDzOrder viewDzOrder) {
		return viewDzOrder.getInvoiceOrderId()
				+ "_" + viewDzOrder.getOrderSn()
				// aucuo.id AS dz_order_id
				+ "_" + viewDzOrder.getDzOrderId()
				+ "_" + viewDzOrder.getDzOrderGoodsId();
	}

	private static String fetchGroupKeyByOrderSnAndUnifiedOrderGoodsId(UnifiedOrderGoods unifiedOrderGoods) {

		return unifiedOrderGoods.getOrderSn()
				+ "_" + unifiedOrderGoods.getId();
	}

	private static BigDecimal fetchGroupValue(UnifiedOrderGoods unifiedOrderGoods) {
		return unifiedOrderGoods.getPrice().multiply(new BigDecimal(unifiedOrderGoods.getQuantity()));
	}

	/**
	 * 反转
	 *
	 * @param mapByGroupKeyAndGroupValue
	 * @return
	 */
	private static Map<BigDecimal, String> reverse(Map<String, BigDecimal> mapByGroupKeyAndGroupValue) {

		Map<BigDecimal, String> mapReverseByGroupKeyAndGroupValue = new HashMap<>();

		for (Map.Entry<String, BigDecimal> _entry : mapByGroupKeyAndGroupValue.entrySet()) {
			mapReverseByGroupKeyAndGroupValue.put(_entry.getValue(), _entry.getKey());
		}

		return mapReverseByGroupKeyAndGroupValue;
	}

	private static List<BigDecimal> aggregate(Map<String, BigDecimal> mapByGroupKeyAndGroupValue) {

		List<BigDecimal> aggregateInput = new ArrayList<>();

		for (Map.Entry<String, BigDecimal> _entry : mapByGroupKeyAndGroupValue.entrySet()) {
			aggregateInput.add(_entry.getValue());
		}

		return aggregateInput;
	}


	/**
	 * TODO 重构 mark by linjinyu at 20210201
	 *
	 * @param invoiceApplyId
	 * @return
	 */
	public List<ViewDzOrder> findInvoiceApplyDetail20210201Dim1Unified2Goods(Long invoiceApplyId) {

		// invoiceApply.getRealAmount() 老的版本是没有数值的
		InvoiceApply invoiceApply = findById(invoiceApplyId);

		List<ViewDzOrder> dzOrders = new ArrayList<>();


		// 此地方要加工 mark by linjinyu at 20210401
		dzOrders = invoiceApplyMapperExUnifiedCompatible.findInvoiceApplyDetail20210201Dim1Unified2Goods(invoiceApplyId);


		// 这个证明是个老版本 要再分支做
		if (null == invoiceApply.getRealAmount()) {
			return dzOrders;
		}

		if (AnCollectionUtils.isEmpty(dzOrders)) {
			return dzOrders;
		}

		// TODO 要添加 验证 看明细加起来是否等于开票申请的金额 可以改装成 开票申请的验证程序

		// 包含两个情况
		// 1. 关联不到uog
		// 2. 只是单纯的金额不对
		BigDecimal goodsAmount = dzOrders
				.stream()
				.map(item -> item.getPrice() == null ? BigDecimal.ZERO : item.getPrice().multiply(new BigDecimal(item.getTotal())))
				.reduce(BigDecimal.ZERO, BigDecimal::add);

//		if (invoiceApply.getRealAmount().compareTo(goodsAmount) != 0) {
//
//			// TODO
//
//			List<String> processOrderSns = dzOrders.stream()
//					.filter(o -> null != o.getOrderSn())
//					.filter(AnLamdaUtils.distinctByKey(o -> o.getOrderSn()))
//					.map(o -> o.getOrderSn())
//					.collect(Collectors.toList());
//
//			// TODO 先写死只处理一个订单的
//			// TODO 还是不能确定 宣布 死亡 mark by linjinyu at 202102011919
////			if (processOrderSns.size() == 1) {
////
////				List<UnifiedOrderGoods> processUnifiedOrderGoodsList = unifiedOrderGoodsService.findByOrderSns(processOrderSns);
////
//////			collect(Collectors.toMap(UnifiedOrderGoods::getId, v -> v, (k, v) -> v));
////
////				Map<String, BigDecimal> mapByGroupKeyAndGroupValue = processUnifiedOrderGoodsList.stream().collect(Collectors.toMap(o -> fetchGroupKeyByOrderSnAndUnifiedOrderGoodsId(o), o -> fetchGroupValue(o)));
////
////				Map<BigDecimal, String> mapReverseByGroupKeyAndGroupValue = reverse(mapByGroupKeyAndGroupValue);
////
////				log.info("\n\n{}\n{}\n\n", JsonUtils.toJson(mapByGroupKeyAndGroupValue), JsonUtils.toJson(mapReverseByGroupKeyAndGroupValue));
////
////				BigDecimal       eqTarget       = invoiceApply.getRealAmount();
////				List<BigDecimal> aggregateInput = aggregate(mapByGroupKeyAndGroupValue);
////
////				Algorithm001 algorithm001 = new Algorithm001();
////
////				List<BigDecimal> result = algorithm001.run(aggregateInput, eqTarget);
////
////				log.info("\n\n{}\n\n", JsonUtils.toJson(result));
////
////				// TODO
////
////				for (BigDecimal toBeUnifiedOrderGoodsId : result) {
////
////					String orderSnJoinUnifiedOrderGoodsIdString = mapReverseByGroupKeyAndGroupValue.get(toBeUnifiedOrderGoodsId);
////
////					String[] orderSnJoinUnifiedOrderGoodsIdArray = orderSnJoinUnifiedOrderGoodsIdString.split("_");
////
////					List<Predicate<ViewDzOrder>> predicatesByTransportGoods = new ArrayList<>();
////					predicatesByTransportGoods.add(r -> r.getOrderSn() != null && r.getOrderSn().equals(orderSnJoinUnifiedOrderGoodsIdArray[0]));
////
////					List<ViewDzOrder> predicatesByPlusGoodsFilter = AnLamdaUtils.filters(dzOrders, predicatesByTransportGoods);
////
////				}
////
////
////			}
//
//
//		}


		/****************************************** 不要看系列 start ******************************************/
//		if (AnCollectionUtils.isEmpty(dzOrders)) {
		// 方法2
//						dzOrders = invoiceApplyMapperExUnifiedCompatible.findInvoiceApplyDetailOldDim1Unified2Goods(invoiceApplyDetailVo.getId());
//				FROM
//				invoice_order invo
//				LEFT JOIN accounting_unified_customer aucu ON invo.dz_id = aucu.id
//				LEFT JOIN accounting_unified_customer_order auco ON invo.dz_order_id = auco.id
//				LEFT JOIN accounting_unified_customer_order_goods aucog ON auco.id = aucog.dz_order_id
//				LEFT JOIN invoice_bank invb ON invo.bank_id = invb.id
//						log.info("\n\n\n 方法1 : {}", dzOrders.size());
		// 方法3
//				<!-- 客户结算-发票申请-查看详情 OLD 等 findInvoiceApplyDetailNewDim1Unified2Goods -->
//				dzOrders = invoiceApplyMapperEx.findDzOrderByGoodId(invoiceApplyDetailVo.getId());
//		}
		/****************************************** 不要看系列   end ******************************************/


		return dzOrders;


	}

	/**
	 * 前端-客户结算-开票申请-详情
	 * 前端-客户结算-发票管理-详情
	 *
	 * @param params
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	public InvoiceApplyDetailDimGoodsVo getUnifiedCustomerInvoice2GoodsDetail(Map<String, Object> params) throws UnifiedOrderRuntimeException {

		log.info("\n前端-客户结算-开票申请-详情\n" +
				"前端-客户结算-发票管理-详情\n" +
				"params : {}\n", JsonUtils.toJson(params));

//		eg:
//		// 发票申请Id
//		params.put("id", getLong("id"));

		Long invoiceApplyId = AnLongUtils.getLong(params.get("id"));

		InvoiceApply invoiceApply = invoiceApplyMapper.selectByPrimaryKey(invoiceApplyId);

		if (null == invoiceApply) {
			return null;
		}

		log.info("\n前端-客户结算-发票申请-详情\n{}", JsonUtils.toJson(invoiceApply));


		/****************************************** 最终返回 start ******************************************/
		InvoiceApplyDetailDimGoodsVo finalResponseVo = new InvoiceApplyDetailDimGoodsVo();
		/****************************************** 最终返回   end ******************************************/

		/****************************************** 查出开票详情 main 部分 TODO 待优化 重构 start ******************************************/

		// TODO 有问题的用法
//		params : {"id":6127}
		List<InvoiceApplyPage> invoiceApplyPageList = invoiceApplyMapperExUnified.selectByCondition(params);
		/****************************************** 查出开票详情 main 部分 TODO 待优化 重构 start ******************************************/


		if (AnCollectionUtils.isNotEmpty(invoiceApplyPageList)) {

			InvoiceApplyPage invoiceApplyPage = invoiceApplyPageList.get(0);

			// 问题 mark by linjinyu at 20210312
//			AnBeanUtils.copyProperties(invoiceApplyPage, invoiceApplyDetailVo);
			// 问题 mark by linjinyu at 20210610
//			finalResponseVo = AnBeanUtils.copy(invoiceApplyPage, InvoiceApplyDetailDimGoodsVo.class);
			// 先修改成这样，有空再重构
			Dto2DtoConvertUtils.invoiceApplyPage2InvoiceApplyDetailDimGoodsVo(invoiceApplyPage, finalResponseVo);

			// 附加信息
			finalResponseVo.setAuditStatusName(InvoiceApplyAuditStatusEnum.get(finalResponseVo.getAuditStatus()).getDesc());// 审核状态 1-未审核;2-已同意;3-已拒绝
			finalResponseVo.setMakeInvoiceStatusName(InvoiceApplyMakeInvoiceStatusEnum.get(finalResponseVo.getMakeInvoiceStatus()).getDesc());// 开票状态 0-未开票;1-已开票;2-重新开票;
			finalResponseVo.setMailTickStatusName(InvoiceApplyMailTickStatusEnum.get(finalResponseVo.getMailTickStatus()).getDesc());// 寄票状态:0-未寄票;1-已寄票
			finalResponseVo.setBackAccountStatusName(InvoiceApplyBackAccountStatusEnum.get(finalResponseVo.getBackAccountStatus()).getDesc());// 回款状态 0-未回款;1-部分回款;2全部回款;


			// 对账单类型 1-一般;2-积分;
			//		invoiceApply.getAccountingOrderType();
			// 对账单 创建维度:0-订单;1-商品;2-流水;
			//		invoiceApply.getDimCreateBy();


			switch (AccountingOrderDimCreateByEnum.get(invoiceApply.getDimCreateBy())) {
				case 订单:

					List<ViewDzOrder> dzOrders = new ArrayList<>();

					/****************************************** 填充明细 TODO 重构 start ******************************************/

					dzOrders = findInvoiceApplyDetail20210201Dim1Unified2Goods(finalResponseVo.getId());

					log.info("\n\n\n 方法1 : {}", dzOrders.size());


					/****************************************** 填充明细 TODO 重构   end ******************************************/

					/****************************************** 重构1 20201113 start ******************************************/

					// LEFT JOIN sys_oder_user AS real_order_user ON auco.realname_id = real_order_user.user_id
					// LEFT JOIN sys_oder_user AS examine_order_user ON auco.examine_id = examine_order_user.user_id
					// real_order_user.realname AS realname,
					// examine_order_user.realname AS examine_name,

					/****************************************** 填充 人的信息 start ******************************************/
					// 得出 排除空
					List<Long> sysOrderUserIds1 = dzOrders.stream().filter(o -> null != o.getRealnameId()).filter(AnLamdaUtils.distinctByKey(o -> o.getRealnameId())).map(o -> o.getRealnameId()).collect(Collectors.toList());
					List<Long> sysOrderUserIds2 = dzOrders.stream().filter(o -> null != o.getExamineId()).filter(AnLamdaUtils.distinctByKey(o -> o.getExamineId())).map(o -> o.getExamineId()).collect(Collectors.toList());

					List<Long> sysOrderUserIdsAll = new ArrayList<>();

					sysOrderUserIdsAll.addAll(sysOrderUserIds1);
					sysOrderUserIdsAll.addAll(sysOrderUserIds2);

					List<Long> sysOrderUserIdsFilter = new ArrayList<>();
					sysOrderUserIdsFilter = sysOrderUserIdsAll.parallelStream().distinct().collect(Collectors.toList());

					Map<Long, SysOderUser> resultSysUser = sysOderUserService.convertSysOderUserIds2MapKeyValue(sysOrderUserIdsFilter);

					for (ViewDzOrder vo : dzOrders) {

						if (null != vo.getRealnameId() && null != resultSysUser.get(vo.getRealnameId())) {
							vo.setRealname(resultSysUser.get(vo.getRealnameId()).getRealname());
						} else {
							vo.setRealname("-");
						}

						if (null != vo.getExamineId() && null != resultSysUser.get(vo.getExamineId())) {
							vo.setExamineName(resultSysUser.get(vo.getExamineId()).getRealname());
						} else {
							vo.setExamineName("-");
						}
					}
					/****************************************** 填充 人的信息   end ******************************************/


					/****************************************** 重构1 20201113   end ******************************************/


					finalResponseVo.setDzOrders(dzOrders);
					break;
				case 商品:

					List<InvoiceApplyDetailDimGoodsV3Vo> invoiceApplyDetailDimGoodsV3VoList = new ArrayList<>();

					invoiceApplyDetailDimGoodsV3VoList = invoiceApplyMapperExUnifiedClear.findInvoiceApplyDetailInnerInfo(invoiceApplyId);

					// 附加信息
					invoiceApplyDetailDimGoodsV3VoList.forEach(AnLamdaUtils.consumerWithIndex((item, index) -> {
						item.setRowNum(index + 1);
					}));

					finalResponseVo.setInnerOrderJoinGoodsList(invoiceApplyDetailDimGoodsV3VoList);

					// 补充信息 mark by linjinyu at 20210526
					// 开票信息:
					// 1. 对账单编号 accountingOrderSn -> private List<String> accountingOrderSns;
					// 1. 企业信息   purchaseVirtName  -> private List<String> outVirtNames;
					// 1. 订单数     orderSn -> private Integer orderSnStatisticsCount;
					// 1. 账单金额? 开票金额 realAmount? goodsAmount累加? -> private BigDecimal invoicedStatisticsCountAmount;


					List<String> accountingOrderSns = invoiceApplyDetailDimGoodsV3VoList.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getAccountingOrderSn())).map(o -> o.getAccountingOrderSn()).collect(Collectors.toList());
					finalResponseVo.setAccountingOrderSns(accountingOrderSns);
					finalResponseVo.setAccountingOrderSnsStr(AnStringUtils.stringListConvertToString(accountingOrderSns));

					List<String> outVirtNames = invoiceApplyDetailDimGoodsV3VoList.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getPurchaseVirtName())).map(o -> o.getPurchaseVirtName()).collect(Collectors.toList());
					finalResponseVo.setOutVirtNamesStr(AnStringUtils.stringListConvertToString(outVirtNames));
					finalResponseVo.setOutVirtNames(outVirtNames);

					// orderSnCount
					Long orderSnStatisticsCount = invoiceApplyDetailDimGoodsV3VoList.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getOrderSn())).map(o -> o.getOrderSn()).collect(Collectors.counting());
					finalResponseVo.setOrderSnStatisticsCount(orderSnStatisticsCount.longValue());

					BigDecimal invoicedStatisticsCountAmount = invoiceApplyDetailDimGoodsV3VoList
							.stream()
							.map(item -> item.getGoodsAmount() == null ? BigDecimal.ZERO : item.getGoodsAmount())
							.reduce(BigDecimal.ZERO, BigDecimal::add);
					finalResponseVo.setInvoicedStatisticsCountAmount(invoicedStatisticsCountAmount);

					break;

				case 流水:
					throw new UnifiedOrderRuntimeException(500, "客户结算(对账) 发票 目前不支持 流水维度");

				default:
					break;
			}


			return finalResponseVo;
		}

		return null;
	}

	/**
	 * 查看详情
	 *
	 * @param criteria
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	public InvoiceApplyDetailDimCreditVo getUnifiedCustomerInvoice2CreditDetail(ExportExcelInvoiceApplyQueryCriteria criteria, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException {


//		eg:
//		// 发票申请Id
//		params.put("id", getLong("id"));

		Long id = criteria.getId();

		InvoiceApply invoiceApply = invoiceApplyMapper.selectByPrimaryKey(id);

		log.info("\n\ngetUnifiedCustomerInvoice2CreditDetail \n\ninvoiceApply :\n\n{}\n\n", JsonUtils.toJson(invoiceApply));

		if (null == invoiceApply) {

			return null;
		}

		List<InvoiceApplyPage> invoiceApplyPageList = invoiceApplyMapperExScore.findViewByPage(criteria);

		log.info("getUnifiedCustomerInvoice2CreditDetail invoiceApplyPageList :\n{}", JsonUtils.toJson(invoiceApplyPageList));

		InvoiceApplyDetailDimCreditVo invoiceApplyDetailDimCreditVo = new InvoiceApplyDetailDimCreditVo();

		if (AnCollectionUtils.isNotEmpty(invoiceApplyPageList)) {

			InvoiceApplyPage invoiceApplyPage = invoiceApplyPageList.get(0);

			// 问题  mark by linjinyu at 20210312
//			AnBeanUtils.copyProperties(invoiceApplyPage, invoiceApplyDetailDimCreditVo);
			invoiceApplyDetailDimCreditVo = AnBeanUtils.copy(invoiceApplyPage, InvoiceApplyDetailDimCreditVo.class);


			/****************************************** start ******************************************/


//			superdesk-uniorder/superdesk-uniorder-web/src/main/java/cn/superdesk/uniorder/controller/accounting/customer/ScoreCustomerStatementController.java
			// 240
			// 得到 发票申请 X 积分流水
			// |---- 筛选条件
			List<Long> idsCredit = invoiceApplyXGoodsService.findCreditSetByInvoicApplyId(id);

			Map<String, Object> setCreditListParams = new HashMap<>();
			setCreditListParams.put("ids", idsCredit.toArray());
			// 客户对账:1-已对账;2-未对账 这个方法默认的是 2
//			setCreditListParams.put("accountingStateCustomer", 1);

			log.info("setCreditListParams {}", JsonUtils.toJson(setCreditListParams));

			List<ScoreOrderReconciliationNotYetVo> setCreditListObj = scoreOrderService.getScoreOrderReconciliationNotYet(setCreditListParams, loginSysUser);

			for (ScoreOrderReconciliationNotYetVo vo : setCreditListObj) {
				vo.setAccountingStateCustomerName(CommonAccountingStateEnum.getDesc(vo.getAccountingStateCustomer()));

				vo.setInvoiceApplyStatusName(UnifiedOrderCreditInvoiceApplyStatusEnum.getDesc(vo.getInvoiceApplyStatus()));
				vo.setInvoiceMakeStatusName(UnifiedOrderCreditInvoiceMakeStatusEnum.getDesc(vo.getInvoiceMakeStatus()));
				vo.setBackStatusName(UnifiedOrderCreditBackStatusEnum.getDesc(vo.getBackStatus()));
			}

			/******************************************   end ******************************************/

			invoiceApplyDetailDimCreditVo.setDzOrders(setCreditListObj);

			return invoiceApplyDetailDimCreditVo;
		}

		return null;
	}

	/**
	 * 删除 发票申请
	 *
	 * @param invoiceApplyId
	 * @param loginSysUser
	 */
	public void opDelete(Long invoiceApplyId, LoginSysUser loginSysUser) {


		// 对账单相关信息没有在 invoiceApply, 要用 invoiceApplyId 去查 invoiceOrder
		InvoiceApplyXGoodsExample invoiceOrderExample = new InvoiceApplyXGoodsExample();
		invoiceOrderExample.createCriteria()
				.andInvoiceApplyIdEqualTo(invoiceApplyId);

		List<InvoiceApplyXGoods> forResetAccountingOrderInvoiceStatusList = invoiceApplyXGoodsMapper.selectByExample(invoiceOrderExample);

		// 得出 发票申请关联对账单Ids
		List<Long> accountingOrderIds = forResetAccountingOrderInvoiceStatusList
				.stream()
				.filter(AnLamdaUtils.distinctByKey(o -> o.getAccountingOrderId()))
				.map(o -> o.getAccountingOrderId())
				.collect(Collectors.toList());

		if (AnCollectionUtils.isNotEmpty(accountingOrderIds)) {

			// 恢复对账单 发票申请状态 = 未开票 (20201023 注释 修正为下边代码 会检查 对账单 发票申请状态)
//            AccountingScoreCustomerExample accountingScoreCustomerExample = new AccountingScoreCustomerExample();
//            accountingScoreCustomerExample.createCriteria()
//                    .andIdIn(accountingOrderIds);
//            AccountingScoreCustomer forUpdateInvoiceStatus = new AccountingScoreCustomer();
//            // 20201023 修正 直接 未开票 是有问题要去检查
//            forUpdateInvoiceStatus.setInvoiceStatus(AccountingOrderInvoiceStatusEnum.未开票.getKey());
//            accountingScoreCustomerMapper.updateByExampleSelective(forUpdateInvoiceStatus, accountingScoreCustomerExample);


			accountingOrderIds.forEach(accountingOrderId -> {
				invoiceApplyXGoodsService.checkInvoiceStatusByAccountingOrderIdAndUpdateAccountingEntityFocusScore(accountingOrderId);
			});

			invoiceApplyXGoodsMapper.deleteByExample(invoiceOrderExample);

		}

		invoiceApplyMapper.deleteByPrimaryKey(invoiceApplyId);

	}

	/**
	 * 操作-opt 发票登记 (过) TODO 还是得重构 mark by linjinyu at 20210311
	 *
	 * @param params
	 * @param loginSysUser
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	public void opRegister(Map<String, Object> params, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException {

//		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);


		SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");

		Long   invoiceApplyId = Long.valueOf(params.get("id").toString());
		String invoiceNumber  = params.get("invoiceNumber").toString();
		String dateStr        = params.get("datestr").toString();


		// 1. 判定发票号是不是重复登记的问题
		InvoiceApplyExample example = new InvoiceApplyExample();
		example.createCriteria()
				.andInvoiceNumberEqualTo(invoiceNumber)
				.andMakeInvoiceStatusEqualTo(InvoiceApplyMakeInvoiceStatusEnum.已开票.getKey());
		List<InvoiceApply> invoiceApplyList = invoiceApplyMapper.selectByExample(example);

		if (AnCollectionUtils.isNotEmpty(invoiceApplyList)) {
			throw new UnifiedOrderRuntimeException(ExceptionMsg.INVOICE_EXIST);
		}

		// 2. 更新发票主体的 相关信息
		InvoiceApply invoiceApply = new InvoiceApply();
		invoiceApply.setId(invoiceApplyId);
		// |---- 开票登记(处理)人
		invoiceApply.setMakeInvoiceUserId(loginSysUser.getSysUserId());
		// |---- 开票日期
		try {
			invoiceApply.setMakeInvoiceTime(sdf.parse(dateStr));
		} catch (ParseException e) {
			e.printStackTrace();
		}
		invoiceApply.setMakeInvoiceStatus(InvoiceApplyMakeInvoiceStatusEnum.已开票.getKey());
		// |---- 发票号 税局出来的
		invoiceApply.setInvoiceNumber(invoiceNumber);
		invoiceApplyMapper.updateByPrimaryKeySelective(invoiceApply);
	}

	/**
	 * 操作-opt 寄票登记 (过)  TODO 还是得重构 mark by linjinyu at 20210311
	 *
	 * @param sendInvoiceRegisterList
	 * @param loginSysUser
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	@Transactional
	public void invoiceRegisterSend(List<Map> sendInvoiceRegisterList, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException {

//		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		for (Map map : sendInvoiceRegisterList) {

			InvoiceApply invoiceApply = new InvoiceApply();

			invoiceApply.setId(Long.valueOf(map.get("id").toString()));

			invoiceApply.setInvoiceStatus(InvoiceApplyInvoiceProgressingStatusEnum.已邮寄.getKey());

			invoiceApply.setMailTickTime(AnDateHelper.getNow());
			invoiceApply.setMailTickUserId(loginSysUser.getSysUserId());
			// 0-未邮寄;1-已邮寄;
			invoiceApply.setMailTickStatus(InvoiceApplyMailTickStatusEnum.已邮寄.getKey());

			invoiceApply.setExpressCompanyId(Long.valueOf(map.get("expressCompanyId").toString()));
			if (map.get("expressNo") != null) {
				invoiceApply.setExpressNo(map.get("expressNo").toString());
			}

			invoiceApplyMapper.updateByPrimaryKeySelective(invoiceApply);
		}
	}

	/**
	 * 操作-opt 重新开票
	 *
	 * @param params
	 * @param loginSysUser
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	@Transactional
	public TailUpdateAccountingOrderInvoiceStatusEvent opAgain(Map<String, Object> params, LoginSysUser loginSysUser) throws UnifiedOrderRuntimeException {

		Long id = AnLongUtils.getLong(params.get("id"));

		InvoiceApply invoiceApply = invoiceApplyMapper.selectByPrimaryKey(id);

		// 如果这个发票信息 回款状态 0-未回款;1-部分回款;2全部回款;
		// 意思 就是回款过的就不能重新开票
		if (!invoiceApply.getBackAccountStatus().equals(InvoiceApplyBackAccountStatusEnum.未回款.getKey())) {
			// 该发票已回款
			throw new UnifiedOrderRuntimeException(ExceptionMsg.INVOICE_HAVE_BACK);
		}

		// 发票 审核状态 变成 拒绝
		invoiceApply.setAuditStatus(InvoiceApplyAuditStatusEnum.拒绝.getKey());

		// 登记开票 状态 变成 重新开票 且 清除 发票号
		invoiceApply.setMakeInvoiceStatus(InvoiceApplyMakeInvoiceStatusEnum.重新开票.getKey());
		invoiceApply.setInvoiceNumber(null);

		// 发票申请 状态 变成 未开票
		invoiceApply.setInvoiceStatus(InvoiceApplyInvoiceProgressingStatusEnum.已作废.getKey());

		// 重置 寄票 信息
		invoiceApply.setExpressCompanyId(null);
		invoiceApply.setExpressNo(null);

		invoiceApplyMapper.updateByPrimaryKey(invoiceApply);


//		InvoiceOrderExample example = new InvoiceOrderExample();
//		example.createCriteria()
//				.andInvoiceApplyIdEqualTo(Long.valueOf(params.get("id").toString()));
//		List<InvoiceOrder> ls = invoiceOrderMapper.selectByExample(example);
//		for (InvoiceOrder invoiceOrder : ls) {
//
//			AccountingUnifiedCustomer dzMain = new AccountingUnifiedCustomer();
//
//			Integer status = invoiceApplyMapperExUnified.checkInvoiceStatusByAccountingOrderId(invoiceOrder.getDzId());
//
//			dzMain.setId(invoiceOrder.getDzId());
//			dzMain.setInvoiceStatus(status);
//			accountingUnifiedCustomerMapper.updateByPrimaryKeySelective(dzMain);
//		}

		// 得出受影响的对账单 ids
		List<Long> affectedAccountingOrderIds = invoiceApplyXGoodsService.getAffectedAccountingOrderIdsByInvoiceApplyId(id);

		/**
		 * 通过 对账单 ids(得出受影响的对账单 ids)
		 * 再去 较验 对账单 发票状态
		 */
//		processTailUpdateAccountingOrderInvoiceStatus(affectedAccountingOrderIds, AccountingOrderTypeDimEnum.get(invoiceApply.getAccountingOrderType()));
//		invoiceApplyTriggerEventPublisher.triggerTailUpdateAccountingOrderInvoiceStatus(affectedAccountingOrderIds, AccountingOrderTypeDimEnum.get(invoiceApply.getAccountingOrderType()));

		return TailUpdateAccountingOrderInvoiceStatusEvent
				.builder()
				.affectedAccountingOrderIds(affectedAccountingOrderIds)
				.dim(AccountingOrderTypeDimEnum.get(invoiceApply.getAccountingOrderType()))
				.build();

	}

	/**
	 * 客户结算-发票管理-opt 导入发票信息
	 *
	 * @param token
	 * @param list
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	@Transactional
	public String importInvoiceExcel(String token, List<Map<String, Object>> list) throws UnifiedOrderRuntimeException {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		List<InvoiceApply> processInvoiceApplyArrayList = new ArrayList<>();

		boolean flag  = true;
		String  error = "";
		int     h     = 1;

		for (Map<String, Object> map : list) {

			String invoiceNo     = map.get("invoiceNo").toString();
			String invoiceNumber = map.get("invoiceNumber").toString();

			InvoiceApplyExample example = new InvoiceApplyExample();
			example.createCriteria()
					.andInvoiceNoEqualTo(invoiceNo)
					.andAuditStatusEqualTo(InvoiceApplyAuditStatusEnum.同意.getKey());
			List<InvoiceApply> invoiceApplyList = invoiceApplyMapper.selectByExample(example);

			if (invoiceApplyList != null && invoiceApplyList.size() > 0) {

				InvoiceApply invoiceApply = invoiceApplyList.get(0);

				invoiceApply.setMakeInvoiceStatus(InvoiceApplyMakeInvoiceStatusEnum.已开票.getKey());
				invoiceApply.setMakeInvoiceUserId(loginSysUser.getSysUserId());
				invoiceApply.setMakeInvoiceTime(AnDateHelper.getNow());

				invoiceApply.setInvoiceNumber(invoiceNumber);

				processInvoiceApplyArrayList.add(invoiceApply);

			} else {
				flag = false;
				error += "第" + h + "行 , " + invoiceNo + " , 该<发票申请号>错误 或 不存在 或 审核状态 未审核通过(不等于 已同意). \n";
			}

			InvoiceApplyExample example1 = new InvoiceApplyExample();
			example1.createCriteria()
					.andInvoiceNumberEqualTo(invoiceNumber)// 发票号 税局 产生的
					.andMakeInvoiceStatusEqualTo(InvoiceApplyMakeInvoiceStatusEnum.已开票.getKey());
			List<InvoiceApply> invoiceApplyList1 = invoiceApplyMapper.selectByExample(example1);

			if (invoiceApplyList1 != null && invoiceApplyList1.size() > 0) {
				flag = false;
				error += "第" + h + "行 , " + invoiceNumber + " , 该<发票号>已存在, 不能重复导入. \n";
			}

			h++;
		}

		if (flag) {
			for (InvoiceApply invoiceApply : processInvoiceApplyArrayList) {
				invoiceApplyMapper.updateByPrimaryKeySelective(invoiceApply);
			}
		}
//		else {
//			throw new SuperdeskUniOrderException(500, error);
//		}

		return error;
	}

	/**
	 * 客户结算-发票管理-opt 导入寄票信息
	 *
	 * @param token
	 * @param list
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	@Transactional
	public String importSendInvoiceExcel(String token, List<Map<String, Object>> list) throws UnifiedOrderRuntimeException {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		List<InvoiceApply> invoiceApplys = new ArrayList<>();

		boolean flag  = true;
		String  error = "";
		int     h     = 1;

		for (Map<String, Object> map : list) {


			String invoiceNumber = map.get("invoiceNumber").toString();

			InvoiceApplyExample example = new InvoiceApplyExample();
			example.createCriteria()
					.andInvoiceNumberEqualTo(invoiceNumber)
					.andMakeInvoiceStatusEqualTo(InvoiceApplyMakeInvoiceStatusEnum.已开票.getKey());
			List<InvoiceApply> invoiceApplyList = invoiceApplyMapper.selectByExample(example);

			if (invoiceApplyList != null && invoiceApplyList.size() > 0) {

				InvoiceApply invoiceApply = invoiceApplyList.get(0);

				invoiceApply.setInvoiceStatus(InvoiceApplyInvoiceProgressingStatusEnum.已邮寄.getKey());

				invoiceApply.setMailTickUserId(loginSysUser.getSysUserId());
				invoiceApply.setMailTickTime(AnDateHelper.getNow());

				String expressCompanyName = map.get("expressCompanyName").toString();

				List<ExpressCompany> expressCompanyList = expressCompanyMapper.selectByCompanyName(expressCompanyName);

				if (expressCompanyList != null && expressCompanyList.size() > 0) {
					ExpressCompany expressCompany = expressCompanyList.get(0);
					invoiceApply.setExpressCompanyId(expressCompany.getId());
				} else {
					flag = false;
					error += "第" + h + "行," + expressCompanyName + ",该快递公司名称不正确.";
				}

				if (map.get("expressNo") != null) {
					String expressNo = map.get("expressNo").toString();
					invoiceApply.setExpressNo(expressNo);
				}

				invoiceApplys.add(invoiceApply);

			} else {
				flag = false;
				error += "第" + h + "行," + invoiceNumber + ",该发票号未开票.";
			}
			h++;
		}

		if (flag) {
			for (InvoiceApply invoiceApply : invoiceApplys) {
				invoiceApplyMapper.updateByPrimaryKeySelective(invoiceApply);
			}
		}
//		else {
//			throw new SuperdeskUniOrderException(500, error);
//		}

		return error;
	}


	/**
	 * 待重构
	 *
	 * @return
	 * @throws UnifiedOrderRuntimeException
	 */
	@Override
	public List<ExpressCompany> findExpressCompany() throws UnifiedOrderRuntimeException {
		return expressCompanyMapper.findAll();
	}

	@Override
	public List<InvoiceApply> findAll(Map<String, Object> params) {
		return invoiceApplyMapperEx.findAll(params);
	}

	@Override
	public InvoiceApply findById(Long id) {
		return invoiceApplyMapper.selectByPrimaryKey(id);
	}

	@Override
	public R<List<InvoiceApply>> findInvoiceByPageNew(Map<String, Object> params, int pageNo, int pageSize) {

		PageHelper.startPage(pageNo, pageSize);

		List<InvoiceApply> ls = invoiceApplyMapperEx.findAll(params);

		PageInfo<InvoiceApply> page = new PageInfo<InvoiceApply>(ls);
		PageHelper.clearPage();

		return new R<List<InvoiceApply>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), ls);
	}

	/**
	 * 通过 orderSn 查找从属在 哪个开票申请中
	 *
	 * @param invQuery
	 * @return
	 */
	@Override
//	@Cacheable(keyGenerator = "findByXXKeyGenerator")
	public List<InvoiceApply> findInvoiceByOrderSn(Map<String, Object> invQuery) {

		if (null == invQuery.get("orderSn")) {
			return null;
		}

		return invoiceApplyMapperEx.findInvoiceByOrderSn(invQuery);
	}

	@Override
	public Map<String, InvoiceApply> findInvoiceByOrderSnList(List<String> orderSnList) {

		log.info("findInvoiceByOrderSnList 1 .size {}", orderSnList.size());

		if (AnCollectionUtils.isEmpty(orderSnList)) {
			return null;
		}

		Map<String, InvoiceApply> result = new HashMap<>();

		Map<String, Object> invQuery = new HashMap<>();
		invQuery.put("orderSnList", orderSnList);
		List<OrderSnMapInvoiceApplyVo> resultList = invoiceApplyMapperEx.findInvoiceByOrderSnList(invQuery);

		log.info("findInvoiceByOrderSnList 2 .size {}", resultList.size());

		try {
			for (OrderSnMapInvoiceApplyVo item : resultList) {


				InvoiceApply temp = new InvoiceApply();

				// 问题  mark by linjinyu at 20210312
//				AnBeanUtils.copyProperties(item, temp);

				temp = AnBeanUtils.copy(item, InvoiceApply.class);

				log.info(JsonUtils.toPrettyJson(temp));

				log.info("这个为空的? {}", item.toString());
				log.info("这个为空的? {}", temp.toString());

				result.put(item.getOrderSn(), temp);
			}
		} catch (BeansException e) {
			e.printStackTrace();
		}


		return result;

	}

	@Override
	public List<InvoiceApply> query4CheckIsOverdue() {


		// 得出要催款的发票数据
//		SELECT *
//		FROM `invoice_apply`
//		WHERE
//	    	audit_status = 2 //发票申请审核部分-审核状态 1-未审核;2-已同意;3-已拒绝
//	       	AND make_invoice_status = 1 // 发票登记部分-开票状态 0-未开票;1-已开票;2-重新开票;
//	       	AND invoice_status = 1 // 发票状态 0未邮寄 1已邮寄 2已作废
//	       	AND back_account_status in (0,1) // 回款状态 0-未回款;1-部分回款;2全部回款;


		List<InvoiceApply> result = new ArrayList<>();

		InvoiceApplyExample example = new InvoiceApplyExample();
		example.createCriteria()
				.andAuditStatusEqualTo(2)
				.andMakeInvoiceStatusEqualTo(1)
				.andInvoiceStatusEqualTo(1)
				.andBackAccountStatusIn(Arrays.asList(0, 1));

		result = invoiceApplyMapper.selectByExample(example);


		return result;

	}


	public static List<Long> arrToListRemoval(String[] arrStr) {
		List<Long> list = new ArrayList<>();
		for (int i = 0; i < arrStr.length; i++) {
			if (!list.contains(arrStr[i])) {
				list.add(Long.valueOf(arrStr[i]));
			}
		}
		return list;
	}


	// 未写完 有问题 大概是弃了
	public void validatedInvoiceApplyRelationTable() {


		// TODO mark by linjinyu 20201113

		// 1. 开票申请 先添加三个字段 ， 分别记录 1. 此申请是用什么关联关系 2. 关联关系 方法1 明细数据  3. 关联关系 方法2 明细数据  ... ---- 已完成
		// 2. 找出 标记是有效的开票申请 记录 (有可能 修正为 且 发票正常的记录?) | 方向2 找出 字段 relation_mode 标记为 -1的记录
		// 3. TODO 未写完...

		List<InvoiceApply> processInvoiceApplyList = new ArrayList<>();

		InvoiceApplyExample exampleForProcessList = new InvoiceApplyExample();
		exampleForProcessList.createCriteria()
				.andRelationModeEqualTo(-1);

		processInvoiceApplyList = invoiceApplyMapper.selectByExample(exampleForProcessList);

		for (InvoiceApply invoiceApply : processInvoiceApplyList) {


			List<ViewDzOrder> mode01 = new ArrayList<>();
			List<ViewDzOrder> mode02 = new ArrayList<>();
			List<ViewDzOrder> mode03 = new ArrayList<>();


			// findDzOrderByGoodIdNew
			// 方法1
			mode01 = invoiceApplyMapperExUnifiedCompatible.findInvoiceApplyDetailNewDim1Unified2Goods(invoiceApply.getId());
			// 方法2
			mode02 = invoiceApplyMapperExUnifiedCompatible.findInvoiceApplyDetailOldDim1Unified2Goods(invoiceApply.getId());
			// 方法3
//			mode03 = invoiceApplyMapperEx.findDzOrderByGoodId(invoiceApply.getId());

			InvoiceApply invoiceApplyForUpdate = new InvoiceApply();
			invoiceApplyForUpdate.setId(invoiceApply.getId());
			invoiceApplyForUpdate.setErrorCheckRelation01(0L);
			invoiceApplyForUpdate.setErrorCheckRelation02(0L);

			if (AnCollectionUtils.isNotEmpty(mode01)) {
				invoiceApplyForUpdate.setErrorCheckRelation01(Long.parseLong(String.valueOf(mode01.size())));
			}

			if (AnCollectionUtils.isNotEmpty(mode02)) {
				invoiceApplyForUpdate.setErrorCheckRelation01(Long.parseLong(String.valueOf(mode02.size())));
			}

			invoiceApplyMapper.updateByPrimaryKeySelective(invoiceApplyForUpdate);

		}


	}

}
