package cn.superdesk.uniorder.service.invoice.impl;

import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.common.lamda.AnLamdaUtils;
import cn.superdesk.uniorder.common.mq.redis.constants.BaseRedisConf;
import cn.superdesk.uniorder.common.mq.redis.constants.RedisKeyPrefix;
import cn.superdesk.uniorder.common.mq.redis.service.RedisService;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.numerical.AnCollectionUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.invoice.InvoiceBankInfo;
import cn.superdesk.uniorder.dao.entity.invoice.InvoiceBankInfoExample;
import cn.superdesk.uniorder.dao.mapper.invoice.InvoiceBankInfoMapper;
import cn.superdesk.uniorder.dao.mapper.invoice.InvoiceBankInfoMapperEx;
import cn.superdesk.uniorder.service.invoice.InvoiceBankInfoService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Predicate;
import java.util.stream.Collectors;

/**
 * @Description: 重构
 * @Author: linjinyu
 * @CreateDate: 2021/7/23 下午4:03
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021/7/23 下午4:03
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class InvoiceBankInfoServiceImpl implements InvoiceBankInfoService {

	@Autowired
	private InvoiceBankInfoMapper   invoiceBankInfoMapper;
	@Autowired
	private InvoiceBankInfoMapperEx invoiceBankInfoMapperEx;

	@Autowired
	private RedisService redisService;

	/****************************************** extends BaseService 部分 start ******************************************/
	@Override
	public void addObj(InvoiceBankInfo entity) {
		invoiceBankInfoMapper.insert(entity);
	}

	@Override
	public void updateObj(InvoiceBankInfo entity) {
		invoiceBankInfoMapper.updateByPrimaryKeySelective(entity);
	}

	@Override
	public void deleteObj(Long id) {
		invoiceBankInfoMapper.deleteByPrimaryKey(id);
	}

	@Override
	public InvoiceBankInfo findById(Long id) {
		return invoiceBankInfoMapper.selectByPrimaryKey(id);
	}

	@Override
	public PageInfo<InvoiceBankInfo> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
		return null;
	}

	@Override
	public List<InvoiceBankInfo> findAll(Map<String, Object> queryMap) {
		return invoiceBankInfoMapperEx.findAll(queryMap);
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	public void addInvoiceBankInfo(InvoiceBankInfo entity) {
		invoiceBankInfoMapper.insertSelective(entity);
	}

	public void updateInvoiceBankInfo(InvoiceBankInfo entity) {
		InvoiceBankInfo originEntity = invoiceBankInfoMapper.selectByPrimaryKey(entity.getId());
//		AssertUtil.notNull(originEntity);
		AnBeanUtils.copy(entity, originEntity);
		invoiceBankInfoMapper.updateByPrimaryKey(originEntity);
	}

	public void deleteInvoiceBankInfo(Long id) {
		invoiceBankInfoMapper.deleteByPrimaryKey(id);
	}

	public InvoiceBankInfo findInvoiceBankInfoById(Long id) {
		InvoiceBankInfo entity = invoiceBankInfoMapper.selectByPrimaryKey(id);
//		AssertUtil.notNull(entity);
		return entity;
	}

	public R<List<InvoiceBankInfo>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

		// 样例 保留
//		InvoiceBankInfo invoiceBankInfoConditions = BeanUtils.mapToBean(conditions,InvoiceBankInfo.class);

		InvoiceBankInfoExample          example  = new InvoiceBankInfoExample();
		InvoiceBankInfoExample.Criteria criteria = example.createCriteria();

		PageHelper.startPage(pageNun, pageSize);
		List<InvoiceBankInfo>     resultList = invoiceBankInfoMapper.selectByExample(example);
		PageInfo<InvoiceBankInfo> page       = new PageInfo<InvoiceBankInfo>(resultList);
		PageHelper.clearPage();

		return new R<List<InvoiceBankInfo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

	}


	/******************************************  start ******************************************/

	@Override
	public R<List<InvoiceBankInfo>> getDataByPage(Map<String, Object> params, int pageNo, int pageSize) {

		PageHelper.startPage(pageNo, pageSize);
		List<InvoiceBankInfo>     resultList = invoiceBankInfoMapperEx.findAll(params);
		PageInfo<InvoiceBankInfo> page       = new PageInfo<>(resultList);
		PageHelper.clearPage();

		return new R<List<InvoiceBankInfo>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);
	}

	@Override
	public void updateObjAuto() {
		invoiceBankInfoMapperEx.updateObjAuto();
	}

	@Override
	public InvoiceBankInfo getByDefault() {

		Map<String, Object>   params = new HashMap<>();
		List<InvoiceBankInfo> result = invoiceBankInfoMapperEx.findAll(params);

		List<Predicate<InvoiceBankInfo>> predicatesByFieldParam1Eqy = new ArrayList<>();
		predicatesByFieldParam1Eqy.add(r -> r.getParam1() != null && r.getParam1().equals("y"));
		List<InvoiceBankInfo> predicatesByFieldParam1EqyFilter = AnLamdaUtils.filters(result, predicatesByFieldParam1Eqy);

		if (AnCollectionUtils.isNotEmpty(predicatesByFieldParam1EqyFilter)) {
			return predicatesByFieldParam1EqyFilter.get(0);
		} else if (AnCollectionUtils.isNotEmpty(result)) {
			return result.get(0);
		} else {
			return null;
		}
	}

	/****************************************** 工具方法 start ******************************************/

	public Map<String, InvoiceBankInfo> convertToMapStringEntity() {

		Map<String, InvoiceBankInfo> result = new HashMap<>();

		InvoiceBankInfoExample          example  = new InvoiceBankInfoExample();
		InvoiceBankInfoExample.Criteria criteria = example.createCriteria();

		List<InvoiceBankInfo> resultList = invoiceBankInfoMapper.selectByExample(example);

		if (AnCollectionUtils.isNotEmpty(resultList)) {
			result = resultList.stream().collect(Collectors.toMap(InvoiceBankInfo::getCompanyName, v -> v, (k, v) -> v));
		}

		return result;

	}

	/**
	 * InvoiceBankInfoCriteria conditions
	 *
	 * @return
	 */
	public Map<String, String> convertToMapStringString() {

		Map<String, String> result = new HashMap<>();

		Map<String, InvoiceBankInfo> tmp = convertToMapStringEntity();

		tmp.forEach((companyName, entity) -> {
			result.put(companyName, JsonUtils.toJson(entity));
//			result.put(URLUtil.encode((companyName)), JsonUtils.toJson(entity));
		});

		return result;

	}


	/****************************************** 工具方法   end ******************************************/

	/****************************************** 缓存 start ******************************************/
	public void cacheInit() {

//		InvoiceBankInfoCriteria conditions = new InvoiceBankInfoCriteria();

		Map<String, String> mapValue = convertToMapStringString();

		// 验证
		redisService.hashSave(mapValue, RedisKeyPrefix.关联性校验_前缀, RedisKeyPrefix.关联性校验_销方主体_发票抬头.getKey(), BaseRedisConf.REFRESH_TOKEN_EXPIRE_TIME);

		// 测试过 结果与上边一个样
//		mapValue.forEach((companyName, entityJsonString) -> {
//			cacheService.hashSet(RedisKeyPrefix.关联性校验_前缀.getKey() + ":" + RedisKeyPrefix.关联性校验_销方主体_发票抬头.getKey(), companyName, entityJsonString);
//		});
	}

	public void cacheRefresh() {

		redisService.deleteKey(RedisKeyPrefix.关联性校验_前缀, RedisKeyPrefix.关联性校验_销方主体_发票抬头.getKey());
		cacheInit();
	}

	public void cacheRemove() {

		redisService.deleteKey(RedisKeyPrefix.关联性校验_前缀, RedisKeyPrefix.关联性校验_销方主体_发票抬头.getKey());
	}

	public String cacheGet(String hashTable, String keyField) {
//		return (String) cacheService.hashGetByKey(hashTable, URLUtil.encode(keyField));

		log.info("hashTable@{}@field@{}@cacheService@{}", hashTable, keyField, redisService);

//		hashTable@relation:sys_enterprise_ext_invoice:company_name@field@中航物业管理有限公司成都分公司@cacheService@cn.superdesk.uniorder.common.cache.impl.RedisServiceImpl@4435b6b
//		hashTable@relation:sys_enterprise_ext_invoice:company_name@field@中航物业管理有限公司济南分公司@cacheService@cn.superdesk.uniorder.common.cache.impl.RedisServiceImpl@643f6179
		return (String) redisService.hashGetByKey(hashTable, keyField);
	}
	/****************************************** 缓存   end ******************************************/
}
