package cn.superdesk.uniorder.service.invoice.supplier;

import cn.superdesk.uniorder.dao.entity.invoice.supplier.UnifiedSupplierInvItem;
import cn.superdesk.uniorder.dto.vo.invoice.supplier.InvoiceApplyXUnifiedOrderGoodsEdVo;
import cn.superdesk.uniorder.dto.vo.invoice.supplier.UnifiedSupplierInvGoodsDetail;
import cn.superdesk.uniorder.service.base.BaseService;
import org.apache.ibatis.annotations.Param;
import org.apache.kafka.common.protocol.types.Field;

import java.util.List;
import java.util.Map;

/**
 * @Description: 供应商 开票申请 X 商品
 * @Author: linjinyu
 * @CreateDate: 2020/11/4 下午2:42
 * @UpdateUser: linjinyu
 * @UpdateDate: 2020/11/4 下午2:42
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
public interface UnifiedSupplierInvItemService extends BaseService<UnifiedSupplierInvItem> {

    List<UnifiedSupplierInvGoodsDetail> getDetail(Map<String, Object> params);


    /****************************************** 工具方法 start ******************************************/

	/**
	 * 用于 发票申请 排除已开票的商品
	 * * 装的是 基于 某对账单Sn 查出这个对账单 商品 已申请开票
	 *
	 * @param accountingOrderSn
	 * @return
	 */
	List<InvoiceApplyXUnifiedOrderGoodsEdVo> getInvoiceApplyXUnifiedOrderGoodsEd(String accountingOrderSn);
    /**
     * 根据发票申请Id 获取 关联 积分流水 ids 集合
     *
     * @param invoiceApplyId
     * @return
     */
    List<Long> findGoodsSetByInvoicApplyId(Long invoiceApplyId);
	List<Long> findGoodsSetByInvoicApplySn(String invoiceApplySn);

    /**
     * 根据开票申请Id 获取 关联 对账单 ids 集合
     * <p>
     * 由于 这个 开票申请 X 对账单 X 订单 X 商品 表是没有记录 invoiceApplyId and accountingOrderid
     * <p>
     * 所以不实际
     *
     * @param invoiceApplyId
     * @return
     */
    @Deprecated
    List<Long> getAffectedAccountingOrderIdsByInvoiceApplyId(Long invoiceApplyId);
    List<String> getAffectedAccountingOrderSnsByInvoiceApplySn(String invoiceApplySn);
    /****************************************** 工具方法   end ******************************************/

    /****************************************** 基于对账单Id检测开票状态 start ******************************************/

    @Deprecated
    Integer checkInvoiceStatusByAccountingOrderIdFocusSupplier(Long accountingOrderId);
    Integer checkInvoiceStatusByAccountingOrderSnFocusSupplier(String accountingOrderSn);
    /****************************************** 基于对账单Id检测开票状态   end ******************************************/

    /****************************************** 基于对账单Sn检测开票状态 并 更新 对账单 开票状态 start ******************************************/
    @Deprecated
    void checkInvoiceStatusByAccountingOrderIdAndUpdateAccountingEntityFocusSupplier(Long accountingOrderId);
    void checkInvoiceStatusByAccountingOrderSnAndUpdateAccountingEntityFocusSupplier(String accountingOrderSn);

    /****************************************** 基于对账单Sn检测开票状态 并 更新 对账单 开票状态   end ******************************************/
}
