package cn.superdesk.uniorder.service.invoice.supplier.impl;

import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.common.numerical.AnCollectionUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.enums.statement.AccountingOrderDimCreateByEnum;
import cn.superdesk.uniorder.dao.entity.accounting.unified.supplier.AccountingUnifiedSupplier;
import cn.superdesk.uniorder.dao.entity.invoice.supplier.UnifiedSupplierInv;
import cn.superdesk.uniorder.dao.entity.invoice.supplier.UnifiedSupplierInvExample;
import cn.superdesk.uniorder.dao.entity.invoice.supplier.UnifiedSupplierInvItem;
import cn.superdesk.uniorder.dao.entity.invoice.supplier.UnifiedSupplierInvItemExample;
import cn.superdesk.uniorder.dao.mapper.accounting.unified.supplier.AccountingUnifiedSupplierXGoodsMapperEx;
import cn.superdesk.uniorder.dao.mapper.accounting.unified.supplier.AccountingUnifiedSupplierXOrderMapperEx;
import cn.superdesk.uniorder.dao.mapper.invoice.supplier.UnifiedSupplierInvItemMapper;
import cn.superdesk.uniorder.dao.mapper.invoice.supplier.UnifiedSupplierInvItemMapperEx;
import cn.superdesk.uniorder.dao.mapper.invoice.supplier.UnifiedSupplierInvMapper;
import cn.superdesk.uniorder.dao.mapper.invoice.supplier.UnifiedSupplierInvMapperEx;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.AccountingUnifiedSuplierCheckAmountErrorForFixDimGoods;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.AccountingUnifiedSuplierCheckAmountErrorForFixDimOrder;
import cn.superdesk.uniorder.dto.vo.invoice.supplier.InvoiceApplyXUnifiedOrderGoodsEdVo;
import cn.superdesk.uniorder.dto.vo.unified.InvoiceApplySupplierSelectGoodsVo;
import cn.superdesk.uniorder.dto.vo.unified.UnifiedInvHE;
import cn.superdesk.uniorder.service.accounting.unified.supplier.AccountingUnifiedSupplierService;
import cn.superdesk.uniorder.service.accounting.unified.supplier.AccountingUnifiedSupplierXGoodsService;
import cn.superdesk.uniorder.service.invoice.supplier.UnifiedSupplierInvItemService;
import cn.superdesk.uniorder.service.invoice.supplier.UnifiedSupplierInvService;
import cn.superdesk.uniorder.common.lamda.AnLamdaUtils;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.*;
import java.util.function.Predicate;
import java.util.stream.Collectors;

@Slf4j
@Service
public class UnifiedSupplierInvServiceImpl implements UnifiedSupplierInvService {


    @Autowired
    private UnifiedSupplierInvMapper   unifiedSupplierInvMapper;
    @Autowired
    private UnifiedSupplierInvMapperEx unifiedSupplierInvMapperEx;
    @Autowired
    private UnifiedSupplierInvService unifiedSupplierInvService;

    @Autowired
    private UnifiedSupplierInvItemMapper   unifiedSupplierInvItemMapper;
    @Autowired
    private UnifiedSupplierInvItemMapperEx unifiedSupplierInvItemMapperEx;
    @Autowired
    private UnifiedSupplierInvItemService  unifiedSupplierInvItemService;

    @Autowired
    private AccountingUnifiedSupplierXOrderMapperEx accountingUnifiedSupplierXOrderMapperEx;
    @Autowired
    private AccountingUnifiedSupplierXGoodsMapperEx accountingUnifiedSupplierXGoodsMapperEx;


    @Autowired
    private AccountingUnifiedSupplierService       accountingUnifiedSupplierService;
    @Autowired
    private AccountingUnifiedSupplierXGoodsService accountingUnifiedSupplierXGoodsService;

    @Override
    public PageInfo<UnifiedSupplierInv> findByPaging(Map<String, Object> params, Integer pageNo, Integer pageSize) {

        return null;
    }

    @Override
    public void deleteObj(Long id) {

        unifiedSupplierInvMapper.deleteByPrimaryKey(id);
    }

    @Override
    public void updateObj(UnifiedSupplierInv t) {

        unifiedSupplierInvMapper.updateByPrimaryKeySelective(t);
    }

    @Override
    public UnifiedSupplierInv findById(Long id) {

        return unifiedSupplierInvMapper.selectByPrimaryKey(id);
    }

    @Override
    public void addObj(UnifiedSupplierInv t) {

        unifiedSupplierInvMapper.insert(t);
    }

    @Override
    public List<UnifiedSupplierInv> findAll(Map<String, Object> queryMap) {

        return unifiedSupplierInvMapperEx.findAll(queryMap);
    }

    @Override
    public R<List<UnifiedSupplierInv>> getInvoiceApplyList(Map<String, Object> params, int pageNo, int pageSize) {

        PageHelper.startPage(pageNo, pageSize);

        List<UnifiedSupplierInv> resultList = unifiedSupplierInvMapperEx.findAll(params);

        PageInfo<UnifiedSupplierInv> page = new PageInfo<UnifiedSupplierInv>(resultList);
        PageHelper.clearPage();

        return new R<List<UnifiedSupplierInv>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

    }

    @Override
    public UnifiedInvHE getInvoiceApplyListHeadSum(Map<String, Object> params) {

        return unifiedSupplierInvMapperEx.getDataPageHead(params);
    }

    /**
     * <p>
     * -- accountingOrderSn aus.accounting_order_sn
     * -- ids uog.id
     * <p>
     * <p>
     * -- 弃用 supplierId    uo.sale_id
     * -- 弃用 supplierName  uo.sale_name
     *
     * @param params
     * @return
     */
    @Override
    public List<InvoiceApplySupplierSelectGoodsVo> getStatementOfAccountGoodsListByAccountingOrderSn(String accountingOrderSn) {

        Map<String, Object> params = new HashMap<>();
        params.put("accountingOrderSn", accountingOrderSn);

        List<InvoiceApplySupplierSelectGoodsVo> result = new ArrayList<>();

        // TODO 添加 对账单维度的差异
//        String     accountingOrderSn              = (String) params.get("accountingOrderSn");
//        List<Long> processSysUnifiedOrderGoodsIds = (List<Long>) params.get("ids");


        AccountingUnifiedSupplier statementOfAccount = accountingUnifiedSupplierService.findByAccountingOrderSn(accountingOrderSn);

        // TODO 待重构
        switch (AccountingOrderDimCreateByEnum.get(statementOfAccount.getDimCreateBy())) {

            case 订单:

//                result = unifiedSupplierInvMapperEx.getStatementOfAccountDimOrder2GoodsList(params);

                // 先得出一份 对账单 X 商品 的数据
                List<AccountingUnifiedSuplierCheckAmountErrorForFixDimOrder> statementOfAccountDetailDimOrder2GoodsResultList = accountingUnifiedSupplierXOrderMapperEx.checkAmountErrorForFixDimOrder(params);

                for (AccountingUnifiedSuplierCheckAmountErrorForFixDimOrder itemDim0 : statementOfAccountDetailDimOrder2GoodsResultList) {

                    InvoiceApplySupplierSelectGoodsVo vo0 = new InvoiceApplySupplierSelectGoodsVo();

                    vo0.setAccountingOrderSn(itemDim0.getAccountingOrderSn());
                    vo0.setOrderSn(itemDim0.getOrderSn());
                    vo0.setGoodsId(itemDim0.getUnifiedOrderGoodsId());
                    vo0.setGoodsName(itemDim0.getGoodsName());
                    vo0.setCostPrice(itemDim0.getCostPrice());
                    vo0.setQuantity(itemDim0.getQuantity());

                    result.add(vo0);
                }

                break;
            case 商品:

                // 先得出一份 对账单 X 商品 的数据
                List<AccountingUnifiedSuplierCheckAmountErrorForFixDimGoods> statementOfAccountDetailDimGoods2GoodsResultList = accountingUnifiedSupplierXGoodsMapperEx.checkAmountErrorForFixDimGoods(params);

                for (AccountingUnifiedSuplierCheckAmountErrorForFixDimGoods itemDim1 : statementOfAccountDetailDimGoods2GoodsResultList) {

                    InvoiceApplySupplierSelectGoodsVo vo1 = new InvoiceApplySupplierSelectGoodsVo();

                    vo1.setAccountingOrderSn(itemDim1.getAccountingOrderSn());
                    vo1.setOrderSn(itemDim1.getOrderSn());
                    vo1.setGoodsId(itemDim1.getUnifiedOrderGoodsId());
                    vo1.setGoodsName(itemDim1.getGoodsName());
                    vo1.setCostPrice(itemDim1.getCostPrice());
                    vo1.setQuantity(itemDim1.getQuantity());

                    result.add(vo1);
                }

                break;
        }


        return result;
    }

    /**
     * TODO 待重构
     *
     * @param processSysUnifiedOrderGoodsIds
     * @return
     */
    public List<InvoiceApplySupplierSelectGoodsVo> getStatementOfAccountGoodsListBySysUnifiedOrderGoodsIds(String accountingOrderSn, List<Long> processSysUnifiedOrderGoodsIds) {

        List<InvoiceApplySupplierSelectGoodsVo> result = new ArrayList<>();

        Map<String, Object> params = new HashMap<>();
        params.put("accountingOrderSn", accountingOrderSn);
        params.put("unifiedOrderGoodsIds", processSysUnifiedOrderGoodsIds);


        // 先得出一份 对账单 X 商品 的数据
        List<AccountingUnifiedSuplierCheckAmountErrorForFixDimGoods> temp = accountingUnifiedSupplierXGoodsMapperEx.checkAmountErrorForFixDimGoods(params);

        for (AccountingUnifiedSuplierCheckAmountErrorForFixDimGoods item : temp) {

            InvoiceApplySupplierSelectGoodsVo vo = new InvoiceApplySupplierSelectGoodsVo();

            vo.setAccountingOrderSn(item.getAccountingOrderSn());

            vo.setOrderSn(item.getOrderSn());

            vo.setGoodsId(item.getUnifiedOrderGoodsId());
            vo.setGoodsName(item.getGoodsName());

            vo.setPrice(item.getPrice());
            vo.setCostPrice(item.getCostPrice());
            vo.setQuantity(item.getQuantity());


            result.add(vo);
        }

        return result;

    }

    @Override
    public List<InvoiceApplySupplierSelectGoodsVo> invoiceApplySelectFocusUnified(String accountingOrderSn) {

        List<InvoiceApplySupplierSelectGoodsVo>  result             = new ArrayList<>();
        List<InvoiceApplySupplierSelectGoodsVo>  resultFilter       = new ArrayList<>();
        List<InvoiceApplyXUnifiedOrderGoodsEdVo> appliedGoodsVoList = new ArrayList<>();

        // 某对账单的记录
        result = getStatementOfAccountGoodsListByAccountingOrderSn(accountingOrderSn);

        // 基于对账单Sn 反查 有作用的 开票申请 再得出 商品

        appliedGoodsVoList = unifiedSupplierInvItemMapperEx.getInvoiceApplyXUnifiedOrderGoodsEd(accountingOrderSn);

        if (AnCollectionUtils.isNotEmpty(appliedGoodsVoList)) {

            List<Long> appliedGoodsIds = appliedGoodsVoList.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getUnifiedOrderGoodsId())).map(o -> o.getUnifiedOrderGoodsId()).collect(Collectors.toList());


            // 排除在 容器 内记录
            List<Predicate<InvoiceApplySupplierSelectGoodsVo>> predicatesByOne = new ArrayList<>();
            predicatesByOne.add(r -> !appliedGoodsIds.contains(r.getGoodsId()));

            resultFilter = AnLamdaUtils.filters(result, predicatesByOne);

        } else {
            resultFilter = result;
        }

        log.info("\n开票申请 搜索 accountingOrderSn : {}\n\n\n\n原始数据 : {}\n排除商品 : {}\n过滤结果 : {}\n\n\n\n",
                accountingOrderSn,
                JsonUtils.toJson(result), JsonUtils.toJson(appliedGoodsVoList), JsonUtils.toJson(resultFilter));

        return resultFilter;
    }

    /**
     * 这个供应商对账 开票申请好像逻辑上是没变，基于订单|商品维度创建的对账单是同样兼容
     *
     * @param invoiceApplyEntity
     * @param items
     * @return
     */
    @Override
    public UnifiedSupplierInv opInvoiceApply(UnifiedSupplierInv invoiceApplyEntity, List<UnifiedSupplierInvItem> items) {

        unifiedSupplierInvMapper.insert(invoiceApplyEntity);

        // TODO mark by linjinyu 20201104 这样一个个插有性能问题，有空再去重构
        for (UnifiedSupplierInvItem invoiceApplyXGoodsItem : items) {
            unifiedSupplierInvItemMapper.insert(invoiceApplyXGoodsItem);
        }

        /****************************************** mark by linjinyu 20201104 start ******************************************/

        // TODO 相关于状态要更新
        // 0. 得出 这个 开票申请 影响的 对账单
        // 1. 对账单 开票状态 要作判定
        // 2. 对商品 开票状态 修改 AccountingOrderInvoiceStatusEnum TODO 目前没有字段

        // 关联 更新 对账单 开票申请状态
        processTailUpdateAccountingOrderInvoiceStatus(invoiceApplyEntity.getInvoiceSn(), false);

        /****************************************** mark by linjinyu 20201104   end ******************************************/

        return invoiceApplyEntity;
    }


    /**
     * 供应商对账(结算)-货款管理-row opt 重新开票 mark by linjinyu 20201104
     *
     * @param invoiceApplyEntity
     */
    @Override
    public void opAgain(UnifiedSupplierInv invoiceApplyEntity) {

        // 更新状态
        unifiedSupplierInvMapper.updateByPrimaryKeySelective(invoiceApplyEntity);


        /****************************************** mark by linjinyu 20201104 start ******************************************/

        // TODO 相关于状态要更新
        // 0. 得出 这个 开票申请 影响的 对账单
        // 1. 对账单 开票状态 要作判定
        // 2. 对商品 开票状态 修改 AccountingOrderInvoiceStatusEnum TODO 目前没有字段

        // 关联 更新 对账单 开票申请状态
        processTailUpdateAccountingOrderInvoiceStatus(invoiceApplyEntity.getInvoiceSn(), true);

        /****************************************** mark by linjinyu 20201104   end ******************************************/
    }

    public void opDelete(UnifiedSupplierInv invoiceApplyEntity) {

        // 关联 更新 对账单 开票申请状态
        processTailUpdateAccountingOrderInvoiceStatus(invoiceApplyEntity.getInvoiceSn(), true);

        unifiedSupplierInvMapper.deleteByPrimaryKey(invoiceApplyEntity.getId());
    }


    private void processTailUpdateAccountingOrderInvoiceStatus(String invoiceApplySn, Boolean isDeleteX) {

        List<String> affectedAccountingOrderSns = unifiedSupplierInvItemService.getAffectedAccountingOrderSnsByInvoiceApplySn(invoiceApplySn);

        if (isDeleteX.equals(true)) {
            // 删除 关联关系 invoiceApplyXGoodsItem
            unifiedSupplierInvItemMapperEx.deleteByInvoiceSn(invoiceApplySn);
        }

        for (String processAccountingOrderSn : affectedAccountingOrderSns) {

            unifiedSupplierInvItemService.checkInvoiceStatusByAccountingOrderSnAndUpdateAccountingEntityFocusSupplier(processAccountingOrderSn);
        }


    }


    public void patchInvoiceApplyFieldStatistics() {

        // 先得到全部对账

        // 已拒绝的关联关系也没了，没必要拉出来了
        UnifiedSupplierInvExample example = new UnifiedSupplierInvExample();
        example.createCriteria()
//                <!-- 1-未审核;2-同意;3-拒绝 -->
//                inva.audit_status in (1,2)
                .andAuditStatusIn(Arrays.asList(1, 2));

        List<UnifiedSupplierInv> processInvoiceApplyList = unifiedSupplierInvMapper.selectByExample(example);

        // 每个开票申请
        for (UnifiedSupplierInv invoiceApplyEntity4Process : processInvoiceApplyList) {

            List<InvoiceApplySupplierSelectGoodsVo> invoiceApplySupplierSelectGoodsVoList = new ArrayList<>();

            // 得到每份关联数据
            UnifiedSupplierInvItemExample getInvoiceApplyXExample = new UnifiedSupplierInvItemExample();
            getInvoiceApplyXExample.clear();
            getInvoiceApplyXExample.createCriteria()
                    .andInvoiceSnEqualTo(invoiceApplyEntity4Process.getInvoiceSn());

            List<UnifiedSupplierInvItem> X = unifiedSupplierInvItemMapper.selectByExample(getInvoiceApplyXExample);




            // 假定每份数据都可能 包含多个对账单
            Map<String, List<Long>> processAccountingOrderList = X.parallelStream()
                    .collect(Collectors.groupingBy(UnifiedSupplierInvItem::getAccountingOrderSn, Collectors.mapping(UnifiedSupplierInvItem::getGoodsId, Collectors.toList())));

            for (Map.Entry<String, List<Long>> _entry : processAccountingOrderList.entrySet()) {

                List<InvoiceApplySupplierSelectGoodsVo> sampleData = unifiedSupplierInvService.getStatementOfAccountGoodsListBySysUnifiedOrderGoodsIds(_entry.getKey(), _entry.getValue());

                if (AnCollectionUtils.isNotEmpty(sampleData)) {
                    invoiceApplySupplierSelectGoodsVoList.addAll(sampleData);
                }
            }



            UnifiedSupplierInv invoiceApplyEntity4Update = new UnifiedSupplierInv();

            invoiceApplyEntity4Update.setId(invoiceApplyEntity4Process.getId());

            /****************************************** 统计 start ******************************************/

            Long accountingOrderSnCount = invoiceApplySupplierSelectGoodsVoList.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getAccountingOrderSn())).map(o -> o.getAccountingOrderSn()).collect(Collectors.counting());
            Long orderSnCount           = invoiceApplySupplierSelectGoodsVoList.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getOrderSn())).map(o -> o.getOrderSn()).collect(Collectors.counting());
            Long goodsQuantity          = invoiceApplySupplierSelectGoodsVoList.stream().map(o -> o.getGoodsId()).collect(Collectors.counting());
            Long goodsItemQuantity      = invoiceApplySupplierSelectGoodsVoList.stream().map(o -> o.getQuantity()).collect(Collectors.counting());

            BigDecimal goodsAmount = invoiceApplySupplierSelectGoodsVoList
                    .stream()
                    .map(item -> item.getCostPrice() == null ? BigDecimal.ZERO : item.getPrice().multiply(new BigDecimal(item.getQuantity())))
                    .reduce(BigDecimal.ZERO, BigDecimal::add);

            BigDecimal goodsCostAmount = invoiceApplySupplierSelectGoodsVoList
                    .stream()
                    .map(item -> item.getCostPrice() == null ? BigDecimal.ZERO : item.getCostPrice().multiply(new BigDecimal(item.getQuantity())))
                    .reduce(BigDecimal.ZERO, BigDecimal::add);

            invoiceApplyEntity4Update.setAccountingOrderQuantity(accountingOrderSnCount.intValue());
            invoiceApplyEntity4Update.setOrderQuantity(orderSnCount.intValue());
            invoiceApplyEntity4Update.setOrderAmount(goodsCostAmount);
            invoiceApplyEntity4Update.setGoodsAmount(goodsAmount);
            invoiceApplyEntity4Update.setGoodsCostAmount(goodsCostAmount);
            invoiceApplyEntity4Update.setGoodsQuantity(goodsQuantity.intValue());
            invoiceApplyEntity4Update.setGoodsItemQuantity(goodsItemQuantity.intValue());

            unifiedSupplierInvMapper.updateByPrimaryKeySelective(invoiceApplyEntity4Update);

            /****************************************** 统计   end ******************************************/

        }


    }

}
