package cn.superdesk.uniorder.service.operationCenter.order.impl;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.operationCenter.OperationCenterOrder;
import cn.superdesk.uniorder.dao.mapper.operationCenter.OperationCenterOrderMapper;
import cn.superdesk.uniorder.dto.param.operationCenter.order.OperationCenterOrderParam;
import cn.superdesk.uniorder.dto.vo.operationCenter.order.OperationCenterOrderFormVo;
import cn.superdesk.uniorder.dto.vo.operationCenter.order.OperationCenterOrderVo;
import cn.superdesk.uniorder.service.operationCenter.order.OperationCenterOrderService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * @Author : zx
 * @Create : 2023/3/24 17:04
 * Description :
 */
@Slf4j
@Service
@RequiredArgsConstructor
public class OperationCenterOrderServiceImpl implements OperationCenterOrderService {
    private final OperationCenterOrderMapper operationCenterOrderMapper;


    @Override
    public int insertSelective(OperationCenterOrder operationCenterOrder) {
        return operationCenterOrderMapper.insertSelective(operationCenterOrder);
    }

    @Override
    public int updateByPrimaryKeySelective(OperationCenterOrder operationCenterOrder) {
        return operationCenterOrderMapper.updateByPrimaryKeySelective(operationCenterOrder);
    }

    @Override
    public void deleteObj(Long id) {
        operationCenterOrderMapper.deleteByPrimaryKey(id);
    }

    @Override
    public OperationCenterOrder findById(Long id) {
        return operationCenterOrderMapper.selectByPrimaryKey(id);
    }

    @Override
    public List<OperationCenterOrder> findAll(Map<String, Object> queryMap) {
        return null;
    }

    @Override
    public PageInfo<OperationCenterOrder> findByPaging(Map<String, Object> params, Integer pageNo, Integer pageSize) {
        return null;
    }

    /**
     *  条件查询运营中心订单列表
     * @param param
     * @return
     */
    @Override
    public R<OperationCenterOrderFormVo> list(OperationCenterOrderParam param) {
        PageHelper.startPage(param.getPageNumber(), param.getPageSize());
        OperationCenterOrderFormVo formVo =new OperationCenterOrderFormVo();
        List<OperationCenterOrderVo> resultList = operationCenterOrderMapper.getOperatorCenterOrderList(param);

        formVo.setOperationCenterOrderVos(resultList);
        Map<String, Object> mapCount = operationCenterOrderMapper.getOrderStatisticsCount(param);
        formVo.setOrderCount((Long) mapCount.get("orderCount"));
        formVo.setOrderGoodsAmountCount((BigDecimal) mapCount.get("orderGoodsAmountCount"));
        formVo.setTransportAmountCount((BigDecimal)mapCount.get("transportAmountCount"));
        formVo.setDiscountAmountCount((BigDecimal)mapCount.get("discountAmountCount"));
        formVo.setOrderPriceCount((BigDecimal)mapCount.get("orderPriceCount"));
        formVo.setOrderSettlementAmountCount((BigDecimal)mapCount.get("orderSettlementAmountCount"));

        PageInfo<OperationCenterOrderVo> page       = new PageInfo<OperationCenterOrderVo>(resultList);
        PageHelper.clearPage();

        return new R<OperationCenterOrderFormVo>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(),formVo );

    }
}
