package cn.superdesk.uniorder.service.organisation.impl;

import cn.hutool.core.lang.Snowflake;
import cn.hutool.core.util.StrUtil;
import cn.superdesk.app.supercloud.dto.receive.organisation.VirtualarchitectureReceiveParam;
import cn.superdesk.uniorder.common.chinese.ChinesePingYinFirstLetterUtil;
import cn.superdesk.uniorder.common.exception.constants.ExceptionMsg;
import cn.superdesk.uniorder.common.enums.common.CommonEnabledEnum;
import cn.superdesk.uniorder.common.enums.common.CommonSoftDeleteEnum;
import cn.superdesk.uniorder.common.enums.common.CommonSourceFromEnum;
import cn.superdesk.uniorder.common.exception.UnifiedOrderRuntimeException;
import cn.superdesk.uniorder.common.exception.utils.AssertUtils;
import cn.superdesk.uniorder.common.exception.utils.ExceptionUtils;
import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.common.lamda.AnLamdaUtils;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import cn.superdesk.uniorder.common.numerical.AnCollectionUtils;
import cn.superdesk.uniorder.common.numerical.AnLongUtils;
import cn.superdesk.uniorder.common.numerical.AnStringUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.organisation.SysEnterprise;
import cn.superdesk.uniorder.dao.entity.organisation.SysEnterpriseExample;
import cn.superdesk.uniorder.dao.entity.organisation.SysOrganization;
import cn.superdesk.uniorder.dao.entity.unified.TempDaide;
import cn.superdesk.uniorder.dao.mapper.organisation.SysEnterpriseMapper;
import cn.superdesk.uniorder.dao.mapper.organisation.SysEnterpriseMapperEx;
import cn.superdesk.uniorder.dao.mapper.unified.TempDaideMapper;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.SlaveVirtualarchitectureReceiveParam;
import cn.superdesk.uniorder.dto.vo._function.select.SelectOptionVirt;
import cn.superdesk.uniorder.dto.vo.sys.SysOrganizationXEnterprise;
import cn.superdesk.uniorder.event.CommonEventPublisher;
import cn.superdesk.uniorder.service.organisation.SysEnterpriseService;
import cn.superdesk.uniorder.service.organisation.SysOrganizationService;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 7/7/20 3:44 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 7/7/20 3:44 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class SysEnterpriseServiceImpl implements SysEnterpriseService {

	@Autowired
	private SysEnterpriseMapper   sysEnterpriseMapper;
	@Autowired
	private SysEnterpriseMapperEx sysEnterpriseMapperEx;
	@Autowired
	private TempDaideMapper       tempDaideMapper;

	@Autowired
	private SysOrganizationService sysOrganizationService;

	@Autowired
	private CommonEventPublisher commonEventPublisher;

	@Resource
	private Snowflake snowflake;


	/****************************************** extends BaseService 部分 start ******************************************/

	@Override
	public void addObj(SysEnterprise entity) {
		sysEnterpriseMapper.insert(entity);
	}

	@Override
	public void updateObj(SysEnterprise entity) {
		sysEnterpriseMapper.updateByPrimaryKeySelective(entity);
	}

	@Override
	public void deleteObj(Long id) {
		sysEnterpriseMapper.deleteByPrimaryKey(id);
	}

	@Override
	public SysEnterprise findById(Long id) {
		return sysEnterpriseMapper.selectByPrimaryKey(id);
	}


	@Override
	public PageInfo<SysEnterprise> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
		return null;
	}

	@Override
	public List<SysEnterprise> findAll(Map<String, Object> queryMap) {
//		return sysEnterpriseMapperEx.findAll(queryMap);
		return null;
	}

	@Override
	public List<SysOrganizationXEnterprise> findSysOrganizationXEnterprise(Map<String, Object> queryMap) {
		return sysEnterpriseMapperEx.findSysOrganizationXEnterprise(queryMap);
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	public void addSysEnterprise(SysEnterprise entity) {
		sysEnterpriseMapper.insertSelective(entity);
	}

	public void updateSysEnterprise(SysEnterprise entity) {
		SysEnterprise originEntity = sysEnterpriseMapper.selectByPrimaryKey(entity.getId());
		AssertUtils.notNull(originEntity);
		AnBeanUtils.copy(entity, originEntity);
		sysEnterpriseMapper.updateByPrimaryKey(originEntity);
	}

	public void deleteSysEnterprise(Long id) {
		sysEnterpriseMapper.deleteByPrimaryKey(id);
	}

	public SysEnterprise findSysEnterpriseById(Long id) {
		SysEnterprise entity = sysEnterpriseMapper.selectByPrimaryKey(id);
//		AssertUtil.notNull(entity);
		return entity;
	}

	public R<List<SysEnterprise>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

		// 样例 保留
//		SysEnterprise sysEnterpriseConditions = AnBeanUtils.mapToBean(conditions,SysEnterprise.class);

		SysEnterpriseExample          example  = new SysEnterpriseExample();
		SysEnterpriseExample.Criteria criteria = example.createCriteria();

		if (null != conditions.get("enterpriseId") && StringUtils.isNotBlank(conditions.get("enterpriseId").toString())) {
			criteria.andEnterpriseIdEqualTo(AnLongUtils.getLong(conditions.get("enterpriseId")));
		}

		PageHelper.startPage(pageNun, pageSize);
		List<SysEnterprise>     resultList = sysEnterpriseMapper.selectByExample(example);
		PageInfo<SysEnterprise> page       = new PageInfo<SysEnterprise>(resultList);
		PageHelper.clearPage();

		return new R<List<SysEnterprise>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

	}


	/****************************************** 之前的 要合并 start ******************************************/


	@Override
	public SysEnterprise findByOutVirtId(Long outVirtId) {
		return sysEnterpriseMapperEx.findByVirtId(outVirtId);
	}

	@Override
	public SysEnterprise findByOutVirtName(String outVirtName) {

		SysEnterpriseExample example = new SysEnterpriseExample();
		example.createCriteria()
				.andEnterpriseNameEqualTo(outVirtName);
		List<SysEnterprise> resultList = sysEnterpriseMapper.selectByExample(example);

		if (AnCollectionUtils.isNotEmpty(resultList)) {
			return resultList.get(0);
		}

		return null;
	}

	@Override
	public List<SysEnterprise> findByOutVirtIds(List<Long> outVirtIds) {

		SysEnterpriseExample example = new SysEnterpriseExample();
		example.createCriteria()
				.andEnterpriseIdIn(outVirtIds);
		List<SysEnterprise> result = sysEnterpriseMapper.selectByExample(example);
		return result;

	}

	@Override
	public Map<Long, SysEnterprise> findByOutVirtIdsConvertKV(List<Long> outVirtIds) {

		Map<Long, SysEnterprise> result = new HashMap<>();

		if (AnCollectionUtils.isNotEmpty(outVirtIds)) {

			List<SysEnterprise> sysEnterpriseList = findByOutVirtIds(outVirtIds);

			if (AnCollectionUtils.isNotEmpty(sysEnterpriseList)) {

				result = sysEnterpriseList.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getEnterpriseId())).collect(Collectors.toMap(SysEnterprise::getEnterpriseId, v -> v, (k, v) -> v));
			}
		}

		return result;

	}

	@Override
	public List<String> convertOutVirtIds2VirtNames(List<Long> outVirtIds) {

		List<String> result = new ArrayList<>();

		List<SysEnterprise> sysEnterpriseList = findByOutVirtIds(outVirtIds);

		if (AnCollectionUtils.isNotEmpty(sysEnterpriseList)) {
			result = sysEnterpriseList.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getEnterpriseId())).map(SysEnterprise::getEnterpriseName).collect(Collectors.toList());
		}

		return result;

	}

	@Override
	public List<SysEnterprise> findByVirtName(Long orgId, String enterpriseName) {

		if (orgId == null) {
			throw new UnifiedOrderRuntimeException(ExceptionMsg.SYS_ERROR.getCode(), "项目Id不能为空");
		}

//		Map<String, Object> params = new HashMap<>();
//		params.put("enterpriseName", enterpriseName);
//		return sysEnterpriseMapperEx.findAll(params);

		SysEnterpriseExample example = new SysEnterpriseExample();
		example.createCriteria()
				.andEnterpriseNameLike("%" + enterpriseName + "%");

		return sysEnterpriseMapper.selectByExample(example);
	}

	/***
	 * 企业下拉列表 daizhi 19-0808
	 */
	@Override
	public R<List<SelectOptionVirt>> getVirtSelect(Map<String, Object> params, int pageNo, int pageSize) {

		PageHelper.startPage(pageNo, pageSize);

		List<SelectOptionVirt> ls = sysEnterpriseMapperEx.getVirtSelect(params);

		PageInfo<SelectOptionVirt> page = new PageInfo<SelectOptionVirt>(ls);
		PageHelper.clearPage();

		return new R<List<SelectOptionVirt>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), ls);

	}

	@Override
	public List<SelectOptionVirt> getVirtSelectByOutOrgId(Long outOrgId) {

		List<SelectOptionVirt> result = new ArrayList<>();

		Map<String, Object> params = new HashMap<>();
		params.put("projectId", outOrgId);

		result = sysEnterpriseMapperEx.getVirtSelect(params);

		return result;
	}


	@Override
	public R<List<SelectOptionVirt>> getVirtSelectByOutOrgId(Long outOrgId, int pageNum, int pageSize) {
		Map<String, Object> params = new HashMap<>();
		params.put("projectId", outOrgId);

		return getVirtSelect(params, pageNum, pageSize);
	}

	@Override
	public List<Long> getOutVirtIdsByOutOrgId(Long outOrgId) {


		List<Long> result = new ArrayList<>();

		SysEnterpriseExample example = new SysEnterpriseExample();
		example.createCriteria()
				.andOrganizationIdEqualTo(outOrgId);

		List<SysEnterprise> sysEnterpriseList = sysEnterpriseMapper.selectByExample(example);

		result = sysEnterpriseList.stream().filter(AnLamdaUtils.distinctByKey(o -> o.getEnterpriseId())).map(SysEnterprise::getEnterpriseId).collect(Collectors.toList());

		log.info("\n\n\n\ngetOutVirtIdsByOutOrgId \nparams outOrgId : {}\nresult : {}\n\n\n\n", outOrgId, JsonUtils.toJson(result));

		return result;
	}

	@Override
	public void addSpecDaiDeLiangHang(Long id) {

		TempDaide daide = new TempDaide();
		daide.setId(id);
		tempDaideMapper.insert(daide);
	}

	@Override
	public void deleteDaiDeLiangHang(Long id) {

		tempDaideMapper.deleteByPrimaryKey(id);
	}


	/****************************************** 之前的 要合并   end ******************************************/


	/****************************************** 来源于 商城的 kafka 同步 start start ******************************************/

	private void convertReceiveVirtualarchitectureParam2Entity4SuperdeskMall(SlaveVirtualarchitectureReceiveParam params, SysEnterprise entity) {

		entity.setEnterpriseId(params.getId());
		entity.setEnterpriseName(params.getEnterpriseName());
		entity.setEnterpriseNo(params.getEnterpriseNo());
		entity.setOrganizationId(params.getOrganizationId());
		entity.setSyncTime(new Date());

		entity.setEnabled(CommonEnabledEnum.启用.getKey());
		entity.setDeleted(CommonSoftDeleteEnum.正常.getKey());

		entity.setOtherField3("来源于侨城汇商城?");
	}

	@Override
	public void mergeReceiveVirtualarchitecture4SuperdeskMall(String message) {

		try {

			SysEnterprise sysEnterprise = null;

			SlaveVirtualarchitectureReceiveParam params = JsonUtils.toObject(message, SlaveVirtualarchitectureReceiveParam.class);

			// TODO 先让他 覆盖吧
			SysEnterpriseExample example = new SysEnterpriseExample();
			example.createCriteria()
					.andEnterpriseIdEqualTo(params.getId());
//					.andEnterpriseNameEqualTo(params.getEnterpriseName())
//					.andEnterpriseNoEqualTo(params.getEnterpriseNo())
//					.andOrganizationIdEqualTo(params.getOrganizationId());

			List<SysEnterprise> checkExists = sysEnterpriseMapper.selectByExample(example);

			if (AnCollectionUtils.isEmpty(checkExists)) {

				sysEnterprise = new SysEnterprise();
				convertReceiveVirtualarchitectureParam2Entity4SuperdeskMall(params, sysEnterprise);
				sysEnterpriseMapper.insert(sysEnterprise);

			} else {

				sysEnterprise = checkExists.get(0);
				convertReceiveVirtualarchitectureParam2Entity4SuperdeskMall(params, sysEnterprise);
				sysEnterpriseMapper.updateByPrimaryKey(sysEnterprise);
			}

			// 更新订单
			commonEventPublisher.triggerEnterpriseEvent(sysEnterprise);

		} catch (Exception e) {

			e.printStackTrace();
			log.error("商城 同步 统一订单 (侨城汇)-mergeReceiveVirtualarchitecture 失败:{}", ExceptionUtils.getMessage(e));
		}


	}

	@Override
	@Deprecated
	public void deleteReceiveVirtualarchitecture4SuperdeskMall(String message) {

	}


	/****************************************** 来源于 商城的 kafka 同步   end start ******************************************/


	/****************************************** 来源于 服务之窗 kafka 同步 start start ******************************************/


	private void convertVirtualarchitectureReceiveParam2Entity(VirtualarchitectureReceiveParam virtualarchitectureReceiveParam, SysEnterprise sysEnterprise) {

		sysEnterprise.setEnterpriseId(virtualarchitectureReceiveParam.getId().longValue());
		sysEnterprise.setEnterpriseNo(virtualarchitectureReceiveParam.getCodeNumber());
		sysEnterprise.setEnterpriseName(virtualarchitectureReceiveParam.getName());

		sysEnterprise.setOrganizationId(virtualarchitectureReceiveParam.getOrgId().longValue());
		sysEnterprise.setSyncTime(new Date());
		sysEnterprise.setEnabled(virtualarchitectureReceiveParam.getEnabled());

		/****************************************** 添加软删除 at 20201130 start ******************************************/
		if (null != virtualarchitectureReceiveParam.getEnabled()) {
			sysEnterprise.setDeleted(virtualarchitectureReceiveParam.getEnabled().equals(1) ? 0 : 1);
		} else {
			// 默认为未删除
			sysEnterprise.setDeleted(CommonSoftDeleteEnum.正常.getKey());
		}

		/****************************************** 添加软删除 at 20201130 start ******************************************/

	}

	@Override
	public void mergeReceiveVirtualarchitecture4SuperdeskTransfer(String message) {

		try {

			VirtualarchitectureReceiveParam virtualarchitectureReceiveParam = JsonUtils.toObject(message, VirtualarchitectureReceiveParam.class);

			log.info(JsonUtils.toJson(virtualarchitectureReceiveParam));

			SysEnterprise sysEnterprise = sysEnterpriseMapperEx.findByVirtId(virtualarchitectureReceiveParam.getId().longValue());

			if (null == sysEnterprise) {

				sysEnterprise = new SysEnterprise();

				convertVirtualarchitectureReceiveParam2Entity(virtualarchitectureReceiveParam, sysEnterprise);

				sysEnterpriseMapper.insertSelective(sysEnterprise);

			} else {

				convertVirtualarchitectureReceiveParam2Entity(virtualarchitectureReceiveParam, sysEnterprise);

				sysEnterpriseMapper.updateByPrimaryKeySelective(sysEnterprise);
			}

			// 更新订单
			commonEventPublisher.triggerEnterpriseEvent(sysEnterprise);


		} catch (Exception e) {

			e.printStackTrace();
			log.error("服务之窗 同步 统一订单-Virtualarchitecture 失败:{}", ExceptionUtils.getMessage(e));

		}
	}

	@Override
	public void deleteReceiveVirtualarchitecture4SuperdeskTransfer(String message) {

		VirtualarchitectureReceiveParam virtualarchitectureReceiveParam = JsonUtils.toObject(message, VirtualarchitectureReceiveParam.class);


		// TODO 先让他 覆盖吧
		SysEnterpriseExample example = new SysEnterpriseExample();
		example.createCriteria()
				.andEnterpriseIdEqualTo(virtualarchitectureReceiveParam.getId().longValue());
//					.andEnterpriseNameEqualTo(params.getEnterpriseName())
//					.andEnterpriseNoEqualTo(params.getEnterpriseNo())
//					.andOrganizationIdEqualTo(params.getOrganizationId());

		List<SysEnterprise> checkExists = sysEnterpriseMapper.selectByExample(example);

		if (AnCollectionUtils.isNotEmpty(checkExists)) {
			for (SysEnterprise item : checkExists) {
				item.setEnabled(CommonEnabledEnum.禁用.getKey());
				item.setDeleted(CommonSoftDeleteEnum.删除.getKey());
				sysEnterpriseMapper.updateByPrimaryKey(item);
			}
		}
	}


	/****************************************** 来源于 服务之窗 kafka 同步  end start ******************************************/


	/****************************************** 关于游客问题 start ******************************************/

	public SysEnterprise touchByOutOrgId(Long outOrgId) {

		SysEnterpriseExample example = new SysEnterpriseExample();
		example.createCriteria()
				.andSourceFromEqualTo(CommonSourceFromEnum.统一订单.getSourceFromCode())
				.andOrganizationIdEqualTo(outOrgId);

		List<SysEnterprise> checkExists = sysEnterpriseMapper.selectByExample(example);

		if (AnCollectionUtils.isNotEmpty(checkExists)) {
			return checkExists.get(0);
		} else {
			// TODO 创建一个
			return createByBizVisitorLogic(outOrgId);
		}
	}

	/**
	 * 先是要已知项目是更名
	 *
	 * @param sysOrganization
	 * @return
	 */
	public SysEnterprise renameByOutOrgId(SysOrganization sysOrganization) {

		SysEnterpriseExample example = new SysEnterpriseExample();
		example.createCriteria()
				.andSourceFromEqualTo(CommonSourceFromEnum.统一订单.getSourceFromCode())
				.andOrganizationIdEqualTo(sysOrganization.getOrganizationId());

		List<SysEnterprise> checkExists = sysEnterpriseMapper.selectByExample(example);

		if (AnCollectionUtils.isNotEmpty(checkExists)) {

			SysEnterprise existSysEnterprise = checkExists.get(0);

			SysEnterprise visitorVirt = new SysEnterprise();

			visitorVirt.setId(existSysEnterprise.getId());
			String knownObjectName = StrUtil.format("{}{}", sysOrganization.getOrganizationName(), "@游客企业");

			visitorVirt.setEnterpriseNo(ChinesePingYinFirstLetterUtil.getPinYinHeadChar(knownObjectName));
			visitorVirt.setEnterpriseName(knownObjectName);

			sysEnterpriseMapper.updateByPrimaryKeySelective(visitorVirt);

			return visitorVirt;
		}

		return null;
	}

	/**
	 * 项目名称+游客企业
	 * 编码为企业名称首先字母，地址、联系人、联系电话均为企业名称。
	 *
	 * @param outOrgId
	 * @return
	 */
	public SysEnterprise createByBizVisitorLogic(Long outOrgId) {

		Long   snowflakeId    = snowflake.nextId();
		String snowflakeIdStr = AnStringUtils.getString(snowflakeId);
//		截取
		String snowflakeStrSub = snowflakeIdStr.substring(snowflakeIdStr.length() - 16, snowflakeIdStr.length());

		SysOrganization sysOrganization = sysOrganizationService.getByOutOrgId(outOrgId);

		SysEnterprise visitorVirt = new SysEnterprise();
		visitorVirt.setSourceFrom(CommonSourceFromEnum.统一订单.getSourceFromCode());
		visitorVirt.setOrganizationId(outOrgId);
		visitorVirt.setEnterpriseId(AnLongUtils.getLong(snowflakeStrSub));


		visitorVirt.setEnabled(CommonEnabledEnum.启用.getKey());
		visitorVirt.setDeleted(CommonSoftDeleteEnum.正常.getKey());
		// 是否有订单:0-默认;1-有的;2-没有;
		visitorVirt.setIsHasOrder(0);

		if (null == sysOrganization) {

			log.error("哪里?outOrgId查不到数据? {}", outOrgId);

			String unknownObjectName = StrUtil.format("未知项目[{}]", outOrgId);

			visitorVirt.setEnterpriseNo(ChinesePingYinFirstLetterUtil.getPinYinHeadChar(unknownObjectName));
			visitorVirt.setEnterpriseName(unknownObjectName);

		} else {

			String knownObjectName = StrUtil.format("{}{}", sysOrganization.getOrganizationName(), "@游客企业");

			visitorVirt.setEnterpriseNo(ChinesePingYinFirstLetterUtil.getPinYinHeadChar(knownObjectName));
			visitorVirt.setEnterpriseName(knownObjectName);
		}

		sysEnterpriseMapper.insertSelective(visitorVirt);

		return visitorVirt;

	}

	/****************************************** 关于游客问题   end ******************************************/

	/****************************************** 工具方法  start ******************************************/
	public Map<Long, SysEnterprise> convertOutVirtIds2MapOutVirtId2Entity(List<Long> outVirtIds) {

		Map<Long, SysEnterprise> result = new HashMap<>();

		if (AnCollectionUtils.isNotEmpty(outVirtIds)) {

			List<SysEnterprise> resultList = findByOutVirtIds(outVirtIds);

			if (AnCollectionUtils.isNotEmpty(resultList)) {

				result = resultList.stream().collect(Collectors.toMap(SysEnterprise::getEnterpriseId, v -> v, (k, v) -> v));
			}
		}

		return result;
	}

	/****************************************** 工具方法    end ******************************************/

	@Override
	public Long countOutVirt() {
		SysEnterpriseExample example = new SysEnterpriseExample();
		return sysEnterpriseMapper.countByExample(example);
	}

}
