package cn.superdesk.uniorder.service.scheduler.impl;

import cn.hutool.core.date.DateUtil;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.scheduler.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.dao.entity.scheduler.SysQuartzScheduleTaskStatementOfAccountJdExample;
import cn.superdesk.uniorder.dao.mapper.scheduler.SysQuartzScheduleTaskStatementOfAccountJdMapper;
import cn.superdesk.uniorder.dao.mapper.scheduler.SysQuartzScheduleTaskStatementOfAccountJdMapperEx;
import cn.superdesk.uniorder.dto.param.scheduler.SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria;
import cn.superdesk.uniorder.service.scheduler.SysQuartzScheduleTaskStatementOfAccountJdService;
import cn.superdesk.uniorder.common.numerical.AnBeanUtils;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @Description: 定时任务-时刻任务-对账单
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Service
public class SysQuartzScheduleTaskStatementOfAccountJdServiceImpl implements SysQuartzScheduleTaskStatementOfAccountJdService {

	@Autowired
	private SysQuartzScheduleTaskStatementOfAccountJdMapper   sysQuartzScheduleTaskStatementOfAccountJdMapper;
	@Autowired
	private SysQuartzScheduleTaskStatementOfAccountJdMapperEx sysQuartzScheduleTaskStatementOfAccountJdMapperEx;


	/****************************************** extends BaseService 部分 start ******************************************/
	@Override
	public void addObj(SysQuartzScheduleTaskStatementOfAccountJd entity) {
		sysQuartzScheduleTaskStatementOfAccountJdMapper.insert(entity);
	}

	@Override
	public void updateObj(SysQuartzScheduleTaskStatementOfAccountJd entity) {
		sysQuartzScheduleTaskStatementOfAccountJdMapper.updateByPrimaryKeySelective(entity);
	}

	@Override
	public void deleteObj(Long id) {
	}

	@Override
	public SysQuartzScheduleTaskStatementOfAccountJd findById(Long id) {
		return sysQuartzScheduleTaskStatementOfAccountJdMapper.selectByPrimaryKey(id);
	}

	@Override
	public PageInfo<SysQuartzScheduleTaskStatementOfAccountJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {
		return null;
	}

	@Override
	public List<SysQuartzScheduleTaskStatementOfAccountJd> findAll(Map<String, Object> queryMap) {
		return null;
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	public void addSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJd entity) {

		entity.setCreateTime(DateUtil.date());
		entity.setCreateUserId(1L);

		sysQuartzScheduleTaskStatementOfAccountJdMapper.insertSelective(entity);
	}

	public void updateSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJd entity) {
		SysQuartzScheduleTaskStatementOfAccountJd originEntity = sysQuartzScheduleTaskStatementOfAccountJdMapper.selectByPrimaryKey(entity.getId());
//		AssertUtil.notNull(originEntity);
		AnBeanUtils.copy(entity, originEntity);
		sysQuartzScheduleTaskStatementOfAccountJdMapper.updateByPrimaryKey(originEntity);
	}

	public void deleteSysQuartzScheduleTaskStatementOfAccountJd(Long id) {
		sysQuartzScheduleTaskStatementOfAccountJdMapper.deleteByPrimaryKey(id);
	}

	public SysQuartzScheduleTaskStatementOfAccountJd findSysQuartzScheduleTaskStatementOfAccountJdById(Long id) {
		SysQuartzScheduleTaskStatementOfAccountJd entity = sysQuartzScheduleTaskStatementOfAccountJdMapper.selectByPrimaryKey(id);
//		AssertUtil.notNull(entity);
		return entity;
	}

	public R<List<SysQuartzScheduleTaskStatementOfAccountJd>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

		SysQuartzScheduleTaskStatementOfAccountJdExample          example  = new SysQuartzScheduleTaskStatementOfAccountJdExample();
		SysQuartzScheduleTaskStatementOfAccountJdExample.Criteria criteria = example.createCriteria();

		// TODO 喜欢用Map 还是 Bean 自己喜欢... 后期添加 转 SysQuartzScheduleTaskStatementOfAccountJdExample.Criteria
		// SysQuartzScheduleTaskStatementOfAccountJd sysQuartzScheduleTaskStatementOfAccountJdConditions = AnBeanUtils.mapToBean(conditions,SysQuartzScheduleTaskStatementOfAccountJd.class);

		PageHelper.startPage(pageNun, pageSize);
		List<SysQuartzScheduleTaskStatementOfAccountJd>     resultList = sysQuartzScheduleTaskStatementOfAccountJdMapper.selectByExample(example);
		PageInfo<SysQuartzScheduleTaskStatementOfAccountJd> page       = new PageInfo<SysQuartzScheduleTaskStatementOfAccountJd>(resultList);
		PageHelper.clearPage();

		return new R<List<SysQuartzScheduleTaskStatementOfAccountJd>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

	}

	public R<List<SysQuartzScheduleTaskStatementOfAccountJd>> pageQueryGenericParam(SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria) {

//		SysQuartzScheduleTaskStatementOfAccountJdExample          example  = new SysQuartzScheduleTaskStatementOfAccountJdExample();
//		SysQuartzScheduleTaskStatementOfAccountJdExample.Criteria criteria = example.createCriteria();
//
//		// TODO 添加条件... 后期添加 queryCriteria 转 SysQuartzScheduleTaskStatementOfAccountJdExample.Criteria
//
//		// 产品(账单类型：京东) 对账单类型 1-客户结算;2-供应商结算;21-供应商结算-京东;
//		if (null != queryCriteria.getStatementOfAccountType()) {
//			criteria
//					.andStatementOfAccountTypeEqualTo(queryCriteria.getStatementOfAccountType());
//		}
//
//		// 产品(⑥支持结算周期查询，导入账单时输入的周期) eg 2021-01-01
//		if (ObjectUtil.isNotNull(queryCriteria.getCycleBeginTime()) && ObjectUtil.isNotNull(queryCriteria.getCycleEndTime())) {
//			criteria
//					.andCycleBeginTimeEqualTo(DateUtil.beginOfDay(queryCriteria.getCycleBeginTime()))
//					.andCycleEndTimeEqualTo(DateUtil.endOfDay(queryCriteria.getCycleEndTime()));
//		}
//
//		// 产品(⑧支持核对编号查询) 批次Id
//		if (StrUtil.isNotBlank(queryCriteria.getBatchId())) {
//			criteria
//					.andBatchIdEqualTo(queryCriteria.getBatchId());
//		}
//
//		/****************************************** 状态 start ******************************************/
//
//		// 产品(③支持任务状态下拉查询：任务状态：待执行、执行中、执行成功、执行失败) 说明 前端上传完Excel与提交完表单后 后端创建任务 任务状态为 待执行 |
//		if (ObjectUtil.isNotNull(queryCriteria.getRunState())) {
//			criteria
//					.andRunStateEqualTo(queryCriteria.getRunState());
//		}
//		// 产品(②支持导入状态下拉查询：导入状态：成功、失败) 说明 Excel的数据全部入库视之为 导入状态 成功 | 任务运行状态：-1-失败;0-待命;1-成功
//		if (ObjectUtil.isNotNull(queryCriteria.getProcessState())) {
//			criteria
//					.andProcessStateEqualTo(queryCriteria.getProcessState());
//		}
//		// 产品(⑤支持核对状态下拉查询：核对状态：正常、异常) 添加个 初始状态为 初始 0
//		if (ObjectUtil.isNotNull(queryCriteria.getCheckState())) {
//			criteria
//					.andCheckStateEqualTo(queryCriteria.getCheckState());
//		}
//		// 产品(④支持账单状态下拉查询：账单状态：待确认、已确认、已取消) 初始状态为 待确认 0  | 对账单(结算单)状态:-1-已取消;0-未确认(待确认);1-已确认;2-已拒绝;3-待提交;
//		if (ObjectUtil.isNotNull(queryCriteria.getAccountingStatus())) {
//			criteria
//					.andAccountingStatusEqualTo(queryCriteria.getAccountingStatus());
//		}
//
//		/****************************************** 状态   end ******************************************/
//
//		// 产品(⑥支持结算周期查询，导入账单时输入的周期) eg 2021-01-01
//		if (ObjectUtil.isNotNull(queryCriteria.getStartTime()) && ObjectUtil.isNotNull(queryCriteria.getEndTime())) {
//			criteria
//					.andCreateTimeBetween(DateUtil.beginOfDay(queryCriteria.getStartTime()), DateUtil.endOfDay(queryCriteria.getEndTime()));
//		}


		PageHelper.startPage(queryCriteria.getPageNumber(), queryCriteria.getPageSize());

//		List<SysQuartzScheduleTaskStatementOfAccountJd> resultList = sysQuartzScheduleTaskStatementOfAccountJdMapper.selectByExample(example);


		List<SysQuartzScheduleTaskStatementOfAccountJd> resultList = sysQuartzScheduleTaskStatementOfAccountJdMapperEx.pageQueryGenericParam(queryCriteria);

		PageInfo<SysQuartzScheduleTaskStatementOfAccountJd> page = new PageInfo<SysQuartzScheduleTaskStatementOfAccountJd>(resultList);

		PageHelper.clearPage();

		return new R<List<SysQuartzScheduleTaskStatementOfAccountJd>>(page.getPageNum(), page.getPageSize(), (int) page.getTotal(), resultList);

	}

	/****************************************** 检查 start ******************************************/

//	public R<String> opCheckUp(SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form){
//
//
//		return ResponseResultUtil.createSuccesResult();
//	}

}