package cn.superdesk.uniorder.config;

import com.github.xiaoymin.knife4j.spring.annotations.EnableKnife4j;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import springfox.documentation.builders.ApiInfoBuilder;
import springfox.documentation.builders.PathSelectors;
import springfox.documentation.builders.RequestHandlerSelectors;
import springfox.documentation.service.ApiInfo;
import springfox.documentation.service.Contact;
import springfox.documentation.spi.DocumentationType;
import springfox.documentation.spring.web.plugins.Docket;
import springfox.documentation.swagger2.annotations.EnableSwagger2;

@Configuration
@EnableSwagger2
@EnableKnife4j
public class Knife4jConfig {

	@Bean
	public Docket createRestApi() {
		return new Docket(DocumentationType.SWAGGER_2)
				.useDefaultResponseMessages(false)
				.apiInfo(apiInfo())
				.select()
				.apis(RequestHandlerSelectors.basePackage("cn.superdesk.uniorder.controller"))
				.paths(PathSelectors.any())
				.build();

	}

	    private ApiInfo apiInfo() {
        return new ApiInfoBuilder()
                .title("Superdesk UniOrder Services APIs")
                .description("Superdesk UniOrder Services Readme")
                .termsOfServiceUrl("https://www.superdesk.cn/superdesk-uniorder")
                .contact(new Contact("linjinyu", "", "linjinyu@avic-s.com"))
                .version("1.0")
                .build();
    }

}