package cn.superdesk.uniorder.controller.accounting.supplier.jd;

import cn.hutool.json.JSONUtil;
import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.controller.base.BaseController;
import cn.superdesk.uniorder.dto.param.accounting.jd.AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria;
import cn.superdesk.uniorder.dubbo.consumer.accounting.AccountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


/**
 * @Description: 京东对账单中的订单 算是临时 sheet eg 深圳市侨城汇网络科技有限公司-2021年8月1日集采账单.xlsx
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-14 17:04:08
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-14 17:04:08
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Api(value = "第三方-jd-京东对账-京东账单任务-导出", tags = {"第三方-jd-京东对账-京东账单任务-导出"})
@Slf4j
@RestController
@RequestMapping("/accountingUnifiedSupplierOrderJdCheckUpReport/export")
public class AccountingUnifiedSupplierOrderJdCheckUpReportExportExcelController extends BaseController {

	@Autowired
	private AccountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService;

	/***
	 * 京东账单任务-某次导入数据-报告导出
	 *
	 * http://192.168.6.223:8089/web/accountingUnifiedSupplierOrderJdCheckUpReport/export/excel/jdCheckUpReport
	 * @return
	 */
	@ApiOperation(value = "京东账单任务-某次导入数据-报告导出", notes = "京东账单任务-某次导入数据-报告导出")
	@RequestMapping(value = "/excel/jdCheckUpReport", method = RequestMethod.POST)
	public R<String> exportExcelJdCheckUpReport(@RequestBody AccountingUnifiedSupplierOrderJdCheckUpReportQueryCriteria criteria) {

		log.info("京东账单任务-某次导入数据-报告导出 params: \n{}", JSONUtil.toJsonStr(criteria));

		return new R<String>(accountingUnifiedSupplierOrderJdCheckUpReportDubboConsumerService.exportExcelJdCheckUpReport(criteria, getToken()));
	}

}
