package cn.superdesk.uniorder.controller.invoice.customer;

import cn.superdesk.uniorder.common.exception.utils.ExceptionUtils;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.controller.base.BaseController;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.dubbo.consumer.invoice.customer.InvoiceApplyDubboConsumerService;
import cn.superdesk.uniorder.dubbo.consumer.invoice.customer.InvoiceApplyFieldBackAccountStatusDubboConsumerService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Api(value = "InvoiceApply-BackAccountStatus", tags = {"InvoiceApply-BackAccountStatus"})
@Slf4j
@RestController
@RequestMapping("/invoice/apply/customer/score/state/backAccountStatus")
public class InvoiceApplyCustomerScoreFieldBackAccountStatusController extends BaseController {

	@Autowired
	private InvoiceApplyDubboConsumerService                       invoiceApplyDubboConsumerService;
	@Autowired
	private InvoiceApplyFieldBackAccountStatusDubboConsumerService invoiceApplyFieldBackAccountStatusDubboConsumerService;

	@ApiOperation(value = "InvoiceApply-BackAccountStatus-op 未回款 0")
	@RequestMapping(value = "/opInit/{id}", method = RequestMethod.POST)
	@ResponseBody
	public R<?> opInit(@PathVariable("id") Long id) {

		R<?> result = new R<>();

		try {
			InvoiceApply entity = invoiceApplyDubboConsumerService.findById(id);
			invoiceApplyFieldBackAccountStatusDubboConsumerService.opInit(getToken(), entity);
			result.setSuccess(true);

		} catch (Exception e) {

			result.setSuccess(false);
			result.setMessage("系统错误，请联系管理员！");
			log.error(ExceptionUtils.getMessage(e));
			e.printStackTrace();
		}
		return result;
	}

	@ApiOperation(value = "InvoiceApply-BackAccountStatus-op 部分回款 1")
	@RequestMapping(value = "/opPart/{id}", method = RequestMethod.POST)
	@ResponseBody
	public R<?> opPart(@PathVariable("id") Long id) {

		R<?> result = new R<>();

		try {
			InvoiceApply entity = invoiceApplyDubboConsumerService.findById(id);
			invoiceApplyFieldBackAccountStatusDubboConsumerService.opPart(getToken(), entity);
			result.setSuccess(true);

		} catch (Exception e) {

			result.setSuccess(false);
			result.setMessage("系统错误，请联系管理员！");
			log.error(ExceptionUtils.getMessage(e));
			e.printStackTrace();
		}
		return result;
	}

	@ApiOperation(value = "InvoiceApply-BackAccountStatus-op 已回款 2")
	@RequestMapping(value = "/opComplete/{id}", method = RequestMethod.POST)
	@ResponseBody
	public R<?> opComplete(@PathVariable("id") Long id) {

		R<?> result = new R<>();

		try {
			InvoiceApply entity = invoiceApplyDubboConsumerService.findById(id);
			invoiceApplyFieldBackAccountStatusDubboConsumerService.opComplete(getToken(), entity);
			result.setSuccess(true);

		} catch (Exception e) {

			result.setSuccess(false);
			result.setMessage("系统错误，请联系管理员！");
			log.error(ExceptionUtils.getMessage(e));
			e.printStackTrace();
		}
		return result;
	}


}
