package cn.superdesk.uniorder.controller.scheduler;

import cn.superdesk.libs.common.json.JsonUtils;
import cn.superdesk.uniorder.common.pagination.PageQueryGenericParam;
import cn.superdesk.uniorder.common.pagination.PageQueryParam;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.controller.base.BaseController;
import cn.superdesk.uniorder.dao.entity.scheduler.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.dto.param.scheduler.SysQuartzScheduleTaskStatementOfAccountJdParam;
import cn.superdesk.uniorder.dto.param.scheduler.SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria;
import cn.superdesk.uniorder.dubbo.consumer.scheduler.SysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;


/**
 * @Description: 定时任务-时刻任务-京东对账单
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Api(value = "定时任务-时刻任务-对账单(京东对账单Excel文件上传)", tags = {"定时任务-时刻任务-对账单(京东对账单Excel文件上传)"})
@Slf4j
@RestController
@RequestMapping("/sysQuartzScheduleTaskStatementOfAccountJd")
public class SysQuartzScheduleTaskStatementOfAccountJdController extends BaseController {

	@Autowired
	private SysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService sysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService;

	@ApiOperation(value = "分页查询-默认不用")
	@RequestMapping(value = "listByObscure", method = RequestMethod.POST)
	@ResponseBody
	public R<List<SysQuartzScheduleTaskStatementOfAccountJd>> pageQuerySysQuartzScheduleTaskStatementOfAccountJd(@RequestBody PageQueryParam param) {

		log.info("pageQuerySysQuartzScheduleTaskStatementOfAccountJd:\n{}", JsonUtils.toJson(param));

		R<List<SysQuartzScheduleTaskStatementOfAccountJd>> result = new R<>();

		// TODO 参数合法性判定

		result = sysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService.pageQuery(param.getConditions(), param.getPageNo(), param.getPageSize());

		return result;
	}

	/**
	 * http://192.168.6.223:8089/web/sysQuartzScheduleTaskStatementOfAccountJd/list
	 *
	 * @param param
	 * @return
	 */
	@ApiOperation(value = "分页查询")
	@RequestMapping(value = "list", method = RequestMethod.POST)
	@ResponseBody
	public R<List<SysQuartzScheduleTaskStatementOfAccountJd>> pageQueryGenericParamSysQuartzScheduleTaskStatementOfAccountJd(@RequestBody PageQueryGenericParam<SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria> param) {

		log.info("pageQuerySysQuartzScheduleTaskStatementOfAccountJd:\n{}\n{}", "此处显示是会少8小时 实际上sql查询是没问题 再解决", JsonUtils.toJson(param));

//		log.info("pageQuerySysQuartzScheduleTaskStatementOfAccountJd:\n{}", JSONUtil.toJsonStr(param));

		R<List<SysQuartzScheduleTaskStatementOfAccountJd>> result = new R<>();

		// TODO 参数合法性判定

		result = sysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService.pageQueryGenericParam(param.getConditions());

		return result;
	}

	@ApiOperation(value = "按id查询")
	@RequestMapping(value = "{id}", method = RequestMethod.GET)
	@ResponseBody
	public R<List<SysQuartzScheduleTaskStatementOfAccountJd>> getById(@PathVariable("id") long id) {

		R<List<SysQuartzScheduleTaskStatementOfAccountJd>> result = new R<>();

		// TODO 参数合法性判定

		SysQuartzScheduleTaskStatementOfAccountJd entity = sysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService.findSysQuartzScheduleTaskStatementOfAccountJdById(id);

		List<SysQuartzScheduleTaskStatementOfAccountJd> data = new ArrayList<>();
		data.add(entity);

		result.setData(data);

		return result;
	}

	@ApiOperation(value = "新增")
	@RequestMapping(value = "add", method = RequestMethod.POST)
	@ResponseBody
	public R<String> addSysQuartzScheduleTaskStatementOfAccountJd(@RequestBody SysQuartzScheduleTaskStatementOfAccountJdParam param) {

		log.info("addSysQuartzScheduleTaskStatementOfAccountJd:\n{}", JsonUtils.toJson(param));


		// TODO 参数合法性判定

		sysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService.addSysQuartzScheduleTaskStatementOfAccountJd(param);

		return new R<>("200", "操作成功", true);
	}

	@ApiOperation(value = "更新")
	@RequestMapping(value = "update", method = RequestMethod.POST)
	@ResponseBody
	public R<String> updateSysQuartzScheduleTaskStatementOfAccountJd(@RequestBody SysQuartzScheduleTaskStatementOfAccountJdParam param) {

		log.info("updateSysQuartzScheduleTaskStatementOfAccountJd:\n{}", JsonUtils.toJson(param));

		sysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService.updateSysQuartzScheduleTaskStatementOfAccountJd(param);

		return new R<>("200", "操作成功", true);
	}

	@ApiOperation(value = "删除")
	@RequestMapping(value = "delete/{id}", method = RequestMethod.POST)
	@ResponseBody
	public R<String> deleteSysQuartzScheduleTaskStatementOfAccountJd(@PathVariable("id") long id) {

		// TODO 参数合法性判定

		sysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService.deleteSysQuartzScheduleTaskStatementOfAccountJd(id);

		return new R<>("200", "操作成功", true);
	}

	@ApiOperation(value = "批量删除")
	@RequestMapping(value = "delete_ids", method = RequestMethod.POST)
	@ResponseBody
	public R<String> deleteIdsSysQuartzScheduleTaskStatementOfAccountJd(@RequestParam(value = "ids") long[] ids) {

		log.info(JsonUtils.toJson(ids));

		for (long id : ids) {
			sysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService.deleteSysQuartzScheduleTaskStatementOfAccountJd(id);
		}

		return new R<>("200", "操作成功", true);

	}


}
