package cn.superdesk.uniorder.dubbo.consumer.base;

import cn.superdesk.uniorder.common.json.JsonUtils;
import cn.superdesk.uniorder.common.pagination.PageQueryParam;
import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrder;
import cn.superdesk.uniorder.dto.param._function.select.SelectOptionDepartmentCriteria;
import cn.superdesk.uniorder.dto.param.accounting.unified.customer.ExportCustomerStatementOfAccountDetailCriteria;
import cn.superdesk.uniorder.dto.param.accounting.unified.supplier.AccountingSupplierNotYetDimGoodsCriteria;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.UnifiedLnssOrderAdd;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.flashdeliver.FlashDeliverOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.flashdeliver.FlashDeliverRefundOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskappservices.meetingroomreservation.MeetingRoomReservationOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.proxyclient.ProxyClientOrderOptBecomeInvalidQueryCriteria;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.score.ScoreOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.score.refund.ScoreOrderRefundReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.unified.UnifiedOrderReceiveParam;
import cn.superdesk.uniorder.dto.receive.consumer.superdeskmall.unified.refund.UnifiedOrderRefundReceiveParam;
import cn.superdesk.uniorder.dto.vo._function.select.SelectOptionDepartment;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.CustomerUnAccountingDimGoodsVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.UnifiedOrderCustomerHeadSumVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.customer.notyet.UnifiedOrderCustomerNotCheckVo;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.notyet.UnifiedOrderJoinGoodsOfSupplierStatementOfAccount;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.notyet.UnifiedOrderSupplierHeadSumVo;
import cn.superdesk.uniorder.dto.vo.order.Org2VirtStatisticsVo;
import cn.superdesk.uniorder.dto.vo.score.ScoreOrderReconciliationNotYetHeadVo;
import cn.superdesk.uniorder.dto.vo.score.ScoreOrderReconciliationNotYetVo;
import cn.superdesk.uniorder.dto.vo.unified.*;
import cn.superdesk.uniorder.dto.vo.wechat.WxBillOrder;
import cn.superdesk.uniorder.dto.vo.wechat.WxBillVirt;
import cn.superdesk.uniorder.dubbo.consumer._permission.PermissionDubboCustomerService;
import cn.superdesk.uniorder.dubbo.facade.base.DubboUnifiedOrderService;
import com.alibaba.dubbo.config.annotation.Reference;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.List;
import java.util.Map;


/**
 * @Description: Java类作用描述
 * @Author: linjinyu 重构
 * @CreateDate: 2020/12/23 下午9:20
 * @UpdateUser: linjinyu
 * @UpdateDate: 2020/12/23 下午9:20
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class UnifiedOrderDubboConsumerService {

	@Reference(version = "1.0.0", timeout = 180000, retries = -1)
	private DubboUnifiedOrderService dubboUnifiedOrderService;

	@Resource
	private PermissionDubboCustomerService permissionDubboCustomerService;

	public List<SelectOptionDepartment> getSelectPurchaseDepartment(String token, SelectOptionDepartmentCriteria criteria) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
//		Boolean      isPass       = permissionDubboCustomerService.addOnPerm(token, criteria);
//		if (isPass.equals(false)) {
//			return null;
//		}

		return dubboUnifiedOrderService.getSelectPurchaseDepartment(criteria, loginSysUser);
	}

	public Map<String, Object> addObjTran(UnifiedLnssOrderAdd unifiedLnssOrderAdd) {

		return dubboUnifiedOrderService.addObjTran(unifiedLnssOrderAdd);
	}

	public void updateObj(UnifiedOrder unifiedOrder) {
		dubboUnifiedOrderService.updateObj(unifiedOrder);
	}

	public UnifiedOrder findByOrderSn(String sn) {

		return dubboUnifiedOrderService.findByOrderSn(sn);
	}


	/****************************************** kafka 一般订单 start ******************************************/


	public R<String> httpUnifiedOrderReceive(UnifiedOrderReceiveParam unifiedOrderReceiveParam) {
		return dubboUnifiedOrderService.httpUnifiedOrderReceive(unifiedOrderReceiveParam);
	}

	public R<String> httpUnifiedOrderRefundReceive(UnifiedOrderRefundReceiveParam unifiedOrderRefundReceiveParam) {
		return dubboUnifiedOrderService.httpUnifiedOrderRefundReceive(unifiedOrderRefundReceiveParam);
	}

	/**
	 * 商城 订单 一般
	 *
	 * @param message
	 */
	public void kafkaUnifiedOrderReceive(String message) {

		dubboUnifiedOrderService.kafkaUnifiedOrderReceive(message);
	}

	public void kafkaUnifiedOrderRefundReceive(String message) {
		dubboUnifiedOrderService.kafkaUnifiedOrderRefundReceive(message);
	}

	/****************************************** kafka 一般订单   end ******************************************/


	/****************************************** kafka 积分订单 start ******************************************/

	/**
	 * http 积分订单 mark by linjinyu at 20210308
	 *
	 * @param scoreOrderReceiveParam
	 * @return
	 */
	public R<String> httpScoreOrderReceive(ScoreOrderReceiveParam scoreOrderReceiveParam) {
		return dubboUnifiedOrderService.httpScoreOrderReceive(scoreOrderReceiveParam);
	}

	/**
	 * http 积分订单 mark by linjinyu at 20210308
	 *
	 * @param scoreOrderRefundReceiveParam
	 * @return
	 */
	public R<String> httpScoreOrderRefundReceive(ScoreOrderRefundReceiveParam scoreOrderRefundReceiveParam) {
		return dubboUnifiedOrderService.httpScoreOrderRefundReceive(scoreOrderRefundReceiveParam);
	}

	/**
	 * 商城 订单 侨城汇(积分订单)
	 *
	 * @param message
	 */
	public void kafkaScoreOrderReceive(String message) {
		dubboUnifiedOrderService.kafkaScoreOrderReceive(message);
	}

	public void kafkaScoreOrderRefundReceive(String message) {
		dubboUnifiedOrderService.kafkaScoreOrderRefundReceive(message);
	}
	/****************************************** kafka 积分订单   end ******************************************/

	/****************************************** kafka 代客下单 start ******************************************/
	public void kafkaProxyClientOrderReceive(String message) {
		dubboUnifiedOrderService.kafkaProxyClientOrderReceive(message);
	}

	/**
	 * 订单作废
	 *
	 * @param queryCriteria
	 * @return
	 */
	public R<String> proxyClientOrderOptBecomeInvalid(ProxyClientOrderOptBecomeInvalidQueryCriteria queryCriteria) {
		return dubboUnifiedOrderService.proxyClientOrderOptBecomeInvalid(queryCriteria);
	}

	/****************************************** kafka 代客下单   end ******************************************/

	/****************************************** kafka 服务之窗 楼闪送 start ******************************************/

	public R<String> httpFlashDeliverOrderReceive(FlashDeliverOrderReceiveParam orderReceiveParam) {
		return dubboUnifiedOrderService.httpFlashDeliverOrderReceive(orderReceiveParam);
	}

	public R<String> httpFlashDeliverOrderRefundReceive(FlashDeliverRefundOrderReceiveParam refundOrderReceiveParam) {
		return dubboUnifiedOrderService.httpFlashDeliverOrderRefundReceive(refundOrderReceiveParam);
	}

	public void kafkaFlashDeliverOrderReceive(String message) {
		dubboUnifiedOrderService.kafkaFlashDeliverOrderReceive(message);
	}

	public void kafkaFlashDeliverOrderRefundReceive(String message){
		dubboUnifiedOrderService.kafkaFlashDeliverOrderRefundReceive(message);
	}

	public void kafkaFlashDeliverOrderStateUpdate(String message) {

		dubboUnifiedOrderService.kafkaFlashDeliverOrderReceiveStateUpdate(message);
	}

	/****************************************** kafka 服务之窗 楼闪送   end ******************************************/

	/****************************************** kafka patchUnifiedOrderFieldOutVirt start ******************************************/

	public void kafkaFlashDeliverPatchUnifiedOrderFieldOutVirt(String message) {

		dubboUnifiedOrderService.kafkaFlashDeliverPatchUnifiedOrderFieldOutVirt(message);
	}

	/****************************************** kafka patchUnifiedOrderFieldOutVirt   end ******************************************/

	/****************************************** kafka 服务之窗 小邮局订单 start ******************************************/

	public void kafkaPostOfficeOrderMergeReceive(String message) {
		dubboUnifiedOrderService.kafkaPostOfficeOrderMergeReceive(message);
	}

	public void kafkaPostOfficeOrderDeleteReceive(String message) {
		dubboUnifiedOrderService.kafkaPostOfficeOrderDeleteReceive(message);
	}

	/****************************************** kafka 服务之窗 小邮局订单   end ******************************************/


	/****************************************** kafka 服务之窗 会议室预约 start ******************************************/

	public R<String> httpMeetingRoomReservationOrderMergeReceive(MeetingRoomReservationOrderReceiveParam meetingRoomReservationOrderReceiveParam) {
		return dubboUnifiedOrderService.httpMeetingRoomReservationOrderMergeReceive(meetingRoomReservationOrderReceiveParam);
	}

	public void kafkaMeetingRoomReservationOrderMergeReceive(String message) {
		dubboUnifiedOrderService.kafkaMeetingRoomReservationOrderMergeReceive(message);
	}

	public void kafkaMeetingRoomReservationOrderDeleteReceive(String message) {
		dubboUnifiedOrderService.kafkaMeetingRoomReservationOrderDeleteReceive(message);
	}
	/****************************************** kafka 服务之窗 会议室预约   end ******************************************/


	/*************************************************  订单管理  start ********************************************************/
	/**
	 * 前端-订单管理-订单管理 列表
	 *
	 * @param token
	 * @param params
	 * @param pageNum
	 * @param pageSize
	 * @return
	 */
	public R<List<ViewUnifiedOrderGoods>> getOrderManagerGoodsByPage(String token, Map<String, Object> params, int pageNum, int pageSize) {


		// 20191205 add 数据权限
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			R<List<ViewUnifiedOrderGoods>> responseResult = new R<>();
			responseResult.setSuccess(false);
			responseResult.setMessage("您没有企业数据权限！");
			return responseResult;
		}

		return dubboUnifiedOrderService.getOrderManagerGoodsByPage(params, pageNum, pageSize);
	}

	/**
	 * 前端-订单管理-订单管理 头部
	 *
	 * @param token
	 * @param params
	 * @return
	 */
	public UnifiedOrderCommonHeadSum getOrderManagerGoodsPageHead(String token, Map<String, Object> params) {

		// 20191205 add 数据权限
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}
		return dubboUnifiedOrderService.getOrderManagerGoodsPageHead(params);
	}

	/**
	 * 前端-订单管理-订单管理(企业采购) opt(按钮) 导出成本
	 *
	 * @param token
	 * @param params
	 * @return
	 */
	public List<ViewUnifiedOrderGoods> getOrderManagerGoodsView(String token, Map<String, Object> params) {

		// 20191205 add 数据权限
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}

		log.info("\n订单管理 > 订单管理 (企业采购) opt 导出成本 params : \n{}", JsonUtils.toPrettyJson(params));

		// TODO 排序 订单 create_time 倒
//		params.put("orderBy", "uo.create_time desc , uo.order_sn desc, uog.id asc");
		return dubboUnifiedOrderService.getOrderManagerGoodsView(params);
	}

	/****************************************** export excel mark by linjinyu at 20210305 start ******************************************/

	public String exportExcelOrderManagerGoodsData(String token, Map<String, Object> params) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		Boolean      isPass       = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}
		return dubboUnifiedOrderService.exportExcelOrderManagerGoodsData(params, loginSysUser);
	}

	public String exportExcelOrderManagerGoodsCostPrice(String token, Map<String, Object> params) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		Boolean      isPass       = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}
		return dubboUnifiedOrderService.exportExcelOrderManagerGoodsCostPrice(params, loginSysUser);
	}

	/****************************************** export excel mark by linjinyu at 20210305   end ******************************************/

	/**
	 * 项目 2 企业 订单 统计
	 *
	 * @param token
	 * @param params
	 * @return
	 */
	public R<List<Org2VirtStatisticsVo>> getOrg2VirtStatistics(String token, Map<String, Object> params, int pageNum, int pageSize) {

		// 20191205 add 数据权限
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}

		log.info("\n订单管理 > 订单管理 项目 2 企业 订单 统计 params : \n{}", JsonUtils.toPrettyJson(params));

		return dubboUnifiedOrderService.getOrg2VirtStatistics(params, pageNum, pageSize);
	}


	/****************************************** 订单管理   end ******************************************/


	/****************************************** 客户结算 dim order 未对账 订单 start ******************************************/
	/**
	 * 前端 客户结算 > 未对账订单
	 *
	 * @param token
	 * @param params
	 * @param pageNum
	 * @param pageSize
	 * @return
	 */
	public R<List<UnifiedOrderCustomerNotCheckVo>> getCustomerUnAccountingDimOrderList(String token, Map<String, Object> params, int pageNum, int pageSize) {

		// 20191205 add 数据权限
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			R<List<UnifiedOrderCustomerNotCheckVo>> responseResult = new R<>();
			responseResult.setSuccess(false);
			responseResult.setMessage("您没有企业数据权限！");
			return responseResult;
		}

		return dubboUnifiedOrderService.getCustomerUnAccountingDimOrderList(params, pageNum, pageSize);
	}

	public UnifiedOrderCommonHeadSum getCustomerUnAccountingDimOrderHeadSum(String token, Map<String, Object> params) {

		// 20191205 add 数据权限
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}

		return dubboUnifiedOrderService.getCustomerUnAccountingDimOrderHeadSum(params);
	}
	/****************************************** 客户结算 dim order 未对账 订单   end ******************************************/

	/****************************************** 客户结算 dim goods 未对账 商品 start ******************************************/

	public UnifiedOrderCustomerHeadSumVo getCustomerUnAccountingDimGoodsHeadSum(String token, Map<String, Object> params) {
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}

		return dubboUnifiedOrderService.getCustomerUnAccountingDimGoodsHeadSum(token, params);
	}

	public List<CustomerUnAccountingDimGoodsVo> getCustomerUnAccountingDimGoodsList(String token, Map<String, Object> params) {
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}
		return dubboUnifiedOrderService.getCustomerUnAccountingDimGoodsList(token, params);
	}

	public R<List<CustomerUnAccountingDimGoodsVo>> getCustomerUnAccountingDimGoodsList(String token, Map<String, Object> params, int pageNo, int pageSize) {
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}
		return dubboUnifiedOrderService.getCustomerUnAccountingDimGoodsList(token, params, pageNo, pageSize);
	}


	/****************************************** 客户结算 dim goods 未对账 商品   end ******************************************/


	/****************************************** 积分结算 未对账 流水 start ******************************************/
	public R<List<ScoreOrderReconciliationNotYetVo>> getScoreOrderReconciliationNotYet(String token, Map<String, Object> params, int pageNum, int pageSize) {

		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}

		return dubboUnifiedOrderService.getScoreOrderReconciliationNotYet(token, params, pageNum, pageSize);
	}

	public List<ScoreOrderReconciliationNotYetVo> getScoreOrderReconciliationNotYet(String token, Map<String, Object> params) {

		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}

		return dubboUnifiedOrderService.getScoreOrderReconciliationNotYet(token, params);
	}

	public String exportExcelScoreOrderReconciliationNotYet(String token, Map<String, Object> params) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		return dubboUnifiedOrderService.exportExcelScoreOrderReconciliationNotYet(params, loginSysUser);
	}

	public ScoreOrderReconciliationNotYetHeadVo getScoreOrderReconciliationNotYetHeadSum(String token, Map<String, Object> params) {

		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}

		return dubboUnifiedOrderService.getScoreOrderReconciliationNotYetHeadSum(token, params);
	}

	/****************************************** 积分结算 未对账 流水   end ******************************************/

	/****************************************** 供应商结算 dim order 未对账 订单 start ******************************************/
	public UnifiedOrderSupplierHeadSumVo getSupplierUnAccountingDimOrderHeadSum(String token, Map<String, Object> params) {

		// 20191205 add 数据权限
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}

		return dubboUnifiedOrderService.getSupplierUnAccountingDimOrderHeadSum(params);
	}

	public List<UnifiedOrderSupplierNotCheckDetail2GoodsVo> getSupplierUnAccountingDetailDimOrder2Goods(String token, Map<String, Object> params) {

		// 20191205 add 数据权限
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}
		return dubboUnifiedOrderService.getSupplierUnAccountingDetail2Goods(params);
	}

	public List<UnifiedOrderSupplierDimOrderNotCheckVo> getSupplierUnAccountingDimOrderList(String token, Map<String, Object> params) {

		return dubboUnifiedOrderService.getSupplierUnAccountingDimOrderList(params);
	}

	public R<List<UnifiedOrderSupplierDimOrderNotCheckVo>> getSupplierUnAccountingDimOrderList(String token, Map<String, Object> params, int pageNum, int pageSize) {

		// 20191205 add 数据权限
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			R<List<UnifiedOrderSupplierDimOrderNotCheckVo>> responseResult = new R<>();
			responseResult.setSuccess(false);
			responseResult.setMessage("您没有企业数据权限！");
			return responseResult;
		}

		return dubboUnifiedOrderService.getSupplierUnAccountingDimOrderList(params, pageNum, pageSize);
	}

	/****************************************** 供应商结算 dim order 未对账 订单   end ******************************************/

	/****************************************** 供应商结算 dim goods 未对账 商品 start ******************************************/
	public UnifiedOrderSupplierHeadSumVo getSupplierUnAccountingDimGoodsHeadSum(String token, AccountingSupplierNotYetDimGoodsCriteria criteria) {
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, criteria);
		if (isPass.equals(false)) {
			return null;
		}

		return dubboUnifiedOrderService.getSupplierUnAccountingDimGoodsHeadSum(criteria);
	}

	public List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierUnAccountingDimGoodsList(String token, AccountingSupplierNotYetDimGoodsCriteria criteria) {
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, criteria);
		if (isPass.equals(false)) {
			return null;
		}
		return dubboUnifiedOrderService.getSupplierUnAccountingDimGoodsList(criteria);
	}

	public R<List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount>> getSupplierUnAccountingDimGoodsListByPageQuery(String token, AccountingSupplierNotYetDimGoodsCriteria criteria) {
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, criteria);
		if (isPass.equals(false)) {
			return null;
		}
		return dubboUnifiedOrderService.getSupplierUnAccountingDimGoodsListByPageQuery(criteria);
	}

	public String exportExcelAccountingSupplierNotYetDimGoods(String token, AccountingSupplierNotYetDimGoodsCriteria criteria) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		return dubboUnifiedOrderService.exportExcelAccountingSupplierNotYetDimGoods(criteria, loginSysUser);
	}

	/****************************************** 供应商结算 dim goods 未对账 商品   end ******************************************/


	/****************************************** 客户结算 对账单 详情 start ******************************************/
	public String exportCustomerStatementOfAccountDetailCompatible(String token, ExportCustomerStatementOfAccountDetailCriteria criteria) {

//		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, criteria);
//		if (isPass.equals(false)) {
//			return null;
//		}

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		return dubboUnifiedOrderService.exportCustomerStatementOfAccountDetailCompatible(criteria, loginSysUser);

	}

	/****************************************** 供应商结算 对账单 详情 start ******************************************/
	/**
	 * 对账单 详情 订单维度
	 *
	 * @param params
	 * @return
	 */
	public List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierStatementOfAccountDetailDimOrder2Goods(Map<String, Object> params) {

		return dubboUnifiedOrderService.getSupplierStatementOfAccountDetailDimOrder2Goods(params);
	}

	/**
	 * 对账单 详情 商品维度
	 *
	 * @param params
	 * @return
	 */
	public List<UnifiedOrderJoinGoodsOfSupplierStatementOfAccount> getSupplierStatementOfAccountDetailDimGoods2Goods(Map<String, Object> params) {

		return dubboUnifiedOrderService.getSupplierStatementOfAccountDetailDimGoods2Goods(params);
	}

	public String exportSupplierStatementOfAccountDetailCompatible(String token, Map<String, Object> params) {

		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		return dubboUnifiedOrderService.exportSupplierStatementOfAccountDetailCompatible(params, loginSysUser);

	}

	/****************************************** 供应商结算 对账单 详情   end ******************************************/


	public UnifiedOrderGoodsDetail getGoodsDetail(String token, Long id) {

		return dubboUnifiedOrderService.getGoodsDetail(id);
	}


	/****************************************** 客户结算对账 未对账商品 start ******************************************/
	/**
	 * 1. 客户结算对账 未对账商品 列表
	 *
	 * @param token
	 * @param params
	 * @return
	 */
	public List<UnifiedOrderJoinGoodsDetailVo> getUnifiedOrderJoinGoodsDetailVoList(String token, Map<String, Object> params) {

		// 20191205 add 数据权限
		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}
		return dubboUnifiedOrderService.getUnifiedOrderJoinGoodsDetailVoList(params);
	}


	/**
	 * 超级前台
	 *
	 * @param token
	 * @param params
	 * @return
	 */
	public String exportExcelAccountingCustomerNotYetDimOrder(String token, Map<String, Object> params) {

		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		return dubboUnifiedOrderService.exportExcelAccountingCustomerNotYetDimOrder(params, loginSysUser);
	}

	/**
	 * 超级前台
	 * 1. 客户结算对账 未对账商品 新版 导出
	 *
	 * @param token
	 * @param params
	 * @return
	 */
	public String exportExcelAccountingCustomerNotYetDimGoods(String token, Map<String, Object> params) {

		Boolean isPass = permissionDubboCustomerService.addOnPerm(token, params);
		if (isPass.equals(false)) {
			return null;
		}

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		return dubboUnifiedOrderService.exportExcelAccountingCustomerNotYetDimGoods(params, loginSysUser);
	}


	/****************************************** 客户结算对账 未对账商品   end ******************************************/

	public List<UnifiedOrder> findAll(String token, Map<String, Object> queryMap) {

		return dubboUnifiedOrderService.findAll(queryMap);
	}

	public R<List<UnifiedOrder>> patchFlashDeliverPatchUnifiedOrderFieldOutVirt(PageQueryParam pageQueryParam) {

		return dubboUnifiedOrderService.patchFlashDeliverPatchUnifiedOrderFieldOutVirt(pageQueryParam);
	}

	public Integer countAll(Map<String, Object> queryMap) {
		return dubboUnifiedOrderService.countAll(queryMap);
	}


	/**
	 * TODO 这个取什么 金额呀?
	 *
	 * @param amountQuery
	 * @return
	 */
	public BigDecimal getAmount(Map<String, Object> amountQuery) {

		return dubboUnifiedOrderService.getAmount(amountQuery);
	}

	public BigDecimal getPayAmount(Map<String, Object> upaymap) {

		return dubboUnifiedOrderService.getPayAmount(upaymap);
	}

	public List<WxBillOrder> getVirtOrder(Map<String, Object> params) {

		return dubboUnifiedOrderService.getVirtOrder(params);
	}

	public WxBillVirt getVirtBill(Long virtId, int syear) {

		return dubboUnifiedOrderService.getVirtBill(virtId, syear);
	}


	public Integer getOrderCount(Map<String, Object> queryMap) {
		return dubboUnifiedOrderService.getOrderCount(queryMap);
	}
}
