package cn.superdesk.uniorder.dubbo.consumer.base;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.base.UnifiedOrderGoods;
import cn.superdesk.uniorder.dto.dubbo.base.UnifiedOrderGoodsParam;
import cn.superdesk.uniorder.dubbo.facade.base.DubboUnifiedOrderGoodsService;
import com.alibaba.dubbo.config.annotation.Reference;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-01-06 20:55:13
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-01-06 20:55:13
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class UnifiedOrderGoodsDubboConsumerService {

	@Reference(version = "1.0.0", timeout = 60000, retries = -1)
	private DubboUnifiedOrderGoodsService dubboUnifiedOrderGoodsService;


	/****************************************** extends BaseService 部分 start ******************************************/

	public void addObj(UnifiedOrderGoodsParam param) {

		dubboUnifiedOrderGoodsService.addObj(param);

	}

	public void updateObj(UnifiedOrderGoodsParam param) {

		dubboUnifiedOrderGoodsService.updateObj(param);
	}

	public void deleteObj(Long id) {

		dubboUnifiedOrderGoodsService.deleteObj(id);
	}

	public UnifiedOrderGoods findById(Long id) {

		return dubboUnifiedOrderGoodsService.findById(id);
	}

	public PageInfo<UnifiedOrderGoods> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {

		return dubboUnifiedOrderGoodsService.findByPaging(conditions, pageNun, pageSize);
	}

	public List<UnifiedOrderGoods> findAll(Map<String, Object> queryMap) {

		return dubboUnifiedOrderGoodsService.findAll(queryMap);
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	public void addUnifiedOrderGoods(UnifiedOrderGoodsParam param) {

		dubboUnifiedOrderGoodsService.addUnifiedOrderGoods(param);
	}


	public void updateUnifiedOrderGoods(UnifiedOrderGoodsParam param) {

		dubboUnifiedOrderGoodsService.updateUnifiedOrderGoods(param);
	}


	public void deleteUnifiedOrderGoods(Long id) {
		dubboUnifiedOrderGoodsService.deleteUnifiedOrderGoods(id);
	}


	public UnifiedOrderGoods findUnifiedOrderGoodsById(Long id) {

		return dubboUnifiedOrderGoodsService.findUnifiedOrderGoodsById(id);
	}


	public R<List<UnifiedOrderGoods>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

		return dubboUnifiedOrderGoodsService.pageQuery(conditions, pageNun, pageSize);
	}

	/****************************************** 补丁部分 mark by linjinyu at 20210323 start ******************************************/

	public String checkAndFixFixTaxRateTaxCodeFiscalCode(){
		return dubboUnifiedOrderGoodsService.checkAndFixFixTaxRateTaxCodeFiscalCode();
	}
}
