package cn.superdesk.uniorder.dubbo.consumer.invoice;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.InvoiceBankInfo;
import cn.superdesk.uniorder.dubbo.facade.invoice.DubboInvoiceBankInfoService;
import com.alibaba.dubbo.config.annotation.Reference;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

@Slf4j
@Component
public class InvoiceBankInfoDubboConsumerService {

	@Reference(version = "1.0.0", timeout = 30000, retries = -1)
	private DubboInvoiceBankInfoService dubboInvoiceBankInfoService;

	public Map<String, Object> addObj(String token, InvoiceBankInfo param) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		return dubboInvoiceBankInfoService.addObj(param, loginSysUser);
	}

	public Map<String, Object> updateObj(String token, InvoiceBankInfo param) {

		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);

		return dubboInvoiceBankInfoService.updateObj(param, loginSysUser);
	}

	public void delObj(Long id) {
		dubboInvoiceBankInfoService.delObj(id);
	}

	public R<List<InvoiceBankInfo>> getDataByPage(String token, Map<String, Object> params, int pageNum, int pageSize) {
		return dubboInvoiceBankInfoService.getDataByPage(params, pageNum, pageSize);
	}

	public void updateAuto(Long id) {
		dubboInvoiceBankInfoService.updateAuto(id);
	}

	/****************************************** 缓存 start ******************************************/

	/**
	 * 初始化
	 */
	public void cacheInit() {
		dubboInvoiceBankInfoService.cacheInit();
	}

	/**
	 * 刷新
	 */
	public void cacheRefresh() {
		dubboInvoiceBankInfoService.cacheRefresh();
	}

	/**
	 * 清除
	 */
	public void cacheRemove() {
		dubboInvoiceBankInfoService.cacheRemove();
	}

	public String cacheGet(String hashTable, String keyField) {
		return dubboInvoiceBankInfoService.cacheGet(hashTable, keyField);
	}
}
