package cn.superdesk.uniorder.dubbo.consumer.invoice;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.invoice.InvoiceType;
import cn.superdesk.uniorder.dto.param.invoice.InvoiceTypeCacheCriteria;
import cn.superdesk.uniorder.dto.param.invoice.InvoiceTypeParam;
import cn.superdesk.uniorder.dubbo.facade.invoice.DubboInvoiceTypeService;
import com.alibaba.dubbo.config.annotation.Reference;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-07-23 15:30:45
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-07-23 15:30:45
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class InvoiceTypeDubboConsumerService {

	@Reference(version = "1.0.0", timeout = 10000, retries = -1)
	private DubboInvoiceTypeService dubboInvoiceTypeService;


	/****************************************** extends BaseService 部分 start ******************************************/

	public void addObj(InvoiceTypeParam param) {

		dubboInvoiceTypeService.addObj(param);

	}

	public void updateObj(InvoiceTypeParam param) {

		dubboInvoiceTypeService.updateObj(param);
	}

	public void deleteObj(Long id) {

		dubboInvoiceTypeService.deleteObj(id);
	}

	public InvoiceType findById(Long id) {

		return dubboInvoiceTypeService.findById(id);
	}

	public PageInfo<InvoiceType> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {

		return dubboInvoiceTypeService.findByPaging(conditions, pageNun, pageSize);
	}

	public List<InvoiceType> findAll(Map<String, Object> queryMap) {

		return dubboInvoiceTypeService.findAll(queryMap);
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	public void addInvoiceType(InvoiceTypeParam param) {

		dubboInvoiceTypeService.addInvoiceType(param);
	}


	public void updateInvoiceType(InvoiceTypeParam param) {

		dubboInvoiceTypeService.updateInvoiceType(param);
	}


	public void deleteInvoiceType(Long id) {
		dubboInvoiceTypeService.deleteInvoiceType(id);
	}


	public InvoiceType findInvoiceTypeById(Long id) {

		return dubboInvoiceTypeService.findInvoiceTypeById(id);
	}


	public R<List<InvoiceType>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

		return dubboInvoiceTypeService.pageQuery(conditions, pageNun, pageSize);
	}


	/****************************************** 缓存 start ******************************************/

	/**
	 * 初始化
	 *
	 * @param criteria
	 */
	public void cacheInit(InvoiceTypeCacheCriteria criteria) {
		dubboInvoiceTypeService.cacheInit(criteria);
	}

	/**
	 * 刷新
	 *
	 * @param criteria
	 */
	public void cacheRefresh(InvoiceTypeCacheCriteria criteria) {
		dubboInvoiceTypeService.cacheRefresh(criteria);
	}

	/**
	 * 清除
	 *
	 * @param criteria
	 */
	public void cacheRemove(InvoiceTypeCacheCriteria criteria) {
		dubboInvoiceTypeService.cacheRemove(criteria);
	}

	public String cacheGet(InvoiceTypeCacheCriteria criteria) {
		return dubboInvoiceTypeService.cacheGet(criteria);
	}
}
