package cn.superdesk.uniorder.dubbo.consumer.invoice.customer;

import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.dubbo.consumer._permission.PermissionDubboCustomerService;
import cn.superdesk.uniorder.dubbo.facade.invoice.customer.DubboInvoiceApplyFieldInvoiceProgressingStatusService;
import com.alibaba.dubbo.config.annotation.Reference;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;


/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class InvoiceApplyFieldInvoiceProgressingStatusDubboConsumerService {

	@Reference(version = "1.0.0", timeout = 300000, retries = -1)
	private DubboInvoiceApplyFieldInvoiceProgressingStatusService dubboInvoiceApplyFieldInvoiceProgressingStatusService;

	@Resource
	private PermissionDubboCustomerService permissionDubboCustomerService;

	/****************************************** 状态机 外部使用 类门面 start ******************************************/
	// 状态流转为 待开票(0, "待开票")
	public void opInit(String token, InvoiceApply entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		dubboInvoiceApplyFieldInvoiceProgressingStatusService.opInit(entity, loginSysUser);
	}

	// 状态流转为 已作废(2, "已作废")
	public void opBecomeInvalid(String token, InvoiceApply entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		dubboInvoiceApplyFieldInvoiceProgressingStatusService.opBecomeInvalid(entity, loginSysUser);
	}

	// 状态流转为 开票中(10, "开票中")
	public void opOngoing(String token, InvoiceApply entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		dubboInvoiceApplyFieldInvoiceProgressingStatusService.opOngoing(entity, loginSysUser);
	}

	// 状态流转为 已开票(11, "已开票")
	public void opComplete(String token, InvoiceApply entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		dubboInvoiceApplyFieldInvoiceProgressingStatusService.opComplete(entity, loginSysUser);
	}

	/****************************************** 状态机 外部使用 类门面   end ******************************************/
}
