package cn.superdesk.uniorder.dubbo.consumer.invoice.customer;

import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.invoice.customer.InvoiceApply;
import cn.superdesk.uniorder.dubbo.consumer._permission.PermissionDubboCustomerService;
import cn.superdesk.uniorder.dubbo.facade.invoice.customer.DubboInvoiceApplyFieldMailTickStatusService;
import com.alibaba.dubbo.config.annotation.Reference;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;


/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class InvoiceApplyFieldMailTickStatusDubboConsumerService {

	@Reference(version = "1.0.0", timeout = 300000, retries = -1)
	private DubboInvoiceApplyFieldMailTickStatusService dubboInvoiceApplyFieldMailTickStatusService;

	@Resource
	private PermissionDubboCustomerService permissionDubboCustomerService;

	/****************************************** 状态机 外部使用 类门面 start ******************************************/
	// 状态流转为 未邮寄(0, "未邮寄")
	public void opInit(String token, InvoiceApply entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		dubboInvoiceApplyFieldMailTickStatusService.opInit(entity, loginSysUser);
	}

	// 状态流转为 已邮寄(1, "已邮寄")
	public void opComplete(String token, InvoiceApply entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		dubboInvoiceApplyFieldMailTickStatusService.opComplete(entity, loginSysUser);
	}

	/****************************************** 状态机 外部使用 类门面   end ******************************************/
}
