package cn.superdesk.uniorder.dubbo.consumer.organisation;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.organisation.UnifiedSupplier;
import cn.superdesk.uniorder.dto.param.organisation.UnifiedSupplierCriteria;
import cn.superdesk.uniorder.dto.param.organisation.UnifiedSupplierParam;
import cn.superdesk.uniorder.dto.vo.organisation.UnifiedSupplierVo;
import cn.superdesk.uniorder.dubbo.facade.organisation.DubboUnifiedSupplierService;
import com.alibaba.dubbo.config.annotation.Reference;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Map;

/**
 * @Description:
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-05-14 12:51:18
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-05-14 12:51:18
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class UnifiedSupplierDubboConsumerService {

	@Reference(version = "1.0.0", timeout = 30000, retries = -1)
	private DubboUnifiedSupplierService dubboUnifiedSupplierService;


	/****************************************** extends BaseService 部分 start ******************************************/

	public void addObj(UnifiedSupplierParam param) {

		dubboUnifiedSupplierService.addObj(param);

	}

	public void updateObj(UnifiedSupplierParam param) {

		dubboUnifiedSupplierService.updateObj(param);
	}

	public void deleteObj(Long id) {

		dubboUnifiedSupplierService.deleteObj(id);
	}

	public UnifiedSupplier findById(Long id) {

		return dubboUnifiedSupplierService.findById(id);
	}

	public PageInfo<UnifiedSupplier> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {

		return dubboUnifiedSupplierService.findByPaging(conditions, pageNun, pageSize);
	}

	public List<UnifiedSupplier> findAll(Map<String, Object> queryMap) {

		return dubboUnifiedSupplierService.findAll(queryMap);
	}


	/****************************************** extends BaseService 部分   end ******************************************/


	public void addUnifiedSupplier(UnifiedSupplierParam param) {

		dubboUnifiedSupplierService.addUnifiedSupplier(param);
	}

	public void updateUnifiedSupplier(UnifiedSupplierParam param) {

		dubboUnifiedSupplierService.updateUnifiedSupplier(param);
	}

	public void deleteUnifiedSupplier(Long id) {
		dubboUnifiedSupplierService.deleteUnifiedSupplier(id);
	}

	public UnifiedSupplier findUnifiedSupplierById(Long id) {

		return dubboUnifiedSupplierService.findUnifiedSupplierById(id);
	}

	public R<List<UnifiedSupplier>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

		return dubboUnifiedSupplierService.pageQuery(conditions, pageNun, pageSize);
	}


	/****************************************** extends BaseService 部分 start ******************************************/


	public void updateObj(UnifiedSupplier oe) {
		dubboUnifiedSupplierService.updateObj(oe);
	}

	public void addObj(UnifiedSupplier oe) {
		dubboUnifiedSupplierService.addObj(oe);
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	/******************************************  start ******************************************/

	public R<List<UnifiedSupplierVo>> getDataByPage(String token, UnifiedSupplierCriteria unifiedSupplierCriteria, int pageNum, int pageSize) {
		return dubboUnifiedSupplierService.getDataByPage(unifiedSupplierCriteria, pageNum, pageSize);
	}

	public void kafkaMergeReceiveMerchant4SuperdeskMall(String message) {
		dubboUnifiedSupplierService.kafkaMergeReceiveMerchant4SuperdeskMall(message);
	}

	@Deprecated
	public void kafkaDeleteReceiveMerchant4SuperdeskMall(String message) {
		dubboUnifiedSupplierService.kafkaDeleteReceiveMerchant4SuperdeskMall(message);
	}


	public void kafkaMergeReceiveMerchant4SuperdeskMallFLSC_QCH(String message) {
		dubboUnifiedSupplierService.kafkaMergeReceiveMerchant4SuperdeskMallFLSC_QCH(message);
	}

	/**
	 * 20200707 林志鹏说是没删除
	 *
	 * @param message
	 */
	@Deprecated
	public void kafkaDeleteReceiveMerchant4SuperdeskMallFLSC_QCH(String message) {
		dubboUnifiedSupplierService.kafkaDeleteReceiveMerchant4SuperdeskMallFLSC_QCH(message);
	}
}
