package cn.superdesk.uniorder.dubbo.consumer.scheduler;

import cn.superdesk.uniorder.common.rest.response.R;
import cn.superdesk.uniorder.dao.entity.scheduler.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.dto.param.scheduler.SysQuartzScheduleTaskStatementOfAccountJdParam;
import cn.superdesk.uniorder.dto.param.scheduler.SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria;
import cn.superdesk.uniorder.dto.param.scheduler.SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm;
import cn.superdesk.uniorder.dubbo.consumer._permission.PermissionDubboCustomerService;
import cn.superdesk.uniorder.dubbo.facade.scheduler.DubboSysQuartzScheduleTaskStatementOfAccountJdService;
import com.alibaba.dubbo.config.annotation.Reference;
import com.github.pagehelper.PageInfo;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * @Description: 定时任务-时刻任务-对账单
 * @Author: linjinyu
 * @Email linjinyu@avic-s.com
 * @CreateDate: 2021-10-12 11:29:24
 * @UpdateUser: linjinyu
 * @UpdateDate: 2021-10-12 11:29:24
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class SysQuartzScheduleTaskStatementOfAccountJdDubboConsumerService {

	@Reference(version = "1.0.0", timeout = 10000, retries = -1)
	private DubboSysQuartzScheduleTaskStatementOfAccountJdService dubboSysQuartzScheduleTaskStatementOfAccountJdService;

	@Resource
	private PermissionDubboCustomerService permissionDubboCustomerService;


	/****************************************** extends BaseService 部分 start ******************************************/

	public void addObj(SysQuartzScheduleTaskStatementOfAccountJdParam param) {

		dubboSysQuartzScheduleTaskStatementOfAccountJdService.addObj(param);

	}

	public void updateObj(SysQuartzScheduleTaskStatementOfAccountJdParam param) {

		dubboSysQuartzScheduleTaskStatementOfAccountJdService.updateObj(param);
	}

	public void deleteObj(Long id) {

		dubboSysQuartzScheduleTaskStatementOfAccountJdService.deleteObj(id);
	}

	public SysQuartzScheduleTaskStatementOfAccountJd findById(Long id) {

		return dubboSysQuartzScheduleTaskStatementOfAccountJdService.findById(id);
	}

	public PageInfo<SysQuartzScheduleTaskStatementOfAccountJd> findByPaging(Map<String, Object> conditions, Integer pageNun, Integer pageSize) {

		return dubboSysQuartzScheduleTaskStatementOfAccountJdService.findByPaging(conditions, pageNun, pageSize);
	}

	public List<SysQuartzScheduleTaskStatementOfAccountJd> findAll(Map<String, Object> queryMap) {

		return dubboSysQuartzScheduleTaskStatementOfAccountJdService.findAll(queryMap);
	}

	/****************************************** extends BaseService 部分   end ******************************************/


	public void addSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJdParam param) {

		dubboSysQuartzScheduleTaskStatementOfAccountJdService.addSysQuartzScheduleTaskStatementOfAccountJd(param);
	}


	public void updateSysQuartzScheduleTaskStatementOfAccountJd(SysQuartzScheduleTaskStatementOfAccountJdParam param) {

		dubboSysQuartzScheduleTaskStatementOfAccountJdService.updateSysQuartzScheduleTaskStatementOfAccountJd(param);
	}


	public void deleteSysQuartzScheduleTaskStatementOfAccountJd(Long id) {
		dubboSysQuartzScheduleTaskStatementOfAccountJdService.deleteSysQuartzScheduleTaskStatementOfAccountJd(id);
	}


	public SysQuartzScheduleTaskStatementOfAccountJd findSysQuartzScheduleTaskStatementOfAccountJdById(Long id) {

		return dubboSysQuartzScheduleTaskStatementOfAccountJdService.findSysQuartzScheduleTaskStatementOfAccountJdById(id);
	}


	public R<List<SysQuartzScheduleTaskStatementOfAccountJd>> pageQuery(Map<String, Object> conditions, int pageNun, int pageSize) {

		return dubboSysQuartzScheduleTaskStatementOfAccountJdService.pageQuery(conditions, pageNun, pageSize);
	}


	public R<List<SysQuartzScheduleTaskStatementOfAccountJd>> pageQueryGenericParam(SysQuartzScheduleTaskStatementOfAccountJdQueryCriteria queryCriteria) {

		return dubboSysQuartzScheduleTaskStatementOfAccountJdService.pageQueryGenericParam(queryCriteria);
	}

	/****************************************** 检查 start ******************************************/

	/**
	 * 步骤3:通过京东的订单数据-比对统一订单数据-生成报告
	 * 检查 比对
	 *
	 * @param form
	 * @return
	 */
	public R<String> opCheckUp(SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form) {

		return dubboSysQuartzScheduleTaskStatementOfAccountJdService.opCheckUp(form);
	}

	/**
	 * 步骤3:通过报告的异常数据-重新比对统一订单数据-生成报告
	 * @param form
	 * @return
	 */
	public R<String> opCheckUpException(SysQuartzScheduleTaskStatementOfAccountJdRunExcelImportForm form) {

		return dubboSysQuartzScheduleTaskStatementOfAccountJdService.opCheckUpException(form);
	}




}
