package cn.superdesk.uniorder.dubbo.consumer.scheduler;

import cn.superdesk.uniorder.common.security.JwtUtil;
import cn.superdesk.uniorder.common.security.dto.LoginSysUser;
import cn.superdesk.uniorder.dao.entity.scheduler.SysQuartzScheduleTaskStatementOfAccountJd;
import cn.superdesk.uniorder.dubbo.consumer._permission.PermissionDubboCustomerService;
import cn.superdesk.uniorder.dubbo.facade.scheduler.DubboSysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService;
import com.alibaba.dubbo.config.annotation.Reference;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;


/**
 * @Description: 简易状态机 星型结构
 * @Author: linjinyu
 * @CreateDate: 10/12/20 4:28 PM
 * @UpdateUser: linjinyu
 * @UpdateDate: 10/12/20 4:28 PM
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Component
public class SysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusDubboConsumerService {

	@Reference(version = "1.0.0", timeout = 300000, retries = -1)
	private DubboSysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService dubboSysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService;

	@Resource
	private PermissionDubboCustomerService permissionDubboCustomerService;

	/****************************************** 状态机 外部使用 类门面 start ******************************************/
	// 状态流转为 已取消(-1, "已取消")
	public void opCancel(String token, SysQuartzScheduleTaskStatementOfAccountJd entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		dubboSysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService.opCancel(entity, loginSysUser);
	}

	// 状态流转为 待确认(0, "待确认")
	public void opInitOrReset(String token, SysQuartzScheduleTaskStatementOfAccountJd entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		dubboSysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService.opInitOrReset(entity, loginSysUser);
	}

	// 状态流转为 已确认(1, "已确认")
	public void opConfirm(String token, SysQuartzScheduleTaskStatementOfAccountJd entity) {
		LoginSysUser loginSysUser = JwtUtil.getLoginSysUser(token);
		dubboSysQuartzScheduleTaskStatementOfAccountJdFieldAccountingStatusService.opConfirm(entity, loginSysUser);
	}

	/****************************************** 状态机 外部使用 类门面   end ******************************************/
}
