package cn.superdesk.uniorder.function.accounting;


import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.AccountingUnifiedSupplierStatementOfAccountFixVoDimGoods;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.AccountingUnifiedSupplierStatementOfAccountFixVoDimOrder;
import cn.superdesk.uniorder.dto.vo.accounting.unified.supplier.UnifiedSupplierStatementOfAccountVo;
import cn.superdesk.uniorder.dubbo.consumer.accounting.AccountingUnifiedSupplierDubboConsumerService;
import cn.superdesk.uniorder.dubbo.consumer.base.UnifiedOrderDubboConsumerService;
import cn.superdesk.uniorder.dubbo.consumer.organisation.UnifiedSupplierDubboConsumerService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description: Java类作用描述
 * @Author: linjinyu
 * @CreateDate: 2020/11/18 下午4:56
 * @UpdateUser: linjinyu
 * @UpdateDate: 2020/11/18 下午4:56
 * @UpdateRemark: 修改内容
 * @Version: 1.0
 */
@Slf4j
@Service
public class UnifiedSupplierStatementFunction {


	@Autowired
	private UnifiedOrderDubboConsumerService              unifiedOrderDubboConsumerService;
	@Autowired
	private UnifiedSupplierDubboConsumerService           unifiedSupplierDubboConsumerService;
	@Autowired
	private AccountingUnifiedSupplierDubboConsumerService accountingUnifiedSupplierDubboConsumerService;

	/**
	 * TODO 待合并 修正列表数据显示
	 *
	 * @param unifiedSupplierStatementOfAccountVo
	 */
	public void fixDimOrder(UnifiedSupplierStatementOfAccountVo unifiedSupplierStatementOfAccountVo) {


		// 得到 accountingOrderSn
		Map<String, Object> params = new HashMap<>();
		params.put("accountingOrderSn", unifiedSupplierStatementOfAccountVo.getAccountingOrderSn());

		AccountingUnifiedSupplierStatementOfAccountFixVoDimOrder fixVoDimOrder = accountingUnifiedSupplierDubboConsumerService.checkAmountErrorForFixDimOrder(params);


		BigDecimal newAmount            = fixVoDimOrder.getGoodsCostAmount().add(fixVoDimOrder.getGoodsRefundCostAmount());
		BigDecimal newAmountWithFreight = newAmount.add(fixVoDimOrder.getGoodsTransportAmount());


		// 商品成本-商品退成本
		unifiedSupplierStatementOfAccountVo.setCostAmount(newAmount);
		// 商品成本-商品退成本 + 运费
		unifiedSupplierStatementOfAccountVo.setCostAmountWithFreight(newAmountWithFreight);

		unifiedSupplierStatementOfAccountVo.setOrderCostAmount(fixVoDimOrder.getOrderCostAmount());
		unifiedSupplierStatementOfAccountVo.setOrderTransportAmount(fixVoDimOrder.getOrderTransportAmount());

		unifiedSupplierStatementOfAccountVo.setGoodsCostAmount(fixVoDimOrder.getGoodsCostAmount());
		unifiedSupplierStatementOfAccountVo.setGoodsRefundCostAmount(fixVoDimOrder.getGoodsRefundCostAmount());
		unifiedSupplierStatementOfAccountVo.setGoodsTransportAmount(fixVoDimOrder.getGoodsTransportAmount());

	}

	/**
	 * TODO 待合并 修正列表数据显示
	 *
	 * @param unifiedSupplierStatementOfAccountVo
	 */
	public void fixDimGoods(UnifiedSupplierStatementOfAccountVo unifiedSupplierStatementOfAccountVo) {

		// 得到 accountingOrderSn
		Map<String, Object> params = new HashMap<>();
		params.put("accountingOrderSn", unifiedSupplierStatementOfAccountVo.getAccountingOrderSn());
		AccountingUnifiedSupplierStatementOfAccountFixVoDimGoods fixVoDimGoods = accountingUnifiedSupplierDubboConsumerService.checkAmountErrorForFixDimGoods(params);


		BigDecimal newAmount            = fixVoDimGoods.getGoodsCostAmount().add(fixVoDimGoods.getGoodsRefundCostAmount());
		BigDecimal newAmountWithFreight = newAmount.add(fixVoDimGoods.getGoodsTransportAmount());


		// 商品成本-商品退成本
		unifiedSupplierStatementOfAccountVo.setCostAmount(newAmount);
		// 商品成本-商品退成本 + 运费
		unifiedSupplierStatementOfAccountVo.setCostAmountWithFreight(newAmountWithFreight);

		unifiedSupplierStatementOfAccountVo.setOrderCostAmount(fixVoDimGoods.getOrderCostAmount());
		unifiedSupplierStatementOfAccountVo.setOrderTransportAmount(fixVoDimGoods.getOrderTransportAmount());

		unifiedSupplierStatementOfAccountVo.setGoodsCostAmount(fixVoDimGoods.getGoodsCostAmount());
		unifiedSupplierStatementOfAccountVo.setGoodsRefundCostAmount(fixVoDimGoods.getGoodsRefundCostAmount());
		unifiedSupplierStatementOfAccountVo.setGoodsTransportAmount(fixVoDimGoods.getGoodsTransportAmount());

	}
}
